#coding:utf8

from volcenginesdkarkruntime import Ark
import time
import traceback
import re

client = Ark(
    api_key='11caf7c4-05d4-4f86-b507-f7a3d9f323b1',
    base_url="https://ark.cn-beijing.volces.com/api/v3",
)

model_name = "ep-20250212111145-fflr7" #1.5pro 256k
model_name = "ep-20250314164242-jd62g" #1.5pro 32k
# model_name = "ep-20241226161807-95wp8" #lite 128k
# model_name = "ep-20241225142604-lv25x" #lite 32k

def chat_doubao(msg,stream=False,retry_time=3,model_name=model_name):

    for _ in range(retry_time):
        try:
            result = None
            if not stream:
                # Non-streaming:
                completion = client.chat.completions.create(
                    model=model_name,
                    messages = [
                        # {"role": "system", "content": "你是豆包，是由字节跳动开发的 AI 人工智能助手"},
                        {"role": "user", "content": msg},
                    ],
                )
                result = completion.choices[0].message.content

            else:
                # Streaming:
                print("----- streaming request -----")
                stream = client.chat.completions.create(
                    model=model_name,
                    messages = [
                        {"role": "system", "content": "你是豆包，是由字节跳动开发的 AI 人工智能助手"},
                        {"role": "user", "content": msg},
                    ],
                    stream=True
                )
                result = ""
                for chunk in stream:
                    if not chunk.choices:
                        continue
                    result += chunk.choices[0].delta.content
            return result
        except Exception as e:
            traceback.print_exc()
            time.sleep(30)

def chat_doubao_messages(messages,stream=False,retry_time=3,model_name = "ep-20241226161807-95wp8"):

    for _ in range(retry_time):
        try:
            result = None
            if not stream:
                # Non-streaming:
                completion = client.chat.completions.create(
                    model=model_name,
                    messages = messages,
                )
                result = completion.choices[0].message.content

            else:
                # Streaming:
                print("----- streaming request -----")
                stream = client.chat.completions.create(
                    model=model_name,
                    messages = messages,
                    stream=True
                )
                result = ""
                for chunk in stream:
                    if not chunk.choices:
                        continue
                    result += chunk.choices[0].delta.content
            return result
        except Exception as e:
            traceback.print_exc()
            time.sleep(10)

def get_json_from_text(_text):
    _pattern = "```json(?P<json>.*)```"
    _search = re.search(_pattern, _text, re.DOTALL)
    if _search is not None:
        _json = _search.groupdict().get("json")
    else:
        _json = _text
    return _json

if __name__ == '__main__':
    msg = '''
    提取以下内容的产品名称，单价，数量、总价、规格，型号，结果返回json
中山大学孙逸仙纪念医院-结果公告(CBSYSH2024000252)
申购单号：CBSYSH2024000252成交总额：192000.00
申购主题：腹腔镜基础训练系统（带系统） 送货时间：合同签订后7天内送达
采购单位：中山大学孙逸仙纪念医院 安装要求：免费上门安装（含材料费）
竞价开始时间：2024-12-16 16:43:48 收货地址：
竞价截至时间：2024-12-19 16:53:24
币种：人民币
付款方式：货到验收合格后付款
备注说明：投标者默认已认真阅读并接受我院以下投标条款： 1. 签收发票之日起算，为期4个月的付款周期及3个月内投标产品出现非人为质量问题无条件退货； 2. 投标者必须是广州本地供应商或广州有售后服务驻点的供应商，优先考虑本地供应商，提供专人送货上门、安装及维护服务，不接受快递公司、物流公司发货、送货服务； 3. 投标者必须是正规合法供应商，提供投标产品授权证明，保证投标产品为原装正品，承诺保修期内无偿提供相关技术支持服务； 4. 投标者存在欺诈行为，中标后未能满足上述投标条款的，我院有权废除中标结果，重新挂网竞价。经营医疗器械设备必须有国家颁发的医疗器械经营许可证，负责一票否决。5.万元以上标的需签订合同，请中标公司中标后请加qq号2545649826，并于1周内提交合同，合同模板在医院官网-招聘采购-采购专栏-其他（表单下载及指引）-关于竞彩星、竞价网中标后操作指引。
质疑说明：如果对成交结果有异议，请在发布成交结果之日起三个工作日内向采购单位提出质疑
竞价结果：
采购项：腹腔镜基础训练系统（带系统） 品牌： 广州融穗 型号： Das-2000
成交总价：192000.00
成交供应商：佛山市博霆医疗科技有限公司
质保及售后服务： 按行业标准提供服务
技术参数： 一、基本要求：进行腹腔镜手术基础技能训练的教学设备，可选配0°或30°摄像系统、无延迟高清显示系统，配合腹腔镜操作器械、训练模块等组成，用于扶镜、视觉适应、三维定位、手眼协调、缝合打结、离体器官模拟手术、团队配合等训练，并提升腹腔镜手术器械使用夹取、穿孔、牵引、剪切、缝合、打结等基本技能。适用个人培训或团队配合训练。 二、功能要求： 1.腹部体膜（箱体）模拟真实气腹外形： ▲1.1.左右两边各设置一个训练模块入口，可方便放置、更换训练模块； ▲1.2.配套箱体同材质及同色调底座 ▲1.3.箱体具备可与底座翻开、合紧，可方便放置、更换大型训练模块或部分动物器官； ▲1.4.箱体可放置不少于26.536.5cm尺寸的托盘、可放置干燥或湿性训练模块； ▲2.腹部不少于14个手术器械置入口供训练者使用，入路为密封切口设计，保障训练时不可通过腹部看到训练模块，训练者可以选择合适入路置入摄像系统或手术器械；摄像系统配套ABS固定器，可用于固定摄像系统在不同的手术器械置入口，训练时直接更换不同的摄像系统；兼容临床真实内窥镜及能力平台； 3.配备不低于500万像素的全高清摄像系统： ▲3.1.可通过鼠标一键切换摄像头角度0°、30°镜头视野；摄像系统镜杆尺寸与临床真实器械一致为10mm；（注：投标人投标时需提供功能截图） ▲3.2.摄像系统可以360°转动、可拉伸、可锁定，可在操作区域内进行全方位移动，练习扶镜手操作能力； 3.3.可通过鼠标调节镜头亮度、色差等技术参数及翻转摄像系统画面； ▲3.4.摄像系统可录制不低于25921944P分辨率全高清视频。 ▲3.5.摄像系统具备防水功能，可用于离体器官训练。 4.摄像系统在可视范围内固定焦距，镜头在可视范围内伸缩不影响画面视感，不闪屏对焦，对训练者使用不会造成视野误差； 5.摄像系统可以保证镜头与画面实现无延迟节奏，确保训练中手眼操作感受完全一致； ▲6.摄像系统视频采集使用无码转化流技术，通过转换器可实时捕捉镜头内容，时间误差不高于0.01s，可实现操作时截图、录像、储存功能； ▲7.多台设备可组成内局域网，实行多设备内容共享，可实时下载操作保存录像、截图；（注：投标人投标时需提供功能视频、产品照片） ▲8.配套电机升降台车，可根据训练者身高和舒适度自由调节操作台高度，台面高度距离地面为70-87cm可调；脚轮为带固定锁的静音滑轮，方便移动摆放；台车配备收纳抽屉及键盘支架，方便鼠标键盘及训练模块放置；台车侧面需带有器械放置孔位16个，可稳固手术器械的立式摆放； 9.配备不小于27英寸LED显示器系统，内置音箱广视角显示器： 9.1.分辨率：≥1920x1080 9.2.屏幕比例：≥16:9（宽屏） 9.3.面板类型：IPS 9.4.背光类型：LED背光 9.5.亮度：≥250cd/㎡ 9.6.可视角度：178/178° ▲9.7.色域：143%sRGB 9.8.刷新率：60Hz 9.9.视频接口：Sub（VGA），HDMI 9.10.有线网络接口：J45网口 9.11.无线功能：千兆双频WIFI、蓝牙4.2以上 ▲9.12.开放端口：USB3.0接口不少于2个、USB2.0接口不少于4个 9.13.底座功能：向左向右可旋转不低于90° 9.14.壁挂：支持100mm100mm壁挂支架。 ▲9.15. 512GB高速内存，读写500M/秒 ▲9.16. 16GB运行内存 10.配备训练操作模块套装 10.1.缝合打结模块：适用于缝合打结训练；3D立体仿真结构；训练模块柔软度手感真实；模拟组织各种切口；多种难度，增加实操经验；高度仿真实材料制造，模拟人体组织及立体伤口类型； 10.2.吻合模块：模拟腹腔内部肠管；进口硅胶，触感真实，仿真度高；可重复使用，进行多次练习； 10.3.钉转移模块：练习腹腔下手眼协调能力； 10.4.夹取模块：主要训练手术中对于细碎物的夹取，训练操作者夹取精准度和协调度； 10.5.穿隧道模块：穿孔模块针对训练协调能力培养训练操作者双手精准度； 10.6.精准剪切模块：训练指定内容的剪切； ▲10.7.标准化腹腔离体器官模型：帮助提高手术操作的技术水平和专业知识，从而提高手术的效果和减少术后并发症的发生。术式至少包括：肝门阻断、肝局部切除、肝叶切除、胆囊切除、胆肠吻合、胰体尾切除、胰肠吻合、脾切除、大部切除、各式胃肠吻合、胃穿孔修补、胃袖状切除、胃底食道折叠、肠段切除、肠肠吻合、各器官切除/重建步骤中的系膜游离、淋巴结清扫、血管裸化、结扎缝合。（注：投标人投标时需提供模块实物图及图解） 11.配有腹腔镜手术器械：1把持针器、1把弯剪刀、1把分离钳、1把无损伤抓钳。共4把手术器械； ▲12.配套临床及竞赛评分表，通过扫描二维码即可进行无纸化评分； ▲13.系统配备【训练模式】:（注：投标人投标时需提供功能截图） ▲13.1.【训练模式】集成包含30°镜头、操作者镜头、AI教师画面内容，画面内容可选择屏蔽或者部分屏蔽。 ▲13.2【训练模式】可同屏录制30°镜头、操作者镜头画面信息，并提供可回放功能。 ▲14.系统配备【竞赛模式】: ▲14.1.【竞赛模式】集成包含30°镜头、操作者镜头、活动水印、无纸化考评二维码、参赛者编号或名字画面内容、倒计时功能，画面内容可选择屏蔽或者部分屏蔽。 ▲14.2【竞赛模式】可一键录制参赛操作视频，并提供可回放功能；可一键截屏自动保存。 ▲14.3【竞赛模式】所有录制的视频，截图可通过网络分享或者储存设备进行复制，以便备份保管，作为有争议时的证据。 三、联网功能系统： 1.屏幕广播：将教师机屏幕和教师讲话实时广播给单一、部分或全体学生，可选择全屏或窗口方式。窗口模式下或教师机与学生机分辨率不同情况下，学生机可以以不同的窗口方式接收广播。 2.扩展屏广播模式：教师机连接两个显示器，可在广播时选择将任意一个显示器的内容广播到学生机。 3.网络影院：实现教师机播放的视频同步广播到学生机、实现教学内容同步。 4. 5.视频直播：通过USB摄像头将教师的画面实时广播到学生机，达到更形象的教学效果。 ▲6.学生演示：教师可选定一台学生机作为示范，由此学生代替教师进行示范教学。 7.屏幕录制：教师机可以将本地的操作和讲解过程录制为mp4录像文件，可以用 Windows 自带的 Media Player 直接播放。 8.学生端屏幕录制、回放：学生端接收教师端广播的时候可以自动录制教师机广播教学的过程，课后可以重复观看学习。 9.屏幕监视：教师机可以监视单一、部分、全体学生机的屏幕，教师机每屏可监视多个学生屏幕（最多36个）。可以控制教师机监控的同屏幕各窗口间、屏幕与屏幕间的切换速度。可手动或自动循环监视 11.系统日志：显示和自动保存系统运行过程中的关键事件，包括学生登录登出，资源不足，提交文件等。 12.远程命令及远程消息：可以进行远程开机、关机、重启等操作，支持远程打开网页、远程启动程序和远程关闭所有学生正在执行的应用程序；教师与学生能够使用远程消息进行交流；学生端遇到问题可请求帮助，教师端可远程遥控帮助学生解决问题。 13.整机保修3年或以上 四、配置要求： 1.模拟气腹腹腔体膜1套； 2.静音升降台车1套； 3.27英寸多功能集成显示系统主机1台； 4.无线鼠标键盘1套； 5.键盘支架1套； 6.摄像系统1套（可选0°镜头或30°镜头，默认30°镜头）； 7.摄像系统ABS固定器2个； 8.训练器械4把； 9.训练操作模块套装及离体器官托盘1套； 10.安装工具包1套； 11.说明书1本。

更多咨询报价请点击： https://www.easyjcx.com/#/auction/detail/189da766-7444-4246-98bc-45842f3ff6da
    '''
    _result = chat_doubao(msg,stream=True)
    print(_result)