
import json
from BaseDataMaintenance.dataSource.source import getConnect_ots,getConnect_ots_capacity
from BaseDataMaintenance.model.ots.document import Document
from BaseDataMaintenance.model.ots.document_tmp import *
from BaseDataMaintenance.common.multiThread import MultiThreadHandler
from queue import Queue
from BaseDataMaintenance.AIUtils.html2text import html2text_with_tablehtml
from BaseDataMaintenance.AIUtils.DoubaoUtils import chat_doubao,get_json_from_text
from BaseDataMaintenance.AIUtils.prompts import get_prompt_extract_role


def export_extract_ai():
    filename = r"C:\Users\Administrator\Desktop\extract_ai.txt"
    list_docid = []

    ots_client = getConnect_ots()
    with open(filename,"r",encoding="utf8") as f:
        while 1:
            line = f.readline()
            if not line:
                break
            line = line.strip()
            if line!="":
                try:
                    docid = line.split(":")[-1]
                    print(docid)
                    list_docid.append(int(docid))
                except Exception as e:
                    pass
    list_docid.reverse()
    import pandas as pd
    list_data = []
    for docid in list_docid:
        partitionkey = docid%500+1
        _d = {document_tmp_partitionkey:partitionkey,
              document_tmp_docid:docid}
        dtmp = Document(_d)
        if dtmp.fix_columns(ots_client,["extract_json_ai","docchannel"],True):
            docchannel = dtmp.getProperties().get("docchannel",0)
            extract_json_ai = dtmp.getProperties().get("extract_json_ai")
            if docchannel in (52,101,118,119,120,121,122) and extract_json_ai is not None and extract_json_ai!="":
                extract_ai = json.loads(extract_json_ai)
                data_d = {
                    "docid":docid,
                    "招标人":extract_ai.get("招标信息",{}).get("招标人名称",""),
                    "项目预算":extract_ai.get("招标信息",{}).get("项目预算",""),
                    "招标人联系方式":extract_ai.get("招标信息",{}).get("招标人联系方式",""),
                    "中标信息":extract_ai.get("中标信息","[]")
                }
                list_data.append(data_d)
                if len(list_data)>=200:
                    break
    df = pd.DataFrame(list_data)
    df.to_excel("%s.xlsx"%(filename))

def export_extract_ai1():
    filename = r"C:\Users\Administrator\Desktop\extract_ai.txt"
    list_docid = []
    ots_client = getConnect_ots()
    ots_capacity = getConnect_ots_capacity()
    with open(filename,"r",encoding="utf8") as f:
        while 1:
            line = f.readline()
            if not line:
                break
            line = line.strip()
            if line!="":
                try:
                    docid = line.split(":")[-1]
                    print(docid)
                    list_docid.append(int(docid))
                except Exception as e:
                    pass
    list_docid.reverse()
    import pandas as pd
    _count = 0
    task_queue = Queue()
    result_queue = Queue()
    _count = 0
    for docid in list_docid:
        task_queue.put(docid)
        _count += 1
        # if _count>=1000:
        #     break

    def get_ai_money(_text):
        b = re.search(r'[\d,，\.]+[亿万元人民币]+',str(_text))
        if b is not None:
            return b.group()

    def get_columns_from_extract(extract1):
        tenderee1 = extract1.get("招标信息",{}).get("招标人名称","")
        _budget1 = extract1.get("招标信息",{}).get("项目预算","")

        _win1 = extract1.get("中标信息",[])
        if len(_win1)==0:
            _win1 = {}
        else:
            _win1 = _win1[0]

        win_tenderer1 = _win1.get("中标人名称","")

        _win_price1 = _win1.get("中标金额","")
        if _win_price1 is not None and _win_price1!="":
            _win_price1 = getUnifyMoney(_win_price1)
            _win_price1 = str(float(_win_price1))
        return tenderee1,win_tenderer1,_budget1,_win_price1

    def clean_ai_entity(entity):
        if isinstance(entity,str):
            if re.search("(未|无)(明确|提及)|某(部|单位|医院|公司)|\*\*|XX|登录|详见|招标单位",entity) is not None:
                return ""
            if re.search("无|区|县|市|省|某|中心|部|公司",entity) is not None and len(entity)<=5:
                return ""
            return entity
        return ""

    def clean_ai_extract(_extract,_extract_ai):
        set_entitys = set()
        set_moneys = set()
        dict_enterprise = _extract.get("dict_enterprise",{})
        for k,v in dict_enterprise.items():
            set_entitys.add(str(k))
        for _money in _extract.get("moneys",[]):
            set_moneys.add(str(float(_money)))
        for _money in _extract.get("moneys_attachment",[]):
            set_moneys.add(str(float(_money)))

        _tenderee_dict = _extract_ai.get("招标信息",{})
        _tenderee_ai = _tenderee_dict.get("招标人名称")
        if _tenderee_ai is not None:
            _tenderee_ai = clean_ai_entity(_tenderee_ai)
            if _tenderee_ai in set_entitys:
                _tenderee_dict["招标人名称"] = _tenderee_ai
            else:
                _tenderee_dict["招标人名称"] = ""


        _budget = _tenderee_dict.get("项目预算")
        if _budget is not None:
            _budget = get_ai_money(_budget)
            if _budget is not None and _budget!="":
                _budget = getUnifyMoney(_budget)
                _budget = str(float(_budget))
                if _budget in set_moneys:
                    _tenderee_dict["项目预算"] = _budget
                else:
                    _tenderee_dict["项目预算"] = ""
            else:
                _tenderee_dict["项目预算"] = ""

        list_win = _extract_ai.get("中标信息",[])

        for _win_dict_i in range(len(list_win)):
            _win_dict = list_win[_win_dict_i]
            _pack = _win_dict.get("标段号","")
            if _pack=="":
                if len(list_win)>1:
                    _pack = "AI_%d"%(_win_dict_i)
                else:
                    _pack = "Project"
            _win_money = _win_dict.get("中标金额")
            _win_money = get_ai_money(_win_money)
            if _win_money is not None and _win_money!="":
                _win_money = getUnifyMoney(_win_money)
                _win_money = str(float(_win_money))
                if _win_money in set_moneys:
                    _win_dict["中标金额"] = _win_money
                else:
                    _win_dict["中标金额"] = ""
            else:
                _win_dict["中标金额"] = ""
            _win_tenderer = _win_dict.get("中标人名称")
            _win_tenderer = clean_ai_entity(_win_tenderer)
            if _win_tenderer in set_entitys:
                _win_dict["中标人名称"] = _win_tenderer
            else:
                _win_dict["中标人名称"] = ""

    def handle(docid,result_queue):
        partitionkey = docid%500+1
        _d = {document_tmp_partitionkey:partitionkey,
              document_tmp_docid:docid}
        dtmp = Document(_d)
        if dtmp.fix_columns(ots_client,["extract_json","docchannel","extract_json_ai"],True):

            # if not dtmp.getProperties().get("docchannel",0) in (52,101,118,119,120,121,122):
            #     return


            _dochtmlcon = dtmp.getProperties().get("dochtmlcon","")
            _text = html2text_with_tablehtml(_dochtmlcon)

            msg = get_prompt_extract_role(_text)

            extract_json = dtmp.getProperties().get("extract_json","{}")
            _extract = json.loads(extract_json)

            #model_name = "ep-20250212111145-fflr7" #1.5pro 256k
            #model_name = "ep-20250314164242-jd62g" #1.5pro 32k
            # result = chat_doubao(msg,model_name='ep-20250212111145-fflr7')

            # _json_256k = get_json_from_text(result)
            # _extract_ai_256k = {}
            #
            #
            # if _json_256k is not None:
            #     try:
            #         _extract_ai_256k = json.loads(_json_256k)
            #     except Exception as e:
            #         pass
            #
            # result = chat_doubao(msg,model_name='ep-20250314164242-jd62g')
            #
            # _json_32k = get_json_from_text(result)
            _json_32k = dtmp.getProperties().get("extract_json_ai","{}")
            _extract_ai_32k = {}

            if _json_32k is not None:
                try:
                    _extract_ai_32k = json.loads(_json_32k)
                except Exception as e:
                    pass
            # clean_ai_extract(_extract,_extract_ai_256k)
            clean_ai_extract(_extract,_extract_ai_32k)
            # tenderee1,win_tenderer1,_budget1,_win_price1 = get_columns_from_extract(_extract_ai_256k)
            tenderee2,win_tenderer2,_budget2,_win_price2 = get_columns_from_extract(_extract_ai_32k)
            _d = {
                "docid":docid,
                # "extract_ai_256k":_json_256k,
                # "招标人_256k":tenderee1,
                # "项目预算_256k":_budget1,
                # "中标人_256k":win_tenderer1,
                # "中标金额_256k":_win_price1,
                "extract_ai_32k":_json_32k,
                "招标人_32k":tenderee2,
                "项目预算_32k":_budget2,
                "中标人_32k":win_tenderer2,
                "中标金额_32k":_win_price2,
                # "招标人对比":tenderee1==tenderee2,
                # "中标人对比":win_tenderer1==win_tenderer2,
                # "项目预算对比":_budget1==_budget2,
                # "中标金额对比":_win_price1==_win_price2
            }
            result_queue.put(_d)

    # a = '''
    # {"addr_dic": {}, "aptitude": "", "attachmentTypes": "", "bid_score": [], "bidway": "", "candidate": "宁波海曙宏远汽车检测设备有限公司", "code": ["2025-JLXLBS-W3001"], "code_investment": "", "cost_time": {"attrs": 0.05, "codename": 0.03, "deposit": 0.0, "district": 0.1, "kvtree": 0.04, "moneygrade": 0.0, "nerToken": 0.05, "outline": 0.02, "pb_extract": 0.14, "person": 0.0, "prem": 0.03, "preprocess": 0.11, "product": 0.03, "product_attrs": 0.01, "roleRuleFinal": 0.01, "rolegrade": 0.0, "rule": 0.0, "rule_channel": 0.02, "rule_channel2": 0.29, "tableToText": 0.03000166893005371, "tendereeRuleRecall": 0.0, "time": 0.01, "total_unit_money": 0.0}, "demand_info": {"data": [], "header": [], "header_col": []}, "deposit_patment_way": "", "dict_enterprise": {"宁波海曙宏远汽车检测设备有限公司": {"credit_code": "9133020357050581XA", "in_text": 1}}, "district": {"area": "西北", "city": "未知", "district": "未知", "is_in_text": false, "province": "甘肃"}, "docchannel": {"docchannel": "中标信息", "doctype": "采招数据", "life_docchannel": "中标信息", "use_original_docchannel": 0}, "docid": "", "doctitle_refine": "甘肃某单位空压机及配套设备管路项目", "exist_table": 1, "extract_count": 9, "fail_reason": "", "fingerprint": "md5=efd4d94fefc77cc6a8a4bed218f44085", "industry": {"class": "零售批发", "class_name": "机械设备", "subclass": "通用设备"}, "is_deposit_project": false, "label_dic": {}, "match_enterprise": [], "match_enterprise_type": 0, "moneys": [196000.0], "moneys_attachment": [], "moneysource": "", "name": "甘肃某单位空压机及配套设备管路采购项目", "nlp_enterprise": ["宁波海曙宏远汽车检测设备有限公司"], "nlp_enterprise_attachment": [], "pb": {"project_name_refind": "甘肃某单位空压机及配套设备管路采购", "project_property": "新建"}, "pb_project_name": "甘肃某单位空压机及配套设备管路采购", "person_review": [], "pinmu_name": "", "policies": [], "prem": {"1": {"code": "", "in_attachment": false, "name": "甘肃某单位空压机及配套设备管路采购项目", "roleList": [{"address": "", "linklist": [], "role_money": {"discount_ratio": "", "downward_floating_ratio": "", "floating_ratio": "", "money": "196000.00000000", "money_unit": "元"}, "role_name": "win_tenderer", "role_prob": 0.9499475598335266, "role_text": "宁波海曙宏远汽车检测设备有限公司", "serviceTime": ""}], "tendereeMoney": 0, "tendereeMoneyUnit": ""}, "Project": {"roleList": [{"role_name": "tenderee", "role_text": "甘肃某单位", "linklist": [["", "180********3904"]]}]}}, "process_time": "2025-03-13 13:46:21", "product": ["空压机及配套设备管路"], "product_attrs": {"data": [], "header": [], "header_col": []}, "project_contacts": [], "project_label": {"标题": {}, "核心字段": {}}, "property_label": "", "proportion": "", "requirement": "", "serviceTime": {"service_days": 0, "service_end": "", "service_start": ""}, "success": true, "time_bidclose": "", "time_bidopen": "", "time_bidstart": "", "time_commencement": "", "time_completion": "", "time_contractEnd": "", "time_contractStart": "", "time_earnestMoneyEnd": "", "time_earnestMoneyStart": "", "time_getFileEnd": "", "time_getFileStart": "", "time_listingEnd": "", "time_listingStart": "", "time_planned": "", "time_publicityEnd": "", "time_publicityStart": "", "time_registrationEnd": "", "time_registrationStart": "", "time_release": "2025-03-13", "time_signContract": "", "total_tendereeMoney": 0, "total_tendereeMoneyUnit": "", "version_date": "2025-03-10", "word_count": {"正文": 352, "附件": 0}}
    # '''
    # b = '''
    # {"招标信息": {"招标人名称": "甘肃某单位", "项目预算": "", "招标人联系方式": [{"联系人": "", "联系电话": "180********3904"}]}, "中标信息": [{"中标人名称": "宁波海曙宏远汽车检测设备有限公司", "中标金额": "196000.00元", "标段号": "001"}]}
    # '''
    # _extract = json.loads(a)
    # _extract_ai = json.loads(b)
    # clean_ai_extract(_extract,_extract_ai)
    # print(_extract_ai)

    mt = MultiThreadHandler(task_queue,handle,result_queue,5)
    mt.run()
    list_data = []
    while 1:
        try:
            _d = result_queue.get(timeout=1)
            list_data.append(_d)
        except Exception as e:
            break


    df = pd.DataFrame(list_data)
    df.to_excel("%s.xlsx"%(filename))

if __name__ == '__main__':
    # export_extract_ai()
    export_extract_ai1()