#coding:utf8
# API 端点
import json
import requests

url = "http://120.132.118.205:21000/api/generate"

models = {
    "qwq:32b": "qwq:32b",
    "deepseek-r1:7b": "deepseek-r1:7b",
    "deepseek-r1:1.5b": "deepseek-r1:1.5b",
  }

def request_llm(prompt, model="deepseek-r1:1.5b"):
    # 请求数据
    data = {
        "model": model,
        "prompt": prompt,
        "stream": False,
        'temperature': 0.6,
        'top_p': 0.95,
        'min_p': 0,
        "options": {
            "num_ctx": 4096
        }
    }

    # 发送 POST 请求
    response = requests.post(url, json=data)

    # 检查响应状态码
    if response.status_code == 200:
        result = response.json()
        return_text = result["response"]
        return_text = json.dumps(return_text, ensure_ascii=False)
        return_text = json.loads(return_text)
        token_count = result["eval_count"]
        cost_time = result["eval_duration"]
        cost_time = round(cost_time / 1e9, 2)
        speed = token_count / cost_time
        print(f'回答tokens数{token_count}, 耗时{cost_time} s, 速度{speed} tokens/s')
    else:
        print(f"请求失败，状态码: {response.status_code}，错误信息: {response.text}")
        return_text = response.text
    return response.status_code, return_text


if __name__ == '__main__':

    a = '''

一、 *采购人名称：桐城市东关小学

二、 *履约供应商名称：桐城市博瑞电脑器材销售有限公司

三、 *采购项目编号：2971451000000741040

四、 *合同编号:30974996

五、 *验收单位：桐城市东关小学

六、 *验收日期：2025年3月26日

七、 *验收结果：

序号	服务内容	验收数量	验收金额(元)	验收标准\规格型号\技术标准	验收结果	备注
1	得力 卡纸 卡纸	2	90.0	得力/deli\卡纸	验收通过	
2	斯伯丁 83-218Y 篮球	2	530.0	斯伯丁/Spalding\83-218Y	验收通过	
3	得力 24830 奖状/证书	600	1200.0	得力/deli\24830	验收通过	
4	得力 党员徽章 铭牌	32	160.0	得力/deli\党员徽章	验收通过	
5	梅花 挂锁 挂锁	20	120.0	梅花\挂锁	验收通过	
6	梅花 挂锁 挂锁	10	120.0	梅花\挂锁	验收通过	
7	威露士 健康抑菌洗手液 洗手液	24	360.0	威露士/Walch\健康抑菌洗手液	验收通过	
8	得力 名片盒/本/夹/册	10	480.0	得力/deli\A5皮面记事本	验收通过	
9	得力 名片盒/本/夹/册	80	1600.0	得力/deli\16K皮面记事本	验收通过	
10	得力 名片盒/本/夹/册	150	1200.0	得力/deli\备课笔记本	验收通过	
11	得力 名片盒/本/夹/册	150	1050.0	得力/deli\听课笔记	验收通过	
12	晨光 名片盒/本/夹/册	20	120.0	晨光/M&G\会议记录本	验收通过	
13	航天 六角粉笔 粉笔	2	300.0	航天\六角粉笔	验收通过	
14	航天 六角粉笔 粉笔	4	400.0	航天\六角粉笔	验收通过	
15	妙洁 背心式垃圾袋大号 垃圾袋	1	750.0	妙洁/magic\背心式垃圾袋大号	验收通过	
16	妙洁 背心式垃圾袋大号 垃圾袋	1	500.0	妙洁/magic\背心式垃圾袋大号	验收通过	
17	得力 A3打印纸 打印/复印纸	4	1032.0	得力/deli\A3打印纸	验收通过	
18	得力 莱茵河 80g A4 打印/复印纸	7	1806.0	得力/deli\莱茵河 80g A4	验收通过	
19	柯尼卡美能达 TN119 粉盒	2	336.0	柯尼卡美能达/KONICA MINOLTA\TN119	验收通过	
20	得力 33415 档案袋	20	160.0	得力/deli\33415	验收通过	
21	得力 5910 档案袋	20	120.0	得力/deli\5910	验收通过	
22	得力 7103 胶水	84	252.0	得力/deli\7103	验收通过	
23	南孚 5号2粒（2代） 普通干电池	50	250.0	南孚/NANFU\5号2粒（2代）	验收通过	
24	公牛 GN-604-3米 多功能插座	5	340.0	公牛/BULL\GN-604-3米	验收通过	
25	公牛 GN-218 5m 多功能插座	3	234.0	公牛/BULL\GN-218 5m	验收通过	
26	上汇 0051 票夹/长尾夹	10	220.0	上汇\0051	验收通过	
27	南孚+7号5粒（4代）电池 普通干电池	100	250.0	南孚/NANFU\南孚+7号5粒（4代）电池	验收通过	
28	晨光 黑板擦	48	384.0	晨光/M&G\ASC99364	验收通过	
29	晨光 MG2160 白板笔	20	50.0	晨光/M&G\MG2160	验收通过	
30	晨光 APYVG608 复写纸	4	880.0	晨光/M&G\APYVG608	验收通过	
31	齐心 D4032 复写纸（粉色）	2	720.0	齐心/Comix\D4032	验收通过	
32	得力 9378 复写纸（大红色）	1	360.0	得力\9378	验收通过	
33	心相印 DT15100 抽纸	24	528.0	心相印/Mind Act Upon Mind\DT15100	验收通过	
34	晨光 8001A 中性笔芯	84	2100.0	晨光/M&G\8001A	验收通过	
35	晨光 8001A 中性笔芯	84	2100.0	晨光/M&G\8001A	验收通过	
36	舒肤佳 纯白清香型108g 香皂	30	180.0	舒肤佳/safeguard\纯白清香型108g	验收通过	
37	洁丽雅 7416 毛巾/面巾/方巾	30	600.0	洁丽雅/grace\7416	验收通过	
38	得力 S856 中性笔	12	432.0	得力/deli\S856	验收通过	
39	得力 硬面抄	60	240.0	得力/deli\T3272	验收通过	
40	得力 8591F 票夹/长尾夹	10	240.0	得力/deli\8591F	验收通过	
41	得力 33425 票夹/长尾夹	10	150.0	得力/deli\33425	验收通过	
42	齐心 AP-117 档案袋	200	200.0	齐心/Comix\AP-117	验收通过	
43	奔图 PD-206 硒鼓	4	580.0	奔图/Pantum\PD-206	验收通过	
44	得力 7304 胶水	24	144.0	得力/deli\7304	验收通过	
45	公牛 GN-609 1.8米 电源插座	5	225.0	公牛/BULL\GN-609 1.8米	验收通过	
46	晨光 ADM92990 档案盒	12	216.0	晨光/M&G\ADM92990	验收通过	
47	得力 1529 电子计算器	2	110.0	得力/deli\1529	验收通过	
48	得力 0037 回形针座/盒	20	50.0	得力/deli\0037	验收通过	
49	得力 0027 订书钉	20	40.0	得力/deli\0027	验收通过	
50	得力 0466 订书机	2	70.0	得力/deli\0466	验收通过	
51	得力 S128 中性笔签字笔	60	300.0	得力/deli\S128	验收通过	
52	得力 S128 中性笔签字笔	24	648.0	得力/deli\S128	验收通过	
53	齐心 A1457 档案盒	24	312.0	齐心/Comix\A1457	验收通过	
54	齐心 A1285 档案盒	24	360.0	齐心/Comix\A1285	验收通过	
55	金晨鸣 70g A4 打印/复印纸	12	2640.0	金晨鸣\70g A4	验收通过	
56	【运费】	1	0.0		验收通过	

验收报告：
验收人员名单： ah0881036011

提取出以上内容的中标人和中标金额
    '''
    code, answer = request_llm(a,model="deepseek-r1:14b")
    print(answer)