#coding:utf8
import json


class AreaGet():

    def __init__(self):
        areaJson = '''
        {"1": {"ctype": "10", "cname": "华北", "id": 1, "cdesc": "华北地区", "parentid": -1}, "2": {"ctype": "20", "cname": "北京", "id": 2, "cdesc": "北京市", "parentid": 1}, "3": {"ctype": "10", "cname": "华南", "id": 3, "cdesc": "华南地区", "parentid": -1}, "4": {"ctype": "20", "cname": "广东", "id": 4, "cdesc": "广东省", "parentid": 3}, "5": {"ctype": "20", "cname": "海南", "id": 5, "cdesc": "海南省", "parentid": 3}, "6": {"ctype": "20", "cname": "广西", "id": 6, "cdesc": "广西省", "parentid": 3}, "11": {"ctype": "10", "cname": "华东", "id": 11, "cdesc": "华东地区", "parentid": -1}, "12": {"ctype": "10", "cname": "华中", "id": 12, "cdesc": "华中地区", "parentid": -1}, "13": {"ctype": "10", "cname": "西南", "id": 13, "cdesc": "西南地区", "parentid": -1}, "14": {"ctype": "10", "cname": "东北", "id": 14, "cdesc": "东北地区", "parentid": -1}, "15": {"ctype": "10", "cname": "西北", "id": 15, "cdesc": "西北地区", "parentid": -1}, "16": {"ctype": "20", "cname": "天津", "id": 16, "cdesc": "天津市", "parentid": 1}, "17": {"ctype": "20", "cname": "河北", "id": 17, "cdesc": "河北省", "parentid": 1}, "18": {"ctype": "20", "cname": "山西", "id": 18, "cdesc": "山西省", "parentid": 1}, "19": {"ctype": "20", "cname": "内蒙古", "id": 19, "cdesc": "内蒙古省", "parentid": 1}, "20": {"ctype": "20", "cname": "上海", "id": 20, "cdesc": "上海市", "parentid": 11}, "21": {"ctype": "20", "cname": "江苏", "id": 21, "cdesc": "江苏省", "parentid": 11}, "22": {"ctype": "20", "cname": "浙江", "id": 22, "cdesc": "浙江省", "parentid": 11}, "23": {"ctype": "20", "cname": "安徽", "id": 23, "cdesc": "安徽省", "parentid": 11}, "24": {"ctype": "20", "cname": "福建", "id": 24, "cdesc": "福建省", "parentid": 11}, "25": {"ctype": "20", "cname": "江西", "id": 25, "cdesc": "江西省", "parentid": 11}, "26": {"ctype": "20", "cname": "山东", "id": 26, "cdesc": "山东省", "parentid": 11}, "27": {"ctype": "20", "cname": "河南", "id": 27, "cdesc": "河南省", "parentid": 12}, "28": {"ctype": "20", "cname": "湖北", "id": 28, "cdesc": "湖北省", "parentid": 12}, "29": {"ctype": "20", "cname": "湖南", "id": 29, "cdesc": "湖南省", "parentid": 12}, "30": {"ctype": "20", "cname": "重庆", "id": 30, "cdesc": "重庆市", "parentid": 13}, "31": {"ctype": "20", "cname": "四川", "id": 31, "cdesc": "四川省", "parentid": 13}, "32": {"ctype": "20", "cname": "贵州", "id": 32, "cdesc": "贵州省", "parentid": 13}, "33": {"ctype": "20", "cname": "云南", "id": 33, "cdesc": "云南省", "parentid": 13}, "34": {"ctype": "20", "cname": "西藏", "id": 34, "cdesc": "西藏省", "parentid": 13}, "35": {"ctype": "20", "cname": "黑龙江", "id": 35, "cdesc": "黑龙江省", "parentid": 14}, "36": {"ctype": "20", "cname": "辽宁", "id": 36, "cdesc": "辽宁省", "parentid": 14}, "37": {"ctype": "20", "cname": "吉林", "id": 37, "cdesc": "吉林省", "parentid": 14}, "38": {"ctype": "20", "cname": "陕西", "id": 38, "cdesc": "陕西省", "parentid": 15}, "39": {"ctype": "20", "cname": "甘肃", "id": 39, "cdesc": "甘肃省", "parentid": 15}, "40": {"ctype": "20", "cname": "青海", "id": 40, "cdesc": "青海省", "parentid": 15}, "41": {"ctype": "20", "cname": "宁夏", "id": 41, "cdesc": "宁夏省", "parentid": 15}, "42": {"ctype": "20", "cname": "新疆", "id": 42, "cdesc": "新疆省", "parentid": 15}, "51": {"ctype": "20", "cname": "全国", "id": 51, "cdesc": "全国", "parentid": -1}, "56": {"ctype": "30", "cname": "东城", "id": 56, "cdesc": "东城区", "parentid": 2}, "57": {"ctype": "30", "cname": "和平", "id": 57, "cdesc": "和平", "parentid": 16}, "58": {"ctype": "30", "cname": "石家庄", "id": 58, "cdesc": "石家庄市", "parentid": 17}, "59": {"ctype": "30", "cname": "唐山", "id": 59, "cdesc": "唐山市", "parentid": 17}, "60": {"ctype": "30", "cname": "秦皇岛", "id": 60, "cdesc": "秦皇岛市", "parentid": 17}, "61": {"ctype": "30", "cname": "邯郸", "id": 61, "cdesc": "邯郸市", "parentid": 17}, "62": {"ctype": "30", "cname": "邢台", "id": 62, "cdesc": "邢台市", "parentid": 17}, "63": {"ctype": "30", "cname": "保定", "id": 63, "cdesc": "保定市", "parentid": 17}, "64": {"ctype": "30", "cname": "张家口", "id": 64, "cdesc": "张家口市", "parentid": 17}, "65": {"ctype": "30", "cname": "承德", "id": 65, "cdesc": "承德市", "parentid": 17}, "66": {"ctype": "30", "cname": "沧州", "id": 66, "cdesc": "沧州市", "parentid": 17}, "67": {"ctype": "30", "cname": "廊坊", "id": 67, "cdesc": "廊坊市", "parentid": 17}, "68": {"ctype": "30", "cname": "衡水", "id": 68, "cdesc": "衡水市", "parentid": 17}, "69": {"ctype": "30", "cname": "太原", "id": 69, "cdesc": "太原市", "parentid": 18}, "70": {"ctype": "30", "cname": "大同", "id": 70, "cdesc": "大同市", "parentid": 18}, "71": {"ctype": "30", "cname": "阳泉", "id": 71, "cdesc": "阳泉市", "parentid": 18}, "72": {"ctype": "30", "cname": "长治", "id": 72, "cdesc": "长治市", "parentid": 18}, "73": {"ctype": "30", "cname": "晋城", "id": 73, "cdesc": "晋城市", "parentid": 18}, "74": {"ctype": "30", "cname": "朔州", "id": 74, "cdesc": "朔州市", "parentid": 18}, "75": {"ctype": "30", "cname": "晋中", "id": 75, "cdesc": "晋中市", "parentid": 18}, "76": {"ctype": "30", "cname": "运城", "id": 76, "cdesc": "运城市", "parentid": 18}, "77": {"ctype": "30", "cname": "忻州", "id": 77, "cdesc": "忻州市", "parentid": 18}, "78": {"ctype": "30", "cname": "临汾", "id": 78, "cdesc": "临汾市", "parentid": 18}, "79": {"ctype": "30", "cname": "吕梁", "id": 79, "cdesc": "吕梁市", "parentid": 18}, "80": {"ctype": "30", "cname": "呼和浩特", "id": 80, "cdesc": "呼和浩特市", "parentid": 19}, "81": {"ctype": "30", "cname": "包头", "id": 81, "cdesc": "包头市", "parentid": 19}, "82": {"ctype": "30", "cname": "乌海", "id": 82, "cdesc": "乌海市", "parentid": 19}, "83": {"ctype": "30", "cname": "赤峰", "id": 83, "cdesc": "赤峰市", "parentid": 19}, "84": {"ctype": "30", "cname": "通辽", "id": 84, "cdesc": "通辽市", "parentid": 19}, "85": {"ctype": "30", "cname": "鄂尔多斯", "id": 85, "cdesc": "鄂尔多斯市", "parentid": 19}, "86": {"ctype": "30", "cname": "呼伦贝尔", "id": 86, "cdesc": "呼伦贝尔市", "parentid": 19}, "87": {"ctype": "30", "cname": "巴彦淖尔", "id": 87, "cdesc": "巴彦淖尔市", "parentid": 19}, "88": {"ctype": "30", "cname": "乌兰察布", "id": 88, "cdesc": "乌兰察布市", "parentid": 19}, "89": {"ctype": "30", "cname": "兴安盟", "id": 89, "cdesc": "兴安盟市", "parentid": 19}, "90": {"ctype": "30", "cname": "锡林郭勒盟", "id": 90, "cdesc": "锡林郭勒盟市", "parentid": 19}, "91": {"ctype": "30", "cname": "阿拉善盟", "id": 91, "cdesc": "阿拉善盟市", "parentid": 19}, "92": {"ctype": "30", "cname": "广州", "id": 92, "cdesc": "广州市", "parentid": 4}, "93": {"ctype": "30", "cname": "韶关", "id": 93, "cdesc": "韶关市", "parentid": 4}, "94": {"ctype": "30", "cname": "深圳", "id": 94, "cdesc": "深圳市", "parentid": 4}, "95": {"ctype": "30", "cname": "珠海", "id": 95, "cdesc": "珠海市", "parentid": 4}, "96": {"ctype": "30", "cname": "汕头", "id": 96, "cdesc": "汕头市", "parentid": 4}, "97": {"ctype": "30", "cname": "佛山", "id": 97, "cdesc": "佛山市", "parentid": 4}, "98": {"ctype": "30", "cname": "江门", "id": 98, "cdesc": "江门市", "parentid": 4}, "99": {"ctype": "30", "cname": "湛江", "id": 99, "cdesc": "湛江市", "parentid": 4}, "100": {"ctype": "30", "cname": "茂名", "id": 100, "cdesc": "茂名市", "parentid": 4}, "101": {"ctype": "30", "cname": "肇庆", "id": 101, "cdesc": "肇庆市", "parentid": 4}, "102": {"ctype": "30", "cname": "惠州", "id": 102, "cdesc": "惠州市", "parentid": 4}, "103": {"ctype": "30", "cname": "梅州", "id": 103, "cdesc": "梅州市", "parentid": 4}, "104": {"ctype": "30", "cname": "汕尾", "id": 104, "cdesc": "汕尾市", "parentid": 4}, "105": {"ctype": "30", "cname": "河源", "id": 105, "cdesc": "河源市", "parentid": 4}, "106": {"ctype": "30", "cname": "阳江", "id": 106, "cdesc": "阳江市", "parentid": 4}, "107": {"ctype": "30", "cname": "清远", "id": 107, "cdesc": "清远市", "parentid": 4}, "108": {"ctype": "30", "cname": "潮州", "id": 108, "cdesc": "潮州市", "parentid": 4}, "109": {"ctype": "30", "cname": "揭阳", "id": 109, "cdesc": "揭阳市", "parentid": 4}, "110": {"ctype": "30", "cname": "云浮", "id": 110, "cdesc": "云浮市", "parentid": 4}, "112": {"ctype": "30", "cname": "海口", "id": 112, "cdesc": "海口市", "parentid": 5}, "113": {"ctype": "30", "cname": "三亚", "id": 113, "cdesc": "三亚市", "parentid": 5}, "114": {"ctype": "30", "cname": "南宁", "id": 114, "cdesc": "南宁市", "parentid": 6}, "115": {"ctype": "30", "cname": "直辖县级行政单位", "id": 115, "cdesc": "直辖县级行政单位", "parentid": 5}, "116": {"ctype": "30", "cname": "柳州", "id": 116, "cdesc": "柳州市", "parentid": 6}, "117": {"ctype": "30", "cname": "桂林", "id": 117, "cdesc": "桂林市", "parentid": 6}, "118": {"ctype": "30", "cname": "梧州", "id": 118, "cdesc": "梧州市", "parentid": 6}, "119": {"ctype": "30", "cname": "北海", "id": 119, "cdesc": "北海市", "parentid": 6}, "120": {"ctype": "30", "cname": "防城港", "id": 120, "cdesc": "防城港市", "parentid": 6}, "121": {"ctype": "30", "cname": "钦州", "id": 121, "cdesc": "钦州市", "parentid": 6}, "122": {"ctype": "30", "cname": "贵港", "id": 122, "cdesc": "贵港市", "parentid": 6}, "123": {"ctype": "30", "cname": "玉林", "id": 123, "cdesc": "玉林市", "parentid": 6}, "124": {"ctype": "30", "cname": "百色", "id": 124, "cdesc": "百色市", "parentid": 6}, "125": {"ctype": "30", "cname": "贺州", "id": 125, "cdesc": "贺州市", "parentid": 6}, "126": {"ctype": "30", "cname": "河池", "id": 126, "cdesc": "河池市", "parentid": 6}, "127": {"ctype": "30", "cname": "来宾", "id": 127, "cdesc": "来宾市", "parentid": 6}, "128": {"ctype": "30", "cname": "崇左", "id": 128, "cdesc": "崇左市", "parentid": 6}, "129": {"ctype": "30", "cname": "黄浦", "id": 129, "cdesc": "黄浦", "parentid": 20}, "130": {"ctype": "30", "cname": "南京", "id": 130, "cdesc": "南京市", "parentid": 21}, "131": {"ctype": "30", "cname": "无锡", "id": 131, "cdesc": "无锡市", "parentid": 21}, "132": {"ctype": "30", "cname": "徐州", "id": 132, "cdesc": "徐州市", "parentid": 21}, "133": {"ctype": "30", "cname": "常州", "id": 133, "cdesc": "常州市", "parentid": 21}, "134": {"ctype": "30", "cname": "苏州", "id": 134, "cdesc": "苏州市", "parentid": 21}, "135": {"ctype": "30", "cname": "南通", "id": 135, "cdesc": "南通市", "parentid": 21}, "136": {"ctype": "30", "cname": "连云港", "id": 136, "cdesc": "连云港市", "parentid": 21}, "137": {"ctype": "30", "cname": "淮安", "id": 137, "cdesc": "淮安市", "parentid": 21}, "138": {"ctype": "30", "cname": "盐城", "id": 138, "cdesc": "盐城市", "parentid": 21}, "139": {"ctype": "30", "cname": "扬州", "id": 139, "cdesc": "扬州市", "parentid": 21}, "140": {"ctype": "30", "cname": "镇江", "id": 140, "cdesc": "镇江市", "parentid": 21}, "141": {"ctype": "30", "cname": "泰州", "id": 141, "cdesc": "泰州市", "parentid": 21}, "142": {"ctype": "30", "cname": "宿迁", "id": 142, "cdesc": "宿迁市", "parentid": 21}, "143": {"ctype": "30", "cname": "杭州", "id": 143, "cdesc": "杭州市", "parentid": 22}, "144": {"ctype": "30", "cname": "宁波", "id": 144, "cdesc": "宁波市", "parentid": 22}, "145": {"ctype": "30", "cname": "温州", "id": 145, "cdesc": "温州市", "parentid": 22}, "146": {"ctype": "30", "cname": "嘉兴", "id": 146, "cdesc": "嘉兴市", "parentid": 22}, "147": {"ctype": "30", "cname": "湖州", "id": 147, "cdesc": "湖州市", "parentid": 22}, "148": {"ctype": "30", "cname": "绍兴", "id": 148, "cdesc": "绍兴市", "parentid": 22}, "149": {"ctype": "30", "cname": "金华", "id": 149, "cdesc": "金华市", "parentid": 22}, "150": {"ctype": "30", "cname": "衢州", "id": 150, "cdesc": "衢州市", "parentid": 22}, "151": {"ctype": "30", "cname": "舟山", "id": 151, "cdesc": "舟山市", "parentid": 22}, "152": {"ctype": "30", "cname": "台州", "id": 152, "cdesc": "台州市", "parentid": 22}, "153": {"ctype": "30", "cname": "丽水", "id": 153, "cdesc": "丽水市", "parentid": 22}, "154": {"ctype": "30", "cname": "合肥", "id": 154, "cdesc": "合肥市", "parentid": 23}, "155": {"ctype": "30", "cname": "芜湖", "id": 155, "cdesc": "芜湖市", "parentid": 23}, "156": {"ctype": "30", "cname": "蚌埠", "id": 156, "cdesc": "蚌埠市", "parentid": 23}, "157": {"ctype": "30", "cname": "淮南", "id": 157, "cdesc": "淮南市", "parentid": 23}, "158": {"ctype": "30", "cname": "马鞍山", "id": 158, "cdesc": "马鞍山市", "parentid": 23}, "159": {"ctype": "30", "cname": "淮北", "id": 159, "cdesc": "淮北市", "parentid": 23}, "160": {"ctype": "30", "cname": "铜陵", "id": 160, "cdesc": "铜陵市", "parentid": 23}, "161": {"ctype": "30", "cname": "安庆", "id": 161, "cdesc": "安庆市", "parentid": 23}, "162": {"ctype": "30", "cname": "黄山", "id": 162, "cdesc": "黄山市", "parentid": 23}, "163": {"ctype": "30", "cname": "滁州", "id": 163, "cdesc": "滁州市", "parentid": 23}, "164": {"ctype": "30", "cname": "阜阳", "id": 164, "cdesc": "阜阳市", "parentid": 23}, "165": {"ctype": "30", "cname": "宿州", "id": 165, "cdesc": "宿州市", "parentid": 23}, "166": {"ctype": "30", "cname": "巢湖", "id": 166, "cdesc": "巢湖市", "parentid": 23}, "167": {"ctype": "30", "cname": "六安", "id": 167, "cdesc": "六安市", "parentid": 23}, "168": {"ctype": "30", "cname": "亳州", "id": 168, "cdesc": "亳州市", "parentid": 23}, "169": {"ctype": "30", "cname": "池州", "id": 169, "cdesc": "池州市", "parentid": 23}, "170": {"ctype": "30", "cname": "宣城", "id": 170, "cdesc": "宣城市", "parentid": 23}, "171": {"ctype": "30", "cname": "福州", "id": 171, "cdesc": "福州市", "parentid": 24}, "172": {"ctype": "30", "cname": "厦门", "id": 172, "cdesc": "厦门市", "parentid": 24}, "173": {"ctype": "30", "cname": "莆田", "id": 173, "cdesc": "莆田市", "parentid": 24}, "174": {"ctype": "30", "cname": "三明", "id": 174, "cdesc": "三明市", "parentid": 24}, "175": {"ctype": "30", "cname": "泉州", "id": 175, "cdesc": "泉州市", "parentid": 24}, "176": {"ctype": "30", "cname": "漳州", "id": 176, "cdesc": "漳州市", "parentid": 24}, "177": {"ctype": "30", "cname": "南平", "id": 177, "cdesc": "南平市", "parentid": 24}, "178": {"ctype": "30", "cname": "龙岩", "id": 178, "cdesc": "龙岩市", "parentid": 24}, "179": {"ctype": "30", "cname": "宁德", "id": 179, "cdesc": "宁德市", "parentid": 24}, "180": {"ctype": "30", "cname": "南昌", "id": 180, "cdesc": "南昌市", "parentid": 25}, "181": {"ctype": "30", "cname": "景德镇", "id": 181, "cdesc": "景德镇市", "parentid": 25}, "182": {"ctype": "30", "cname": "萍乡", "id": 182, "cdesc": "萍乡市", "parentid": 25}, "183": {"ctype": "30", "cname": "九江", "id": 183, "cdesc": "九江市", "parentid": 25}, "184": {"ctype": "30", "cname": "新余", "id": 184, "cdesc": "新余市", "parentid": 25}, "185": {"ctype": "30", "cname": "鹰潭", "id": 185, "cdesc": "鹰潭市", "parentid": 25}, "186": {"ctype": "30", "cname": "赣州", "id": 186, "cdesc": "赣州市", "parentid": 25}, "187": {"ctype": "30", "cname": "吉安", "id": 187, "cdesc": "吉安市", "parentid": 25}, "188": {"ctype": "30", "cname": "宜春", "id": 188, "cdesc": "宜春市", "parentid": 25}, "189": {"ctype": "30", "cname": "抚州", "id": 189, "cdesc": "抚州市", "parentid": 25}, "190": {"ctype": "30", "cname": "上饶", "id": 190, "cdesc": "上饶市", "parentid": 25}, "191": {"ctype": "30", "cname": "济南", "id": 191, "cdesc": "济南市", "parentid": 26}, "192": {"ctype": "30", "cname": "青岛", "id": 192, "cdesc": "青岛市", "parentid": 26}, "193": {"ctype": "30", "cname": "淄博", "id": 193, "cdesc": "淄博市", "parentid": 26}, "194": {"ctype": "30", "cname": "枣庄", "id": 194, "cdesc": "枣庄市", "parentid": 26}, "195": {"ctype": "30", "cname": "东营", "id": 195, "cdesc": "东营市", "parentid": 26}, "196": {"ctype": "30", "cname": "烟台", "id": 196, "cdesc": "烟台市", "parentid": 26}, "197": {"ctype": "30", "cname": "潍坊", "id": 197, "cdesc": "潍坊市", "parentid": 26}, "198": {"ctype": "30", "cname": "济宁", "id": 198, "cdesc": "济宁市", "parentid": 26}, "199": {"ctype": "30", "cname": "泰安", "id": 199, "cdesc": "泰安市", "parentid": 26}, "200": {"ctype": "30", "cname": "威海", "id": 200, "cdesc": "威海市", "parentid": 26}, "201": {"ctype": "30", "cname": "日照", "id": 201, "cdesc": "日照市", "parentid": 26}, "202": {"ctype": "30", "cname": "莱芜", "id": 202, "cdesc": "莱芜市", "parentid": 26}, "203": {"ctype": "30", "cname": "临沂", "id": 203, "cdesc": "临沂市", "parentid": 26}, "204": {"ctype": "30", "cname": "德州", "id": 204, "cdesc": "德州市", "parentid": 26}, "205": {"ctype": "30", "cname": "聊城", "id": 205, "cdesc": "聊城市", "parentid": 26}, "206": {"ctype": "30", "cname": "滨州", "id": 206, "cdesc": "滨州市", "parentid": 26}, "207": {"ctype": "30", "cname": "菏泽", "id": 207, "cdesc": "菏泽市", "parentid": 26}, "208": {"ctype": "30", "cname": "郑州", "id": 208, "cdesc": "郑州市", "parentid": 27}, "209": {"ctype": "30", "cname": "开封", "id": 209, "cdesc": "开封市", "parentid": 27}, "210": {"ctype": "30", "cname": "洛阳", "id": 210, "cdesc": "洛阳市", "parentid": 27}, "211": {"ctype": "30", "cname": "平顶山", "id": 211, "cdesc": "平顶山市", "parentid": 27}, "212": {"ctype": "30", "cname": "安阳", "id": 212, "cdesc": "安阳市", "parentid": 27}, "213": {"ctype": "30", "cname": "鹤壁", "id": 213, "cdesc": "鹤壁市", "parentid": 27}, "214": {"ctype": "30", "cname": "新乡", "id": 214, "cdesc": "新乡市", "parentid": 27}, "215": {"ctype": "30", "cname": "焦作", "id": 215, "cdesc": "焦作市", "parentid": 27}, "216": {"ctype": "30", "cname": "濮阳", "id": 216, "cdesc": "濮阳市", "parentid": 27}, "217": {"ctype": "30", "cname": "许昌", "id": 217, "cdesc": "许昌市", "parentid": 27}, "218": {"ctype": "30", "cname": "漯河", "id": 218, "cdesc": "漯河市", "parentid": 27}, "219": {"ctype": "30", "cname": "三门峡", "id": 219, "cdesc": "三门峡市", "parentid": 27}, "220": {"ctype": "30", "cname": "南阳", "id": 220, "cdesc": "南阳市", "parentid": 27}, "221": {"ctype": "30", "cname": "商丘", "id": 221, "cdesc": "商丘市", "parentid": 27}, "222": {"ctype": "30", "cname": "信阳", "id": 222, "cdesc": "信阳市", "parentid": 27}, "223": {"ctype": "30", "cname": "周口", "id": 223, "cdesc": "周口市", "parentid": 27}, "224": {"ctype": "30", "cname": "驻马店", "id": 224, "cdesc": "驻马店市", "parentid": 27}, "225": {"ctype": "30", "cname": "武汉", "id": 225, "cdesc": "武汉市", "parentid": 28}, "226": {"ctype": "30", "cname": "黄石", "id": 226, "cdesc": "黄石市", "parentid": 28}, "227": {"ctype": "30", "cname": "十堰", "id": 227, "cdesc": "十堰市", "parentid": 28}, "228": {"ctype": "30", "cname": "宜昌", "id": 228, "cdesc": "宜昌市", "parentid": 28}, "229": {"ctype": "30", "cname": "襄阳", "id": 229, "cdesc": "襄阳市", "parentid": 28}, "230": {"ctype": "30", "cname": "鄂州", "id": 230, "cdesc": "鄂州市", "parentid": 28}, "231": {"ctype": "30", "cname": "荆门", "id": 231, "cdesc": "荆门市", "parentid": 28}, "232": {"ctype": "30", "cname": "孝感", "id": 232, "cdesc": "孝感市", "parentid": 28}, "233": {"ctype": "30", "cname": "荆州", "id": 233, "cdesc": "荆州市", "parentid": 28}, "234": {"ctype": "30", "cname": "黄冈", "id": 234, "cdesc": "黄冈市", "parentid": 28}, "235": {"ctype": "30", "cname": "咸宁", "id": 235, "cdesc": "咸宁市", "parentid": 28}, "236": {"ctype": "30", "cname": "随州", "id": 236, "cdesc": "随州市", "parentid": 28}, "237": {"ctype": "30", "cname": "恩施土家族", "id": 237, "cdesc": "恩施土家族", "parentid": 28}, "238": {"ctype": "30", "cname": "直辖行政单位", "id": 238, "cdesc": "直辖行政单位", "parentid": 28}, "239": {"ctype": "30", "cname": "长沙", "id": 239, "cdesc": "长沙市", "parentid": 29}, "240": {"ctype": "30", "cname": "株洲", "id": 240, "cdesc": "株洲市", "parentid": 29}, "241": {"ctype": "30", "cname": "湘潭", "id": 241, "cdesc": "湘潭市", "parentid": 29}, "242": {"ctype": "30", "cname": "衡阳", "id": 242, "cdesc": "衡阳市", "parentid": 29}, "243": {"ctype": "30", "cname": "邵阳", "id": 243, "cdesc": "邵阳市", "parentid": 29}, "244": {"ctype": "30", "cname": "岳阳", "id": 244, "cdesc": "岳阳市", "parentid": 29}, "245": {"ctype": "30", "cname": "常德", "id": 245, "cdesc": "常德市", "parentid": 29}, "246": {"ctype": "30", "cname": "张家界", "id": 246, "cdesc": "张家界市", "parentid": 29}, "247": {"ctype": "30", "cname": "益阳", "id": 247, "cdesc": "益阳市", "parentid": 29}, "248": {"ctype": "30", "cname": "郴州", "id": 248, "cdesc": "郴州市", "parentid": 29}, "249": {"ctype": "30", "cname": "永州", "id": 249, "cdesc": "永州市", "parentid": 29}, "250": {"ctype": "30", "cname": "怀化", "id": 250, "cdesc": "怀化市", "parentid": 29}, "251": {"ctype": "30", "cname": "娄底", "id": 251, "cdesc": "娄底市", "parentid": 29}, "252": {"ctype": "30", "cname": "湘西土家族", "id": 252, "cdesc": "湘西土家族", "parentid": 29}, "253": {"ctype": "30", "cname": "万州", "id": 253, "cdesc": "万州", "parentid": 30}, "254": {"ctype": "30", "cname": "成都", "id": 254, "cdesc": "成都市", "parentid": 31}, "255": {"ctype": "30", "cname": "自贡", "id": 255, "cdesc": "自贡市", "parentid": 31}, "256": {"ctype": "30", "cname": "攀枝花", "id": 256, "cdesc": "攀枝花市", "parentid": 31}, "257": {"ctype": "30", "cname": "泸州", "id": 257, "cdesc": "泸州市", "parentid": 31}, "258": {"ctype": "30", "cname": "德阳", "id": 258, "cdesc": "德阳市", "parentid": 31}, "259": {"ctype": "30", "cname": "绵阳", "id": 259, "cdesc": "绵阳市", "parentid": 31}, "260": {"ctype": "30", "cname": "广元", "id": 260, "cdesc": "广元市", "parentid": 31}, "261": {"ctype": "30", "cname": "遂宁", "id": 261, "cdesc": "遂宁市", "parentid": 31}, "262": {"ctype": "30", "cname": "内江", "id": 262, "cdesc": "内江市", "parentid": 31}, "263": {"ctype": "30", "cname": "乐山", "id": 263, "cdesc": "乐山市", "parentid": 31}, "264": {"ctype": "30", "cname": "南充", "id": 264, "cdesc": "南充市", "parentid": 31}, "265": {"ctype": "30", "cname": "眉山", "id": 265, "cdesc": "眉山市", "parentid": 31}, "266": {"ctype": "30", "cname": "宜宾", "id": 266, "cdesc": "宜宾市", "parentid": 31}, "267": {"ctype": "30", "cname": "广安", "id": 267, "cdesc": "广安市", "parentid": 31}, "268": {"ctype": "30", "cname": "达州", "id": 268, "cdesc": "达州", "parentid": 31}, "269": {"ctype": "30", "cname": "雅安", "id": 269, "cdesc": "雅安市", "parentid": 31}, "270": {"ctype": "30", "cname": "巴中", "id": 270, "cdesc": "巴中市", "parentid": 31}, "271": {"ctype": "30", "cname": "资阳", "id": 271, "cdesc": "资阳市", "parentid": 31}, "272": {"ctype": "30", "cname": "阿坝藏族羌族", "id": 272, "cdesc": "阿坝藏族羌族", "parentid": 31}, "273": {"ctype": "30", "cname": "甘孜藏族", "id": 273, "cdesc": "甘孜藏族", "parentid": 31}, "274": {"ctype": "30", "cname": "凉山彝族", "id": 274, "cdesc": "凉山彝族", "parentid": 31}, "275": {"ctype": "30", "cname": "贵阳", "id": 275, "cdesc": "贵阳市", "parentid": 32}, "276": {"ctype": "30", "cname": "六盘水", "id": 276, "cdesc": "六盘水市", "parentid": 32}, "277": {"ctype": "30", "cname": "遵义", "id": 277, "cdesc": "遵义市", "parentid": 32}, "278": {"ctype": "30", "cname": "安顺", "id": 278, "cdesc": "安顺市", "parentid": 32}, "279": {"ctype": "30", "cname": "铜仁地区", "id": 279, "cdesc": "铜仁地区市", "parentid": 32}, "280": {"ctype": "30", "cname": "黔西南布依族", "id": 280, "cdesc": "黔西南布依族", "parentid": 32}, "281": {"ctype": "30", "cname": "毕节地区", "id": 281, "cdesc": "毕节地区市", "parentid": 32}, "282": {"ctype": "30", "cname": "黔东南苗族", "id": 282, "cdesc": "黔东南苗族", "parentid": 32}, "283": {"ctype": "30", "cname": "黔南布依族", "id": 283, "cdesc": "黔南布依族", "parentid": 32}, "284": {"ctype": "30", "cname": "昆明", "id": 284, "cdesc": "昆明市", "parentid": 33}, "285": {"ctype": "30", "cname": "曲靖", "id": 285, "cdesc": "曲靖市", "parentid": 33}, "286": {"ctype": "30", "cname": "玉溪", "id": 286, "cdesc": "玉溪市", "parentid": 33}, "287": {"ctype": "30", "cname": "保山", "id": 287, "cdesc": "保山市", "parentid": 33}, "288": {"ctype": "30", "cname": "昭通", "id": 288, "cdesc": "昭通市", "parentid": 33}, "289": {"ctype": "30", "cname": "丽江", "id": 289, "cdesc": "丽江市", "parentid": 33}, "290": {"ctype": "30", "cname": "普洱", "id": 290, "cdesc": "普洱市", "parentid": 33}, "291": {"ctype": "30", "cname": "临沧", "id": 291, "cdesc": "临沧市", "parentid": 33}, "292": {"ctype": "30", "cname": "楚雄彝族", "id": 292, "cdesc": "楚雄彝族", "parentid": 33}, "293": {"ctype": "30", "cname": "红河哈尼族", "id": 293, "cdesc": "红河哈尼族", "parentid": 33}, "294": {"ctype": "30", "cname": "文山苗族", "id": 294, "cdesc": "文山苗族", "parentid": 33}, "295": {"ctype": "30", "cname": "西双版纳傣族", "id": 295, "cdesc": "西双版纳傣族", "parentid": 33}, "296": {"ctype": "30", "cname": "大理白族", "id": 296, "cdesc": "大理白族", "parentid": 33}, "297": {"ctype": "30", "cname": "德宏傣族景颇族", "id": 297, "cdesc": "德宏傣族景颇族", "parentid": 33}, "298": {"ctype": "30", "cname": "怒江傈僳族", "id": 298, "cdesc": "怒江傈僳族", "parentid": 33}, "299": {"ctype": "30", "cname": "迪庆藏族", "id": 299, "cdesc": "迪庆藏族", "parentid": 33}, "300": {"ctype": "30", "cname": "拉萨", "id": 300, "cdesc": "拉萨市", "parentid": 34}, "301": {"ctype": "30", "cname": "昌都", "id": 301, "cdesc": "昌都市", "parentid": 34}, "302": {"ctype": "30", "cname": "山南", "id": 302, "cdesc": "山南市", "parentid": 34}, "303": {"ctype": "30", "cname": "日喀则", "id": 303, "cdesc": "日喀则市", "parentid": 34}, "304": {"ctype": "30", "cname": "那曲地区", "id": 304, "cdesc": "那曲地区", "parentid": 34}, "305": {"ctype": "30", "cname": "阿里地区", "id": 305, "cdesc": "阿里地区", "parentid": 34}, "306": {"ctype": "30", "cname": "林芝", "id": 306, "cdesc": "林芝市", "parentid": 34}, "307": {"ctype": "30", "cname": "哈尔滨", "id": 307, "cdesc": "哈尔滨市", "parentid": 35}, "308": {"ctype": "30", "cname": "齐齐哈尔", "id": 308, "cdesc": "齐齐哈尔市", "parentid": 35}, "309": {"ctype": "30", "cname": "鸡西", "id": 309, "cdesc": "鸡西市", "parentid": 35}, "310": {"ctype": "30", "cname": "鹤岗", "id": 310, "cdesc": "鹤岗市", "parentid": 35}, "311": {"ctype": "30", "cname": "双鸭山", "id": 311, "cdesc": "双鸭山市", "parentid": 35}, "312": {"ctype": "30", "cname": "大庆", "id": 312, "cdesc": "大庆市", "parentid": 35}, "313": {"ctype": "30", "cname": "伊春", "id": 313, "cdesc": "伊春市", "parentid": 35}, "314": {"ctype": "30", "cname": "佳木斯", "id": 314, "cdesc": "佳木斯市", "parentid": 35}, "315": {"ctype": "30", "cname": "七台河", "id": 315, "cdesc": "七台河市", "parentid": 35}, "316": {"ctype": "30", "cname": "牡丹江", "id": 316, "cdesc": "牡丹江市", "parentid": 35}, "317": {"ctype": "30", "cname": "黑河", "id": 317, "cdesc": "黑河市", "parentid": 35}, "318": {"ctype": "30", "cname": "绥化", "id": 318, "cdesc": "绥化市", "parentid": 35}, "319": {"ctype": "30", "cname": "大兴安岭", "id": 319, "cdesc": "大兴安岭", "parentid": 35}, "320": {"ctype": "30", "cname": "沈阳", "id": 320, "cdesc": "沈阳市", "parentid": 36}, "321": {"ctype": "30", "cname": "大连", "id": 321, "cdesc": "大连市", "parentid": 36}, "322": {"ctype": "30", "cname": "鞍山", "id": 322, "cdesc": "鞍山市", "parentid": 36}, "323": {"ctype": "30", "cname": "抚顺", "id": 323, "cdesc": "抚顺市", "parentid": 36}, "324": {"ctype": "30", "cname": "本溪", "id": 324, "cdesc": "本溪市", "parentid": 36}, "325": {"ctype": "30", "cname": "丹东", "id": 325, "cdesc": "丹东市", "parentid": 36}, "326": {"ctype": "30", "cname": "锦州", "id": 326, "cdesc": "锦州市", "parentid": 36}, "327": {"ctype": "30", "cname": "营口", "id": 327, "cdesc": "营口市", "parentid": 36}, "328": {"ctype": "30", "cname": "阜新", "id": 328, "cdesc": "阜新市", "parentid": 36}, "329": {"ctype": "30", "cname": "辽阳", "id": 329, "cdesc": "辽阳市", "parentid": 36}, "330": {"ctype": "30", "cname": "盘锦", "id": 330, "cdesc": "盘锦市", "parentid": 36}, "331": {"ctype": "30", "cname": "铁岭", "id": 331, "cdesc": "铁岭市", "parentid": 36}, "332": {"ctype": "30", "cname": "朝阳", "id": 332, "cdesc": "朝阳市", "parentid": 36}, "333": {"ctype": "30", "cname": "葫芦岛", "id": 333, "cdesc": "葫芦岛市", "parentid": 36}, "334": {"ctype": "30", "cname": "长春", "id": 334, "cdesc": "长春市", "parentid": 37}, "335": {"ctype": "30", "cname": "吉林", "id": 335, "cdesc": "吉林市", "parentid": 37}, "336": {"ctype": "30", "cname": "四平", "id": 336, "cdesc": "四平市", "parentid": 37}, "337": {"ctype": "30", "cname": "辽源", "id": 337, "cdesc": "辽源市", "parentid": 37}, "338": {"ctype": "30", "cname": "通化", "id": 338, "cdesc": "通化市", "parentid": 37}, "339": {"ctype": "30", "cname": "白山", "id": 339, "cdesc": "白山市", "parentid": 37}, "340": {"ctype": "30", "cname": "松原", "id": 340, "cdesc": "松原市", "parentid": 37}, "341": {"ctype": "30", "cname": "白城", "id": 341, "cdesc": "白城市", "parentid": 37}, "342": {"ctype": "30", "cname": "延边朝鲜族", "id": 342, "cdesc": "延边朝鲜族", "parentid": 37}, "343": {"ctype": "30", "cname": "西安", "id": 343, "cdesc": "西安市", "parentid": 38}, "344": {"ctype": "30", "cname": "铜川", "id": 344, "cdesc": "铜川市", "parentid": 38}, "345": {"ctype": "30", "cname": "宝鸡", "id": 345, "cdesc": "宝鸡市", "parentid": 38}, "346": {"ctype": "30", "cname": "咸阳", "id": 346, "cdesc": "咸阳市", "parentid": 38}, "347": {"ctype": "30", "cname": "渭南", "id": 347, "cdesc": "渭南市", "parentid": 38}, "348": {"ctype": "30", "cname": "延安", "id": 348, "cdesc": "延安市", "parentid": 38}, "349": {"ctype": "30", "cname": "汉中", "id": 349, "cdesc": "汉中市", "parentid": 38}, "350": {"ctype": "30", "cname": "榆林", "id": 350, "cdesc": "榆林市", "parentid": 38}, "351": {"ctype": "30", "cname": "安康", "id": 351, "cdesc": "安康市", "parentid": 38}, "352": {"ctype": "30", "cname": "商洛", "id": 352, "cdesc": "商洛市", "parentid": 38}, "353": {"ctype": "30", "cname": "兰州", "id": 353, "cdesc": "兰州市", "parentid": 39}, "354": {"ctype": "30", "cname": "嘉峪关", "id": 354, "cdesc": "嘉峪关市", "parentid": 39}, "355": {"ctype": "30", "cname": "金昌", "id": 355, "cdesc": "金昌市", "parentid": 39}, "356": {"ctype": "30", "cname": "白银", "id": 356, "cdesc": "白银市", "parentid": 39}, "357": {"ctype": "30", "cname": "天水", "id": 357, "cdesc": "天水市", "parentid": 39}, "358": {"ctype": "30", "cname": "武威", "id": 358, "cdesc": "武威市", "parentid": 39}, "359": {"ctype": "30", "cname": "张掖", "id": 359, "cdesc": "张掖市", "parentid": 39}, "360": {"ctype": "30", "cname": "平凉", "id": 360, "cdesc": "平凉市", "parentid": 39}, "361": {"ctype": "30", "cname": "酒泉", "id": 361, "cdesc": "酒泉市", "parentid": 39}, "362": {"ctype": "30", "cname": "庆阳", "id": 362, "cdesc": "庆阳市", "parentid": 39}, "363": {"ctype": "30", "cname": "定西", "id": 363, "cdesc": "定西市", "parentid": 39}, "364": {"ctype": "30", "cname": "陇南", "id": 364, "cdesc": "陇南市", "parentid": 39}, "365": {"ctype": "30", "cname": "临夏", "id": 365, "cdesc": "临夏自", "parentid": 39}, "366": {"ctype": "30", "cname": "甘南藏族", "id": 366, "cdesc": "甘南藏族", "parentid": 39}, "367": {"ctype": "30", "cname": "西宁", "id": 367, "cdesc": "西宁市", "parentid": 40}, "368": {"ctype": "30", "cname": "海东地区", "id": 368, "cdesc": "海东地区", "parentid": 40}, "369": {"ctype": "30", "cname": "海北藏族", "id": 369, "cdesc": "海北藏族", "parentid": 40}, "370": {"ctype": "30", "cname": "黄南藏族", "id": 370, "cdesc": "黄南藏族", "parentid": 40}, "371": {"ctype": "30", "cname": "海南藏族", "id": 371, "cdesc": "海南藏族", "parentid": 40}, "372": {"ctype": "30", "cname": "果洛藏族", "id": 372, "cdesc": "果洛藏族", "parentid": 40}, "373": {"ctype": "30", "cname": "玉树藏族", "id": 373, "cdesc": "玉树藏族", "parentid": 40}, "374": {"ctype": "30", "cname": "海西蒙古族", "id": 374, "cdesc": "海西蒙古族", "parentid": 40}, "375": {"ctype": "30", "cname": "银川", "id": 375, "cdesc": "银川市", "parentid": 41}, "376": {"ctype": "30", "cname": "石嘴山", "id": 376, "cdesc": "石嘴山市", "parentid": 41}, "377": {"ctype": "30", "cname": "吴忠", "id": 377, "cdesc": "吴忠市", "parentid": 41}, "378": {"ctype": "30", "cname": "固原", "id": 378, "cdesc": "固原市", "parentid": 41}, "379": {"ctype": "30", "cname": "中卫", "id": 379, "cdesc": "中卫市", "parentid": 41}, "380": {"ctype": "30", "cname": "乌鲁木齐", "id": 380, "cdesc": "乌鲁木齐市", "parentid": 42}, "381": {"ctype": "30", "cname": "克拉玛依", "id": 381, "cdesc": "克拉玛依市", "parentid": 42}, "382": {"ctype": "30", "cname": "吐鲁番", "id": 382, "cdesc": "吐鲁番", "parentid": 42}, "383": {"ctype": "30", "cname": "哈密地区", "id": 383, "cdesc": "哈密地区", "parentid": 42}, "384": {"ctype": "30", "cname": "昌吉", "id": 384, "cdesc": "昌吉", "parentid": 42}, "385": {"ctype": "30", "cname": "博尔塔拉蒙古", "id": 385, "cdesc": "博尔塔拉蒙古", "parentid": 42}, "386": {"ctype": "30", "cname": "巴音郭楞蒙古", "id": 386, "cdesc": "巴音郭楞蒙古", "parentid": 42}, "387": {"ctype": "30", "cname": "阿克苏", "id": 387, "cdesc": "阿克苏", "parentid": 42}, "388": {"ctype": "30", "cname": "克孜勒苏柯尔克孜", "id": 388, "cdesc": "克孜勒苏柯尔克孜", "parentid": 42}, "389": {"ctype": "30", "cname": "喀什", "id": 389, "cdesc": "喀什", "parentid": 42}, "390": {"ctype": "30", "cname": "和田地区", "id": 390, "cdesc": "和田地区", "parentid": 42}, "391": {"ctype": "30", "cname": "伊犁哈萨克", "id": 391, "cdesc": "伊犁哈萨克", "parentid": 42}, "392": {"ctype": "30", "cname": "塔城地区", "id": 392, "cdesc": "塔城地区", "parentid": 42}, "393": {"ctype": "30", "cname": "阿勒泰", "id": 393, "cdesc": "阿勒泰", "parentid": 42}, "394": {"ctype": "30", "cname": "直辖行政单位", "id": 394, "cdesc": "直辖行政单位", "parentid": 42}, "401": {"ctype": "30", "cname": "中山", "id": 401, "cdesc": "中山市", "parentid": 4}, "402": {"ctype": "30", "cname": "东莞", "id": 402, "cdesc": "东莞市", "parentid": 4}, "403": {"ctype": "30", "cname": "宁国", "id": 403, "cdesc": "宁国市", "parentid": 23}, "404": {"ctype": "30", "cname": "界首", "id": 404, "cdesc": "界首市", "parentid": 23}, "405": {"ctype": "30", "cname": "明光", "id": 405, "cdesc": "明光市", "parentid": 23}, "406": {"ctype": "30", "cname": "天长", "id": 406, "cdesc": "天长市", "parentid": 23}, "407": {"ctype": "30", "cname": "桐城", "id": 407, "cdesc": "桐城市", "parentid": 23}, "408": {"ctype": "30", "cname": "天门", "id": 408, "cdesc": "天门市", "parentid": 28}, "409": {"ctype": "30", "cname": "仙桃", "id": 409, "cdesc": "仙桃市", "parentid": 28}, "410": {"ctype": "30", "cname": "潜江", "id": 410, "cdesc": "潜江市", "parentid": 28}, "420": {"ctype": "30", "cname": "阜康", "id": 420, "cdesc": "阜康市", "parentid": 42}, "421": {"ctype": "30", "cname": "博乐", "id": 421, "cdesc": "博乐市", "parentid": 42}, "422": {"ctype": "30", "cname": "阿图什", "id": 422, "cdesc": "阿图什市", "parentid": 42}, "423": {"ctype": "30", "cname": "石河子", "id": 423, "cdesc": "石河子市", "parentid": 42}, "424": {"ctype": "30", "cname": "五家渠", "id": 424, "cdesc": "五家渠市", "parentid": 42}, "425": {"ctype": "30", "cname": "阿拉尔", "id": 425, "cdesc": "阿拉尔市", "parentid": 42}, "426": {"ctype": "30", "cname": "图木舒克", "id": 426, "cdesc": "图木舒克市", "parentid": 42}, "432": {"ctype": "30", "cname": "三沙", "id": 432, "cdesc": "三沙市", "parentid": 5}, "433": {"ctype": "30", "cname": "西峰", "id": 433, "cdesc": "西峰区", "parentid": 39}, "434": {"ctype": "30", "cname": "阿城", "id": 434, "cdesc": "阿城市", "parentid": 35}, "435": {"ctype": "30", "cname": "儋州", "id": 435, "cdesc": "儋州市", "parentid": 5}, "436": {"ctype": "30", "cname": "浑江", "id": 436, "cdesc": "浑江市", "parentid": 37}, "437": {"ctype": "30", "cname": "珲春", "id": 437, "cdesc": "珲春市", "parentid": 37}, "438": {"ctype": "30", "cname": "涪陵", "id": 438, "cdesc": "涪陵市", "parentid": 30}, "439": {"ctype": "30", "cname": "永川", "id": 439, "cdesc": "永川市", "parentid": 30}, "440": {"ctype": "30", "cname": "东川", "id": 440, "cdesc": "东川区", "parentid": 33}, "446": {"ctype": "30", "cname": "西城", "id": 446, "cdesc": "西城区", "parentid": 2}, "447": {"ctype": "30", "cname": "朝阳", "id": 447, "cdesc": "朝阳区", "parentid": 2}, "448": {"ctype": "30", "cname": "丰台", "id": 448, "cdesc": "丰台区", "parentid": 2}, "449": {"ctype": "30", "cname": "石景山", "id": 449, "cdesc": "石景山区", "parentid": 2}, "450": {"ctype": "30", "cname": "海淀", "id": 450, "cdesc": "海淀区", "parentid": 2}, "451": {"ctype": "30", "cname": "门头沟", "id": 451, "cdesc": "门头沟区", "parentid": 2}, "452": {"ctype": "30", "cname": "房山", "id": 452, "cdesc": "房山区", "parentid": 2}, "453": {"ctype": "30", "cname": "通州", "id": 453, "cdesc": "通州", "parentid": 2}, "454": {"ctype": "30", "cname": "顺义", "id": 454, "cdesc": "顺义", "parentid": 2}, "455": {"ctype": "30", "cname": "昌平", "id": 455, "cdesc": "昌平", "parentid": 2}, "456": {"ctype": "30", "cname": "大兴", "id": 456, "cdesc": "大兴", "parentid": 2}, "457": {"ctype": "30", "cname": "怀柔", "id": 457, "cdesc": "怀柔", "parentid": 2}, "458": {"ctype": "30", "cname": "平谷", "id": 458, "cdesc": "平谷", "parentid": 2}, "459": {"ctype": "30", "cname": "密云", "id": 459, "cdesc": "密云", "parentid": 2}, "460": {"ctype": "30", "cname": "延庆", "id": 460, "cdesc": "延庆", "parentid": 2}, "461": {"ctype": "30", "cname": "河东", "id": 461, "cdesc": "河东", "parentid": 16}, "462": {"ctype": "30", "cname": "河西", "id": 462, "cdesc": "河西", "parentid": 16}, "464": {"ctype": "30", "cname": "河北区", "id": 464, "cdesc": "河北区", "parentid": 16}, "465": {"ctype": "30", "cname": "红桥", "id": 465, "cdesc": "红桥", "parentid": 16}, "466": {"ctype": "30", "cname": "东丽", "id": 466, "cdesc": "东丽", "parentid": 16}, "467": {"ctype": "30", "cname": "西青", "id": 467, "cdesc": "西青", "parentid": 16}, "468": {"ctype": "30", "cname": "津南", "id": 468, "cdesc": "津南", "parentid": 16}, "469": {"ctype": "30", "cname": "北辰", "id": 469, "cdesc": "北辰", "parentid": 16}, "470": {"ctype": "30", "cname": "武清", "id": 470, "cdesc": "武清", "parentid": 16}, "471": {"ctype": "30", "cname": "宝坻", "id": 471, "cdesc": "宝坻", "parentid": 16}, "472": {"ctype": "30", "cname": "滨海", "id": 472, "cdesc": "滨海新", "parentid": 16}, "473": {"ctype": "30", "cname": "宁河", "id": 473, "cdesc": "宁河", "parentid": 16}, "474": {"ctype": "30", "cname": "静海", "id": 474, "cdesc": "静海", "parentid": 16}, "475": {"ctype": "30", "cname": "蓟州", "id": 475, "cdesc": "蓟州", "parentid": 16}, "476": {"ctype": "30", "cname": "涪陵", "id": 476, "cdesc": "涪陵", "parentid": 30}, "477": {"ctype": "30", "cname": "渝中", "id": 477, "cdesc": "渝中", "parentid": 30}, "478": {"ctype": "30", "cname": "大渡口", "id": 478, "cdesc": "大渡口", "parentid": 30}, "479": {"ctype": "30", "cname": "江北", "id": 479, "cdesc": "江北", "parentid": 30}, "480": {"ctype": "30", "cname": "沙坪坝", "id": 480, "cdesc": "沙坪坝", "parentid": 30}, "481": {"ctype": "30", "cname": "九龙坡", "id": 481, "cdesc": "九龙坡", "parentid": 30}, "482": {"ctype": "30", "cname": "南岸", "id": 482, "cdesc": "南岸", "parentid": 30}, "483": {"ctype": "30", "cname": "北碚", "id": 483, "cdesc": "北碚", "parentid": 30}, "484": {"ctype": "30", "cname": "綦江", "id": 484, "cdesc": "綦江", "parentid": 30}, "485": {"ctype": "30", "cname": "大足", "id": 485, "cdesc": "大足", "parentid": 30}, "486": {"ctype": "30", "cname": "渝北", "id": 486, "cdesc": "渝北", "parentid": 30}, "487": {"ctype": "30", "cname": "巴南", "id": 487, "cdesc": "巴南", "parentid": 30}, "488": {"ctype": "30", "cname": "黔江", "id": 488, "cdesc": "黔江", "parentid": 30}, "489": {"ctype": "30", "cname": "长寿", "id": 489, "cdesc": "长寿", "parentid": 30}, "490": {"ctype": "30", "cname": "江津", "id": 490, "cdesc": "江津", "parentid": 30}, "491": {"ctype": "30", "cname": "合川", "id": 491, "cdesc": "合川", "parentid": 30}, "492": {"ctype": "30", "cname": "永川", "id": 492, "cdesc": "永川", "parentid": 30}, "493": {"ctype": "30", "cname": "南川", "id": 493, "cdesc": "南川", "parentid": 30}, "494": {"ctype": "30", "cname": "璧山", "id": 494, "cdesc": "璧山", "parentid": 30}, "495": {"ctype": "30", "cname": "铜梁", "id": 495, "cdesc": "铜梁", "parentid": 30}, "496": {"ctype": "30", "cname": "潼南", "id": 496, "cdesc": "潼南", "parentid": 30}, "497": {"ctype": "30", "cname": "荣昌", "id": 497, "cdesc": "荣昌", "parentid": 30}, "498": {"ctype": "30", "cname": "开州", "id": 498, "cdesc": "开州", "parentid": 30}, "499": {"ctype": "30", "cname": "徐汇", "id": 499, "cdesc": "徐汇", "parentid": 20}, "500": {"ctype": "30", "cname": "长宁", "id": 500, "cdesc": "长宁", "parentid": 20}, "501": {"ctype": "30", "cname": "静安", "id": 501, "cdesc": "静安", "parentid": 20}, "502": {"ctype": "30", "cname": "普陀", "id": 502, "cdesc": "普陀", "parentid": 20}, "503": {"ctype": "30", "cname": "虹口", "id": 503, "cdesc": "虹口", "parentid": 20}, "504": {"ctype": "30", "cname": "杨浦", "id": 504, "cdesc": "杨浦", "parentid": 20}, "505": {"ctype": "30", "cname": "闵行", "id": 505, "cdesc": "闵行", "parentid": 20}, "506": {"ctype": "30", "cname": "宝山", "id": 506, "cdesc": "宝山", "parentid": 20}, "507": {"ctype": "30", "cname": "嘉定", "id": 507, "cdesc": "嘉定", "parentid": 20}, "508": {"ctype": "30", "cname": "浦东新", "id": 508, "cdesc": "浦东新", "parentid": 20}, "509": {"ctype": "30", "cname": "金山", "id": 509, "cdesc": "金山", "parentid": 20}, "510": {"ctype": "30", "cname": "松江", "id": 510, "cdesc": "松江", "parentid": 20}, "511": {"ctype": "30", "cname": "青浦", "id": 511, "cdesc": "青浦", "parentid": 20}, "512": {"ctype": "30", "cname": "奉贤", "id": 512, "cdesc": "奉贤", "parentid": 20}, "513": {"ctype": "30", "cname": "崇明", "id": 513, "cdesc": "崇明", "parentid": 20}, "514": {"ctype": "30", "cname": "梅河口", "id": 514, "cdesc": "梅河口", "parentid": 37}, "515": {"ctype": "30", "cname": "公主岭", "id": 515, "cdesc": "公主岭", "parentid": 37}, "516": {"ctype": "30", "cname": "定州", "id": 516, "cdesc": "定州市", "parentid": 17}, "517": {"ctype": "30", "cname": "辛集", "id": 517, "cdesc": "辛集市", "parentid": 17}, "518": {"ctype": "30", "cname": "济源", "id": 518, "cdesc": "济源市", "parentid": 27}, "519": {"ctype": "30", "cname": "神农架林区", "id": 519, "cdesc": "神农架林区", "parentid": 28}, "520": {"ctype": "30", "cname": "五指山", "id": 520, "cdesc": "五指山", "parentid": 5}, "521": {"ctype": "30", "cname": "文昌", "id": 521, "cdesc": "文昌", "parentid": 5}, "522": {"ctype": "30", "cname": "琼海", "id": 522, "cdesc": "琼海", "parentid": 5}, "523": {"ctype": "30", "cname": "万宁", "id": 523, "cdesc": "万宁", "parentid": 5}, "524": {"ctype": "30", "cname": "东方", "id": 524, "cdesc": "东方", "parentid": 5}, "525": {"ctype": "30", "cname": "定安", "id": 525, "cdesc": "定安", "parentid": 5}, "526": {"ctype": "30", "cname": "屯昌", "id": 526, "cdesc": "屯昌", "parentid": 5}, "527": {"ctype": "30", "cname": "澄迈", "id": 527, "cdesc": "澄迈", "parentid": 5}, "528": {"ctype": "30", "cname": "临高", "id": 528, "cdesc": "临高", "parentid": 5}, "529": {"ctype": "30", "cname": "白沙黎族", "id": 529, "cdesc": "白沙黎族", "parentid": 5}, "530": {"ctype": "30", "cname": "昌江黎族", "id": 530, "cdesc": "昌江黎族", "parentid": 5}, "531": {"ctype": "30", "cname": "乐东黎族", "id": 531, "cdesc": "乐东黎族", "parentid": 5}, "532": {"ctype": "30", "cname": "陵水黎族", "id": 532, "cdesc": "陵水黎族", "parentid": 5}, "533": {"ctype": "30", "cname": "保亭黎族", "id": 533, "cdesc": "保亭黎族", "parentid": 5}, "534": {"ctype": "30", "cname": "琼中黎族", "id": 534, "cdesc": "琼中黎族", "parentid": 5}, "535": {"ctype": "30", "cname": "洋浦经济开发", "id": 535, "cdesc": "洋浦经济开发区", "parentid": 5}, "1001": {"ctype": "40", "cname": "长安", "id": 1001, "cdesc": "长安区", "parentid": 58}, "1002": {"ctype": "40", "cname": "桥西", "id": 1002, "cdesc": "桥西区", "parentid": 58}, "1003": {"ctype": "40", "cname": "新华", "id": 1003, "cdesc": "新华区", "parentid": 58}, "1004": {"ctype": "40", "cname": "井陉矿", "id": 1004, "cdesc": "井陉矿区", "parentid": 58}, "1005": {"ctype": "40", "cname": "裕华", "id": 1005, "cdesc": "裕华区", "parentid": 58}, "1006": {"ctype": "40", "cname": "藁城", "id": 1006, "cdesc": "藁城区", "parentid": 58}, "1007": {"ctype": "40", "cname": "鹿泉", "id": 1007, "cdesc": "鹿泉区", "parentid": 58}, "1008": {"ctype": "40", "cname": "栾城", "id": 1008, "cdesc": "栾城区", "parentid": 58}, "1009": {"ctype": "40", "cname": "井陉", "id": 1009, "cdesc": "井陉县", "parentid": 58}, "1010": {"ctype": "40", "cname": "正定", "id": 1010, "cdesc": "正定县", "parentid": 58}, "1011": {"ctype": "40", "cname": "行唐", "id": 1011, "cdesc": "行唐县", "parentid": 58}, "1012": {"ctype": "40", "cname": "灵寿", "id": 1012, "cdesc": "灵寿县", "parentid": 58}, "1013": {"ctype": "40", "cname": "高邑", "id": 1013, "cdesc": "高邑县", "parentid": 58}, "1014": {"ctype": "40", "cname": "深泽", "id": 1014, "cdesc": "深泽县", "parentid": 58}, "1015": {"ctype": "40", "cname": "赞皇", "id": 1015, "cdesc": "赞皇县", "parentid": 58}, "1016": {"ctype": "40", "cname": "无极", "id": 1016, "cdesc": "无极县", "parentid": 58}, "1017": {"ctype": "40", "cname": "平山", "id": 1017, "cdesc": "平山县", "parentid": 58}, "1018": {"ctype": "40", "cname": "元氏", "id": 1018, "cdesc": "元氏县", "parentid": 58}, "1019": {"ctype": "40", "cname": "赵县", "id": 1019, "cdesc": "赵县", "parentid": 58}, "1020": {"ctype": "40", "cname": "晋州", "id": 1020, "cdesc": "晋州市", "parentid": 58}, "1021": {"ctype": "40", "cname": "新乐", "id": 1021, "cdesc": "新乐市", "parentid": 58}, "1022": {"ctype": "40", "cname": "路北", "id": 1022, "cdesc": "路北区", "parentid": 59}, "1023": {"ctype": "40", "cname": "路南", "id": 1023, "cdesc": "路南区", "parentid": 59}, "1024": {"ctype": "40", "cname": "古冶", "id": 1024, "cdesc": "古冶区", "parentid": 59}, "1025": {"ctype": "40", "cname": "开平", "id": 1025, "cdesc": "开平区", "parentid": 59}, "1026": {"ctype": "40", "cname": "丰南", "id": 1026, "cdesc": "丰南区", "parentid": 59}, "1027": {"ctype": "40", "cname": "丰润", "id": 1027, "cdesc": "丰润区", "parentid": 59}, "1028": {"ctype": "40", "cname": "曹妃甸", "id": 1028, "cdesc": "曹妃甸区", "parentid": 59}, "1029": {"ctype": "40", "cname": "滦县", "id": 1029, "cdesc": "滦县", "parentid": 59}, "1030": {"ctype": "40", "cname": "滦南", "id": 1030, "cdesc": "滦南县", "parentid": 59}, "1031": {"ctype": "40", "cname": "乐亭", "id": 1031, "cdesc": "乐亭县", "parentid": 59}, "1032": {"ctype": "40", "cname": "迁西", "id": 1032, "cdesc": "迁西县", "parentid": 59}, "1033": {"ctype": "40", "cname": "玉田", "id": 1033, "cdesc": "玉田县", "parentid": 59}, "1034": {"ctype": "40", "cname": "遵化", "id": 1034, "cdesc": "遵化市", "parentid": 59}, "1035": {"ctype": "40", "cname": "迁安", "id": 1035, "cdesc": "迁安市", "parentid": 59}, "1036": {"ctype": "40", "cname": "海港", "id": 1036, "cdesc": "海港区", "parentid": 60}, "1037": {"ctype": "40", "cname": "山海关", "id": 1037, "cdesc": "山海关区", "parentid": 60}, "1038": {"ctype": "40", "cname": "抚宁", "id": 1038, "cdesc": "抚宁区", "parentid": 60}, "1039": {"ctype": "40", "cname": "北戴河", "id": 1039, "cdesc": "北戴河区", "parentid": 60}, "1040": {"ctype": "40", "cname": "青龙满族", "id": 1040, "cdesc": "青龙满族", "parentid": 60}, "1041": {"ctype": "40", "cname": "昌黎", "id": 1041, "cdesc": "昌黎县", "parentid": 60}, "1042": {"ctype": "40", "cname": "卢龙", "id": 1042, "cdesc": "卢龙县", "parentid": 60}, "1043": {"ctype": "40", "cname": "塔城", "id": 1043, "cdesc": "塔城市", "parentid": 392}, "1044": {"ctype": "40", "cname": "乌苏", "id": 1044, "cdesc": "乌苏市", "parentid": 392}, "1045": {"ctype": "40", "cname": "额敏", "id": 1045, "cdesc": "额敏县", "parentid": 392}, "1046": {"ctype": "40", "cname": "沙湾", "id": 1046, "cdesc": "沙湾县", "parentid": 392}, "1047": {"ctype": "40", "cname": "托里", "id": 1047, "cdesc": "托里县", "parentid": 392}, "1048": {"ctype": "40", "cname": "裕民", "id": 1048, "cdesc": "裕民县", "parentid": 392}, "1049": {"ctype": "40", "cname": "和布克赛尔蒙古", "id": 1049, "cdesc": "和布克赛尔蒙古", "parentid": 392}, "1050": {"ctype": "40", "cname": "邯山", "id": 1050, "cdesc": "邯山区", "parentid": 61}, "1051": {"ctype": "40", "cname": "丛台", "id": 1051, "cdesc": "丛台区", "parentid": 61}, "1052": {"ctype": "40", "cname": "复兴", "id": 1052, "cdesc": "复兴区", "parentid": 61}, "1053": {"ctype": "40", "cname": "峰峰矿", "id": 1053, "cdesc": "峰峰矿区", "parentid": 61}, "1054": {"ctype": "40", "cname": "邯郸", "id": 1054, "cdesc": "邯郸县", "parentid": 61}, "1055": {"ctype": "40", "cname": "临漳", "id": 1055, "cdesc": "临漳县", "parentid": 61}, "1056": {"ctype": "40", "cname": "成安", "id": 1056, "cdesc": "成安县", "parentid": 61}, "1057": {"ctype": "40", "cname": "大名", "id": 1057, "cdesc": "大名县", "parentid": 61}, "1058": {"ctype": "40", "cname": "涉县", "id": 1058, "cdesc": "涉县", "parentid": 61}, "1059": {"ctype": "40", "cname": "磁县", "id": 1059, "cdesc": "磁县", "parentid": 61}, "1060": {"ctype": "40", "cname": "肥乡", "id": 1060, "cdesc": "肥乡县", "parentid": 61}, "1061": {"ctype": "40", "cname": "永年", "id": 1061, "cdesc": "永年县", "parentid": 61}, "1062": {"ctype": "40", "cname": "邱县", "id": 1062, "cdesc": "邱县", "parentid": 61}, "1063": {"ctype": "40", "cname": "鸡泽", "id": 1063, "cdesc": "鸡泽县", "parentid": 61}, "1064": {"ctype": "40", "cname": "广平", "id": 1064, "cdesc": "广平县", "parentid": 61}, "1065": {"ctype": "40", "cname": "馆陶", "id": 1065, "cdesc": "馆陶县", "parentid": 61}, "1066": {"ctype": "40", "cname": "曲周", "id": 1066, "cdesc": "曲周县", "parentid": 61}, "1067": {"ctype": "40", "cname": "武安", "id": 1067, "cdesc": "武安市", "parentid": 61}, "1068": {"ctype": "40", "cname": "魏县", "id": 1068, "cdesc": "魏县", "parentid": 61}, "1069": {"ctype": "40", "cname": "阿勒泰", "id": 1069, "cdesc": "阿勒泰市", "parentid": 393}, "1070": {"ctype": "40", "cname": "布尔津", "id": 1070, "cdesc": "布尔津县", "parentid": 393}, "1071": {"ctype": "40", "cname": "富蕴", "id": 1071, "cdesc": "富蕴县", "parentid": 393}, "1072": {"ctype": "40", "cname": "福海", "id": 1072, "cdesc": "福海县", "parentid": 393}, "1073": {"ctype": "40", "cname": "哈巴河", "id": 1073, "cdesc": "哈巴河县", "parentid": 393}, "1074": {"ctype": "40", "cname": "青河", "id": 1074, "cdesc": "青河县", "parentid": 393}, "1075": {"ctype": "40", "cname": "吉木乃", "id": 1075, "cdesc": "吉木乃县", "parentid": 393}, "1076": {"ctype": "40", "cname": "桥东", "id": 1076, "cdesc": "桥东区", "parentid": 62}, "1077": {"ctype": "40", "cname": "桥西", "id": 1077, "cdesc": "桥西区", "parentid": 62}, "1078": {"ctype": "40", "cname": "邢台", "id": 1078, "cdesc": "邢台县", "parentid": 62}, "1079": {"ctype": "40", "cname": "临城", "id": 1079, "cdesc": "临城县", "parentid": 62}, "1080": {"ctype": "40", "cname": "内丘", "id": 1080, "cdesc": "内丘县", "parentid": 62}, "1081": {"ctype": "40", "cname": "柏乡", "id": 1081, "cdesc": "柏乡县", "parentid": 62}, "1082": {"ctype": "40", "cname": "隆尧", "id": 1082, "cdesc": "隆尧县", "parentid": 62}, "1083": {"ctype": "40", "cname": "任县", "id": 1083, "cdesc": "任县", "parentid": 62}, "1084": {"ctype": "40", "cname": "南和", "id": 1084, "cdesc": "南和县", "parentid": 62}, "1085": {"ctype": "40", "cname": "巨鹿", "id": 1085, "cdesc": "巨鹿县", "parentid": 62}, "1086": {"ctype": "40", "cname": "新河", "id": 1086, "cdesc": "新河县", "parentid": 62}, "1087": {"ctype": "40", "cname": "广宗", "id": 1087, "cdesc": "广宗县", "parentid": 62}, "1088": {"ctype": "40", "cname": "平乡", "id": 1088, "cdesc": "平乡县", "parentid": 62}, "1089": {"ctype": "40", "cname": "威县", "id": 1089, "cdesc": "威县", "parentid": 62}, "1090": {"ctype": "40", "cname": "清河", "id": 1090, "cdesc": "清河县", "parentid": 62}, "1091": {"ctype": "40", "cname": "临西", "id": 1091, "cdesc": "临西县", "parentid": 62}, "1092": {"ctype": "40", "cname": "南宫", "id": 1092, "cdesc": "南宫市", "parentid": 62}, "1093": {"ctype": "40", "cname": "沙河", "id": 1093, "cdesc": "沙河市", "parentid": 62}, "1094": {"ctype": "40", "cname": "宁晋", "id": 1094, "cdesc": "宁晋县", "parentid": 62}, "1095": {"ctype": "40", "cname": "竞秀", "id": 1095, "cdesc": "竞秀区", "parentid": 63}, "1096": {"ctype": "40", "cname": "莲池", "id": 1096, "cdesc": "莲池区", "parentid": 63}, "1097": {"ctype": "40", "cname": "满城", "id": 1097, "cdesc": "满城区", "parentid": 63}, "1098": {"ctype": "40", "cname": "清苑", "id": 1098, "cdesc": "清苑区", "parentid": 63}, "1099": {"ctype": "40", "cname": "徐水", "id": 1099, "cdesc": "徐水区", "parentid": 63}, "1100": {"ctype": "40", "cname": "涞水", "id": 1100, "cdesc": "涞水县", "parentid": 63}, "1101": {"ctype": "40", "cname": "阜平", "id": 1101, "cdesc": "阜平县", "parentid": 63}, "1102": {"ctype": "40", "cname": "定兴", "id": 1102, "cdesc": "定兴县", "parentid": 63}, "1103": {"ctype": "40", "cname": "唐县", "id": 1103, "cdesc": "唐县", "parentid": 63}, "1104": {"ctype": "40", "cname": "高阳", "id": 1104, "cdesc": "高阳县", "parentid": 63}, "1105": {"ctype": "40", "cname": "容城", "id": 1105, "cdesc": "容城县", "parentid": 63}, "1106": {"ctype": "40", "cname": "涞源", "id": 1106, "cdesc": "涞源县", "parentid": 63}, "1107": {"ctype": "40", "cname": "望都", "id": 1107, "cdesc": "望都县", "parentid": 63}, "1108": {"ctype": "40", "cname": "安新", "id": 1108, "cdesc": "安新县", "parentid": 63}, "1109": {"ctype": "40", "cname": "易县", "id": 1109, "cdesc": "易县", "parentid": 63}, "1110": {"ctype": "40", "cname": "曲阳", "id": 1110, "cdesc": "曲阳县", "parentid": 63}, "1111": {"ctype": "40", "cname": "蠡县", "id": 1111, "cdesc": "蠡县", "parentid": 63}, "1112": {"ctype": "40", "cname": "顺平", "id": 1112, "cdesc": "顺平县", "parentid": 63}, "1113": {"ctype": "40", "cname": "博野", "id": 1113, "cdesc": "博野县", "parentid": 63}, "1114": {"ctype": "40", "cname": "雄县", "id": 1114, "cdesc": "雄县", "parentid": 63}, "1115": {"ctype": "40", "cname": "安国", "id": 1115, "cdesc": "安国市", "parentid": 63}, "1116": {"ctype": "40", "cname": "高碑店", "id": 1116, "cdesc": "高碑店市", "parentid": 63}, "1117": {"ctype": "40", "cname": "涿州", "id": 1117, "cdesc": "涿州市", "parentid": 63}, "1118": {"ctype": "40", "cname": "桥东", "id": 1118, "cdesc": "桥东区", "parentid": 64}, "1119": {"ctype": "40", "cname": "桥西", "id": 1119, "cdesc": "桥西区", "parentid": 64}, "1120": {"ctype": "40", "cname": "宣化", "id": 1120, "cdesc": "宣化区", "parentid": 64}, "1121": {"ctype": "40", "cname": "下花园", "id": 1121, "cdesc": "下花园区", "parentid": 64}, "1122": {"ctype": "40", "cname": "崇礼", "id": 1122, "cdesc": "崇礼区", "parentid": 64}, "1123": {"ctype": "40", "cname": "万全", "id": 1123, "cdesc": "万全区", "parentid": 64}, "1124": {"ctype": "40", "cname": "张北", "id": 1124, "cdesc": "张北县", "parentid": 64}, "1125": {"ctype": "40", "cname": "康保", "id": 1125, "cdesc": "康保县", "parentid": 64}, "1126": {"ctype": "40", "cname": "沽源", "id": 1126, "cdesc": "沽源县", "parentid": 64}, "1127": {"ctype": "40", "cname": "尚义", "id": 1127, "cdesc": "尚义县", "parentid": 64}, "1128": {"ctype": "40", "cname": "蔚县", "id": 1128, "cdesc": "蔚县", "parentid": 64}, "1129": {"ctype": "40", "cname": "阳原", "id": 1129, "cdesc": "阳原县", "parentid": 64}, "1130": {"ctype": "40", "cname": "怀安", "id": 1130, "cdesc": "怀安县", "parentid": 64}, "1131": {"ctype": "40", "cname": "涿鹿", "id": 1131, "cdesc": "涿鹿县", "parentid": 64}, "1132": {"ctype": "40", "cname": "赤城", "id": 1132, "cdesc": "赤城县", "parentid": 64}, "1133": {"ctype": "40", "cname": "怀来", "id": 1133, "cdesc": "怀来县", "parentid": 64}, "1134": {"ctype": "40", "cname": "伊宁", "id": 1134, "cdesc": "伊宁市", "parentid": 391}, "1135": {"ctype": "40", "cname": "奎屯", "id": 1135, "cdesc": "奎屯市", "parentid": 391}, "1136": {"ctype": "40", "cname": "霍尔果斯", "id": 1136, "cdesc": "霍尔果斯市", "parentid": 391}, "1137": {"ctype": "40", "cname": "尼勒克", "id": 1137, "cdesc": "尼勒克县", "parentid": 391}, "1138": {"ctype": "40", "cname": "伊宁", "id": 1138, "cdesc": "伊宁县", "parentid": 391}, "1139": {"ctype": "40", "cname": "霍城", "id": 1139, "cdesc": "霍城县", "parentid": 391}, "1140": {"ctype": "40", "cname": "巩留", "id": 1140, "cdesc": "巩留县", "parentid": 391}, "1141": {"ctype": "40", "cname": "新源", "id": 1141, "cdesc": "新源县", "parentid": 391}, "1142": {"ctype": "40", "cname": "昭苏", "id": 1142, "cdesc": "昭苏县", "parentid": 391}, "1143": {"ctype": "40", "cname": "特克斯", "id": 1143, "cdesc": "特克斯县", "parentid": 391}, "1144": {"ctype": "40", "cname": "察布查尔锡伯", "id": 1144, "cdesc": "察布查尔锡伯", "parentid": 391}, "1145": {"ctype": "40", "cname": "双桥", "id": 1145, "cdesc": "双桥区", "parentid": 65}, "1146": {"ctype": "40", "cname": "双滦", "id": 1146, "cdesc": "双滦区", "parentid": 65}, "1147": {"ctype": "40", "cname": "鹰手营子矿", "id": 1147, "cdesc": "鹰手营子矿区", "parentid": 65}, "1148": {"ctype": "40", "cname": "承德", "id": 1148, "cdesc": "承德县", "parentid": 65}, "1149": {"ctype": "40", "cname": "兴隆", "id": 1149, "cdesc": "兴隆县", "parentid": 65}, "1150": {"ctype": "40", "cname": "滦平", "id": 1150, "cdesc": "滦平县", "parentid": 65}, "1151": {"ctype": "40", "cname": "隆化", "id": 1151, "cdesc": "隆化县", "parentid": 65}, "1152": {"ctype": "40", "cname": "丰宁满族", "id": 1152, "cdesc": "丰宁满族", "parentid": 65}, "1153": {"ctype": "40", "cname": "宽城满族", "id": 1153, "cdesc": "宽城满族", "parentid": 65}, "1154": {"ctype": "40", "cname": "围场满族", "id": 1154, "cdesc": "围场满族", "parentid": 65}, "1155": {"ctype": "40", "cname": "平泉", "id": 1155, "cdesc": "平泉县", "parentid": 65}, "1156": {"ctype": "40", "cname": "阿图什", "id": 1156, "cdesc": "阿图什市", "parentid": 388}, "1157": {"ctype": "40", "cname": "阿克陶", "id": 1157, "cdesc": "阿克陶县", "parentid": 388}, "1158": {"ctype": "40", "cname": "阿合奇", "id": 1158, "cdesc": "阿合奇县", "parentid": 388}, "1159": {"ctype": "40", "cname": "乌恰", "id": 1159, "cdesc": "乌恰县", "parentid": 388}, "1160": {"ctype": "40", "cname": "运河", "id": 1160, "cdesc": "运河区", "parentid": 66}, "1161": {"ctype": "40", "cname": "新华", "id": 1161, "cdesc": "新华区", "parentid": 66}, "1162": {"ctype": "40", "cname": "沧县", "id": 1162, "cdesc": "沧县", "parentid": 66}, "1163": {"ctype": "40", "cname": "青县", "id": 1163, "cdesc": "青县", "parentid": 66}, "1164": {"ctype": "40", "cname": "东光", "id": 1164, "cdesc": "东光县", "parentid": 66}, "1165": {"ctype": "40", "cname": "海兴", "id": 1165, "cdesc": "海兴县", "parentid": 66}, "1166": {"ctype": "40", "cname": "盐山", "id": 1166, "cdesc": "盐山县", "parentid": 66}, "1167": {"ctype": "40", "cname": "肃宁", "id": 1167, "cdesc": "肃宁县", "parentid": 66}, "1168": {"ctype": "40", "cname": "南皮", "id": 1168, "cdesc": "南皮县", "parentid": 66}, "1169": {"ctype": "40", "cname": "吴桥", "id": 1169, "cdesc": "吴桥县", "parentid": 66}, "1170": {"ctype": "40", "cname": "献县", "id": 1170, "cdesc": "献县", "parentid": 66}, "1171": {"ctype": "40", "cname": "孟村回族", "id": 1171, "cdesc": "孟村回族", "parentid": 66}, "1172": {"ctype": "40", "cname": "泊头", "id": 1172, "cdesc": "泊头市", "parentid": 66}, "1173": {"ctype": "40", "cname": "黄骅", "id": 1173, "cdesc": "黄骅市", "parentid": 66}, "1174": {"ctype": "40", "cname": "河间", "id": 1174, "cdesc": "河间市", "parentid": 66}, "1175": {"ctype": "40", "cname": "任丘", "id": 1175, "cdesc": "任丘市", "parentid": 66}, "1176": {"ctype": "40", "cname": "库尔勒", "id": 1176, "cdesc": "库尔勒市", "parentid": 386}, "1177": {"ctype": "40", "cname": "焉耆回族", "id": 1177, "cdesc": "焉耆回族", "parentid": 386}, "1178": {"ctype": "40", "cname": "轮台", "id": 1178, "cdesc": "轮台县", "parentid": 386}, "1179": {"ctype": "40", "cname": "尉犁", "id": 1179, "cdesc": "尉犁县", "parentid": 386}, "1180": {"ctype": "40", "cname": "若羌", "id": 1180, "cdesc": "若羌县", "parentid": 386}, "1181": {"ctype": "40", "cname": "且末", "id": 1181, "cdesc": "且末县", "parentid": 386}, "1182": {"ctype": "40", "cname": "和静", "id": 1182, "cdesc": "和静县", "parentid": 386}, "1183": {"ctype": "40", "cname": "和硕", "id": 1183, "cdesc": "和硕县", "parentid": 386}, "1184": {"ctype": "40", "cname": "广阳", "id": 1184, "cdesc": "广阳区", "parentid": 67}, "1185": {"ctype": "40", "cname": "安次", "id": 1185, "cdesc": "安次区", "parentid": 67}, "1186": {"ctype": "40", "cname": "固安", "id": 1186, "cdesc": "固安县", "parentid": 67}, "1187": {"ctype": "40", "cname": "永清", "id": 1187, "cdesc": "永清县", "parentid": 67}, "1188": {"ctype": "40", "cname": "香河", "id": 1188, "cdesc": "香河县", "parentid": 67}, "1189": {"ctype": "40", "cname": "大城", "id": 1189, "cdesc": "大城县", "parentid": 67}, "1190": {"ctype": "40", "cname": "文安", "id": 1190, "cdesc": "文安县", "parentid": 67}, "1191": {"ctype": "40", "cname": "大厂回族", "id": 1191, "cdesc": "大厂回族", "parentid": 67}, "1192": {"ctype": "40", "cname": "霸州", "id": 1192, "cdesc": "霸州市", "parentid": 67}, "1193": {"ctype": "40", "cname": "三河", "id": 1193, "cdesc": "三河市", "parentid": 67}, "1198": {"ctype": "40", "cname": "桃城", "id": 1198, "cdesc": "桃城区", "parentid": 68}, "1199": {"ctype": "40", "cname": "冀州", "id": 1199, "cdesc": "冀州区", "parentid": 68}, "1200": {"ctype": "40", "cname": "枣强", "id": 1200, "cdesc": "枣强县", "parentid": 68}, "1201": {"ctype": "40", "cname": "武邑", "id": 1201, "cdesc": "武邑县", "parentid": 68}, "1202": {"ctype": "40", "cname": "武强", "id": 1202, "cdesc": "武强县", "parentid": 68}, "1203": {"ctype": "40", "cname": "饶阳", "id": 1203, "cdesc": "饶阳县", "parentid": 68}, "1204": {"ctype": "40", "cname": "安平", "id": 1204, "cdesc": "安平县", "parentid": 68}, "1205": {"ctype": "40", "cname": "故城", "id": 1205, "cdesc": "故城县", "parentid": 68}, "1206": {"ctype": "40", "cname": "阜城", "id": 1206, "cdesc": "阜城县", "parentid": 68}, "1207": {"ctype": "40", "cname": "深州", "id": 1207, "cdesc": "深州市", "parentid": 68}, "1208": {"ctype": "40", "cname": "景县", "id": 1208, "cdesc": "景县", "parentid": 68}, "1209": {"ctype": "40", "cname": "博乐", "id": 1209, "cdesc": "博乐市", "parentid": 385}, "1210": {"ctype": "40", "cname": "精河", "id": 1210, "cdesc": "精河县", "parentid": 385}, "1211": {"ctype": "40", "cname": "温泉", "id": 1211, "cdesc": "温泉县", "parentid": 385}, "1212": {"ctype": "40", "cname": "阿拉山口", "id": 1212, "cdesc": "阿拉山口市", "parentid": 385}, "1213": {"ctype": "40", "cname": "昌吉", "id": 1213, "cdesc": "昌吉市", "parentid": 384}, "1214": {"ctype": "40", "cname": "阜康", "id": 1214, "cdesc": "阜康市", "parentid": 384}, "1215": {"ctype": "40", "cname": "呼图壁", "id": 1215, "cdesc": "呼图壁县", "parentid": 384}, "1216": {"ctype": "40", "cname": "玛纳斯", "id": 1216, "cdesc": "玛纳斯县", "parentid": 384}, "1217": {"ctype": "40", "cname": "奇台", "id": 1217, "cdesc": "奇台县", "parentid": 384}, "1218": {"ctype": "40", "cname": "吉木萨尔", "id": 1218, "cdesc": "吉木萨尔县", "parentid": 384}, "1219": {"ctype": "40", "cname": "木垒哈萨克", "id": 1219, "cdesc": "木垒哈萨克", "parentid": 384}, "1220": {"ctype": "40", "cname": "和田", "id": 1220, "cdesc": "和田市", "parentid": 390}, "1221": {"ctype": "40", "cname": "和田", "id": 1221, "cdesc": "和田县", "parentid": 390}, "1222": {"ctype": "40", "cname": "墨玉", "id": 1222, "cdesc": "墨玉县", "parentid": 390}, "1223": {"ctype": "40", "cname": "皮山", "id": 1223, "cdesc": "皮山县", "parentid": 390}, "1224": {"ctype": "40", "cname": "洛浦", "id": 1224, "cdesc": "洛浦县", "parentid": 390}, "1225": {"ctype": "40", "cname": "策勒", "id": 1225, "cdesc": "策勒县", "parentid": 390}, "1226": {"ctype": "40", "cname": "于田", "id": 1226, "cdesc": "于田县", "parentid": 390}, "1227": {"ctype": "40", "cname": "喀什", "id": 1227, "cdesc": "喀什市", "parentid": 389}, "1228": {"ctype": "40", "cname": "疏附", "id": 1228, "cdesc": "疏附县", "parentid": 389}, "1229": {"ctype": "40", "cname": "疏勒", "id": 1229, "cdesc": "疏勒县", "parentid": 389}, "1230": {"ctype": "40", "cname": "英吉沙", "id": 1230, "cdesc": "英吉沙县", "parentid": 389}, "1231": {"ctype": "40", "cname": "泽普", "id": 1231, "cdesc": "泽普县", "parentid": 389}, "1232": {"ctype": "40", "cname": "莎车", "id": 1232, "cdesc": "莎车县", "parentid": 389}, "1233": {"ctype": "40", "cname": "叶城", "id": 1233, "cdesc": "叶城县", "parentid": 389}, "1234": {"ctype": "40", "cname": "麦盖提", "id": 1234, "cdesc": "麦盖提县", "parentid": 389}, "1235": {"ctype": "40", "cname": "岳普湖", "id": 1235, "cdesc": "岳普湖县", "parentid": 389}, "1236": {"ctype": "40", "cname": "伽师", "id": 1236, "cdesc": "伽师县", "parentid": 389}, "1237": {"ctype": "40", "cname": "巴楚", "id": 1237, "cdesc": "巴楚县", "parentid": 389}, "1238": {"ctype": "40", "cname": "塔什库尔干塔吉克", "id": 1238, "cdesc": "塔什库尔干塔吉克", "parentid": 389}, "1239": {"ctype": "40", "cname": "阿克苏", "id": 1239, "cdesc": "阿克苏市", "parentid": 387}, "1240": {"ctype": "40", "cname": "温宿", "id": 1240, "cdesc": "温宿县", "parentid": 387}, "1241": {"ctype": "40", "cname": "库车", "id": 1241, "cdesc": "库车县", "parentid": 387}, "1242": {"ctype": "40", "cname": "沙雅", "id": 1242, "cdesc": "沙雅县", "parentid": 387}, "1243": {"ctype": "40", "cname": "新和", "id": 1243, "cdesc": "新和县", "parentid": 387}, "1244": {"ctype": "40", "cname": "拜城", "id": 1244, "cdesc": "拜城县", "parentid": 387}, "1245": {"ctype": "40", "cname": "乌什", "id": 1245, "cdesc": "乌什县", "parentid": 387}, "1246": {"ctype": "40", "cname": "阿瓦提", "id": 1246, "cdesc": "阿瓦提县", "parentid": 387}, "1247": {"ctype": "40", "cname": "柯坪", "id": 1247, "cdesc": "柯坪县", "parentid": 387}, "1248": {"ctype": "40", "cname": "迎泽", "id": 1248, "cdesc": "迎泽区", "parentid": 69}, "1249": {"ctype": "40", "cname": "杏花岭", "id": 1249, "cdesc": "杏花岭区", "parentid": 69}, "1250": {"ctype": "40", "cname": "万柏林", "id": 1250, "cdesc": "万柏林区", "parentid": 69}, "1251": {"ctype": "40", "cname": "尖草坪", "id": 1251, "cdesc": "尖草坪区", "parentid": 69}, "1252": {"ctype": "40", "cname": "小店", "id": 1252, "cdesc": "小店区", "parentid": 69}, "1253": {"ctype": "40", "cname": "晋源", "id": 1253, "cdesc": "晋源区", "parentid": 69}, "1254": {"ctype": "40", "cname": "清徐", "id": 1254, "cdesc": "清徐县", "parentid": 69}, "1255": {"ctype": "40", "cname": "阳曲", "id": 1255, "cdesc": "阳曲县", "parentid": 69}, "1256": {"ctype": "40", "cname": "娄烦", "id": 1256, "cdesc": "娄烦县", "parentid": 69}, "1257": {"ctype": "40", "cname": "古交", "id": 1257, "cdesc": "古交市", "parentid": 69}, "1258": {"ctype": "40", "cname": "城区", "id": 1258, "cdesc": "城区", "parentid": 70}, "1259": {"ctype": "40", "cname": "矿区", "id": 1259, "cdesc": "矿区", "parentid": 70}, "1260": {"ctype": "40", "cname": "南郊", "id": 1260, "cdesc": "南郊区", "parentid": 70}, "1261": {"ctype": "40", "cname": "新荣", "id": 1261, "cdesc": "新荣区", "parentid": 70}, "1262": {"ctype": "40", "cname": "左云", "id": 1262, "cdesc": "左云县", "parentid": 70}, "1263": {"ctype": "40", "cname": "大同", "id": 1263, "cdesc": "大同县", "parentid": 70}, "1264": {"ctype": "40", "cname": "天镇", "id": 1264, "cdesc": "天镇县", "parentid": 70}, "1265": {"ctype": "40", "cname": "浑源", "id": 1265, "cdesc": "浑源县", "parentid": 70}, "1266": {"ctype": "40", "cname": "广灵", "id": 1266, "cdesc": "广灵县", "parentid": 70}, "1267": {"ctype": "40", "cname": "灵丘", "id": 1267, "cdesc": "灵丘县", "parentid": 70}, "1268": {"ctype": "40", "cname": "阳高", "id": 1268, "cdesc": "阳高县", "parentid": 70}, "1269": {"ctype": "40", "cname": "伊州", "id": 1269, "cdesc": "伊州区", "parentid": 383}, "1270": {"ctype": "40", "cname": "伊吾", "id": 1270, "cdesc": "伊吾县", "parentid": 383}, "1271": {"ctype": "40", "cname": "巴里坤哈萨克", "id": 1271, "cdesc": "巴里坤哈萨克", "parentid": 383}, "1272": {"ctype": "40", "cname": "城区", "id": 1272, "cdesc": "城区", "parentid": 71}, "1273": {"ctype": "40", "cname": "矿区", "id": 1273, "cdesc": "矿区", "parentid": 71}, "1274": {"ctype": "40", "cname": "郊区", "id": 1274, "cdesc": "郊区", "parentid": 71}, "1275": {"ctype": "40", "cname": "盂县", "id": 1275, "cdesc": "盂县", "parentid": 71}, "1276": {"ctype": "40", "cname": "平定", "id": 1276, "cdesc": "平定县", "parentid": 71}, "1277": {"ctype": "40", "cname": "高昌", "id": 1277, "cdesc": "高昌区", "parentid": 382}, "1278": {"ctype": "40", "cname": "鄯善", "id": 1278, "cdesc": "鄯善县", "parentid": 382}, "1279": {"ctype": "40", "cname": "托克逊", "id": 1279, "cdesc": "托克逊县", "parentid": 382}, "1280": {"ctype": "40", "cname": "城区", "id": 1280, "cdesc": "城区", "parentid": 72}, "1281": {"ctype": "40", "cname": "郊区", "id": 1281, "cdesc": "郊区", "parentid": 72}, "1282": {"ctype": "40", "cname": "长治", "id": 1282, "cdesc": "长治县", "parentid": 72}, "1283": {"ctype": "40", "cname": "襄垣", "id": 1283, "cdesc": "襄垣县", "parentid": 72}, "1284": {"ctype": "40", "cname": "屯留", "id": 1284, "cdesc": "屯留县", "parentid": 72}, "1285": {"ctype": "40", "cname": "平顺", "id": 1285, "cdesc": "平顺县", "parentid": 72}, "1286": {"ctype": "40", "cname": "黎城", "id": 1286, "cdesc": "黎城县", "parentid": 72}, "1287": {"ctype": "40", "cname": "壶关", "id": 1287, "cdesc": "壶关县", "parentid": 72}, "1288": {"ctype": "40", "cname": "长子", "id": 1288, "cdesc": "长子县", "parentid": 72}, "1289": {"ctype": "40", "cname": "武乡", "id": 1289, "cdesc": "武乡县", "parentid": 72}, "1290": {"ctype": "40", "cname": "沁县", "id": 1290, "cdesc": "沁县", "parentid": 72}, "1291": {"ctype": "40", "cname": "沁源", "id": 1291, "cdesc": "沁源县", "parentid": 72}, "1292": {"ctype": "40", "cname": "潞城", "id": 1292, "cdesc": "潞城市", "parentid": 72}, "1293": {"ctype": "40", "cname": "城区", "id": 1293, "cdesc": "城区", "parentid": 73}, "1294": {"ctype": "40", "cname": "泽州", "id": 1294, "cdesc": "泽州县", "parentid": 73}, "1295": {"ctype": "40", "cname": "阳城", "id": 1295, "cdesc": "阳城县", "parentid": 73}, "1296": {"ctype": "40", "cname": "陵川", "id": 1296, "cdesc": "陵川县", "parentid": 73}, "1297": {"ctype": "40", "cname": "沁水", "id": 1297, "cdesc": "沁水县", "parentid": 73}, "1298": {"ctype": "40", "cname": "高平", "id": 1298, "cdesc": "高平市", "parentid": 73}, "1299": {"ctype": "40", "cname": "朔城", "id": 1299, "cdesc": "朔城区", "parentid": 74}, "1300": {"ctype": "40", "cname": "平鲁", "id": 1300, "cdesc": "平鲁区", "parentid": 74}, "1301": {"ctype": "40", "cname": "山阴", "id": 1301, "cdesc": "山阴县", "parentid": 74}, "1302": {"ctype": "40", "cname": "应县", "id": 1302, "cdesc": "应县", "parentid": 74}, "1303": {"ctype": "40", "cname": "怀仁", "id": 1303, "cdesc": "怀仁县", "parentid": 74}, "1304": {"ctype": "40", "cname": "右玉", "id": 1304, "cdesc": "右玉县", "parentid": 74}, "1305": {"ctype": "40", "cname": "独山子", "id": 1305, "cdesc": "独山子区", "parentid": 381}, "1306": {"ctype": "40", "cname": "克拉玛依", "id": 1306, "cdesc": "克拉玛依区", "parentid": 381}, "1307": {"ctype": "40", "cname": "白碱滩", "id": 1307, "cdesc": "白碱滩区", "parentid": 381}, "1308": {"ctype": "40", "cname": "乌尔禾", "id": 1308, "cdesc": "乌尔禾区", "parentid": 381}, "1309": {"ctype": "40", "cname": "榆次", "id": 1309, "cdesc": "榆次区", "parentid": 75}, "1310": {"ctype": "40", "cname": "榆社", "id": 1310, "cdesc": "榆社县", "parentid": 75}, "1311": {"ctype": "40", "cname": "左权", "id": 1311, "cdesc": "左权县", "parentid": 75}, "1312": {"ctype": "40", "cname": "和顺", "id": 1312, "cdesc": "和顺县", "parentid": 75}, "1313": {"ctype": "40", "cname": "昔阳", "id": 1313, "cdesc": "昔阳县", "parentid": 75}, "1314": {"ctype": "40", "cname": "寿阳", "id": 1314, "cdesc": "寿阳县", "parentid": 75}, "1315": {"ctype": "40", "cname": "太谷", "id": 1315, "cdesc": "太谷县", "parentid": 75}, "1316": {"ctype": "40", "cname": "祁县", "id": 1316, "cdesc": "祁县", "parentid": 75}, "1317": {"ctype": "40", "cname": "平遥", "id": 1317, "cdesc": "平遥县", "parentid": 75}, "1318": {"ctype": "40", "cname": "灵石", "id": 1318, "cdesc": "灵石县", "parentid": 75}, "1319": {"ctype": "40", "cname": "介休", "id": 1319, "cdesc": "介休市", "parentid": 75}, "1320": {"ctype": "40", "cname": "天山", "id": 1320, "cdesc": "天山区", "parentid": 380}, "1321": {"ctype": "40", "cname": "沙依巴克", "id": 1321, "cdesc": "沙依巴克区", "parentid": 380}, "1322": {"ctype": "40", "cname": "新市", "id": 1322, "cdesc": "新市区", "parentid": 380}, "1323": {"ctype": "40", "cname": "水磨沟", "id": 1323, "cdesc": "水磨沟区", "parentid": 380}, "1324": {"ctype": "40", "cname": "头屯河", "id": 1324, "cdesc": "头屯河区", "parentid": 380}, "1325": {"ctype": "40", "cname": "达坂城", "id": 1325, "cdesc": "达坂城区", "parentid": 380}, "1326": {"ctype": "40", "cname": "米东", "id": 1326, "cdesc": "米东区", "parentid": 380}, "1327": {"ctype": "40", "cname": "乌鲁木齐", "id": 1327, "cdesc": "乌鲁木齐县", "parentid": 380}, "1328": {"ctype": "40", "cname": "盐湖", "id": 1328, "cdesc": "盐湖区", "parentid": 76}, "1329": {"ctype": "40", "cname": "临猗", "id": 1329, "cdesc": "临猗县", "parentid": 76}, "1330": {"ctype": "40", "cname": "芮城", "id": 1330, "cdesc": "芮城县", "parentid": 76}, "1331": {"ctype": "40", "cname": "万荣", "id": 1331, "cdesc": "万荣县", "parentid": 76}, "1332": {"ctype": "40", "cname": "新绛", "id": 1332, "cdesc": "新绛县", "parentid": 76}, "1333": {"ctype": "40", "cname": "稷山", "id": 1333, "cdesc": "稷山县", "parentid": 76}, "1334": {"ctype": "40", "cname": "闻喜", "id": 1334, "cdesc": "闻喜县", "parentid": 76}, "1335": {"ctype": "40", "cname": "夏县", "id": 1335, "cdesc": "夏县", "parentid": 76}, "1336": {"ctype": "40", "cname": "绛县", "id": 1336, "cdesc": "绛县", "parentid": 76}, "1337": {"ctype": "40", "cname": "平陆", "id": 1337, "cdesc": "平陆县", "parentid": 76}, "1338": {"ctype": "40", "cname": "垣曲", "id": 1338, "cdesc": "垣曲县", "parentid": 76}, "1339": {"ctype": "40", "cname": "河津", "id": 1339, "cdesc": "河津市", "parentid": 76}, "1340": {"ctype": "40", "cname": "永济", "id": 1340, "cdesc": "永济市", "parentid": 76}, "1341": {"ctype": "40", "cname": "沙坡头", "id": 1341, "cdesc": "沙坡头区", "parentid": 379}, "1342": {"ctype": "40", "cname": "中宁", "id": 1342, "cdesc": "中宁县", "parentid": 379}, "1343": {"ctype": "40", "cname": "海原", "id": 1343, "cdesc": "海原县", "parentid": 379}, "1344": {"ctype": "40", "cname": "忻府", "id": 1344, "cdesc": "忻府区", "parentid": 77}, "1345": {"ctype": "40", "cname": "定襄", "id": 1345, "cdesc": "定襄县", "parentid": 77}, "1346": {"ctype": "40", "cname": "五台", "id": 1346, "cdesc": "五台县", "parentid": 77}, "1347": {"ctype": "40", "cname": "代县", "id": 1347, "cdesc": "代县", "parentid": 77}, "1348": {"ctype": "40", "cname": "繁峙", "id": 1348, "cdesc": "繁峙县", "parentid": 77}, "1349": {"ctype": "40", "cname": "宁武", "id": 1349, "cdesc": "宁武县", "parentid": 77}, "1350": {"ctype": "40", "cname": "静乐", "id": 1350, "cdesc": "静乐县", "parentid": 77}, "1351": {"ctype": "40", "cname": "神池", "id": 1351, "cdesc": "神池县", "parentid": 77}, "1352": {"ctype": "40", "cname": "五寨", "id": 1352, "cdesc": "五寨县", "parentid": 77}, "1353": {"ctype": "40", "cname": "岢岚", "id": 1353, "cdesc": "岢岚县", "parentid": 77}, "1354": {"ctype": "40", "cname": "偏关", "id": 1354, "cdesc": "偏关县", "parentid": 77}, "1355": {"ctype": "40", "cname": "河曲", "id": 1355, "cdesc": "河曲县", "parentid": 77}, "1356": {"ctype": "40", "cname": "保德", "id": 1356, "cdesc": "保德县", "parentid": 77}, "1357": {"ctype": "40", "cname": "原平", "id": 1357, "cdesc": "原平市", "parentid": 77}, "1358": {"ctype": "40", "cname": "原州", "id": 1358, "cdesc": "原州区", "parentid": 378}, "1359": {"ctype": "40", "cname": "西吉", "id": 1359, "cdesc": "西吉县", "parentid": 378}, "1360": {"ctype": "40", "cname": "隆德", "id": 1360, "cdesc": "隆德县", "parentid": 378}, "1361": {"ctype": "40", "cname": "泾源", "id": 1361, "cdesc": "泾源县", "parentid": 378}, "1362": {"ctype": "40", "cname": "彭阳", "id": 1362, "cdesc": "彭阳县", "parentid": 378}, "1363": {"ctype": "40", "cname": "尧都", "id": 1363, "cdesc": "尧都区", "parentid": 78}, "1364": {"ctype": "40", "cname": "曲沃", "id": 1364, "cdesc": "曲沃县", "parentid": 78}, "1365": {"ctype": "40", "cname": "翼城", "id": 1365, "cdesc": "翼城县", "parentid": 78}, "1366": {"ctype": "40", "cname": "襄汾", "id": 1366, "cdesc": "襄汾县", "parentid": 78}, "1367": {"ctype": "40", "cname": "洪洞", "id": 1367, "cdesc": "洪洞县", "parentid": 78}, "1368": {"ctype": "40", "cname": "古县", "id": 1368, "cdesc": "古县", "parentid": 78}, "1369": {"ctype": "40", "cname": "浮山", "id": 1369, "cdesc": "浮山县", "parentid": 78}, "1370": {"ctype": "40", "cname": "吉县", "id": 1370, "cdesc": "吉县", "parentid": 78}, "1371": {"ctype": "40", "cname": "乡宁", "id": 1371, "cdesc": "乡宁县", "parentid": 78}, "1372": {"ctype": "40", "cname": "蒲县", "id": 1372, "cdesc": "蒲县", "parentid": 78}, "1373": {"ctype": "40", "cname": "大宁", "id": 1373, "cdesc": "大宁县", "parentid": 78}, "1374": {"ctype": "40", "cname": "永和", "id": 1374, "cdesc": "永和县", "parentid": 78}, "1375": {"ctype": "40", "cname": "汾西", "id": 1375, "cdesc": "汾西县", "parentid": 78}, "1376": {"ctype": "40", "cname": "隰县", "id": 1376, "cdesc": "隰县", "parentid": 78}, "1377": {"ctype": "40", "cname": "安泽", "id": 1377, "cdesc": "安泽县", "parentid": 78}, "1378": {"ctype": "40", "cname": "侯马", "id": 1378, "cdesc": "侯马市", "parentid": 78}, "1379": {"ctype": "40", "cname": "霍州", "id": 1379, "cdesc": "霍州市", "parentid": 78}, "1380": {"ctype": "40", "cname": "利通", "id": 1380, "cdesc": "利通区", "parentid": 377}, "1381": {"ctype": "40", "cname": "红寺堡", "id": 1381, "cdesc": "红寺堡区", "parentid": 377}, "1382": {"ctype": "40", "cname": "青铜峡", "id": 1382, "cdesc": "青铜峡市", "parentid": 377}, "1383": {"ctype": "40", "cname": "同心", "id": 1383, "cdesc": "同心县", "parentid": 377}, "1384": {"ctype": "40", "cname": "盐池", "id": 1384, "cdesc": "盐池县", "parentid": 377}, "1385": {"ctype": "40", "cname": "离石", "id": 1385, "cdesc": "离石区", "parentid": 79}, "1386": {"ctype": "40", "cname": "文水", "id": 1386, "cdesc": "文水县", "parentid": 79}, "1387": {"ctype": "40", "cname": "交城", "id": 1387, "cdesc": "交城县", "parentid": 79}, "1388": {"ctype": "40", "cname": "兴县", "id": 1388, "cdesc": "兴县", "parentid": 79}, "1389": {"ctype": "40", "cname": "临县", "id": 1389, "cdesc": "临县", "parentid": 79}, "1390": {"ctype": "40", "cname": "柳林", "id": 1390, "cdesc": "柳林县", "parentid": 79}, "1391": {"ctype": "40", "cname": "岚县", "id": 1391, "cdesc": "岚县", "parentid": 79}, "1392": {"ctype": "40", "cname": "石楼", "id": 1392, "cdesc": "石楼县", "parentid": 79}, "1393": {"ctype": "40", "cname": "交口", "id": 1393, "cdesc": "交口县", "parentid": 79}, "1394": {"ctype": "40", "cname": "方山", "id": 1394, "cdesc": "方山县", "parentid": 79}, "1395": {"ctype": "40", "cname": "中阳", "id": 1395, "cdesc": "中阳县", "parentid": 79}, "1396": {"ctype": "40", "cname": "孝义", "id": 1396, "cdesc": "孝义市", "parentid": 79}, "1397": {"ctype": "40", "cname": "汾阳", "id": 1397, "cdesc": "汾阳市", "parentid": 79}, "1398": {"ctype": "40", "cname": "大武口", "id": 1398, "cdesc": "大武口区", "parentid": 376}, "1399": {"ctype": "40", "cname": "惠农", "id": 1399, "cdesc": "惠农区", "parentid": 376}, "1400": {"ctype": "40", "cname": "平罗", "id": 1400, "cdesc": "平罗县", "parentid": 376}, "1401": {"ctype": "40", "cname": "兴庆", "id": 1401, "cdesc": "兴庆区", "parentid": 375}, "1402": {"ctype": "40", "cname": "金凤", "id": 1402, "cdesc": "金凤区", "parentid": 375}, "1403": {"ctype": "40", "cname": "西夏", "id": 1403, "cdesc": "西夏区", "parentid": 375}, "1404": {"ctype": "40", "cname": "灵武", "id": 1404, "cdesc": "灵武市", "parentid": 375}, "1405": {"ctype": "40", "cname": "永宁", "id": 1405, "cdesc": "永宁县", "parentid": 375}, "1406": {"ctype": "40", "cname": "贺兰", "id": 1406, "cdesc": "贺兰县", "parentid": 375}, "1407": {"ctype": "40", "cname": "德令哈", "id": 1407, "cdesc": "德令哈市", "parentid": 374}, "1408": {"ctype": "40", "cname": "格尔木", "id": 1408, "cdesc": "格尔木市", "parentid": 374}, "1409": {"ctype": "40", "cname": "天峻", "id": 1409, "cdesc": "天峻县", "parentid": 374}, "1410": {"ctype": "40", "cname": "都兰", "id": 1410, "cdesc": "都兰县", "parentid": 374}, "1411": {"ctype": "40", "cname": "乌兰", "id": 1411, "cdesc": "乌兰县", "parentid": 374}, "1412": {"ctype": "40", "cname": "回民", "id": 1412, "cdesc": "回民区", "parentid": 80}, "1413": {"ctype": "40", "cname": "新城", "id": 1413, "cdesc": "新城区", "parentid": 80}, "1414": {"ctype": "40", "cname": "玉泉", "id": 1414, "cdesc": "玉泉区", "parentid": 80}, "1415": {"ctype": "40", "cname": "赛罕", "id": 1415, "cdesc": "赛罕区", "parentid": 80}, "1416": {"ctype": "40", "cname": "土默特左旗", "id": 1416, "cdesc": "土默特左旗", "parentid": 80}, "1417": {"ctype": "40", "cname": "托克托", "id": 1417, "cdesc": "托克托县", "parentid": 80}, "1418": {"ctype": "40", "cname": "和林格尔", "id": 1418, "cdesc": "和林格尔县", "parentid": 80}, "1419": {"ctype": "40", "cname": "武川", "id": 1419, "cdesc": "武川县", "parentid": 80}, "1420": {"ctype": "40", "cname": "清水河", "id": 1420, "cdesc": "清水河县", "parentid": 80}, "1421": {"ctype": "40", "cname": "杂多", "id": 1421, "cdesc": "杂多县", "parentid": 373}, "1422": {"ctype": "40", "cname": "称多", "id": 1422, "cdesc": "称多县", "parentid": 373}, "1423": {"ctype": "40", "cname": "治多", "id": 1423, "cdesc": "治多县", "parentid": 373}, "1424": {"ctype": "40", "cname": "囊谦", "id": 1424, "cdesc": "囊谦县", "parentid": 373}, "1425": {"ctype": "40", "cname": "曲麻莱", "id": 1425, "cdesc": "曲麻莱县", "parentid": 373}, "1426": {"ctype": "40", "cname": "昆都仑", "id": 1426, "cdesc": "昆都仑区", "parentid": 81}, "1427": {"ctype": "40", "cname": "东河", "id": 1427, "cdesc": "东河区", "parentid": 81}, "1428": {"ctype": "40", "cname": "青山", "id": 1428, "cdesc": "青山区", "parentid": 81}, "1429": {"ctype": "40", "cname": "石拐", "id": 1429, "cdesc": "石拐区", "parentid": 81}, "1430": {"ctype": "40", "cname": "九原", "id": 1430, "cdesc": "九原区", "parentid": 81}, "1431": {"ctype": "40", "cname": "白云鄂博矿", "id": 1431, "cdesc": "白云鄂博矿区", "parentid": 81}, "1432": {"ctype": "40", "cname": "土默特右旗", "id": 1432, "cdesc": "土默特右旗", "parentid": 81}, "1433": {"ctype": "40", "cname": "固阳", "id": 1433, "cdesc": "固阳县", "parentid": 81}, "1434": {"ctype": "40", "cname": "达尔罕", "id": 1434, "cdesc": "达尔罕", "parentid": 81}, "1435": {"ctype": "40", "cname": "海勃湾", "id": 1435, "cdesc": "海勃湾区", "parentid": 82}, "1436": {"ctype": "40", "cname": "海南", "id": 1436, "cdesc": "海南区", "parentid": 82}, "1437": {"ctype": "40", "cname": "乌达", "id": 1437, "cdesc": "乌达区", "parentid": 82}, "1438": {"ctype": "40", "cname": "红山", "id": 1438, "cdesc": "红山区", "parentid": 83}, "1439": {"ctype": "40", "cname": "元宝山", "id": 1439, "cdesc": "元宝山区", "parentid": 83}, "1440": {"ctype": "40", "cname": "松山", "id": 1440, "cdesc": "松山区", "parentid": 83}, "1441": {"ctype": "40", "cname": "阿鲁科尔沁旗", "id": 1441, "cdesc": "阿鲁科尔沁旗", "parentid": 83}, "1442": {"ctype": "40", "cname": "巴林左旗", "id": 1442, "cdesc": "巴林左旗", "parentid": 83}, "1443": {"ctype": "40", "cname": "巴林右旗", "id": 1443, "cdesc": "巴林右旗", "parentid": 83}, "1444": {"ctype": "40", "cname": "林西", "id": 1444, "cdesc": "林西县", "parentid": 83}, "1445": {"ctype": "40", "cname": "克什克腾旗", "id": 1445, "cdesc": "克什克腾旗", "parentid": 83}, "1446": {"ctype": "40", "cname": "翁牛特旗", "id": 1446, "cdesc": "翁牛特旗", "parentid": 83}, "1447": {"ctype": "40", "cname": "喀喇沁旗", "id": 1447, "cdesc": "喀喇沁旗", "parentid": 83}, "1448": {"ctype": "40", "cname": "宁城", "id": 1448, "cdesc": "宁城县", "parentid": 83}, "1449": {"ctype": "40", "cname": "敖汉旗", "id": 1449, "cdesc": "敖汉旗", "parentid": 83}, "1450": {"ctype": "40", "cname": "科尔沁", "id": 1450, "cdesc": "科尔沁区", "parentid": 84}, "1451": {"ctype": "40", "cname": "霍林郭勒", "id": 1451, "cdesc": "霍林郭勒市", "parentid": 84}, "1452": {"ctype": "40", "cname": "科尔沁左翼中旗", "id": 1452, "cdesc": "科尔沁左翼中旗", "parentid": 84}, "1453": {"ctype": "40", "cname": "科尔沁左翼后旗", "id": 1453, "cdesc": "科尔沁左翼后旗", "parentid": 84}, "1454": {"ctype": "40", "cname": "开鲁", "id": 1454, "cdesc": "开鲁县", "parentid": 84}, "1455": {"ctype": "40", "cname": "库伦旗", "id": 1455, "cdesc": "库伦旗", "parentid": 84}, "1456": {"ctype": "40", "cname": "奈曼旗", "id": 1456, "cdesc": "奈曼旗", "parentid": 84}, "1457": {"ctype": "40", "cname": "扎鲁特旗", "id": 1457, "cdesc": "扎鲁特旗", "parentid": 84}, "1458": {"ctype": "40", "cname": "玉树", "id": 1458, "cdesc": "玉树市", "parentid": 373}, "1459": {"ctype": "40", "cname": "东胜", "id": 1459, "cdesc": "东胜区", "parentid": 85}, "1460": {"ctype": "40", "cname": "康巴什", "id": 1460, "cdesc": "康巴什区", "parentid": 85}, "1461": {"ctype": "40", "cname": "达拉特旗", "id": 1461, "cdesc": "达拉特旗", "parentid": 85}, "1462": {"ctype": "40", "cname": "准格尔旗", "id": 1462, "cdesc": "准格尔旗", "parentid": 85}, "1463": {"ctype": "40", "cname": "鄂托克前旗", "id": 1463, "cdesc": "鄂托克前旗", "parentid": 85}, "1464": {"ctype": "40", "cname": "鄂托克旗", "id": 1464, "cdesc": "鄂托克旗", "parentid": 85}, "1465": {"ctype": "40", "cname": "杭锦旗", "id": 1465, "cdesc": "杭锦旗", "parentid": 85}, "1466": {"ctype": "40", "cname": "乌审旗", "id": 1466, "cdesc": "乌审旗", "parentid": 85}, "1467": {"ctype": "40", "cname": "伊金霍洛旗", "id": 1467, "cdesc": "伊金霍洛旗", "parentid": 85}, "1468": {"ctype": "40", "cname": "海拉尔", "id": 1468, "cdesc": "海拉尔区", "parentid": 86}, "1469": {"ctype": "40", "cname": "满洲里", "id": 1469, "cdesc": "满洲里市", "parentid": 86}, "1470": {"ctype": "40", "cname": "牙克石", "id": 1470, "cdesc": "牙克石市", "parentid": 86}, "1471": {"ctype": "40", "cname": "扎兰屯", "id": 1471, "cdesc": "扎兰屯市", "parentid": 86}, "1472": {"ctype": "40", "cname": "额尔古纳", "id": 1472, "cdesc": "额尔古纳市", "parentid": 86}, "1473": {"ctype": "40", "cname": "根河", "id": 1473, "cdesc": "根河市", "parentid": 86}, "1474": {"ctype": "40", "cname": "阿荣旗", "id": 1474, "cdesc": "阿荣旗", "parentid": 86}, "1475": {"ctype": "40", "cname": "鄂伦春自治旗", "id": 1475, "cdesc": "鄂伦春自治旗", "parentid": 86}, "1476": {"ctype": "40", "cname": "莫力达瓦达斡尔族", "id": 1476, "cdesc": "莫力达瓦达斡尔族", "parentid": 86}, "1477": {"ctype": "40", "cname": "鄂温克族", "id": 1477, "cdesc": "鄂温克族", "parentid": 86}, "1478": {"ctype": "40", "cname": "陈巴尔虎旗", "id": 1478, "cdesc": "陈巴尔虎旗", "parentid": 86}, "1479": {"ctype": "40", "cname": "新巴尔虎左旗", "id": 1479, "cdesc": "新巴尔虎左旗", "parentid": 86}, "1480": {"ctype": "40", "cname": "新巴尔虎右旗", "id": 1480, "cdesc": "新巴尔虎右旗", "parentid": 86}, "1481": {"ctype": "40", "cname": "临河", "id": 1481, "cdesc": "临河区", "parentid": 87}, "1482": {"ctype": "40", "cname": "五原", "id": 1482, "cdesc": "五原县", "parentid": 87}, "1483": {"ctype": "40", "cname": "磴口", "id": 1483, "cdesc": "磴口县", "parentid": 87}, "1484": {"ctype": "40", "cname": "乌拉特前旗", "id": 1484, "cdesc": "乌拉特前旗", "parentid": 87}, "1485": {"ctype": "40", "cname": "乌拉特中旗", "id": 1485, "cdesc": "乌拉特中旗", "parentid": 87}, "1486": {"ctype": "40", "cname": "乌拉特后旗", "id": 1486, "cdesc": "乌拉特后旗", "parentid": 87}, "1487": {"ctype": "40", "cname": "杭锦后旗", "id": 1487, "cdesc": "杭锦后旗", "parentid": 87}, "1488": {"ctype": "40", "cname": "集宁", "id": 1488, "cdesc": "集宁区", "parentid": 88}, "1489": {"ctype": "40", "cname": "丰镇", "id": 1489, "cdesc": "丰镇市", "parentid": 88}, "1490": {"ctype": "40", "cname": "卓资", "id": 1490, "cdesc": "卓资县", "parentid": 88}, "1491": {"ctype": "40", "cname": "化德", "id": 1491, "cdesc": "化德县", "parentid": 88}, "1492": {"ctype": "40", "cname": "商都", "id": 1492, "cdesc": "商都县", "parentid": 88}, "1493": {"ctype": "40", "cname": "兴和", "id": 1493, "cdesc": "兴和县", "parentid": 88}, "1494": {"ctype": "40", "cname": "凉城", "id": 1494, "cdesc": "凉城县", "parentid": 88}, "1495": {"ctype": "40", "cname": "察哈尔右翼前旗", "id": 1495, "cdesc": "察哈尔右翼前旗", "parentid": 88}, "1496": {"ctype": "40", "cname": "察哈尔右翼中旗", "id": 1496, "cdesc": "察哈尔右翼中旗", "parentid": 88}, "1497": {"ctype": "40", "cname": "察哈尔右翼后旗", "id": 1497, "cdesc": "察哈尔右翼后旗", "parentid": 88}, "1498": {"ctype": "40", "cname": "四子王旗", "id": 1498, "cdesc": "四子王旗", "parentid": 88}, "1499": {"ctype": "40", "cname": "玛沁", "id": 1499, "cdesc": "玛沁县", "parentid": 372}, "1500": {"ctype": "40", "cname": "班玛", "id": 1500, "cdesc": "班玛县", "parentid": 372}, "1501": {"ctype": "40", "cname": "甘德", "id": 1501, "cdesc": "甘德县", "parentid": 372}, "1502": {"ctype": "40", "cname": "达日", "id": 1502, "cdesc": "达日县", "parentid": 372}, "1503": {"ctype": "40", "cname": "久治", "id": 1503, "cdesc": "久治县", "parentid": 372}, "1504": {"ctype": "40", "cname": "玛多", "id": 1504, "cdesc": "玛多县", "parentid": 372}, "1505": {"ctype": "40", "cname": "乌兰浩特", "id": 1505, "cdesc": "乌兰浩特市", "parentid": 89}, "1506": {"ctype": "40", "cname": "阿尔山", "id": 1506, "cdesc": "阿尔山市", "parentid": 89}, "1507": {"ctype": "40", "cname": "科尔沁右翼前旗", "id": 1507, "cdesc": "科尔沁右翼前旗", "parentid": 89}, "1508": {"ctype": "40", "cname": "科尔沁右翼中旗", "id": 1508, "cdesc": "科尔沁右翼中旗", "parentid": 89}, "1509": {"ctype": "40", "cname": "扎赉特旗", "id": 1509, "cdesc": "扎赉特旗", "parentid": 89}, "1510": {"ctype": "40", "cname": "突泉", "id": 1510, "cdesc": "突泉县", "parentid": 89}, "1511": {"ctype": "40", "cname": "共和", "id": 1511, "cdesc": "共和县", "parentid": 371}, "1512": {"ctype": "40", "cname": "同德", "id": 1512, "cdesc": "同德县", "parentid": 371}, "1513": {"ctype": "40", "cname": "贵德", "id": 1513, "cdesc": "贵德县", "parentid": 371}, "1514": {"ctype": "40", "cname": "兴海", "id": 1514, "cdesc": "兴海县", "parentid": 371}, "1515": {"ctype": "40", "cname": "贵南", "id": 1515, "cdesc": "贵南县", "parentid": 371}, "1516": {"ctype": "40", "cname": "锡林浩特", "id": 1516, "cdesc": "锡林浩特市", "parentid": 90}, "1517": {"ctype": "40", "cname": "二连浩特", "id": 1517, "cdesc": "二连浩特市", "parentid": 90}, "1518": {"ctype": "40", "cname": "阿巴嘎旗", "id": 1518, "cdesc": "阿巴嘎旗", "parentid": 90}, "1519": {"ctype": "40", "cname": "苏尼特左旗", "id": 1519, "cdesc": "苏尼特左旗", "parentid": 90}, "1520": {"ctype": "40", "cname": "苏尼特右旗", "id": 1520, "cdesc": "苏尼特右旗", "parentid": 90}, "1521": {"ctype": "40", "cname": "东乌珠穆沁旗", "id": 1521, "cdesc": "东乌珠穆沁旗", "parentid": 90}, "1522": {"ctype": "40", "cname": "西乌珠穆沁旗", "id": 1522, "cdesc": "西乌珠穆沁旗", "parentid": 90}, "1523": {"ctype": "40", "cname": "太仆寺旗", "id": 1523, "cdesc": "太仆寺旗", "parentid": 90}, "1524": {"ctype": "40", "cname": "镶黄旗", "id": 1524, "cdesc": "镶黄旗", "parentid": 90}, "1525": {"ctype": "40", "cname": "正镶白旗", "id": 1525, "cdesc": "正镶白旗", "parentid": 90}, "1526": {"ctype": "40", "cname": "正蓝旗", "id": 1526, "cdesc": "正蓝旗", "parentid": 90}, "1527": {"ctype": "40", "cname": "多伦", "id": 1527, "cdesc": "多伦县", "parentid": 90}, "1528": {"ctype": "40", "cname": "阿拉善左旗", "id": 1528, "cdesc": "阿拉善左旗", "parentid": 91}, "1529": {"ctype": "40", "cname": "阿拉善右旗", "id": 1529, "cdesc": "阿拉善右旗", "parentid": 91}, "1530": {"ctype": "40", "cname": "额济纳旗", "id": 1530, "cdesc": "额济纳旗", "parentid": 91}, "1531": {"ctype": "40", "cname": "同仁", "id": 1531, "cdesc": "同仁县", "parentid": 370}, "1532": {"ctype": "40", "cname": "尖扎", "id": 1532, "cdesc": "尖扎县", "parentid": 370}, "1533": {"ctype": "40", "cname": "泽库", "id": 1533, "cdesc": "泽库县", "parentid": 370}, "1534": {"ctype": "40", "cname": "河南蒙古族", "id": 1534, "cdesc": "河南蒙古族", "parentid": 370}, "1535": {"ctype": "40", "cname": "海晏", "id": 1535, "cdesc": "海晏县", "parentid": 369}, "1536": {"ctype": "40", "cname": "祁连", "id": 1536, "cdesc": "祁连县", "parentid": 369}, "1537": {"ctype": "40", "cname": "刚察", "id": 1537, "cdesc": "刚察县", "parentid": 369}, "1538": {"ctype": "40", "cname": "门源回族", "id": 1538, "cdesc": "门源回族", "parentid": 369}, "1539": {"ctype": "40", "cname": "乐都", "id": 1539, "cdesc": "乐都区", "parentid": 368}, "1540": {"ctype": "40", "cname": "平安", "id": 1540, "cdesc": "平安区", "parentid": 368}, "1541": {"ctype": "40", "cname": "民和回族土族", "id": 1541, "cdesc": "民和回族土族", "parentid": 368}, "1542": {"ctype": "40", "cname": "互助土族", "id": 1542, "cdesc": "互助土族", "parentid": 368}, "1543": {"ctype": "40", "cname": "化隆回族", "id": 1543, "cdesc": "化隆回族", "parentid": 368}, "1544": {"ctype": "40", "cname": "循化撒拉族", "id": 1544, "cdesc": "循化撒拉族", "parentid": 368}, "1545": {"ctype": "40", "cname": "城中", "id": 1545, "cdesc": "城中区", "parentid": 367}, "1546": {"ctype": "40", "cname": "城东", "id": 1546, "cdesc": "城东区", "parentid": 367}, "1547": {"ctype": "40", "cname": "城西", "id": 1547, "cdesc": "城西区", "parentid": 367}, "1548": {"ctype": "40", "cname": "城北", "id": 1548, "cdesc": "城北区", "parentid": 367}, "1549": {"ctype": "40", "cname": "大通回族", "id": 1549, "cdesc": "大通回族", "parentid": 367}, "1550": {"ctype": "40", "cname": "湟中", "id": 1550, "cdesc": "湟中县", "parentid": 367}, "1551": {"ctype": "40", "cname": "湟源", "id": 1551, "cdesc": "湟源县", "parentid": 367}, "1552": {"ctype": "40", "cname": "玄武", "id": 1552, "cdesc": "玄武区", "parentid": 130}, "1553": {"ctype": "40", "cname": "秦淮", "id": 1553, "cdesc": "秦淮区", "parentid": 130}, "1554": {"ctype": "40", "cname": "鼓楼", "id": 1554, "cdesc": "鼓楼区", "parentid": 130}, "1555": {"ctype": "40", "cname": "建邺", "id": 1555, "cdesc": "建邺区", "parentid": 130}, "1556": {"ctype": "40", "cname": "栖霞", "id": 1556, "cdesc": "栖霞区", "parentid": 130}, "1557": {"ctype": "40", "cname": "雨花台", "id": 1557, "cdesc": "雨花台区", "parentid": 130}, "1558": {"ctype": "40", "cname": "江宁", "id": 1558, "cdesc": "江宁区", "parentid": 130}, "1559": {"ctype": "40", "cname": "浦口", "id": 1559, "cdesc": "浦口区", "parentid": 130}, "1560": {"ctype": "40", "cname": "六合", "id": 1560, "cdesc": "六合区", "parentid": 130}, "1561": {"ctype": "40", "cname": "溧水", "id": 1561, "cdesc": "溧水区", "parentid": 130}, "1562": {"ctype": "40", "cname": "高淳", "id": 1562, "cdesc": "高淳区", "parentid": 130}, "1563": {"ctype": "40", "cname": "合作", "id": 1563, "cdesc": "合作市", "parentid": 366}, "1564": {"ctype": "40", "cname": "夏河", "id": 1564, "cdesc": "夏河县", "parentid": 366}, "1565": {"ctype": "40", "cname": "玛曲", "id": 1565, "cdesc": "玛曲县", "parentid": 366}, "1566": {"ctype": "40", "cname": "舟曲", "id": 1566, "cdesc": "舟曲县", "parentid": 366}, "1567": {"ctype": "40", "cname": "碌曲", "id": 1567, "cdesc": "碌曲县", "parentid": 366}, "1568": {"ctype": "40", "cname": "迭部", "id": 1568, "cdesc": "迭部县", "parentid": 366}, "1569": {"ctype": "40", "cname": "临潭", "id": 1569, "cdesc": "临潭县", "parentid": 366}, "1570": {"ctype": "40", "cname": "卓尼", "id": 1570, "cdesc": "卓尼县", "parentid": 366}, "1571": {"ctype": "40", "cname": "梁溪", "id": 1571, "cdesc": "梁溪区", "parentid": 131}, "1572": {"ctype": "40", "cname": "滨湖", "id": 1572, "cdesc": "滨湖区", "parentid": 131}, "1573": {"ctype": "40", "cname": "新吴", "id": 1573, "cdesc": "新吴区", "parentid": 131}, "1574": {"ctype": "40", "cname": "锡山", "id": 1574, "cdesc": "锡山区", "parentid": 131}, "1575": {"ctype": "40", "cname": "惠山", "id": 1575, "cdesc": "惠山区", "parentid": 131}, "1576": {"ctype": "40", "cname": "江阴", "id": 1576, "cdesc": "江阴市", "parentid": 131}, "1577": {"ctype": "40", "cname": "宜兴", "id": 1577, "cdesc": "宜兴市", "parentid": 131}, "1578": {"ctype": "40", "cname": "临夏", "id": 1578, "cdesc": "临夏市", "parentid": 365}, "1579": {"ctype": "40", "cname": "临夏", "id": 1579, "cdesc": "临夏县", "parentid": 365}, "1580": {"ctype": "40", "cname": "康乐", "id": 1580, "cdesc": "康乐县", "parentid": 365}, "1581": {"ctype": "40", "cname": "广河", "id": 1581, "cdesc": "广河县", "parentid": 365}, "1582": {"ctype": "40", "cname": "永靖", "id": 1582, "cdesc": "永靖县", "parentid": 365}, "1583": {"ctype": "40", "cname": "和政", "id": 1583, "cdesc": "和政县", "parentid": 365}, "1584": {"ctype": "40", "cname": "东乡族自治", "id": 1584, "cdesc": "东乡族自治县", "parentid": 365}, "1585": {"ctype": "40", "cname": "积石山保安族", "id": 1585, "cdesc": "积石山保安族", "parentid": 365}, "1586": {"ctype": "40", "cname": "云龙", "id": 1586, "cdesc": "云龙区", "parentid": 132}, "1587": {"ctype": "40", "cname": "鼓楼", "id": 1587, "cdesc": "鼓楼区", "parentid": 132}, "1588": {"ctype": "40", "cname": "贾汪", "id": 1588, "cdesc": "贾汪区", "parentid": 132}, "1589": {"ctype": "40", "cname": "泉山", "id": 1589, "cdesc": "泉山区", "parentid": 132}, "1590": {"ctype": "40", "cname": "铜山", "id": 1590, "cdesc": "铜山区", "parentid": 132}, "1591": {"ctype": "40", "cname": "丰县", "id": 1591, "cdesc": "丰县", "parentid": 132}, "1592": {"ctype": "40", "cname": "沛县", "id": 1592, "cdesc": "沛县", "parentid": 132}, "1593": {"ctype": "40", "cname": "睢宁", "id": 1593, "cdesc": "睢宁县", "parentid": 132}, "1594": {"ctype": "40", "cname": "邳州", "id": 1594, "cdesc": "邳州市", "parentid": 132}, "1595": {"ctype": "40", "cname": "新沂", "id": 1595, "cdesc": "新沂市", "parentid": 132}, "1596": {"ctype": "40", "cname": "西峰", "id": 1596, "cdesc": "西峰区", "parentid": 362}, "1597": {"ctype": "40", "cname": "正宁", "id": 1597, "cdesc": "正宁县", "parentid": 362}, "1598": {"ctype": "40", "cname": "华池", "id": 1598, "cdesc": "华池县", "parentid": 362}, "1599": {"ctype": "40", "cname": "合水", "id": 1599, "cdesc": "合水县", "parentid": 362}, "1600": {"ctype": "40", "cname": "宁县", "id": 1600, "cdesc": "宁县", "parentid": 362}, "1601": {"ctype": "40", "cname": "庆城", "id": 1601, "cdesc": "庆城县", "parentid": 362}, "1602": {"ctype": "40", "cname": "镇原", "id": 1602, "cdesc": "镇原县", "parentid": 362}, "1603": {"ctype": "40", "cname": "环县", "id": 1603, "cdesc": "环县", "parentid": 362}, "1604": {"ctype": "40", "cname": "天宁", "id": 1604, "cdesc": "天宁区", "parentid": 133}, "1605": {"ctype": "40", "cname": "钟楼", "id": 1605, "cdesc": "钟楼区", "parentid": 133}, "1606": {"ctype": "40", "cname": "新北", "id": 1606, "cdesc": "新北区", "parentid": 133}, "1607": {"ctype": "40", "cname": "武进", "id": 1607, "cdesc": "武进区", "parentid": 133}, "1608": {"ctype": "40", "cname": "金坛", "id": 1608, "cdesc": "金坛区", "parentid": 133}, "1609": {"ctype": "40", "cname": "溧阳", "id": 1609, "cdesc": "溧阳市", "parentid": 133}, "1610": {"ctype": "40", "cname": "姑苏", "id": 1610, "cdesc": "姑苏区", "parentid": 134}, "1611": {"ctype": "40", "cname": "虎丘", "id": 1611, "cdesc": "虎丘区", "parentid": 134}, "1612": {"ctype": "40", "cname": "吴中", "id": 1612, "cdesc": "吴中区", "parentid": 134}, "1613": {"ctype": "40", "cname": "相城", "id": 1613, "cdesc": "相城区", "parentid": 134}, "1614": {"ctype": "40", "cname": "吴江", "id": 1614, "cdesc": "吴江区", "parentid": 134}, "1615": {"ctype": "40", "cname": "张家港", "id": 1615, "cdesc": "张家港市", "parentid": 134}, "1616": {"ctype": "40", "cname": "昆山", "id": 1616, "cdesc": "昆山市", "parentid": 134}, "1617": {"ctype": "40", "cname": "太仓", "id": 1617, "cdesc": "太仓市", "parentid": 134}, "1618": {"ctype": "40", "cname": "常熟", "id": 1618, "cdesc": "常熟市", "parentid": 134}, "1619": {"ctype": "40", "cname": "崇川", "id": 1619, "cdesc": "崇川区", "parentid": 135}, "1620": {"ctype": "40", "cname": "港闸", "id": 1620, "cdesc": "港闸区", "parentid": 135}, "1621": {"ctype": "40", "cname": "通州", "id": 1621, "cdesc": "通州区", "parentid": 135}, "1622": {"ctype": "40", "cname": "海安", "id": 1622, "cdesc": "海安县", "parentid": 135}, "1623": {"ctype": "40", "cname": "如东", "id": 1623, "cdesc": "如东县", "parentid": 135}, "1624": {"ctype": "40", "cname": "如皋", "id": 1624, "cdesc": "如皋市", "parentid": 135}, "1625": {"ctype": "40", "cname": "海门", "id": 1625, "cdesc": "海门市", "parentid": 135}, "1626": {"ctype": "40", "cname": "启东", "id": 1626, "cdesc": "启东市", "parentid": 135}, "1627": {"ctype": "40", "cname": "崆峒", "id": 1627, "cdesc": "崆峒区", "parentid": 360}, "1628": {"ctype": "40", "cname": "泾川", "id": 1628, "cdesc": "泾川县", "parentid": 360}, "1629": {"ctype": "40", "cname": "灵台", "id": 1629, "cdesc": "灵台县", "parentid": 360}, "1630": {"ctype": "40", "cname": "崇信", "id": 1630, "cdesc": "崇信县", "parentid": 360}, "1631": {"ctype": "40", "cname": "华亭", "id": 1631, "cdesc": "华亭县", "parentid": 360}, "1632": {"ctype": "40", "cname": "庄浪", "id": 1632, "cdesc": "庄浪县", "parentid": 360}, "1633": {"ctype": "40", "cname": "静宁", "id": 1633, "cdesc": "静宁县", "parentid": 360}, "1634": {"ctype": "40", "cname": "连云", "id": 1634, "cdesc": "连云区", "parentid": 136}, "1635": {"ctype": "40", "cname": "海州", "id": 1635, "cdesc": "海州区", "parentid": 136}, "1636": {"ctype": "40", "cname": "赣榆", "id": 1636, "cdesc": "赣榆区", "parentid": 136}, "1637": {"ctype": "40", "cname": "东海", "id": 1637, "cdesc": "东海县", "parentid": 136}, "1638": {"ctype": "40", "cname": "灌云", "id": 1638, "cdesc": "灌云县", "parentid": 136}, "1639": {"ctype": "40", "cname": "灌南", "id": 1639, "cdesc": "灌南县", "parentid": 136}, "1640": {"ctype": "40", "cname": "武都", "id": 1640, "cdesc": "武都区", "parentid": 364}, "1641": {"ctype": "40", "cname": "宕昌", "id": 1641, "cdesc": "宕昌县", "parentid": 364}, "1642": {"ctype": "40", "cname": "两当", "id": 1642, "cdesc": "两当县", "parentid": 364}, "1643": {"ctype": "40", "cname": "徽县", "id": 1643, "cdesc": "徽县", "parentid": 364}, "1644": {"ctype": "40", "cname": "成县", "id": 1644, "cdesc": "成县", "parentid": 364}, "1645": {"ctype": "40", "cname": "西和", "id": 1645, "cdesc": "西和县", "parentid": 364}, "1646": {"ctype": "40", "cname": "礼县", "id": 1646, "cdesc": "礼县", "parentid": 364}, "1647": {"ctype": "40", "cname": "康县", "id": 1647, "cdesc": "康县", "parentid": 364}, "1648": {"ctype": "40", "cname": "文县", "id": 1648, "cdesc": "文县", "parentid": 364}, "1649": {"ctype": "40", "cname": "清江浦", "id": 1649, "cdesc": "清江浦区", "parentid": 137}, "1650": {"ctype": "40", "cname": "淮安", "id": 1650, "cdesc": "淮安区", "parentid": 137}, "1651": {"ctype": "40", "cname": "淮阴", "id": 1651, "cdesc": "淮阴区", "parentid": 137}, "1652": {"ctype": "40", "cname": "洪泽", "id": 1652, "cdesc": "洪泽区", "parentid": 137}, "1653": {"ctype": "40", "cname": "涟水", "id": 1653, "cdesc": "涟水县", "parentid": 137}, "1654": {"ctype": "40", "cname": "盱眙", "id": 1654, "cdesc": "盱眙县", "parentid": 137}, "1655": {"ctype": "40", "cname": "金湖", "id": 1655, "cdesc": "金湖县", "parentid": 137}, "1656": {"ctype": "40", "cname": "安定", "id": 1656, "cdesc": "安定区", "parentid": 363}, "1657": {"ctype": "40", "cname": "通渭", "id": 1657, "cdesc": "通渭县", "parentid": 363}, "1658": {"ctype": "40", "cname": "陇西", "id": 1658, "cdesc": "陇西县", "parentid": 363}, "1659": {"ctype": "40", "cname": "漳县", "id": 1659, "cdesc": "漳县", "parentid": 363}, "1660": {"ctype": "40", "cname": "渭源", "id": 1660, "cdesc": "渭源县", "parentid": 363}, "1661": {"ctype": "40", "cname": "岷县", "id": 1661, "cdesc": "岷县", "parentid": 363}, "1662": {"ctype": "40", "cname": "临洮", "id": 1662, "cdesc": "临洮县", "parentid": 363}, "1663": {"ctype": "40", "cname": "亭湖", "id": 1663, "cdesc": "亭湖区", "parentid": 138}, "1664": {"ctype": "40", "cname": "盐都", "id": 1664, "cdesc": "盐都区", "parentid": 138}, "1665": {"ctype": "40", "cname": "大丰", "id": 1665, "cdesc": "大丰区", "parentid": 138}, "1666": {"ctype": "40", "cname": "响水", "id": 1666, "cdesc": "响水县", "parentid": 138}, "1667": {"ctype": "40", "cname": "滨海", "id": 1667, "cdesc": "滨海县", "parentid": 138}, "1668": {"ctype": "40", "cname": "阜宁", "id": 1668, "cdesc": "阜宁县", "parentid": 138}, "1669": {"ctype": "40", "cname": "射阳", "id": 1669, "cdesc": "射阳县", "parentid": 138}, "1670": {"ctype": "40", "cname": "建湖", "id": 1670, "cdesc": "建湖县", "parentid": 138}, "1671": {"ctype": "40", "cname": "东台", "id": 1671, "cdesc": "东台市", "parentid": 138}, "1672": {"ctype": "40", "cname": "凉州", "id": 1672, "cdesc": "凉州区", "parentid": 358}, "1673": {"ctype": "40", "cname": "古浪", "id": 1673, "cdesc": "古浪县", "parentid": 358}, "1674": {"ctype": "40", "cname": "民勤", "id": 1674, "cdesc": "民勤县", "parentid": 358}, "1675": {"ctype": "40", "cname": "天祝藏族", "id": 1675, "cdesc": "天祝藏族", "parentid": 358}, "1676": {"ctype": "40", "cname": "广陵", "id": 1676, "cdesc": "广陵区", "parentid": 139}, "1677": {"ctype": "40", "cname": "邗江", "id": 1677, "cdesc": "邗江区", "parentid": 139}, "1678": {"ctype": "40", "cname": "江都", "id": 1678, "cdesc": "江都区", "parentid": 139}, "1679": {"ctype": "40", "cname": "宝应", "id": 1679, "cdesc": "宝应县", "parentid": 139}, "1680": {"ctype": "40", "cname": "仪征", "id": 1680, "cdesc": "仪征市", "parentid": 139}, "1681": {"ctype": "40", "cname": "高邮", "id": 1681, "cdesc": "高邮市", "parentid": 139}, "1682": {"ctype": "40", "cname": "甘州", "id": 1682, "cdesc": "甘州区", "parentid": 359}, "1683": {"ctype": "40", "cname": "山丹", "id": 1683, "cdesc": "山丹县", "parentid": 359}, "1684": {"ctype": "40", "cname": "民乐", "id": 1684, "cdesc": "民乐县", "parentid": 359}, "1685": {"ctype": "40", "cname": "临泽", "id": 1685, "cdesc": "临泽县", "parentid": 359}, "1686": {"ctype": "40", "cname": "高台", "id": 1686, "cdesc": "高台县", "parentid": 359}, "1687": {"ctype": "40", "cname": "肃南裕固族", "id": 1687, "cdesc": "肃南裕固族", "parentid": 359}, "1688": {"ctype": "40", "cname": "京口", "id": 1688, "cdesc": "京口区", "parentid": 140}, "1689": {"ctype": "40", "cname": "润州", "id": 1689, "cdesc": "润州区", "parentid": 140}, "1690": {"ctype": "40", "cname": "丹徒", "id": 1690, "cdesc": "丹徒区", "parentid": 140}, "1691": {"ctype": "40", "cname": "丹阳", "id": 1691, "cdesc": "丹阳市", "parentid": 140}, "1692": {"ctype": "40", "cname": "扬中", "id": 1692, "cdesc": "扬中市", "parentid": 140}, "1693": {"ctype": "40", "cname": "句容", "id": 1693, "cdesc": "句容市", "parentid": 140}, "1694": {"ctype": "40", "cname": "肃州", "id": 1694, "cdesc": "肃州区", "parentid": 361}, "1695": {"ctype": "40", "cname": "玉门", "id": 1695, "cdesc": "玉门市", "parentid": 361}, "1696": {"ctype": "40", "cname": "敦煌", "id": 1696, "cdesc": "敦煌市", "parentid": 361}, "1697": {"ctype": "40", "cname": "瓜州", "id": 1697, "cdesc": "瓜州县", "parentid": 361}, "1698": {"ctype": "40", "cname": "金塔", "id": 1698, "cdesc": "金塔县", "parentid": 361}, "1699": {"ctype": "40", "cname": "肃北蒙古族", "id": 1699, "cdesc": "肃北蒙古族", "parentid": 361}, "1700": {"ctype": "40", "cname": "阿克塞哈萨克族", "id": 1700, "cdesc": "阿克塞哈萨克族", "parentid": 361}, "1701": {"ctype": "40", "cname": "海陵", "id": 1701, "cdesc": "海陵区", "parentid": 141}, "1702": {"ctype": "40", "cname": "高港", "id": 1702, "cdesc": "高港区", "parentid": 141}, "1703": {"ctype": "40", "cname": "姜堰", "id": 1703, "cdesc": "姜堰区", "parentid": 141}, "1704": {"ctype": "40", "cname": "兴化", "id": 1704, "cdesc": "兴化市", "parentid": 141}, "1705": {"ctype": "40", "cname": "靖江", "id": 1705, "cdesc": "靖江市", "parentid": 141}, "1706": {"ctype": "40", "cname": "泰兴", "id": 1706, "cdesc": "泰兴市", "parentid": 141}, "1707": {"ctype": "40", "cname": "秦州", "id": 1707, "cdesc": "秦州区", "parentid": 357}, "1708": {"ctype": "40", "cname": "麦积", "id": 1708, "cdesc": "麦积区", "parentid": 357}, "1709": {"ctype": "40", "cname": "清水", "id": 1709, "cdesc": "清水县", "parentid": 357}, "1710": {"ctype": "40", "cname": "秦安", "id": 1710, "cdesc": "秦安县", "parentid": 357}, "1711": {"ctype": "40", "cname": "甘谷", "id": 1711, "cdesc": "甘谷县", "parentid": 357}, "1712": {"ctype": "40", "cname": "武山", "id": 1712, "cdesc": "武山县", "parentid": 357}, "1713": {"ctype": "40", "cname": "张家川回族自治", "id": 1713, "cdesc": "张家川回族自治县", "parentid": 357}, "1714": {"ctype": "40", "cname": "宿城", "id": 1714, "cdesc": "宿城区", "parentid": 142}, "1715": {"ctype": "40", "cname": "宿豫", "id": 1715, "cdesc": "宿豫区", "parentid": 142}, "1716": {"ctype": "40", "cname": "沭阳", "id": 1716, "cdesc": "沭阳县", "parentid": 142}, "1717": {"ctype": "40", "cname": "泗阳", "id": 1717, "cdesc": "泗阳县", "parentid": 142}, "1718": {"ctype": "40", "cname": "泗洪", "id": 1718, "cdesc": "泗洪县", "parentid": 142}, "1719": {"ctype": "40", "cname": "白银", "id": 1719, "cdesc": "白银区", "parentid": 356}, "1720": {"ctype": "40", "cname": "平川", "id": 1720, "cdesc": "平川区", "parentid": 356}, "1721": {"ctype": "40", "cname": "会宁", "id": 1721, "cdesc": "会宁县", "parentid": 356}, "1722": {"ctype": "40", "cname": "靖远", "id": 1722, "cdesc": "靖远县", "parentid": 356}, "1723": {"ctype": "40", "cname": "景泰", "id": 1723, "cdesc": "景泰县", "parentid": 356}, "1724": {"ctype": "40", "cname": "金川", "id": 1724, "cdesc": "金川区", "parentid": 355}, "1725": {"ctype": "40", "cname": "永昌", "id": 1725, "cdesc": "永昌县", "parentid": 355}, "1726": {"ctype": "40", "cname": "上城", "id": 1726, "cdesc": "上城区", "parentid": 143}, "1727": {"ctype": "40", "cname": "下城", "id": 1727, "cdesc": "下城区", "parentid": 143}, "1728": {"ctype": "40", "cname": "江干", "id": 1728, "cdesc": "江干区", "parentid": 143}, "1729": {"ctype": "40", "cname": "拱墅", "id": 1729, "cdesc": "拱墅区", "parentid": 143}, "1730": {"ctype": "40", "cname": "西湖", "id": 1730, "cdesc": "西湖区", "parentid": 143}, "1731": {"ctype": "40", "cname": "滨江", "id": 1731, "cdesc": "滨江区", "parentid": 143}, "1732": {"ctype": "40", "cname": "余杭", "id": 1732, "cdesc": "余杭区", "parentid": 143}, "1733": {"ctype": "40", "cname": "萧山", "id": 1733, "cdesc": "萧山区", "parentid": 143}, "1734": {"ctype": "40", "cname": "富阳", "id": 1734, "cdesc": "富阳区", "parentid": 143}, "1735": {"ctype": "40", "cname": "建德", "id": 1735, "cdesc": "建德市", "parentid": 143}, "1736": {"ctype": "40", "cname": "临安", "id": 1736, "cdesc": "临安市", "parentid": 143}, "1737": {"ctype": "40", "cname": "桐庐", "id": 1737, "cdesc": "桐庐县", "parentid": 143}, "1738": {"ctype": "40", "cname": "淳安", "id": 1738, "cdesc": "淳安县", "parentid": 143}, "1739": {"ctype": "40", "cname": "峪泉镇", "id": 1739, "cdesc": "峪泉镇", "parentid": 354}, "1740": {"ctype": "40", "cname": "文殊镇", "id": 1740, "cdesc": "文殊镇", "parentid": 354}, "1741": {"ctype": "40", "cname": "新城镇", "id": 1741, "cdesc": "新城镇", "parentid": 354}, "1742": {"ctype": "40", "cname": "海曙", "id": 1742, "cdesc": "海曙区", "parentid": 144}, "1743": {"ctype": "40", "cname": "江东", "id": 1743, "cdesc": "江东区", "parentid": 144}, "1744": {"ctype": "40", "cname": "江北", "id": 1744, "cdesc": "江北区", "parentid": 144}, "1745": {"ctype": "40", "cname": "北仑", "id": 1745, "cdesc": "北仑区", "parentid": 144}, "1746": {"ctype": "40", "cname": "镇海", "id": 1746, "cdesc": "镇海区", "parentid": 144}, "1747": {"ctype": "40", "cname": "鄞州", "id": 1747, "cdesc": "鄞州区", "parentid": 144}, "1748": {"ctype": "40", "cname": "余姚", "id": 1748, "cdesc": "余姚市", "parentid": 144}, "1749": {"ctype": "40", "cname": "慈溪", "id": 1749, "cdesc": "慈溪市", "parentid": 144}, "1750": {"ctype": "40", "cname": "奉化", "id": 1750, "cdesc": "奉化市", "parentid": 144}, "1751": {"ctype": "40", "cname": "象山", "id": 1751, "cdesc": "象山县", "parentid": 144}, "1752": {"ctype": "40", "cname": "宁海", "id": 1752, "cdesc": "宁海县", "parentid": 144}, "1753": {"ctype": "40", "cname": "城关", "id": 1753, "cdesc": "城关区", "parentid": 353}, "1754": {"ctype": "40", "cname": "七里河", "id": 1754, "cdesc": "七里河区", "parentid": 353}, "1755": {"ctype": "40", "cname": "西固", "id": 1755, "cdesc": "西固区", "parentid": 353}, "1756": {"ctype": "40", "cname": "安宁", "id": 1756, "cdesc": "安宁区", "parentid": 353}, "1757": {"ctype": "40", "cname": "红古", "id": 1757, "cdesc": "红古区", "parentid": 353}, "1758": {"ctype": "40", "cname": "榆中", "id": 1758, "cdesc": "榆中县", "parentid": 353}, "1759": {"ctype": "40", "cname": "皋兰", "id": 1759, "cdesc": "皋兰县", "parentid": 353}, "1760": {"ctype": "40", "cname": "永登", "id": 1760, "cdesc": "永登县", "parentid": 353}, "1761": {"ctype": "40", "cname": "鹿城", "id": 1761, "cdesc": "鹿城区", "parentid": 145}, "1762": {"ctype": "40", "cname": "龙湾", "id": 1762, "cdesc": "龙湾区", "parentid": 145}, "1763": {"ctype": "40", "cname": "瓯海", "id": 1763, "cdesc": "瓯海区", "parentid": 145}, "1764": {"ctype": "40", "cname": "洞头", "id": 1764, "cdesc": "洞头区", "parentid": 145}, "1765": {"ctype": "40", "cname": "瑞安", "id": 1765, "cdesc": "瑞安市", "parentid": 145}, "1766": {"ctype": "40", "cname": "乐清", "id": 1766, "cdesc": "乐清市", "parentid": 145}, "1767": {"ctype": "40", "cname": "永嘉", "id": 1767, "cdesc": "永嘉县", "parentid": 145}, "1768": {"ctype": "40", "cname": "平阳", "id": 1768, "cdesc": "平阳县", "parentid": 145}, "1769": {"ctype": "40", "cname": "苍南", "id": 1769, "cdesc": "苍南县", "parentid": 145}, "1770": {"ctype": "40", "cname": "文成", "id": 1770, "cdesc": "文成县", "parentid": 145}, "1771": {"ctype": "40", "cname": "泰顺", "id": 1771, "cdesc": "泰顺县", "parentid": 145}, "1778": {"ctype": "40", "cname": "越城", "id": 1778, "cdesc": "越城区", "parentid": 148}, "1779": {"ctype": "40", "cname": "柯桥", "id": 1779, "cdesc": "柯桥区", "parentid": 148}, "1780": {"ctype": "40", "cname": "上虞", "id": 1780, "cdesc": "上虞区", "parentid": 148}, "1781": {"ctype": "40", "cname": "诸暨", "id": 1781, "cdesc": "诸暨市", "parentid": 148}, "1782": {"ctype": "40", "cname": "嵊州", "id": 1782, "cdesc": "嵊州市", "parentid": 148}, "1783": {"ctype": "40", "cname": "新昌", "id": 1783, "cdesc": "新昌县", "parentid": 148}, "1784": {"ctype": "40", "cname": "吴兴", "id": 1784, "cdesc": "吴兴区", "parentid": 147}, "1785": {"ctype": "40", "cname": "南浔", "id": 1785, "cdesc": "南浔区", "parentid": 147}, "1786": {"ctype": "40", "cname": "德清", "id": 1786, "cdesc": "德清县", "parentid": 147}, "1787": {"ctype": "40", "cname": "长兴", "id": 1787, "cdesc": "长兴县", "parentid": 147}, "1788": {"ctype": "40", "cname": "安吉", "id": 1788, "cdesc": "安吉县", "parentid": 147}, "1789": {"ctype": "40", "cname": "南湖", "id": 1789, "cdesc": "南湖区", "parentid": 146}, "1790": {"ctype": "40", "cname": "秀洲", "id": 1790, "cdesc": "秀洲区", "parentid": 146}, "1791": {"ctype": "40", "cname": "海宁", "id": 1791, "cdesc": "海宁市", "parentid": 146}, "1792": {"ctype": "40", "cname": "平湖", "id": 1792, "cdesc": "平湖市", "parentid": 146}, "1793": {"ctype": "40", "cname": "桐乡", "id": 1793, "cdesc": "桐乡市", "parentid": 146}, "1794": {"ctype": "40", "cname": "嘉善", "id": 1794, "cdesc": "嘉善县", "parentid": 146}, "1795": {"ctype": "40", "cname": "海盐", "id": 1795, "cdesc": "海盐县", "parentid": 146}, "1796": {"ctype": "40", "cname": "商州", "id": 1796, "cdesc": "商州区", "parentid": 352}, "1797": {"ctype": "40", "cname": "洛南", "id": 1797, "cdesc": "洛南县", "parentid": 352}, "1798": {"ctype": "40", "cname": "丹凤", "id": 1798, "cdesc": "丹凤县", "parentid": 352}, "1799": {"ctype": "40", "cname": "商南", "id": 1799, "cdesc": "商南县", "parentid": 352}, "1800": {"ctype": "40", "cname": "山阳", "id": 1800, "cdesc": "山阳县", "parentid": 352}, "1801": {"ctype": "40", "cname": "镇安", "id": 1801, "cdesc": "镇安县", "parentid": 352}, "1802": {"ctype": "40", "cname": "柞水", "id": 1802, "cdesc": "柞水县", "parentid": 352}, "1803": {"ctype": "40", "cname": "汉台", "id": 1803, "cdesc": "汉台区", "parentid": 349}, "1804": {"ctype": "40", "cname": "南郑", "id": 1804, "cdesc": "南郑县", "parentid": 349}, "1805": {"ctype": "40", "cname": "城固", "id": 1805, "cdesc": "城固县", "parentid": 349}, "1806": {"ctype": "40", "cname": "洋县", "id": 1806, "cdesc": "洋县", "parentid": 349}, "1807": {"ctype": "40", "cname": "西乡", "id": 1807, "cdesc": "西乡县", "parentid": 349}, "1808": {"ctype": "40", "cname": "勉县", "id": 1808, "cdesc": "勉县", "parentid": 349}, "1809": {"ctype": "40", "cname": "宁强", "id": 1809, "cdesc": "宁强县", "parentid": 349}, "1810": {"ctype": "40", "cname": "略阳", "id": 1810, "cdesc": "略阳县", "parentid": 349}, "1811": {"ctype": "40", "cname": "镇巴", "id": 1811, "cdesc": "镇巴县", "parentid": 349}, "1812": {"ctype": "40", "cname": "留坝", "id": 1812, "cdesc": "留坝县", "parentid": 349}, "1813": {"ctype": "40", "cname": "佛坪", "id": 1813, "cdesc": "佛坪县", "parentid": 349}, "1814": {"ctype": "40", "cname": "婺城", "id": 1814, "cdesc": "婺城区", "parentid": 149}, "1815": {"ctype": "40", "cname": "金东", "id": 1815, "cdesc": "金东区", "parentid": 149}, "1816": {"ctype": "40", "cname": "兰溪", "id": 1816, "cdesc": "兰溪市", "parentid": 149}, "1817": {"ctype": "40", "cname": "东阳", "id": 1817, "cdesc": "东阳市", "parentid": 149}, "1818": {"ctype": "40", "cname": "永康", "id": 1818, "cdesc": "永康市", "parentid": 149}, "1819": {"ctype": "40", "cname": "义乌", "id": 1819, "cdesc": "义乌市", "parentid": 149}, "1820": {"ctype": "40", "cname": "武义", "id": 1820, "cdesc": "武义县", "parentid": 149}, "1821": {"ctype": "40", "cname": "浦江", "id": 1821, "cdesc": "浦江县", "parentid": 149}, "1822": {"ctype": "40", "cname": "磐安", "id": 1822, "cdesc": "磐安县", "parentid": 149}, "1823": {"ctype": "40", "cname": "汉滨", "id": 1823, "cdesc": "汉滨区", "parentid": 351}, "1824": {"ctype": "40", "cname": "旬阳", "id": 1824, "cdesc": "旬阳县", "parentid": 351}, "1825": {"ctype": "40", "cname": "石泉", "id": 1825, "cdesc": "石泉县", "parentid": 351}, "1826": {"ctype": "40", "cname": "平利", "id": 1826, "cdesc": "平利县", "parentid": 351}, "1827": {"ctype": "40", "cname": "汉阴", "id": 1827, "cdesc": "汉阴县", "parentid": 351}, "1828": {"ctype": "40", "cname": "宁陕", "id": 1828, "cdesc": "宁陕县", "parentid": 351}, "1829": {"ctype": "40", "cname": "紫阳", "id": 1829, "cdesc": "紫阳县", "parentid": 351}, "1830": {"ctype": "40", "cname": "岚皋", "id": 1830, "cdesc": "岚皋县", "parentid": 351}, "1831": {"ctype": "40", "cname": "镇坪", "id": 1831, "cdesc": "镇坪县", "parentid": 351}, "1832": {"ctype": "40", "cname": "白河", "id": 1832, "cdesc": "白河县", "parentid": 351}, "1833": {"ctype": "40", "cname": "榆阳", "id": 1833, "cdesc": "榆阳区", "parentid": 350}, "1834": {"ctype": "40", "cname": "横山", "id": 1834, "cdesc": "横山区", "parentid": 350}, "1835": {"ctype": "40", "cname": "神木", "id": 1835, "cdesc": "神木县", "parentid": 350}, "1836": {"ctype": "40", "cname": "府谷", "id": 1836, "cdesc": "府谷县", "parentid": 350}, "1837": {"ctype": "40", "cname": "靖边", "id": 1837, "cdesc": "靖边县", "parentid": 350}, "1838": {"ctype": "40", "cname": "定边", "id": 1838, "cdesc": "定边县", "parentid": 350}, "1839": {"ctype": "40", "cname": "绥德", "id": 1839, "cdesc": "绥德县", "parentid": 350}, "1840": {"ctype": "40", "cname": "米脂", "id": 1840, "cdesc": "米脂县", "parentid": 350}, "1841": {"ctype": "40", "cname": "佳县", "id": 1841, "cdesc": "佳县", "parentid": 350}, "1842": {"ctype": "40", "cname": "吴堡", "id": 1842, "cdesc": "吴堡县", "parentid": 350}, "1843": {"ctype": "40", "cname": "清涧", "id": 1843, "cdesc": "清涧县", "parentid": 350}, "1844": {"ctype": "40", "cname": "子洲", "id": 1844, "cdesc": "子洲县", "parentid": 350}, "1845": {"ctype": "40", "cname": "柯城", "id": 1845, "cdesc": "柯城区", "parentid": 150}, "1846": {"ctype": "40", "cname": "衢江", "id": 1846, "cdesc": "衢江区", "parentid": 150}, "1847": {"ctype": "40", "cname": "江山", "id": 1847, "cdesc": "江山市", "parentid": 150}, "1848": {"ctype": "40", "cname": "常山", "id": 1848, "cdesc": "常山县", "parentid": 150}, "1849": {"ctype": "40", "cname": "开化", "id": 1849, "cdesc": "开化县", "parentid": 150}, "1850": {"ctype": "40", "cname": "龙游", "id": 1850, "cdesc": "龙游县", "parentid": 150}, "1851": {"ctype": "40", "cname": "宝塔", "id": 1851, "cdesc": "宝塔区", "parentid": 348}, "1852": {"ctype": "40", "cname": "延长", "id": 1852, "cdesc": "延长县", "parentid": 348}, "1853": {"ctype": "40", "cname": "延川", "id": 1853, "cdesc": "延川县", "parentid": 348}, "1854": {"ctype": "40", "cname": "子长", "id": 1854, "cdesc": "子长县", "parentid": 348}, "1855": {"ctype": "40", "cname": "安塞", "id": 1855, "cdesc": "安塞县", "parentid": 348}, "1856": {"ctype": "40", "cname": "志丹", "id": 1856, "cdesc": "志丹县", "parentid": 348}, "1857": {"ctype": "40", "cname": "吴起", "id": 1857, "cdesc": "吴起县", "parentid": 348}, "1858": {"ctype": "40", "cname": "甘泉", "id": 1858, "cdesc": "甘泉县", "parentid": 348}, "1859": {"ctype": "40", "cname": "富县", "id": 1859, "cdesc": "富县", "parentid": 348}, "1860": {"ctype": "40", "cname": "洛川", "id": 1860, "cdesc": "洛川县", "parentid": 348}, "1861": {"ctype": "40", "cname": "宜川", "id": 1861, "cdesc": "宜川县", "parentid": 348}, "1862": {"ctype": "40", "cname": "黄龙", "id": 1862, "cdesc": "黄龙县", "parentid": 348}, "1863": {"ctype": "40", "cname": "黄陵", "id": 1863, "cdesc": "黄陵县", "parentid": 348}, "1864": {"ctype": "40", "cname": "椒江", "id": 1864, "cdesc": "椒江区", "parentid": 152}, "1865": {"ctype": "40", "cname": "黄岩", "id": 1865, "cdesc": "黄岩区", "parentid": 152}, "1866": {"ctype": "40", "cname": "路桥", "id": 1866, "cdesc": "路桥区", "parentid": 152}, "1867": {"ctype": "40", "cname": "临海", "id": 1867, "cdesc": "临海市", "parentid": 152}, "1868": {"ctype": "40", "cname": "温岭", "id": 1868, "cdesc": "温岭市", "parentid": 152}, "1869": {"ctype": "40", "cname": "玉环", "id": 1869, "cdesc": "玉环县", "parentid": 152}, "1870": {"ctype": "40", "cname": "三门", "id": 1870, "cdesc": "三门县", "parentid": 152}, "1871": {"ctype": "40", "cname": "天台", "id": 1871, "cdesc": "天台县", "parentid": 152}, "1872": {"ctype": "40", "cname": "仙居", "id": 1872, "cdesc": "仙居县", "parentid": 152}, "1873": {"ctype": "40", "cname": "耀州", "id": 1873, "cdesc": "耀州区", "parentid": 344}, "1874": {"ctype": "40", "cname": "王益", "id": 1874, "cdesc": "王益区", "parentid": 344}, "1875": {"ctype": "40", "cname": "印台", "id": 1875, "cdesc": "印台区", "parentid": 344}, "1876": {"ctype": "40", "cname": "宜君", "id": 1876, "cdesc": "宜君县", "parentid": 344}, "1877": {"ctype": "40", "cname": "莲都", "id": 1877, "cdesc": "莲都区", "parentid": 153}, "1878": {"ctype": "40", "cname": "龙泉", "id": 1878, "cdesc": "龙泉市", "parentid": 153}, "1879": {"ctype": "40", "cname": "青田", "id": 1879, "cdesc": "青田县", "parentid": 153}, "1880": {"ctype": "40", "cname": "松阳", "id": 1880, "cdesc": "松阳县", "parentid": 153}, "1881": {"ctype": "40", "cname": "云和", "id": 1881, "cdesc": "云和县", "parentid": 153}, "1882": {"ctype": "40", "cname": "庆元", "id": 1882, "cdesc": "庆元县", "parentid": 153}, "1883": {"ctype": "40", "cname": "景宁畲族自治", "id": 1883, "cdesc": "景宁畲族自治县", "parentid": 153}, "1884": {"ctype": "40", "cname": "临渭", "id": 1884, "cdesc": "临渭区", "parentid": 347}, "1885": {"ctype": "40", "cname": "华州", "id": 1885, "cdesc": "华州区", "parentid": 347}, "1886": {"ctype": "40", "cname": "韩城", "id": 1886, "cdesc": "韩城市", "parentid": 347}, "1887": {"ctype": "40", "cname": "华阴", "id": 1887, "cdesc": "华阴市", "parentid": 347}, "1888": {"ctype": "40", "cname": "蒲城", "id": 1888, "cdesc": "蒲城县", "parentid": 347}, "1889": {"ctype": "40", "cname": "富平", "id": 1889, "cdesc": "富平县", "parentid": 347}, "1890": {"ctype": "40", "cname": "潼关", "id": 1890, "cdesc": "潼关县", "parentid": 347}, "1891": {"ctype": "40", "cname": "大荔", "id": 1891, "cdesc": "大荔县", "parentid": 347}, "1892": {"ctype": "40", "cname": "合阳", "id": 1892, "cdesc": "合阳县", "parentid": 347}, "1893": {"ctype": "40", "cname": "澄城", "id": 1893, "cdesc": "澄城县", "parentid": 347}, "1894": {"ctype": "40", "cname": "白水", "id": 1894, "cdesc": "白水县", "parentid": 347}, "1895": {"ctype": "40", "cname": "秦都", "id": 1895, "cdesc": "秦都区", "parentid": 346}, "1896": {"ctype": "40", "cname": "渭城", "id": 1896, "cdesc": "渭城区", "parentid": 346}, "1897": {"ctype": "40", "cname": "兴平", "id": 1897, "cdesc": "兴平市", "parentid": 346}, "1898": {"ctype": "40", "cname": "三原", "id": 1898, "cdesc": "三原县", "parentid": 346}, "1899": {"ctype": "40", "cname": "泾阳", "id": 1899, "cdesc": "泾阳县", "parentid": 346}, "1900": {"ctype": "40", "cname": "武功", "id": 1900, "cdesc": "武功县", "parentid": 346}, "1901": {"ctype": "40", "cname": "乾县", "id": 1901, "cdesc": "乾县", "parentid": 346}, "1902": {"ctype": "40", "cname": "礼泉", "id": 1902, "cdesc": "礼泉县", "parentid": 346}, "1903": {"ctype": "40", "cname": "永寿", "id": 1903, "cdesc": "永寿县", "parentid": 346}, "1904": {"ctype": "40", "cname": "彬县", "id": 1904, "cdesc": "彬县", "parentid": 346}, "1905": {"ctype": "40", "cname": "长武", "id": 1905, "cdesc": "长武县", "parentid": 346}, "1906": {"ctype": "40", "cname": "旬邑", "id": 1906, "cdesc": "旬邑县", "parentid": 346}, "1907": {"ctype": "40", "cname": "淳化", "id": 1907, "cdesc": "淳化县", "parentid": 346}, "1908": {"ctype": "40", "cname": "定海", "id": 1908, "cdesc": "定海区", "parentid": 151}, "1909": {"ctype": "40", "cname": "普陀", "id": 1909, "cdesc": "普陀区", "parentid": 151}, "1910": {"ctype": "40", "cname": "岱山", "id": 1910, "cdesc": "岱山县", "parentid": 151}, "1911": {"ctype": "40", "cname": "嵊泗", "id": 1911, "cdesc": "嵊泗县", "parentid": 151}, "1912": {"ctype": "40", "cname": "渭滨", "id": 1912, "cdesc": "渭滨区", "parentid": 345}, "1913": {"ctype": "40", "cname": "金台", "id": 1913, "cdesc": "金台区", "parentid": 345}, "1914": {"ctype": "40", "cname": "陈仓", "id": 1914, "cdesc": "陈仓区", "parentid": 345}, "1915": {"ctype": "40", "cname": "凤翔", "id": 1915, "cdesc": "凤翔县", "parentid": 345}, "1916": {"ctype": "40", "cname": "岐山", "id": 1916, "cdesc": "岐山县", "parentid": 345}, "1917": {"ctype": "40", "cname": "扶风", "id": 1917, "cdesc": "扶风县", "parentid": 345}, "1918": {"ctype": "40", "cname": "眉县", "id": 1918, "cdesc": "眉县", "parentid": 345}, "1919": {"ctype": "40", "cname": "陇县", "id": 1919, "cdesc": "陇县", "parentid": 345}, "1920": {"ctype": "40", "cname": "千阳", "id": 1920, "cdesc": "千阳县", "parentid": 345}, "1921": {"ctype": "40", "cname": "麟游", "id": 1921, "cdesc": "麟游县", "parentid": 345}, "1922": {"ctype": "40", "cname": "凤县", "id": 1922, "cdesc": "凤县", "parentid": 345}, "1923": {"ctype": "40", "cname": "太白", "id": 1923, "cdesc": "太白县", "parentid": 345}, "1924": {"ctype": "40", "cname": "新城", "id": 1924, "cdesc": "新城区", "parentid": 343}, "1925": {"ctype": "40", "cname": "碑林", "id": 1925, "cdesc": "碑林区", "parentid": 343}, "1926": {"ctype": "40", "cname": "莲湖", "id": 1926, "cdesc": "莲湖区", "parentid": 343}, "1927": {"ctype": "40", "cname": "灞桥", "id": 1927, "cdesc": "灞桥区", "parentid": 343}, "1928": {"ctype": "40", "cname": "未央", "id": 1928, "cdesc": "未央区", "parentid": 343}, "1929": {"ctype": "40", "cname": "雁塔", "id": 1929, "cdesc": "雁塔区", "parentid": 343}, "1930": {"ctype": "40", "cname": "阎良", "id": 1930, "cdesc": "阎良区", "parentid": 343}, "1931": {"ctype": "40", "cname": "临潼", "id": 1931, "cdesc": "临潼区", "parentid": 343}, "1932": {"ctype": "40", "cname": "长安", "id": 1932, "cdesc": "长安区", "parentid": 343}, "1933": {"ctype": "40", "cname": "高陵", "id": 1933, "cdesc": "高陵区", "parentid": 343}, "1934": {"ctype": "40", "cname": "蓝田", "id": 1934, "cdesc": "蓝田县", "parentid": 343}, "1935": {"ctype": "40", "cname": "周至", "id": 1935, "cdesc": "周至县", "parentid": 343}, "1936": {"ctype": "40", "cname": "户县", "id": 1936, "cdesc": "户县", "parentid": 343}, "1937": {"ctype": "40", "cname": "延吉", "id": 1937, "cdesc": "延吉市", "parentid": 342}, "1938": {"ctype": "40", "cname": "图们", "id": 1938, "cdesc": "图们市", "parentid": 342}, "1939": {"ctype": "40", "cname": "敦化", "id": 1939, "cdesc": "敦化市", "parentid": 342}, "1940": {"ctype": "40", "cname": "和龙", "id": 1940, "cdesc": "和龙市", "parentid": 342}, "1941": {"ctype": "40", "cname": "珲春", "id": 1941, "cdesc": "珲春市", "parentid": 342}, "1942": {"ctype": "40", "cname": "龙井", "id": 1942, "cdesc": "龙井市", "parentid": 342}, "1943": {"ctype": "40", "cname": "汪清", "id": 1943, "cdesc": "汪清县", "parentid": 342}, "1944": {"ctype": "40", "cname": "安图", "id": 1944, "cdesc": "安图县", "parentid": 342}, "1945": {"ctype": "40", "cname": "瑶海", "id": 1945, "cdesc": "瑶海区", "parentid": 154}, "1946": {"ctype": "40", "cname": "庐阳", "id": 1946, "cdesc": "庐阳区", "parentid": 154}, "1947": {"ctype": "40", "cname": "蜀山", "id": 1947, "cdesc": "蜀山区", "parentid": 154}, "1948": {"ctype": "40", "cname": "包河", "id": 1948, "cdesc": "包河区", "parentid": 154}, "1949": {"ctype": "40", "cname": "肥东", "id": 1949, "cdesc": "肥东县", "parentid": 154}, "1950": {"ctype": "40", "cname": "肥西", "id": 1950, "cdesc": "肥西县", "parentid": 154}, "1951": {"ctype": "40", "cname": "长丰", "id": 1951, "cdesc": "长丰县", "parentid": 154}, "1952": {"ctype": "40", "cname": "庐江", "id": 1952, "cdesc": "庐江县", "parentid": 154}, "1953": {"ctype": "40", "cname": "巢湖", "id": 1953, "cdesc": "巢湖市", "parentid": 154}, "1954": {"ctype": "40", "cname": "宁江", "id": 1954, "cdesc": "宁江区", "parentid": 340}, "1955": {"ctype": "40", "cname": "扶余", "id": 1955, "cdesc": "扶余市", "parentid": 340}, "1956": {"ctype": "40", "cname": "乾安", "id": 1956, "cdesc": "乾安县", "parentid": 340}, "1957": {"ctype": "40", "cname": "长岭", "id": 1957, "cdesc": "长岭县", "parentid": 340}, "1958": {"ctype": "40", "cname": "前郭尔罗斯蒙古族自治", "id": 1958, "cdesc": "前郭尔罗斯蒙古族自治县", "parentid": 340}, "1959": {"ctype": "40", "cname": "镜湖", "id": 1959, "cdesc": "镜湖区", "parentid": 155}, "1960": {"ctype": "40", "cname": "弋江", "id": 1960, "cdesc": "弋江区", "parentid": 155}, "1961": {"ctype": "40", "cname": "鸠江", "id": 1961, "cdesc": "鸠江区", "parentid": 155}, "1962": {"ctype": "40", "cname": "三山", "id": 1962, "cdesc": "三山区", "parentid": 155}, "1963": {"ctype": "40", "cname": "无为", "id": 1963, "cdesc": "无为县", "parentid": 155}, "1964": {"ctype": "40", "cname": "芜湖", "id": 1964, "cdesc": "芜湖县", "parentid": 155}, "1965": {"ctype": "40", "cname": "繁昌", "id": 1965, "cdesc": "繁昌县", "parentid": 155}, "1966": {"ctype": "40", "cname": "南陵", "id": 1966, "cdesc": "南陵县", "parentid": 155}, "1967": {"ctype": "40", "cname": "洮北", "id": 1967, "cdesc": "洮北区", "parentid": 341}, "1968": {"ctype": "40", "cname": "洮南", "id": 1968, "cdesc": "洮南市", "parentid": 341}, "1969": {"ctype": "40", "cname": "大安", "id": 1969, "cdesc": "大安市", "parentid": 341}, "1970": {"ctype": "40", "cname": "镇赉", "id": 1970, "cdesc": "镇赉县", "parentid": 341}, "1971": {"ctype": "40", "cname": "通榆", "id": 1971, "cdesc": "通榆县", "parentid": 341}, "1972": {"ctype": "40", "cname": "龙子湖", "id": 1972, "cdesc": "龙子湖区", "parentid": 156}, "1973": {"ctype": "40", "cname": "蚌山", "id": 1973, "cdesc": "蚌山区", "parentid": 156}, "1974": {"ctype": "40", "cname": "禹会", "id": 1974, "cdesc": "禹会区", "parentid": 156}, "1975": {"ctype": "40", "cname": "淮上", "id": 1975, "cdesc": "淮上区", "parentid": 156}, "1976": {"ctype": "40", "cname": "五河", "id": 1976, "cdesc": "五河县", "parentid": 156}, "1977": {"ctype": "40", "cname": "固镇", "id": 1977, "cdesc": "固镇县", "parentid": 156}, "1978": {"ctype": "40", "cname": "怀远", "id": 1978, "cdesc": "怀远县", "parentid": 156}, "1979": {"ctype": "40", "cname": "浑江", "id": 1979, "cdesc": "浑江区", "parentid": 339}, "1980": {"ctype": "40", "cname": "江源", "id": 1980, "cdesc": "江源区", "parentid": 339}, "1981": {"ctype": "40", "cname": "临江", "id": 1981, "cdesc": "临江市", "parentid": 339}, "1982": {"ctype": "40", "cname": "抚松", "id": 1982, "cdesc": "抚松县", "parentid": 339}, "1983": {"ctype": "40", "cname": "靖宇", "id": 1983, "cdesc": "靖宇县", "parentid": 339}, "1984": {"ctype": "40", "cname": "长白朝鲜族自治", "id": 1984, "cdesc": "长白朝鲜族自治县", "parentid": 339}, "1985": {"ctype": "40", "cname": "大通", "id": 1985, "cdesc": "大通区", "parentid": 157}, "1986": {"ctype": "40", "cname": "田家庵", "id": 1986, "cdesc": "田家庵区", "parentid": 157}, "1987": {"ctype": "40", "cname": "谢家集", "id": 1987, "cdesc": "谢家集区", "parentid": 157}, "1988": {"ctype": "40", "cname": "八公山", "id": 1988, "cdesc": "八公山区", "parentid": 157}, "1989": {"ctype": "40", "cname": "潘集", "id": 1989, "cdesc": "潘集区", "parentid": 157}, "1990": {"ctype": "40", "cname": "凤台", "id": 1990, "cdesc": "凤台县", "parentid": 157}, "1991": {"ctype": "40", "cname": "寿县", "id": 1991, "cdesc": "寿县", "parentid": 157}, "1992": {"ctype": "40", "cname": "东昌", "id": 1992, "cdesc": "东昌区", "parentid": 338}, "1993": {"ctype": "40", "cname": "二道江", "id": 1993, "cdesc": "二道江区", "parentid": 338}, "1994": {"ctype": "40", "cname": "集安", "id": 1994, "cdesc": "集安市", "parentid": 338}, "1995": {"ctype": "40", "cname": "通化", "id": 1995, "cdesc": "通化县", "parentid": 338}, "1996": {"ctype": "40", "cname": "辉南", "id": 1996, "cdesc": "辉南县", "parentid": 338}, "1997": {"ctype": "40", "cname": "柳河", "id": 1997, "cdesc": "柳河县", "parentid": 338}, "1998": {"ctype": "40", "cname": "花山", "id": 1998, "cdesc": "花山区", "parentid": 158}, "1999": {"ctype": "40", "cname": "雨山", "id": 1999, "cdesc": "雨山区", "parentid": 158}, "2000": {"ctype": "40", "cname": "博望", "id": 2000, "cdesc": "博望区", "parentid": 158}, "2001": {"ctype": "40", "cname": "含山", "id": 2001, "cdesc": "含山县", "parentid": 158}, "2002": {"ctype": "40", "cname": "和县", "id": 2002, "cdesc": "和县", "parentid": 158}, "2003": {"ctype": "40", "cname": "当涂", "id": 2003, "cdesc": "当涂县", "parentid": 158}, "2004": {"ctype": "40", "cname": "龙山", "id": 2004, "cdesc": "龙山区", "parentid": 337}, "2005": {"ctype": "40", "cname": "西安", "id": 2005, "cdesc": "西安区", "parentid": 337}, "2006": {"ctype": "40", "cname": "东丰", "id": 2006, "cdesc": "东丰县", "parentid": 337}, "2007": {"ctype": "40", "cname": "东辽", "id": 2007, "cdesc": "东辽县", "parentid": 337}, "2008": {"ctype": "40", "cname": "相山", "id": 2008, "cdesc": "相山区", "parentid": 159}, "2009": {"ctype": "40", "cname": "杜集", "id": 2009, "cdesc": "杜集区", "parentid": 159}, "2010": {"ctype": "40", "cname": "烈山", "id": 2010, "cdesc": "烈山区", "parentid": 159}, "2011": {"ctype": "40", "cname": "濉溪", "id": 2011, "cdesc": "濉溪县", "parentid": 159}, "2012": {"ctype": "40", "cname": "铁西", "id": 2012, "cdesc": "铁西区", "parentid": 336}, "2013": {"ctype": "40", "cname": "铁东", "id": 2013, "cdesc": "铁东区", "parentid": 336}, "2014": {"ctype": "40", "cname": "双辽", "id": 2014, "cdesc": "双辽市", "parentid": 336}, "2015": {"ctype": "40", "cname": "梨树", "id": 2015, "cdesc": "梨树县", "parentid": 336}, "2016": {"ctype": "40", "cname": "伊通满族自治", "id": 2016, "cdesc": "伊通满族自治县", "parentid": 336}, "2017": {"ctype": "40", "cname": "四平辽河农垦管理", "id": 2017, "cdesc": "四平辽河农垦管理区", "parentid": 336}, "2018": {"ctype": "40", "cname": "铜官", "id": 2018, "cdesc": "铜官区", "parentid": 160}, "2019": {"ctype": "40", "cname": "郊区", "id": 2019, "cdesc": "郊区", "parentid": 160}, "2020": {"ctype": "40", "cname": "义安", "id": 2020, "cdesc": "义安区", "parentid": 160}, "2021": {"ctype": "40", "cname": "枞阳", "id": 2021, "cdesc": "枞阳县", "parentid": 160}, "2022": {"ctype": "40", "cname": "船营", "id": 2022, "cdesc": "船营区", "parentid": 335}, "2023": {"ctype": "40", "cname": "龙潭", "id": 2023, "cdesc": "龙潭区", "parentid": 335}, "2024": {"ctype": "40", "cname": "昌邑", "id": 2024, "cdesc": "昌邑区", "parentid": 335}, "2025": {"ctype": "40", "cname": "丰满", "id": 2025, "cdesc": "丰满区", "parentid": 335}, "2026": {"ctype": "40", "cname": "磐石", "id": 2026, "cdesc": "磐石市", "parentid": 335}, "2027": {"ctype": "40", "cname": "桦甸", "id": 2027, "cdesc": "桦甸市", "parentid": 335}, "2028": {"ctype": "40", "cname": "蛟河", "id": 2028, "cdesc": "蛟河市", "parentid": 335}, "2029": {"ctype": "40", "cname": "舒兰", "id": 2029, "cdesc": "舒兰市", "parentid": 335}, "2030": {"ctype": "40", "cname": "永吉", "id": 2030, "cdesc": "永吉县", "parentid": 335}, "2031": {"ctype": "40", "cname": "南关", "id": 2031, "cdesc": "南关区", "parentid": 334}, "2032": {"ctype": "40", "cname": "朝阳", "id": 2032, "cdesc": "朝阳区", "parentid": 334}, "2033": {"ctype": "40", "cname": "绿园", "id": 2033, "cdesc": "绿园区", "parentid": 334}, "2034": {"ctype": "40", "cname": "二道", "id": 2034, "cdesc": "二道区", "parentid": 334}, "2035": {"ctype": "40", "cname": "双阳", "id": 2035, "cdesc": "双阳区", "parentid": 334}, "2036": {"ctype": "40", "cname": "宽城", "id": 2036, "cdesc": "宽城区", "parentid": 334}, "2037": {"ctype": "40", "cname": "九台", "id": 2037, "cdesc": "九台区", "parentid": 334}, "2038": {"ctype": "40", "cname": "榆树", "id": 2038, "cdesc": "榆树市", "parentid": 334}, "2039": {"ctype": "40", "cname": "德惠", "id": 2039, "cdesc": "德惠市", "parentid": 334}, "2040": {"ctype": "40", "cname": "农安", "id": 2040, "cdesc": "农安县", "parentid": 334}, "2041": {"ctype": "40", "cname": "迎江", "id": 2041, "cdesc": "迎江区", "parentid": 161}, "2042": {"ctype": "40", "cname": "大观", "id": 2042, "cdesc": "大观区", "parentid": 161}, "2043": {"ctype": "40", "cname": "宜秀", "id": 2043, "cdesc": "宜秀区", "parentid": 161}, "2044": {"ctype": "40", "cname": "怀宁", "id": 2044, "cdesc": "怀宁县", "parentid": 161}, "2045": {"ctype": "40", "cname": "桐城", "id": 2045, "cdesc": "桐城市", "parentid": 161}, "2046": {"ctype": "40", "cname": "潜山", "id": 2046, "cdesc": "潜山县", "parentid": 161}, "2047": {"ctype": "40", "cname": "太湖", "id": 2047, "cdesc": "太湖县", "parentid": 161}, "2048": {"ctype": "40", "cname": "宿松", "id": 2048, "cdesc": "宿松县", "parentid": 161}, "2049": {"ctype": "40", "cname": "望江", "id": 2049, "cdesc": "望江县", "parentid": 161}, "2050": {"ctype": "40", "cname": "岳西", "id": 2050, "cdesc": "岳西县", "parentid": 161}, "2051": {"ctype": "40", "cname": "屯溪", "id": 2051, "cdesc": "屯溪区", "parentid": 162}, "2052": {"ctype": "40", "cname": "黄山", "id": 2052, "cdesc": "黄山区", "parentid": 162}, "2053": {"ctype": "40", "cname": "徽州", "id": 2053, "cdesc": "徽州区", "parentid": 162}, "2054": {"ctype": "40", "cname": "歙县", "id": 2054, "cdesc": "歙县", "parentid": 162}, "2055": {"ctype": "40", "cname": "休宁", "id": 2055, "cdesc": "休宁县", "parentid": 162}, "2056": {"ctype": "40", "cname": "黟县", "id": 2056, "cdesc": "黟县", "parentid": 162}, "2057": {"ctype": "40", "cname": "祁门", "id": 2057, "cdesc": "祁门县", "parentid": 162}, "2058": {"ctype": "40", "cname": "连山", "id": 2058, "cdesc": "连山区", "parentid": 333}, "2059": {"ctype": "40", "cname": "南票", "id": 2059, "cdesc": "南票区", "parentid": 333}, "2060": {"ctype": "40", "cname": "龙港", "id": 2060, "cdesc": "龙港区", "parentid": 333}, "2061": {"ctype": "40", "cname": "兴城", "id": 2061, "cdesc": "兴城市", "parentid": 333}, "2062": {"ctype": "40", "cname": "绥中", "id": 2062, "cdesc": "绥中县", "parentid": 333}, "2063": {"ctype": "40", "cname": "建昌", "id": 2063, "cdesc": "建昌县", "parentid": 333}, "2064": {"ctype": "40", "cname": "双塔", "id": 2064, "cdesc": "双塔区", "parentid": 332}, "2065": {"ctype": "40", "cname": "龙城", "id": 2065, "cdesc": "龙城区", "parentid": 332}, "2066": {"ctype": "40", "cname": "北票", "id": 2066, "cdesc": "北票市", "parentid": 332}, "2067": {"ctype": "40", "cname": "凌源", "id": 2067, "cdesc": "凌源市", "parentid": 332}, "2068": {"ctype": "40", "cname": "朝阳", "id": 2068, "cdesc": "朝阳县", "parentid": 332}, "2069": {"ctype": "40", "cname": "建平", "id": 2069, "cdesc": "建平县", "parentid": 332}, "2070": {"ctype": "40", "cname": "喀喇沁左翼蒙古族自治", "id": 2070, "cdesc": "喀喇沁左翼蒙古族自治县", "parentid": 332}, "2071": {"ctype": "40", "cname": "颍州", "id": 2071, "cdesc": "颍州区", "parentid": 164}, "2072": {"ctype": "40", "cname": "颍泉", "id": 2072, "cdesc": "颍泉区", "parentid": 164}, "2073": {"ctype": "40", "cname": "颍东", "id": 2073, "cdesc": "颍东区", "parentid": 164}, "2074": {"ctype": "40", "cname": "颍上", "id": 2074, "cdesc": "颍上县", "parentid": 164}, "2075": {"ctype": "40", "cname": "界首", "id": 2075, "cdesc": "界首市", "parentid": 164}, "2076": {"ctype": "40", "cname": "临泉", "id": 2076, "cdesc": "临泉县", "parentid": 164}, "2077": {"ctype": "40", "cname": "阜南", "id": 2077, "cdesc": "阜南县", "parentid": 164}, "2078": {"ctype": "40", "cname": "太和", "id": 2078, "cdesc": "太和县", "parentid": 164}, "2079": {"ctype": "40", "cname": "埇桥", "id": 2079, "cdesc": "埇桥区", "parentid": 165}, "2080": {"ctype": "40", "cname": "萧县", "id": 2080, "cdesc": "萧县", "parentid": 165}, "2081": {"ctype": "40", "cname": "砀山", "id": 2081, "cdesc": "砀山县", "parentid": 165}, "2082": {"ctype": "40", "cname": "灵璧", "id": 2082, "cdesc": "灵璧县", "parentid": 165}, "2083": {"ctype": "40", "cname": "泗县", "id": 2083, "cdesc": "泗县", "parentid": 165}, "2084": {"ctype": "40", "cname": "银州", "id": 2084, "cdesc": "银州区", "parentid": 331}, "2085": {"ctype": "40", "cname": "清河", "id": 2085, "cdesc": "清河区", "parentid": 331}, "2086": {"ctype": "40", "cname": "调兵山", "id": 2086, "cdesc": "调兵山市", "parentid": 331}, "2087": {"ctype": "40", "cname": "开原", "id": 2087, "cdesc": "开原市", "parentid": 331}, "2088": {"ctype": "40", "cname": "铁岭", "id": 2088, "cdesc": "铁岭县", "parentid": 331}, "2089": {"ctype": "40", "cname": "昌图", "id": 2089, "cdesc": "昌图县", "parentid": 331}, "2090": {"ctype": "40", "cname": "西丰", "id": 2090, "cdesc": "西丰县", "parentid": 331}, "2091": {"ctype": "40", "cname": "双台子", "id": 2091, "cdesc": "双台子区", "parentid": 330}, "2092": {"ctype": "40", "cname": "兴隆台", "id": 2092, "cdesc": "兴隆台区", "parentid": 330}, "2093": {"ctype": "40", "cname": "盘山", "id": 2093, "cdesc": "盘山县", "parentid": 330}, "2094": {"ctype": "40", "cname": "大洼", "id": 2094, "cdesc": "大洼县", "parentid": 330}, "2095": {"ctype": "40", "cname": "琅琊", "id": 2095, "cdesc": "琅琊区", "parentid": 163}, "2096": {"ctype": "40", "cname": "南谯", "id": 2096, "cdesc": "南谯区", "parentid": 163}, "2097": {"ctype": "40", "cname": "天长", "id": 2097, "cdesc": "天长市", "parentid": 163}, "2098": {"ctype": "40", "cname": "明光", "id": 2098, "cdesc": "明光市", "parentid": 163}, "2099": {"ctype": "40", "cname": "全椒", "id": 2099, "cdesc": "全椒县", "parentid": 163}, "2100": {"ctype": "40", "cname": "来安", "id": 2100, "cdesc": "来安县", "parentid": 163}, "2101": {"ctype": "40", "cname": "凤阳", "id": 2101, "cdesc": "凤阳县", "parentid": 163}, "2102": {"ctype": "40", "cname": "定远", "id": 2102, "cdesc": "定远县", "parentid": 163}, "2103": {"ctype": "40", "cname": "白塔", "id": 2103, "cdesc": "白塔区", "parentid": 329}, "2104": {"ctype": "40", "cname": "文圣", "id": 2104, "cdesc": "文圣区", "parentid": 329}, "2105": {"ctype": "40", "cname": "宏伟", "id": 2105, "cdesc": "宏伟区", "parentid": 329}, "2106": {"ctype": "40", "cname": "弓长岭", "id": 2106, "cdesc": "弓长岭区", "parentid": 329}, "2107": {"ctype": "40", "cname": "太子河", "id": 2107, "cdesc": "太子河区", "parentid": 329}, "2108": {"ctype": "40", "cname": "灯塔", "id": 2108, "cdesc": "灯塔市", "parentid": 329}, "2109": {"ctype": "40", "cname": "辽阳", "id": 2109, "cdesc": "辽阳县", "parentid": 329}, "2110": {"ctype": "40", "cname": "海州", "id": 2110, "cdesc": "海州区", "parentid": 328}, "2111": {"ctype": "40", "cname": "太平", "id": 2111, "cdesc": "太平区", "parentid": 328}, "2112": {"ctype": "40", "cname": "新邱", "id": 2112, "cdesc": "新邱区", "parentid": 328}, "2113": {"ctype": "40", "cname": "细河", "id": 2113, "cdesc": "细河区", "parentid": 328}, "2114": {"ctype": "40", "cname": "清河门", "id": 2114, "cdesc": "清河门区", "parentid": 328}, "2115": {"ctype": "40", "cname": "阜新蒙古族", "id": 2115, "cdesc": "阜新蒙古族", "parentid": 328}, "2116": {"ctype": "40", "cname": "彰武", "id": 2116, "cdesc": "彰武县", "parentid": 328}, "2117": {"ctype": "40", "cname": "金安", "id": 2117, "cdesc": "金安区", "parentid": 167}, "2118": {"ctype": "40", "cname": "裕安", "id": 2118, "cdesc": "裕安区", "parentid": 167}, "2119": {"ctype": "40", "cname": "叶集", "id": 2119, "cdesc": "叶集区", "parentid": 167}, "2120": {"ctype": "40", "cname": "霍邱", "id": 2120, "cdesc": "霍邱县", "parentid": 167}, "2121": {"ctype": "40", "cname": "霍山", "id": 2121, "cdesc": "霍山县", "parentid": 167}, "2122": {"ctype": "40", "cname": "金寨", "id": 2122, "cdesc": "金寨县", "parentid": 167}, "2123": {"ctype": "40", "cname": "舒城", "id": 2123, "cdesc": "舒城县", "parentid": 167}, "2124": {"ctype": "40", "cname": "站前", "id": 2124, "cdesc": "站前区", "parentid": 327}, "2125": {"ctype": "40", "cname": "西市", "id": 2125, "cdesc": "西市区", "parentid": 327}, "2126": {"ctype": "40", "cname": "老边", "id": 2126, "cdesc": "老边区", "parentid": 327}, "2127": {"ctype": "40", "cname": "鲅鱼圈", "id": 2127, "cdesc": "鲅鱼圈区", "parentid": 327}, "2128": {"ctype": "40", "cname": "大石桥", "id": 2128, "cdesc": "大石桥市", "parentid": 327}, "2129": {"ctype": "40", "cname": "盖州", "id": 2129, "cdesc": "盖州市", "parentid": 327}, "2130": {"ctype": "40", "cname": "宣州", "id": 2130, "cdesc": "宣州区", "parentid": 170}, "2131": {"ctype": "40", "cname": "郎溪", "id": 2131, "cdesc": "郎溪县", "parentid": 170}, "2132": {"ctype": "40", "cname": "广德", "id": 2132, "cdesc": "广德县", "parentid": 170}, "2133": {"ctype": "40", "cname": "宁国", "id": 2133, "cdesc": "宁国市", "parentid": 170}, "2134": {"ctype": "40", "cname": "泾县", "id": 2134, "cdesc": "泾县", "parentid": 170}, "2135": {"ctype": "40", "cname": "绩溪", "id": 2135, "cdesc": "绩溪县", "parentid": 170}, "2136": {"ctype": "40", "cname": "旌德", "id": 2136, "cdesc": "旌德县", "parentid": 170}, "2137": {"ctype": "40", "cname": "贵池", "id": 2137, "cdesc": "贵池区", "parentid": 169}, "2138": {"ctype": "40", "cname": "青阳", "id": 2138, "cdesc": "青阳县", "parentid": 169}, "2139": {"ctype": "40", "cname": "石台", "id": 2139, "cdesc": "石台县", "parentid": 169}, "2140": {"ctype": "40", "cname": "东至", "id": 2140, "cdesc": "东至县", "parentid": 169}, "2141": {"ctype": "40", "cname": "古塔", "id": 2141, "cdesc": "古塔区", "parentid": 326}, "2142": {"ctype": "40", "cname": "凌河", "id": 2142, "cdesc": "凌河区", "parentid": 326}, "2143": {"ctype": "40", "cname": "太和", "id": 2143, "cdesc": "太和区", "parentid": 326}, "2144": {"ctype": "40", "cname": "松山新", "id": 2144, "cdesc": "松山新区", "parentid": 326}, "2145": {"ctype": "40", "cname": "凌海", "id": 2145, "cdesc": "凌海市", "parentid": 326}, "2146": {"ctype": "40", "cname": "北镇", "id": 2146, "cdesc": "北镇市", "parentid": 326}, "2147": {"ctype": "40", "cname": "黑山", "id": 2147, "cdesc": "黑山县", "parentid": 326}, "2148": {"ctype": "40", "cname": "义县", "id": 2148, "cdesc": "义县", "parentid": 326}, "2149": {"ctype": "40", "cname": "元宝", "id": 2149, "cdesc": "元宝区", "parentid": 325}, "2150": {"ctype": "40", "cname": "振兴", "id": 2150, "cdesc": "振兴区", "parentid": 325}, "2151": {"ctype": "40", "cname": "振安", "id": 2151, "cdesc": "振安区", "parentid": 325}, "2152": {"ctype": "40", "cname": "东港", "id": 2152, "cdesc": "东港市", "parentid": 325}, "2153": {"ctype": "40", "cname": "凤城", "id": 2153, "cdesc": "凤城市", "parentid": 325}, "2154": {"ctype": "40", "cname": "宽甸满族", "id": 2154, "cdesc": "宽甸满族", "parentid": 325}, "2155": {"ctype": "40", "cname": "谯城", "id": 2155, "cdesc": "谯城区", "parentid": 168}, "2156": {"ctype": "40", "cname": "蒙城", "id": 2156, "cdesc": "蒙城县", "parentid": 168}, "2157": {"ctype": "40", "cname": "涡阳", "id": 2157, "cdesc": "涡阳县", "parentid": 168}, "2158": {"ctype": "40", "cname": "利辛", "id": 2158, "cdesc": "利辛县", "parentid": 168}, "2159": {"ctype": "40", "cname": "平山", "id": 2159, "cdesc": "平山区", "parentid": 324}, "2160": {"ctype": "40", "cname": "溪湖", "id": 2160, "cdesc": "溪湖区", "parentid": 324}, "2161": {"ctype": "40", "cname": "明山", "id": 2161, "cdesc": "明山区", "parentid": 324}, "2162": {"ctype": "40", "cname": "南芬", "id": 2162, "cdesc": "南芬区", "parentid": 324}, "2163": {"ctype": "40", "cname": "本溪满族", "id": 2163, "cdesc": "本溪满族", "parentid": 324}, "2164": {"ctype": "40", "cname": "桓仁满族", "id": 2164, "cdesc": "桓仁满族", "parentid": 324}, "2165": {"ctype": "40", "cname": "新抚", "id": 2165, "cdesc": "新抚区", "parentid": 323}, "2166": {"ctype": "40", "cname": "东洲", "id": 2166, "cdesc": "东洲区", "parentid": 323}, "2167": {"ctype": "40", "cname": "望花", "id": 2167, "cdesc": "望花区", "parentid": 323}, "2168": {"ctype": "40", "cname": "顺城", "id": 2168, "cdesc": "顺城区", "parentid": 323}, "2169": {"ctype": "40", "cname": "抚顺", "id": 2169, "cdesc": "抚顺县", "parentid": 323}, "2170": {"ctype": "40", "cname": "新宾满族", "id": 2170, "cdesc": "新宾满族", "parentid": 323}, "2171": {"ctype": "40", "cname": "清原满族", "id": 2171, "cdesc": "清原满族", "parentid": 323}, "2172": {"ctype": "40", "cname": "铁东", "id": 2172, "cdesc": "铁东区", "parentid": 322}, "2173": {"ctype": "40", "cname": "铁西", "id": 2173, "cdesc": "铁西区", "parentid": 322}, "2174": {"ctype": "40", "cname": "立山", "id": 2174, "cdesc": "立山区", "parentid": 322}, "2175": {"ctype": "40", "cname": "千山", "id": 2175, "cdesc": "千山区", "parentid": 322}, "2176": {"ctype": "40", "cname": "海城", "id": 2176, "cdesc": "海城市", "parentid": 322}, "2177": {"ctype": "40", "cname": "台安", "id": 2177, "cdesc": "台安县", "parentid": 322}, "2178": {"ctype": "40", "cname": "岫岩满族", "id": 2178, "cdesc": "岫岩满族", "parentid": 322}, "2179": {"ctype": "40", "cname": "西岗", "id": 2179, "cdesc": "西岗区", "parentid": 321}, "2180": {"ctype": "40", "cname": "中山", "id": 2180, "cdesc": "中山区", "parentid": 321}, "2181": {"ctype": "40", "cname": "沙河口", "id": 2181, "cdesc": "沙河口区", "parentid": 321}, "2182": {"ctype": "40", "cname": "甘井子", "id": 2182, "cdesc": "甘井子区", "parentid": 321}, "2183": {"ctype": "40", "cname": "旅顺口", "id": 2183, "cdesc": "旅顺口区", "parentid": 321}, "2184": {"ctype": "40", "cname": "金州", "id": 2184, "cdesc": "金州区", "parentid": 321}, "2185": {"ctype": "40", "cname": "普兰店", "id": 2185, "cdesc": "普兰店区", "parentid": 321}, "2186": {"ctype": "40", "cname": "瓦房店", "id": 2186, "cdesc": "瓦房店市", "parentid": 321}, "2187": {"ctype": "40", "cname": "庄河", "id": 2187, "cdesc": "庄河市", "parentid": 321}, "2188": {"ctype": "40", "cname": "长海", "id": 2188, "cdesc": "长海县", "parentid": 321}, "2189": {"ctype": "40", "cname": "和平", "id": 2189, "cdesc": "和平区", "parentid": 320}, "2190": {"ctype": "40", "cname": "沈河", "id": 2190, "cdesc": "沈河区", "parentid": 320}, "2191": {"ctype": "40", "cname": "大东", "id": 2191, "cdesc": "大东区", "parentid": 320}, "2192": {"ctype": "40", "cname": "皇姑", "id": 2192, "cdesc": "皇姑区", "parentid": 320}, "2193": {"ctype": "40", "cname": "铁西", "id": 2193, "cdesc": "铁西区", "parentid": 320}, "2194": {"ctype": "40", "cname": "苏家屯", "id": 2194, "cdesc": "苏家屯区", "parentid": 320}, "2195": {"ctype": "40", "cname": "浑南", "id": 2195, "cdesc": "浑南区", "parentid": 320}, "2196": {"ctype": "40", "cname": "沈北新", "id": 2196, "cdesc": "沈北新区", "parentid": 320}, "2197": {"ctype": "40", "cname": "于洪", "id": 2197, "cdesc": "于洪区", "parentid": 320}, "2198": {"ctype": "40", "cname": "辽中", "id": 2198, "cdesc": "辽中区", "parentid": 320}, "2199": {"ctype": "40", "cname": "新民", "id": 2199, "cdesc": "新民市", "parentid": 320}, "2200": {"ctype": "40", "cname": "康平", "id": 2200, "cdesc": "康平县", "parentid": 320}, "2201": {"ctype": "40", "cname": "法库", "id": 2201, "cdesc": "法库县", "parentid": 320}, "2202": {"ctype": "40", "cname": "加格达奇", "id": 2202, "cdesc": "加格达奇区", "parentid": 319}, "2203": {"ctype": "40", "cname": "松岭", "id": 2203, "cdesc": "松岭区", "parentid": 319}, "2204": {"ctype": "40", "cname": "新林", "id": 2204, "cdesc": "新林区", "parentid": 319}, "2205": {"ctype": "40", "cname": "呼中", "id": 2205, "cdesc": "呼中区", "parentid": 319}, "2206": {"ctype": "40", "cname": "呼玛", "id": 2206, "cdesc": "呼玛县", "parentid": 319}, "2207": {"ctype": "40", "cname": "塔河", "id": 2207, "cdesc": "塔河县", "parentid": 319}, "2208": {"ctype": "40", "cname": "漠河", "id": 2208, "cdesc": "漠河县", "parentid": 319}, "2209": {"ctype": "40", "cname": "北林", "id": 2209, "cdesc": "北林区", "parentid": 318}, "2210": {"ctype": "40", "cname": "望奎", "id": 2210, "cdesc": "望奎县", "parentid": 318}, "2211": {"ctype": "40", "cname": "兰西", "id": 2211, "cdesc": "兰西县", "parentid": 318}, "2212": {"ctype": "40", "cname": "青冈", "id": 2212, "cdesc": "青冈县", "parentid": 318}, "2213": {"ctype": "40", "cname": "庆安", "id": 2213, "cdesc": "庆安县", "parentid": 318}, "2214": {"ctype": "40", "cname": "明水", "id": 2214, "cdesc": "明水县", "parentid": 318}, "2215": {"ctype": "40", "cname": "绥棱", "id": 2215, "cdesc": "绥棱县", "parentid": 318}, "2216": {"ctype": "40", "cname": "安达", "id": 2216, "cdesc": "安达市", "parentid": 318}, "2217": {"ctype": "40", "cname": "肇东", "id": 2217, "cdesc": "肇东市", "parentid": 318}, "2218": {"ctype": "40", "cname": "海伦", "id": 2218, "cdesc": "海伦市", "parentid": 318}, "2219": {"ctype": "40", "cname": "爱辉", "id": 2219, "cdesc": "爱辉区", "parentid": 317}, "2220": {"ctype": "40", "cname": "嫩江", "id": 2220, "cdesc": "嫩江县", "parentid": 317}, "2221": {"ctype": "40", "cname": "逊克", "id": 2221, "cdesc": "逊克县", "parentid": 317}, "2222": {"ctype": "40", "cname": "孙吴", "id": 2222, "cdesc": "孙吴县", "parentid": 317}, "2223": {"ctype": "40", "cname": "北安", "id": 2223, "cdesc": "北安市", "parentid": 317}, "2224": {"ctype": "40", "cname": "五大连池", "id": 2224, "cdesc": "五大连池市", "parentid": 317}, "2225": {"ctype": "40", "cname": "东安", "id": 2225, "cdesc": "东安区", "parentid": 316}, "2226": {"ctype": "40", "cname": "阳明", "id": 2226, "cdesc": "阳明区", "parentid": 316}, "2227": {"ctype": "40", "cname": "爱民", "id": 2227, "cdesc": "爱民区", "parentid": 316}, "2228": {"ctype": "40", "cname": "西安", "id": 2228, "cdesc": "西安区", "parentid": 316}, "2229": {"ctype": "40", "cname": "林口", "id": 2229, "cdesc": "林口县", "parentid": 316}, "2230": {"ctype": "40", "cname": "绥芬河", "id": 2230, "cdesc": "绥芬河市", "parentid": 316}, "2231": {"ctype": "40", "cname": "海林", "id": 2231, "cdesc": "海林市", "parentid": 316}, "2232": {"ctype": "40", "cname": "宁安", "id": 2232, "cdesc": "宁安市", "parentid": 316}, "2233": {"ctype": "40", "cname": "穆棱", "id": 2233, "cdesc": "穆棱市", "parentid": 316}, "2234": {"ctype": "40", "cname": "东宁", "id": 2234, "cdesc": "东宁市", "parentid": 316}, "2235": {"ctype": "40", "cname": "鼓楼", "id": 2235, "cdesc": "鼓楼区", "parentid": 171}, "2236": {"ctype": "40", "cname": "台江", "id": 2236, "cdesc": "台江区", "parentid": 171}, "2237": {"ctype": "40", "cname": "仓山", "id": 2237, "cdesc": "仓山区", "parentid": 171}, "2238": {"ctype": "40", "cname": "马尾", "id": 2238, "cdesc": "马尾区", "parentid": 171}, "2239": {"ctype": "40", "cname": "晋安", "id": 2239, "cdesc": "晋安区", "parentid": 171}, "2240": {"ctype": "40", "cname": "福清", "id": 2240, "cdesc": "福清市", "parentid": 171}, "2241": {"ctype": "40", "cname": "长乐", "id": 2241, "cdesc": "长乐市", "parentid": 171}, "2242": {"ctype": "40", "cname": "闽侯", "id": 2242, "cdesc": "闽侯县", "parentid": 171}, "2243": {"ctype": "40", "cname": "连江", "id": 2243, "cdesc": "连江县", "parentid": 171}, "2244": {"ctype": "40", "cname": "罗源", "id": 2244, "cdesc": "罗源县", "parentid": 171}, "2245": {"ctype": "40", "cname": "闽清", "id": 2245, "cdesc": "闽清县", "parentid": 171}, "2246": {"ctype": "40", "cname": "永泰", "id": 2246, "cdesc": "永泰县", "parentid": 171}, "2247": {"ctype": "40", "cname": "平潭", "id": 2247, "cdesc": "平潭县", "parentid": 171}, "2248": {"ctype": "40", "cname": "思明", "id": 2248, "cdesc": "思明区", "parentid": 172}, "2249": {"ctype": "40", "cname": "海沧", "id": 2249, "cdesc": "海沧区", "parentid": 172}, "2250": {"ctype": "40", "cname": "湖里", "id": 2250, "cdesc": "湖里区", "parentid": 172}, "2251": {"ctype": "40", "cname": "集美", "id": 2251, "cdesc": "集美区", "parentid": 172}, "2252": {"ctype": "40", "cname": "同安", "id": 2252, "cdesc": "同安区", "parentid": 172}, "2253": {"ctype": "40", "cname": "翔安", "id": 2253, "cdesc": "翔安区", "parentid": 172}, "2254": {"ctype": "40", "cname": "新兴", "id": 2254, "cdesc": "新兴区", "parentid": 315}, "2255": {"ctype": "40", "cname": "桃山", "id": 2255, "cdesc": "桃山区", "parentid": 315}, "2256": {"ctype": "40", "cname": "茄子河", "id": 2256, "cdesc": "茄子河区", "parentid": 315}, "2257": {"ctype": "40", "cname": "勃利", "id": 2257, "cdesc": "勃利县", "parentid": 315}, "2258": {"ctype": "40", "cname": "芗城", "id": 2258, "cdesc": "芗城区", "parentid": 176}, "2259": {"ctype": "40", "cname": "龙文", "id": 2259, "cdesc": "龙文区", "parentid": 176}, "2260": {"ctype": "40", "cname": "龙海", "id": 2260, "cdesc": "龙海市", "parentid": 176}, "2261": {"ctype": "40", "cname": "漳浦", "id": 2261, "cdesc": "漳浦县", "parentid": 176}, "2262": {"ctype": "40", "cname": "南靖", "id": 2262, "cdesc": "南靖县", "parentid": 176}, "2263": {"ctype": "40", "cname": "云霄", "id": 2263, "cdesc": "云霄县", "parentid": 176}, "2264": {"ctype": "40", "cname": "平和", "id": 2264, "cdesc": "平和县", "parentid": 176}, "2265": {"ctype": "40", "cname": "华安", "id": 2265, "cdesc": "华安县", "parentid": 176}, "2266": {"ctype": "40", "cname": "长泰", "id": 2266, "cdesc": "长泰县", "parentid": 176}, "2267": {"ctype": "40", "cname": "诏安", "id": 2267, "cdesc": "诏安县", "parentid": 176}, "2268": {"ctype": "40", "cname": "东山", "id": 2268, "cdesc": "东山县", "parentid": 176}, "2269": {"ctype": "40", "cname": "向阳", "id": 2269, "cdesc": "向阳区", "parentid": 314}, "2270": {"ctype": "40", "cname": "前进", "id": 2270, "cdesc": "前进区", "parentid": 314}, "2271": {"ctype": "40", "cname": "东风", "id": 2271, "cdesc": "东风区", "parentid": 314}, "2272": {"ctype": "40", "cname": "郊区", "id": 2272, "cdesc": "郊区", "parentid": 314}, "2273": {"ctype": "40", "cname": "桦南", "id": 2273, "cdesc": "桦南县", "parentid": 314}, "2274": {"ctype": "40", "cname": "桦川", "id": 2274, "cdesc": "桦川县", "parentid": 314}, "2275": {"ctype": "40", "cname": "汤原", "id": 2275, "cdesc": "汤原县", "parentid": 314}, "2276": {"ctype": "40", "cname": "同江", "id": 2276, "cdesc": "同江市", "parentid": 314}, "2277": {"ctype": "40", "cname": "富锦", "id": 2277, "cdesc": "富锦市", "parentid": 314}, "2278": {"ctype": "40", "cname": "抚远", "id": 2278, "cdesc": "抚远市", "parentid": 314}, "2279": {"ctype": "40", "cname": "丰泽", "id": 2279, "cdesc": "丰泽区", "parentid": 175}, "2280": {"ctype": "40", "cname": "鲤城", "id": 2280, "cdesc": "鲤城区", "parentid": 175}, "2281": {"ctype": "40", "cname": "洛江", "id": 2281, "cdesc": "洛江区", "parentid": 175}, "2282": {"ctype": "40", "cname": "泉港", "id": 2282, "cdesc": "泉港区", "parentid": 175}, "2283": {"ctype": "40", "cname": "石狮", "id": 2283, "cdesc": "石狮市", "parentid": 175}, "2284": {"ctype": "40", "cname": "晋江", "id": 2284, "cdesc": "晋江市", "parentid": 175}, "2285": {"ctype": "40", "cname": "南安", "id": 2285, "cdesc": "南安市", "parentid": 175}, "2286": {"ctype": "40", "cname": "惠安", "id": 2286, "cdesc": "惠安县", "parentid": 175}, "2287": {"ctype": "40", "cname": "安溪", "id": 2287, "cdesc": "安溪县", "parentid": 175}, "2288": {"ctype": "40", "cname": "永春", "id": 2288, "cdesc": "永春县", "parentid": 175}, "2289": {"ctype": "40", "cname": "德化", "id": 2289, "cdesc": "德化县", "parentid": 175}, "2290": {"ctype": "40", "cname": "金门", "id": 2290, "cdesc": "金门县", "parentid": 175}, "2291": {"ctype": "40", "cname": "伊春", "id": 2291, "cdesc": "伊春区", "parentid": 313}, "2292": {"ctype": "40", "cname": "南岔", "id": 2292, "cdesc": "南岔区", "parentid": 313}, "2293": {"ctype": "40", "cname": "友好", "id": 2293, "cdesc": "友好区", "parentid": 313}, "2294": {"ctype": "40", "cname": "西林", "id": 2294, "cdesc": "西林区", "parentid": 313}, "2295": {"ctype": "40", "cname": "翠峦", "id": 2295, "cdesc": "翠峦区", "parentid": 313}, "2296": {"ctype": "40", "cname": "新青", "id": 2296, "cdesc": "新青区", "parentid": 313}, "2297": {"ctype": "40", "cname": "美溪", "id": 2297, "cdesc": "美溪区", "parentid": 313}, "2298": {"ctype": "40", "cname": "金山屯", "id": 2298, "cdesc": "金山屯区", "parentid": 313}, "2299": {"ctype": "40", "cname": "五营", "id": 2299, "cdesc": "五营区", "parentid": 313}, "2300": {"ctype": "40", "cname": "乌马河", "id": 2300, "cdesc": "乌马河区", "parentid": 313}, "2301": {"ctype": "40", "cname": "汤旺河", "id": 2301, "cdesc": "汤旺河区", "parentid": 313}, "2302": {"ctype": "40", "cname": "带岭", "id": 2302, "cdesc": "带岭区", "parentid": 313}, "2303": {"ctype": "40", "cname": "乌伊岭", "id": 2303, "cdesc": "乌伊岭区", "parentid": 313}, "2304": {"ctype": "40", "cname": "红星", "id": 2304, "cdesc": "红星区", "parentid": 313}, "2305": {"ctype": "40", "cname": "上甘岭", "id": 2305, "cdesc": "上甘岭区", "parentid": 313}, "2306": {"ctype": "40", "cname": "嘉荫", "id": 2306, "cdesc": "嘉荫县", "parentid": 313}, "2307": {"ctype": "40", "cname": "铁力", "id": 2307, "cdesc": "铁力市", "parentid": 313}, "2308": {"ctype": "40", "cname": "梅列", "id": 2308, "cdesc": "梅列区", "parentid": 174}, "2309": {"ctype": "40", "cname": "三元", "id": 2309, "cdesc": "三元区", "parentid": 174}, "2310": {"ctype": "40", "cname": "永安", "id": 2310, "cdesc": "永安市", "parentid": 174}, "2311": {"ctype": "40", "cname": "明溪", "id": 2311, "cdesc": "明溪县", "parentid": 174}, "2312": {"ctype": "40", "cname": "清流", "id": 2312, "cdesc": "清流县", "parentid": 174}, "2313": {"ctype": "40", "cname": "宁化", "id": 2313, "cdesc": "宁化县", "parentid": 174}, "2314": {"ctype": "40", "cname": "大田", "id": 2314, "cdesc": "大田县", "parentid": 174}, "2315": {"ctype": "40", "cname": "尤溪", "id": 2315, "cdesc": "尤溪县", "parentid": 174}, "2316": {"ctype": "40", "cname": "沙县", "id": 2316, "cdesc": "沙县", "parentid": 174}, "2317": {"ctype": "40", "cname": "将乐", "id": 2317, "cdesc": "将乐县", "parentid": 174}, "2318": {"ctype": "40", "cname": "泰宁", "id": 2318, "cdesc": "泰宁县", "parentid": 174}, "2319": {"ctype": "40", "cname": "建宁", "id": 2319, "cdesc": "建宁县", "parentid": 174}, "2320": {"ctype": "40", "cname": "萨尔图", "id": 2320, "cdesc": "萨尔图区", "parentid": 312}, "2321": {"ctype": "40", "cname": "龙凤", "id": 2321, "cdesc": "龙凤区", "parentid": 312}, "2322": {"ctype": "40", "cname": "让胡路", "id": 2322, "cdesc": "让胡路区", "parentid": 312}, "2323": {"ctype": "40", "cname": "红岗", "id": 2323, "cdesc": "红岗区", "parentid": 312}, "2324": {"ctype": "40", "cname": "大同", "id": 2324, "cdesc": "大同区", "parentid": 312}, "2325": {"ctype": "40", "cname": "肇州", "id": 2325, "cdesc": "肇州县", "parentid": 312}, "2326": {"ctype": "40", "cname": "肇源", "id": 2326, "cdesc": "肇源县", "parentid": 312}, "2327": {"ctype": "40", "cname": "林甸", "id": 2327, "cdesc": "林甸县", "parentid": 312}, "2328": {"ctype": "40", "cname": "杜尔伯特蒙古族", "id": 2328, "cdesc": "杜尔伯特蒙古族", "parentid": 312}, "2329": {"ctype": "40", "cname": "城厢", "id": 2329, "cdesc": "城厢区", "parentid": 173}, "2330": {"ctype": "40", "cname": "涵江", "id": 2330, "cdesc": "涵江区", "parentid": 173}, "2331": {"ctype": "40", "cname": "荔城", "id": 2331, "cdesc": "荔城区", "parentid": 173}, "2332": {"ctype": "40", "cname": "秀屿", "id": 2332, "cdesc": "秀屿区", "parentid": 173}, "2333": {"ctype": "40", "cname": "仙游", "id": 2333, "cdesc": "仙游县", "parentid": 173}, "2334": {"ctype": "40", "cname": "尖山", "id": 2334, "cdesc": "尖山区", "parentid": 311}, "2335": {"ctype": "40", "cname": "岭东", "id": 2335, "cdesc": "岭东区", "parentid": 311}, "2336": {"ctype": "40", "cname": "四方台", "id": 2336, "cdesc": "四方台区", "parentid": 311}, "2337": {"ctype": "40", "cname": "宝山", "id": 2337, "cdesc": "宝山区", "parentid": 311}, "2338": {"ctype": "40", "cname": "集贤", "id": 2338, "cdesc": "集贤县", "parentid": 311}, "2339": {"ctype": "40", "cname": "友谊", "id": 2339, "cdesc": "友谊县", "parentid": 311}, "2340": {"ctype": "40", "cname": "宝清", "id": 2340, "cdesc": "宝清县", "parentid": 311}, "2341": {"ctype": "40", "cname": "饶河", "id": 2341, "cdesc": "饶河县", "parentid": 311}, "2342": {"ctype": "40", "cname": "延平", "id": 2342, "cdesc": "延平区", "parentid": 177}, "2343": {"ctype": "40", "cname": "建阳", "id": 2343, "cdesc": "建阳区", "parentid": 177}, "2344": {"ctype": "40", "cname": "邵武", "id": 2344, "cdesc": "邵武市", "parentid": 177}, "2345": {"ctype": "40", "cname": "武夷山", "id": 2345, "cdesc": "武夷山市", "parentid": 177}, "2346": {"ctype": "40", "cname": "建瓯", "id": 2346, "cdesc": "建瓯市", "parentid": 177}, "2347": {"ctype": "40", "cname": "顺昌", "id": 2347, "cdesc": "顺昌县", "parentid": 177}, "2348": {"ctype": "40", "cname": "浦城", "id": 2348, "cdesc": "浦城县", "parentid": 177}, "2349": {"ctype": "40", "cname": "光泽", "id": 2349, "cdesc": "光泽县", "parentid": 177}, "2350": {"ctype": "40", "cname": "松溪", "id": 2350, "cdesc": "松溪县", "parentid": 177}, "2351": {"ctype": "40", "cname": "政和", "id": 2351, "cdesc": "政和县", "parentid": 177}, "2352": {"ctype": "40", "cname": "向阳", "id": 2352, "cdesc": "向阳区", "parentid": 310}, "2353": {"ctype": "40", "cname": "工农", "id": 2353, "cdesc": "工农区", "parentid": 310}, "2354": {"ctype": "40", "cname": "南山", "id": 2354, "cdesc": "南山区", "parentid": 310}, "2355": {"ctype": "40", "cname": "兴安", "id": 2355, "cdesc": "兴安区", "parentid": 310}, "2356": {"ctype": "40", "cname": "东山", "id": 2356, "cdesc": "东山区", "parentid": 310}, "2357": {"ctype": "40", "cname": "兴山", "id": 2357, "cdesc": "兴山区", "parentid": 310}, "2358": {"ctype": "40", "cname": "萝北", "id": 2358, "cdesc": "萝北县", "parentid": 310}, "2359": {"ctype": "40", "cname": "绥滨", "id": 2359, "cdesc": "绥滨县", "parentid": 310}, "2360": {"ctype": "40", "cname": "新罗", "id": 2360, "cdesc": "新罗区", "parentid": 178}, "2361": {"ctype": "40", "cname": "永定", "id": 2361, "cdesc": "永定区", "parentid": 178}, "2362": {"ctype": "40", "cname": "漳平", "id": 2362, "cdesc": "漳平市", "parentid": 178}, "2363": {"ctype": "40", "cname": "长汀", "id": 2363, "cdesc": "长汀县", "parentid": 178}, "2364": {"ctype": "40", "cname": "上杭", "id": 2364, "cdesc": "上杭县", "parentid": 178}, "2365": {"ctype": "40", "cname": "武平", "id": 2365, "cdesc": "武平县", "parentid": 178}, "2366": {"ctype": "40", "cname": "连城", "id": 2366, "cdesc": "连城县", "parentid": 178}, "2367": {"ctype": "40", "cname": "鸡冠", "id": 2367, "cdesc": "鸡冠区", "parentid": 309}, "2368": {"ctype": "40", "cname": "恒山", "id": 2368, "cdesc": "恒山区", "parentid": 309}, "2369": {"ctype": "40", "cname": "滴道", "id": 2369, "cdesc": "滴道区", "parentid": 309}, "2370": {"ctype": "40", "cname": "梨树", "id": 2370, "cdesc": "梨树区", "parentid": 309}, "2371": {"ctype": "40", "cname": "城子河", "id": 2371, "cdesc": "城子河区", "parentid": 309}, "2372": {"ctype": "40", "cname": "麻山", "id": 2372, "cdesc": "麻山区", "parentid": 309}, "2373": {"ctype": "40", "cname": "鸡东", "id": 2373, "cdesc": "鸡东县", "parentid": 309}, "2374": {"ctype": "40", "cname": "虎林", "id": 2374, "cdesc": "虎林市", "parentid": 309}, "2375": {"ctype": "40", "cname": "密山", "id": 2375, "cdesc": "密山市", "parentid": 309}, "2376": {"ctype": "40", "cname": "蕉城", "id": 2376, "cdesc": "蕉城区", "parentid": 179}, "2377": {"ctype": "40", "cname": "东侨新", "id": 2377, "cdesc": "东侨新区", "parentid": 179}, "2378": {"ctype": "40", "cname": "福安", "id": 2378, "cdesc": "福安市", "parentid": 179}, "2379": {"ctype": "40", "cname": "福鼎", "id": 2379, "cdesc": "福鼎市", "parentid": 179}, "2380": {"ctype": "40", "cname": "霞浦", "id": 2380, "cdesc": "霞浦县", "parentid": 179}, "2381": {"ctype": "40", "cname": "古田", "id": 2381, "cdesc": "古田县", "parentid": 179}, "2382": {"ctype": "40", "cname": "屏南", "id": 2382, "cdesc": "屏南县", "parentid": 179}, "2383": {"ctype": "40", "cname": "寿宁", "id": 2383, "cdesc": "寿宁县", "parentid": 179}, "2384": {"ctype": "40", "cname": "周宁", "id": 2384, "cdesc": "周宁县", "parentid": 179}, "2385": {"ctype": "40", "cname": "柘荣", "id": 2385, "cdesc": "柘荣县", "parentid": 179}, "2386": {"ctype": "40", "cname": "龙沙", "id": 2386, "cdesc": "龙沙区", "parentid": 308}, "2387": {"ctype": "40", "cname": "建华", "id": 2387, "cdesc": "建华区", "parentid": 308}, "2388": {"ctype": "40", "cname": "铁锋", "id": 2388, "cdesc": "铁锋区", "parentid": 308}, "2389": {"ctype": "40", "cname": "昂昂溪", "id": 2389, "cdesc": "昂昂溪区", "parentid": 308}, "2390": {"ctype": "40", "cname": "富拉尔基", "id": 2390, "cdesc": "富拉尔基区", "parentid": 308}, "2391": {"ctype": "40", "cname": "碾子山", "id": 2391, "cdesc": "碾子山区", "parentid": 308}, "2392": {"ctype": "40", "cname": "梅里斯达斡尔族", "id": 2392, "cdesc": "梅里斯达斡尔族区", "parentid": 308}, "2393": {"ctype": "40", "cname": "龙江", "id": 2393, "cdesc": "龙江县", "parentid": 308}, "2394": {"ctype": "40", "cname": "依安", "id": 2394, "cdesc": "依安县", "parentid": 308}, "2395": {"ctype": "40", "cname": "泰来", "id": 2395, "cdesc": "泰来县", "parentid": 308}, "2396": {"ctype": "40", "cname": "甘南", "id": 2396, "cdesc": "甘南县", "parentid": 308}, "2397": {"ctype": "40", "cname": "富裕", "id": 2397, "cdesc": "富裕县", "parentid": 308}, "2398": {"ctype": "40", "cname": "克山", "id": 2398, "cdesc": "克山县", "parentid": 308}, "2399": {"ctype": "40", "cname": "克东", "id": 2399, "cdesc": "克东县", "parentid": 308}, "2400": {"ctype": "40", "cname": "拜泉", "id": 2400, "cdesc": "拜泉县", "parentid": 308}, "2401": {"ctype": "40", "cname": "讷河", "id": 2401, "cdesc": "讷河市", "parentid": 308}, "2402": {"ctype": "40", "cname": "道里", "id": 2402, "cdesc": "道里区", "parentid": 307}, "2403": {"ctype": "40", "cname": "南岗", "id": 2403, "cdesc": "南岗区", "parentid": 307}, "2404": {"ctype": "40", "cname": "道外", "id": 2404, "cdesc": "道外区", "parentid": 307}, "2405": {"ctype": "40", "cname": "平房", "id": 2405, "cdesc": "平房区", "parentid": 307}, "2406": {"ctype": "40", "cname": "松北", "id": 2406, "cdesc": "松北区", "parentid": 307}, "2407": {"ctype": "40", "cname": "香坊", "id": 2407, "cdesc": "香坊区", "parentid": 307}, "2408": {"ctype": "40", "cname": "呼兰", "id": 2408, "cdesc": "呼兰区", "parentid": 307}, "2409": {"ctype": "40", "cname": "阿城", "id": 2409, "cdesc": "阿城区", "parentid": 307}, "2410": {"ctype": "40", "cname": "双城", "id": 2410, "cdesc": "双城区", "parentid": 307}, "2411": {"ctype": "40", "cname": "依兰", "id": 2411, "cdesc": "依兰县", "parentid": 307}, "2412": {"ctype": "40", "cname": "方正", "id": 2412, "cdesc": "方正县", "parentid": 307}, "2413": {"ctype": "40", "cname": "宾县", "id": 2413, "cdesc": "宾县", "parentid": 307}, "2414": {"ctype": "40", "cname": "巴彦", "id": 2414, "cdesc": "巴彦县", "parentid": 307}, "2415": {"ctype": "40", "cname": "木兰", "id": 2415, "cdesc": "木兰县", "parentid": 307}, "2416": {"ctype": "40", "cname": "通河", "id": 2416, "cdesc": "通河县", "parentid": 307}, "2417": {"ctype": "40", "cname": "延寿", "id": 2417, "cdesc": "延寿县", "parentid": 307}, "2418": {"ctype": "40", "cname": "尚志", "id": 2418, "cdesc": "尚志市", "parentid": 307}, "2419": {"ctype": "40", "cname": "五常", "id": 2419, "cdesc": "五常市", "parentid": 307}, "2420": {"ctype": "40", "cname": "东湖", "id": 2420, "cdesc": "东湖区", "parentid": 180}, "2421": {"ctype": "40", "cname": "西湖", "id": 2421, "cdesc": "西湖区", "parentid": 180}, "2422": {"ctype": "40", "cname": "青云谱", "id": 2422, "cdesc": "青云谱区", "parentid": 180}, "2423": {"ctype": "40", "cname": "湾里", "id": 2423, "cdesc": "湾里区", "parentid": 180}, "2424": {"ctype": "40", "cname": "青山湖", "id": 2424, "cdesc": "青山湖区", "parentid": 180}, "2425": {"ctype": "40", "cname": "新建", "id": 2425, "cdesc": "新建区", "parentid": 180}, "2426": {"ctype": "40", "cname": "南昌", "id": 2426, "cdesc": "南昌县", "parentid": 180}, "2427": {"ctype": "40", "cname": "安义", "id": 2427, "cdesc": "安义县", "parentid": 180}, "2428": {"ctype": "40", "cname": "进贤", "id": 2428, "cdesc": "进贤县", "parentid": 180}, "2429": {"ctype": "40", "cname": "噶尔", "id": 2429, "cdesc": "噶尔县", "parentid": 305}, "2430": {"ctype": "40", "cname": "普兰", "id": 2430, "cdesc": "普兰县", "parentid": 305}, "2431": {"ctype": "40", "cname": "札达", "id": 2431, "cdesc": "札达县", "parentid": 305}, "2432": {"ctype": "40", "cname": "日土", "id": 2432, "cdesc": "日土县", "parentid": 305}, "2433": {"ctype": "40", "cname": "革吉", "id": 2433, "cdesc": "革吉县", "parentid": 305}, "2434": {"ctype": "40", "cname": "改则", "id": 2434, "cdesc": "改则县", "parentid": 305}, "2435": {"ctype": "40", "cname": "措勤", "id": 2435, "cdesc": "措勤县", "parentid": 305}, "2436": {"ctype": "40", "cname": "浔阳", "id": 2436, "cdesc": "浔阳区", "parentid": 183}, "2437": {"ctype": "40", "cname": "濂溪", "id": 2437, "cdesc": "濂溪区", "parentid": 183}, "2438": {"ctype": "40", "cname": "九江", "id": 2438, "cdesc": "九江县", "parentid": 183}, "2439": {"ctype": "40", "cname": "永修", "id": 2439, "cdesc": "永修县", "parentid": 183}, "2440": {"ctype": "40", "cname": "德安", "id": 2440, "cdesc": "德安县", "parentid": 183}, "2441": {"ctype": "40", "cname": "都昌", "id": 2441, "cdesc": "都昌县", "parentid": 183}, "2442": {"ctype": "40", "cname": "湖口", "id": 2442, "cdesc": "湖口县", "parentid": 183}, "2443": {"ctype": "40", "cname": "彭泽", "id": 2443, "cdesc": "彭泽县", "parentid": 183}, "2444": {"ctype": "40", "cname": "武宁", "id": 2444, "cdesc": "武宁县", "parentid": 183}, "2445": {"ctype": "40", "cname": "修水", "id": 2445, "cdesc": "修水县", "parentid": 183}, "2446": {"ctype": "40", "cname": "瑞昌", "id": 2446, "cdesc": "瑞昌市", "parentid": 183}, "2447": {"ctype": "40", "cname": "共青城", "id": 2447, "cdesc": "共青城市", "parentid": 183}, "2448": {"ctype": "40", "cname": "庐山", "id": 2448, "cdesc": "庐山市", "parentid": 183}, "2449": {"ctype": "40", "cname": "那曲", "id": 2449, "cdesc": "那曲县", "parentid": 304}, "2450": {"ctype": "40", "cname": "申扎", "id": 2450, "cdesc": "申扎县", "parentid": 304}, "2451": {"ctype": "40", "cname": "班戈", "id": 2451, "cdesc": "班戈县", "parentid": 304}, "2452": {"ctype": "40", "cname": "聂荣", "id": 2452, "cdesc": "聂荣县", "parentid": 304}, "2453": {"ctype": "40", "cname": "安多", "id": 2453, "cdesc": "安多县", "parentid": 304}, "2454": {"ctype": "40", "cname": "嘉黎", "id": 2454, "cdesc": "嘉黎县", "parentid": 304}, "2455": {"ctype": "40", "cname": "巴青", "id": 2455, "cdesc": "巴青县", "parentid": 304}, "2456": {"ctype": "40", "cname": "比如", "id": 2456, "cdesc": "比如县", "parentid": 304}, "2457": {"ctype": "40", "cname": "索县", "id": 2457, "cdesc": "索县", "parentid": 304}, "2458": {"ctype": "40", "cname": "尼玛", "id": 2458, "cdesc": "尼玛县", "parentid": 304}, "2459": {"ctype": "40", "cname": "乃东", "id": 2459, "cdesc": "乃东区", "parentid": 302}, "2460": {"ctype": "40", "cname": "扎囊", "id": 2460, "cdesc": "扎囊县", "parentid": 302}, "2461": {"ctype": "40", "cname": "贡嘎", "id": 2461, "cdesc": "贡嘎县", "parentid": 302}, "2462": {"ctype": "40", "cname": "桑日", "id": 2462, "cdesc": "桑日县", "parentid": 302}, "2463": {"ctype": "40", "cname": "琼结", "id": 2463, "cdesc": "琼结县", "parentid": 302}, "2464": {"ctype": "40", "cname": "洛扎", "id": 2464, "cdesc": "洛扎县", "parentid": 302}, "2465": {"ctype": "40", "cname": "加查", "id": 2465, "cdesc": "加查县", "parentid": 302}, "2466": {"ctype": "40", "cname": "隆子", "id": 2466, "cdesc": "隆子县", "parentid": 302}, "2467": {"ctype": "40", "cname": "曲松", "id": 2467, "cdesc": "曲松县", "parentid": 302}, "2468": {"ctype": "40", "cname": "措美", "id": 2468, "cdesc": "措美县", "parentid": 302}, "2469": {"ctype": "40", "cname": "错那", "id": 2469, "cdesc": "错那县", "parentid": 302}, "2470": {"ctype": "40", "cname": "浪卡子", "id": 2470, "cdesc": "浪卡子县", "parentid": 302}, "2471": {"ctype": "40", "cname": "信州", "id": 2471, "cdesc": "信州区", "parentid": 190}, "2472": {"ctype": "40", "cname": "广丰", "id": 2472, "cdesc": "广丰区", "parentid": 190}, "2473": {"ctype": "40", "cname": "上饶", "id": 2473, "cdesc": "上饶县", "parentid": 190}, "2474": {"ctype": "40", "cname": "玉山", "id": 2474, "cdesc": "玉山县", "parentid": 190}, "2475": {"ctype": "40", "cname": "铅山", "id": 2475, "cdesc": "铅山县", "parentid": 190}, "2476": {"ctype": "40", "cname": "横峰", "id": 2476, "cdesc": "横峰县", "parentid": 190}, "2477": {"ctype": "40", "cname": "弋阳", "id": 2477, "cdesc": "弋阳县", "parentid": 190}, "2478": {"ctype": "40", "cname": "余干", "id": 2478, "cdesc": "余干县", "parentid": 190}, "2479": {"ctype": "40", "cname": "鄱阳", "id": 2479, "cdesc": "鄱阳县", "parentid": 190}, "2480": {"ctype": "40", "cname": "万年", "id": 2480, "cdesc": "万年县", "parentid": 190}, "2481": {"ctype": "40", "cname": "婺源", "id": 2481, "cdesc": "婺源县", "parentid": 190}, "2482": {"ctype": "40", "cname": "德兴", "id": 2482, "cdesc": "德兴市", "parentid": 190}, "2483": {"ctype": "40", "cname": "巴宜", "id": 2483, "cdesc": "巴宜区", "parentid": 306}, "2484": {"ctype": "40", "cname": "米林", "id": 2484, "cdesc": "米林县", "parentid": 306}, "2485": {"ctype": "40", "cname": "墨脱", "id": 2485, "cdesc": "墨脱县", "parentid": 306}, "2486": {"ctype": "40", "cname": "察隅", "id": 2486, "cdesc": "察隅县", "parentid": 306}, "2487": {"ctype": "40", "cname": "波密", "id": 2487, "cdesc": "波密县", "parentid": 306}, "2488": {"ctype": "40", "cname": "朗县", "id": 2488, "cdesc": "朗县", "parentid": 306}, "2489": {"ctype": "40", "cname": "工布江达", "id": 2489, "cdesc": "工布江达县", "parentid": 306}, "2490": {"ctype": "40", "cname": "临川", "id": 2490, "cdesc": "临川区", "parentid": 189}, "2491": {"ctype": "40", "cname": "南城", "id": 2491, "cdesc": "南城县", "parentid": 189}, "2492": {"ctype": "40", "cname": "黎川", "id": 2492, "cdesc": "黎川县", "parentid": 189}, "2493": {"ctype": "40", "cname": "南丰", "id": 2493, "cdesc": "南丰县", "parentid": 189}, "2494": {"ctype": "40", "cname": "崇仁", "id": 2494, "cdesc": "崇仁县", "parentid": 189}, "2495": {"ctype": "40", "cname": "乐安", "id": 2495, "cdesc": "乐安县", "parentid": 189}, "2496": {"ctype": "40", "cname": "宜黄", "id": 2496, "cdesc": "宜黄县", "parentid": 189}, "2497": {"ctype": "40", "cname": "金溪", "id": 2497, "cdesc": "金溪县", "parentid": 189}, "2498": {"ctype": "40", "cname": "资溪", "id": 2498, "cdesc": "资溪县", "parentid": 189}, "2499": {"ctype": "40", "cname": "东乡", "id": 2499, "cdesc": "东乡县", "parentid": 189}, "2500": {"ctype": "40", "cname": "广昌", "id": 2500, "cdesc": "广昌县", "parentid": 189}, "2501": {"ctype": "40", "cname": "桑珠孜", "id": 2501, "cdesc": "桑珠孜区", "parentid": 303}, "2502": {"ctype": "40", "cname": "南木林", "id": 2502, "cdesc": "南木林县", "parentid": 303}, "2503": {"ctype": "40", "cname": "江孜", "id": 2503, "cdesc": "江孜县", "parentid": 303}, "2504": {"ctype": "40", "cname": "定日", "id": 2504, "cdesc": "定日县", "parentid": 303}, "2505": {"ctype": "40", "cname": "萨迦", "id": 2505, "cdesc": "萨迦县", "parentid": 303}, "2506": {"ctype": "40", "cname": "拉孜", "id": 2506, "cdesc": "拉孜县", "parentid": 303}, "2507": {"ctype": "40", "cname": "昂仁", "id": 2507, "cdesc": "昂仁县", "parentid": 303}, "2508": {"ctype": "40", "cname": "谢通门", "id": 2508, "cdesc": "谢通门县", "parentid": 303}, "2509": {"ctype": "40", "cname": "白朗", "id": 2509, "cdesc": "白朗县", "parentid": 303}, "2510": {"ctype": "40", "cname": "仁布", "id": 2510, "cdesc": "仁布县", "parentid": 303}, "2511": {"ctype": "40", "cname": "康马", "id": 2511, "cdesc": "康马县", "parentid": 303}, "2512": {"ctype": "40", "cname": "定结", "id": 2512, "cdesc": "定结县", "parentid": 303}, "2513": {"ctype": "40", "cname": "仲巴", "id": 2513, "cdesc": "仲巴县", "parentid": 303}, "2514": {"ctype": "40", "cname": "亚东", "id": 2514, "cdesc": "亚东县", "parentid": 303}, "2515": {"ctype": "40", "cname": "吉隆", "id": 2515, "cdesc": "吉隆县", "parentid": 303}, "2516": {"ctype": "40", "cname": "聂拉木", "id": 2516, "cdesc": "聂拉木县", "parentid": 303}, "2517": {"ctype": "40", "cname": "萨嘎", "id": 2517, "cdesc": "萨嘎县", "parentid": 303}, "2518": {"ctype": "40", "cname": "岗巴", "id": 2518, "cdesc": "岗巴县", "parentid": 303}, "2519": {"ctype": "40", "cname": "袁州", "id": 2519, "cdesc": "袁州区", "parentid": 188}, "2520": {"ctype": "40", "cname": "高安", "id": 2520, "cdesc": "高安市", "parentid": 188}, "2521": {"ctype": "40", "cname": "丰城", "id": 2521, "cdesc": "丰城市", "parentid": 188}, "2522": {"ctype": "40", "cname": "樟树", "id": 2522, "cdesc": "樟树市", "parentid": 188}, "2523": {"ctype": "40", "cname": "奉新", "id": 2523, "cdesc": "奉新县", "parentid": 188}, "2524": {"ctype": "40", "cname": "万载", "id": 2524, "cdesc": "万载县", "parentid": 188}, "2525": {"ctype": "40", "cname": "上高", "id": 2525, "cdesc": "上高县", "parentid": 188}, "2526": {"ctype": "40", "cname": "宜丰", "id": 2526, "cdesc": "宜丰县", "parentid": 188}, "2527": {"ctype": "40", "cname": "靖安", "id": 2527, "cdesc": "靖安县", "parentid": 188}, "2528": {"ctype": "40", "cname": "铜鼓", "id": 2528, "cdesc": "铜鼓县", "parentid": 188}, "2529": {"ctype": "40", "cname": "卡若", "id": 2529, "cdesc": "卡若区", "parentid": 301}, "2530": {"ctype": "40", "cname": "察雅", "id": 2530, "cdesc": "察雅县", "parentid": 301}, "2531": {"ctype": "40", "cname": "左贡", "id": 2531, "cdesc": "左贡县", "parentid": 301}, "2532": {"ctype": "40", "cname": "芒康", "id": 2532, "cdesc": "芒康县", "parentid": 301}, "2533": {"ctype": "40", "cname": "洛隆", "id": 2533, "cdesc": "洛隆县", "parentid": 301}, "2534": {"ctype": "40", "cname": "边坝", "id": 2534, "cdesc": "边坝县", "parentid": 301}, "2535": {"ctype": "40", "cname": "江达", "id": 2535, "cdesc": "江达县", "parentid": 301}, "2536": {"ctype": "40", "cname": "贡觉", "id": 2536, "cdesc": "贡觉县", "parentid": 301}, "2537": {"ctype": "40", "cname": "丁青", "id": 2537, "cdesc": "丁青县", "parentid": 301}, "2538": {"ctype": "40", "cname": "八宿", "id": 2538, "cdesc": "八宿县", "parentid": 301}, "2539": {"ctype": "40", "cname": "类乌齐", "id": 2539, "cdesc": "类乌齐县", "parentid": 301}, "2541": {"ctype": "40", "cname": "城关", "id": 2541, "cdesc": "城关区", "parentid": 300}, "2542": {"ctype": "40", "cname": "堆龙德庆", "id": 2542, "cdesc": "堆龙德庆区", "parentid": 300}, "2543": {"ctype": "40", "cname": "林周", "id": 2543, "cdesc": "林周县", "parentid": 300}, "2544": {"ctype": "40", "cname": "达孜", "id": 2544, "cdesc": "达孜县", "parentid": 300}, "2545": {"ctype": "40", "cname": "尼木", "id": 2545, "cdesc": "尼木县", "parentid": 300}, "2546": {"ctype": "40", "cname": "当雄", "id": 2546, "cdesc": "当雄县", "parentid": 300}, "2547": {"ctype": "40", "cname": "曲水", "id": 2547, "cdesc": "曲水县", "parentid": 300}, "2548": {"ctype": "40", "cname": "墨竹工卡", "id": 2548, "cdesc": "墨竹工卡县", "parentid": 300}, "2549": {"ctype": "40", "cname": "景洪", "id": 2549, "cdesc": "景洪市", "parentid": 295}, "2550": {"ctype": "40", "cname": "勐海", "id": 2550, "cdesc": "勐海县", "parentid": 295}, "2551": {"ctype": "40", "cname": "勐腊", "id": 2551, "cdesc": "勐腊县", "parentid": 295}, "2552": {"ctype": "40", "cname": "吉州", "id": 2552, "cdesc": "吉州区", "parentid": 187}, "2553": {"ctype": "40", "cname": "青原", "id": 2553, "cdesc": "青原区", "parentid": 187}, "2554": {"ctype": "40", "cname": "吉安", "id": 2554, "cdesc": "吉安县", "parentid": 187}, "2555": {"ctype": "40", "cname": "井冈山", "id": 2555, "cdesc": "井冈山市", "parentid": 187}, "2556": {"ctype": "40", "cname": "吉水", "id": 2556, "cdesc": "吉水县", "parentid": 187}, "2557": {"ctype": "40", "cname": "新干", "id": 2557, "cdesc": "新干县", "parentid": 187}, "2558": {"ctype": "40", "cname": "永丰", "id": 2558, "cdesc": "永丰县", "parentid": 187}, "2559": {"ctype": "40", "cname": "泰和", "id": 2559, "cdesc": "泰和县", "parentid": 187}, "2560": {"ctype": "40", "cname": "遂川", "id": 2560, "cdesc": "遂川县", "parentid": 187}, "2561": {"ctype": "40", "cname": "万安", "id": 2561, "cdesc": "万安县", "parentid": 187}, "2562": {"ctype": "40", "cname": "安福", "id": 2562, "cdesc": "安福县", "parentid": 187}, "2563": {"ctype": "40", "cname": "永新", "id": 2563, "cdesc": "永新县", "parentid": 187}, "2564": {"ctype": "40", "cname": "峡江", "id": 2564, "cdesc": "峡江县", "parentid": 187}, "2565": {"ctype": "40", "cname": "文山", "id": 2565, "cdesc": "文山市", "parentid": 294}, "2566": {"ctype": "40", "cname": "砚山", "id": 2566, "cdesc": "砚山县", "parentid": 294}, "2567": {"ctype": "40", "cname": "西畴", "id": 2567, "cdesc": "西畴县", "parentid": 294}, "2568": {"ctype": "40", "cname": "麻栗坡", "id": 2568, "cdesc": "麻栗坡县", "parentid": 294}, "2569": {"ctype": "40", "cname": "马关", "id": 2569, "cdesc": "马关县", "parentid": 294}, "2570": {"ctype": "40", "cname": "丘北", "id": 2570, "cdesc": "丘北县", "parentid": 294}, "2571": {"ctype": "40", "cname": "广南", "id": 2571, "cdesc": "广南县", "parentid": 294}, "2572": {"ctype": "40", "cname": "富宁", "id": 2572, "cdesc": "富宁县", "parentid": 294}, "2573": {"ctype": "40", "cname": "章贡", "id": 2573, "cdesc": "章贡区", "parentid": 186}, "2574": {"ctype": "40", "cname": "南康", "id": 2574, "cdesc": "南康区", "parentid": 186}, "2575": {"ctype": "40", "cname": "信丰", "id": 2575, "cdesc": "信丰县", "parentid": 186}, "2576": {"ctype": "40", "cname": "大余", "id": 2576, "cdesc": "大余县", "parentid": 186}, "2577": {"ctype": "40", "cname": "赣县", "id": 2577, "cdesc": "赣县", "parentid": 186}, "2578": {"ctype": "40", "cname": "龙南", "id": 2578, "cdesc": "龙南县", "parentid": 186}, "2579": {"ctype": "40", "cname": "定南", "id": 2579, "cdesc": "定南县", "parentid": 186}, "2580": {"ctype": "40", "cname": "全南", "id": 2580, "cdesc": "全南县", "parentid": 186}, "2581": {"ctype": "40", "cname": "寻乌", "id": 2581, "cdesc": "寻乌县", "parentid": 186}, "2582": {"ctype": "40", "cname": "安远", "id": 2582, "cdesc": "安远县", "parentid": 186}, "2583": {"ctype": "40", "cname": "瑞金", "id": 2583, "cdesc": "瑞金市", "parentid": 186}, "2584": {"ctype": "40", "cname": "宁都", "id": 2584, "cdesc": "宁都县", "parentid": 186}, "2585": {"ctype": "40", "cname": "于都", "id": 2585, "cdesc": "于都县", "parentid": 186}, "2586": {"ctype": "40", "cname": "会昌", "id": 2586, "cdesc": "会昌县", "parentid": 186}, "2587": {"ctype": "40", "cname": "石城", "id": 2587, "cdesc": "石城县", "parentid": 186}, "2588": {"ctype": "40", "cname": "上犹", "id": 2588, "cdesc": "上犹县", "parentid": 186}, "2589": {"ctype": "40", "cname": "兴国", "id": 2589, "cdesc": "兴国县", "parentid": 186}, "2590": {"ctype": "40", "cname": "崇义", "id": 2590, "cdesc": "崇义县", "parentid": 186}, "2591": {"ctype": "40", "cname": "珠山", "id": 2591, "cdesc": "珠山区", "parentid": 181}, "2592": {"ctype": "40", "cname": "昌江", "id": 2592, "cdesc": "昌江区", "parentid": 181}, "2593": {"ctype": "40", "cname": "浮梁", "id": 2593, "cdesc": "浮梁县", "parentid": 181}, "2594": {"ctype": "40", "cname": "乐平", "id": 2594, "cdesc": "乐平市", "parentid": 181}, "2595": {"ctype": "40", "cname": "蒙自", "id": 2595, "cdesc": "蒙自市", "parentid": 293}, "2596": {"ctype": "40", "cname": "个旧", "id": 2596, "cdesc": "个旧市", "parentid": 293}, "2597": {"ctype": "40", "cname": "开远", "id": 2597, "cdesc": "开远市", "parentid": 293}, "2598": {"ctype": "40", "cname": "弥勒", "id": 2598, "cdesc": "弥勒市", "parentid": 293}, "2599": {"ctype": "40", "cname": "建水", "id": 2599, "cdesc": "建水县", "parentid": 293}, "2600": {"ctype": "40", "cname": "石屏", "id": 2600, "cdesc": "石屏县", "parentid": 293}, "2601": {"ctype": "40", "cname": "泸西", "id": 2601, "cdesc": "泸西县", "parentid": 293}, "2602": {"ctype": "40", "cname": "绿春", "id": 2602, "cdesc": "绿春县", "parentid": 293}, "2603": {"ctype": "40", "cname": "元阳", "id": 2603, "cdesc": "元阳县", "parentid": 293}, "2604": {"ctype": "40", "cname": "红河", "id": 2604, "cdesc": "红河县", "parentid": 293}, "2605": {"ctype": "40", "cname": "金平苗族瑶族傣族", "id": 2605, "cdesc": "金平苗族瑶族傣族", "parentid": 293}, "2606": {"ctype": "40", "cname": "河口瑶族", "id": 2606, "cdesc": "河口瑶族", "parentid": 293}, "2607": {"ctype": "40", "cname": "屏边苗族", "id": 2607, "cdesc": "屏边苗族", "parentid": 293}, "2608": {"ctype": "40", "cname": "安源", "id": 2608, "cdesc": "安源区", "parentid": 182}, "2609": {"ctype": "40", "cname": "湘东", "id": 2609, "cdesc": "湘东区", "parentid": 182}, "2610": {"ctype": "40", "cname": "莲花", "id": 2610, "cdesc": "莲花县", "parentid": 182}, "2611": {"ctype": "40", "cname": "上栗", "id": 2611, "cdesc": "上栗县", "parentid": 182}, "2612": {"ctype": "40", "cname": "芦溪", "id": 2612, "cdesc": "芦溪县", "parentid": 182}, "2613": {"ctype": "40", "cname": "楚雄", "id": 2613, "cdesc": "楚雄市", "parentid": 292}, "2614": {"ctype": "40", "cname": "双柏", "id": 2614, "cdesc": "双柏县", "parentid": 292}, "2615": {"ctype": "40", "cname": "牟定", "id": 2615, "cdesc": "牟定县", "parentid": 292}, "2616": {"ctype": "40", "cname": "南华", "id": 2616, "cdesc": "南华县", "parentid": 292}, "2617": {"ctype": "40", "cname": "姚安", "id": 2617, "cdesc": "姚安县", "parentid": 292}, "2618": {"ctype": "40", "cname": "大姚", "id": 2618, "cdesc": "大姚县", "parentid": 292}, "2619": {"ctype": "40", "cname": "永仁", "id": 2619, "cdesc": "永仁县", "parentid": 292}, "2620": {"ctype": "40", "cname": "元谋", "id": 2620, "cdesc": "元谋县", "parentid": 292}, "2621": {"ctype": "40", "cname": "武定", "id": 2621, "cdesc": "武定县", "parentid": 292}, "2622": {"ctype": "40", "cname": "禄丰", "id": 2622, "cdesc": "禄丰县", "parentid": 292}, "2623": {"ctype": "40", "cname": "渝水", "id": 2623, "cdesc": "渝水区", "parentid": 184}, "2624": {"ctype": "40", "cname": "分宜", "id": 2624, "cdesc": "分宜县", "parentid": 184}, "2625": {"ctype": "40", "cname": "大理", "id": 2625, "cdesc": "大理市", "parentid": 296}, "2626": {"ctype": "40", "cname": "祥云", "id": 2626, "cdesc": "祥云县", "parentid": 296}, "2627": {"ctype": "40", "cname": "宾川", "id": 2627, "cdesc": "宾川县", "parentid": 296}, "2628": {"ctype": "40", "cname": "弥渡", "id": 2628, "cdesc": "弥渡县", "parentid": 296}, "2629": {"ctype": "40", "cname": "永平", "id": 2629, "cdesc": "永平县", "parentid": 296}, "2630": {"ctype": "40", "cname": "云龙", "id": 2630, "cdesc": "云龙县", "parentid": 296}, "2631": {"ctype": "40", "cname": "洱源", "id": 2631, "cdesc": "洱源县", "parentid": 296}, "2632": {"ctype": "40", "cname": "剑川", "id": 2632, "cdesc": "剑川县", "parentid": 296}, "2633": {"ctype": "40", "cname": "鹤庆", "id": 2633, "cdesc": "鹤庆县", "parentid": 296}, "2634": {"ctype": "40", "cname": "漾濞彝族", "id": 2634, "cdesc": "漾濞彝族", "parentid": 296}, "2635": {"ctype": "40", "cname": "南涧彝族", "id": 2635, "cdesc": "南涧彝族", "parentid": 296}, "2636": {"ctype": "40", "cname": "巍山彝族", "id": 2636, "cdesc": "巍山彝族", "parentid": 296}, "2637": {"ctype": "40", "cname": "月湖", "id": 2637, "cdesc": "月湖区", "parentid": 185}, "2638": {"ctype": "40", "cname": "余江", "id": 2638, "cdesc": "余江县", "parentid": 185}, "2639": {"ctype": "40", "cname": "贵溪", "id": 2639, "cdesc": "贵溪市", "parentid": 185}, "2640": {"ctype": "40", "cname": "香格里拉", "id": 2640, "cdesc": "香格里拉市", "parentid": 299}, "2641": {"ctype": "40", "cname": "德钦", "id": 2641, "cdesc": "德钦县", "parentid": 299}, "2642": {"ctype": "40", "cname": "维西傈僳族", "id": 2642, "cdesc": "维西傈僳族", "parentid": 299}, "2643": {"ctype": "40", "cname": "历下", "id": 2643, "cdesc": "历下区", "parentid": 191}, "2644": {"ctype": "40", "cname": "市中", "id": 2644, "cdesc": "市中区", "parentid": 191}, "2645": {"ctype": "40", "cname": "槐荫", "id": 2645, "cdesc": "槐荫区", "parentid": 191}, "2646": {"ctype": "40", "cname": "天桥", "id": 2646, "cdesc": "天桥区", "parentid": 191}, "2647": {"ctype": "40", "cname": "历城", "id": 2647, "cdesc": "历城区", "parentid": 191}, "2648": {"ctype": "40", "cname": "长清", "id": 2648, "cdesc": "长清区", "parentid": 191}, "2649": {"ctype": "40", "cname": "章丘", "id": 2649, "cdesc": "章丘市", "parentid": 191}, "2650": {"ctype": "40", "cname": "平阴", "id": 2650, "cdesc": "平阴县", "parentid": 191}, "2651": {"ctype": "40", "cname": "济阳", "id": 2651, "cdesc": "济阳县", "parentid": 191}, "2652": {"ctype": "40", "cname": "商河", "id": 2652, "cdesc": "商河县", "parentid": 191}, "2653": {"ctype": "40", "cname": "泸水", "id": 2653, "cdesc": "泸水县", "parentid": 298}, "2654": {"ctype": "40", "cname": "福贡", "id": 2654, "cdesc": "福贡县", "parentid": 298}, "2655": {"ctype": "40", "cname": "贡山独龙族", "id": 2655, "cdesc": "贡山独龙族", "parentid": 298}, "2656": {"ctype": "40", "cname": "兰坪白族", "id": 2656, "cdesc": "兰坪白族", "parentid": 298}, "2657": {"ctype": "40", "cname": "市南", "id": 2657, "cdesc": "市南区", "parentid": 192}, "2658": {"ctype": "40", "cname": "市北", "id": 2658, "cdesc": "市北区", "parentid": 192}, "2659": {"ctype": "40", "cname": "李沧", "id": 2659, "cdesc": "李沧区", "parentid": 192}, "2660": {"ctype": "40", "cname": "城阳", "id": 2660, "cdesc": "城阳区", "parentid": 192}, "2661": {"ctype": "40", "cname": "崂山", "id": 2661, "cdesc": "崂山区", "parentid": 192}, "2662": {"ctype": "40", "cname": "黄岛", "id": 2662, "cdesc": "黄岛区", "parentid": 192}, "2663": {"ctype": "40", "cname": "即墨", "id": 2663, "cdesc": "即墨市", "parentid": 192}, "2664": {"ctype": "40", "cname": "胶州", "id": 2664, "cdesc": "胶州市", "parentid": 192}, "2665": {"ctype": "40", "cname": "平度", "id": 2665, "cdesc": "平度市", "parentid": 192}, "2666": {"ctype": "40", "cname": "莱西", "id": 2666, "cdesc": "莱西市", "parentid": 192}, "2667": {"ctype": "40", "cname": "张店", "id": 2667, "cdesc": "张店区", "parentid": 193}, "2668": {"ctype": "40", "cname": "淄川", "id": 2668, "cdesc": "淄川区", "parentid": 193}, "2669": {"ctype": "40", "cname": "周村", "id": 2669, "cdesc": "周村区", "parentid": 193}, "2670": {"ctype": "40", "cname": "博山", "id": 2670, "cdesc": "博山区", "parentid": 193}, "2671": {"ctype": "40", "cname": "临淄", "id": 2671, "cdesc": "临淄区", "parentid": 193}, "2672": {"ctype": "40", "cname": "桓台", "id": 2672, "cdesc": "桓台县", "parentid": 193}, "2673": {"ctype": "40", "cname": "高青", "id": 2673, "cdesc": "高青县", "parentid": 193}, "2674": {"ctype": "40", "cname": "沂源", "id": 2674, "cdesc": "沂源县", "parentid": 193}, "2675": {"ctype": "40", "cname": "芒市", "id": 2675, "cdesc": "芒市", "parentid": 297}, "2676": {"ctype": "40", "cname": "瑞丽", "id": 2676, "cdesc": "瑞丽市", "parentid": 297}, "2677": {"ctype": "40", "cname": "梁河", "id": 2677, "cdesc": "梁河县", "parentid": 297}, "2678": {"ctype": "40", "cname": "盈江", "id": 2678, "cdesc": "盈江县", "parentid": 297}, "2679": {"ctype": "40", "cname": "陇川", "id": 2679, "cdesc": "陇川县", "parentid": 297}, "2680": {"ctype": "40", "cname": "薛城", "id": 2680, "cdesc": "薛城区", "parentid": 194}, "2681": {"ctype": "40", "cname": "市中", "id": 2681, "cdesc": "市中区", "parentid": 194}, "2682": {"ctype": "40", "cname": "峄城", "id": 2682, "cdesc": "峄城区", "parentid": 194}, "2683": {"ctype": "40", "cname": "山亭", "id": 2683, "cdesc": "山亭区", "parentid": 194}, "2684": {"ctype": "40", "cname": "台儿庄", "id": 2684, "cdesc": "台儿庄区", "parentid": 194}, "2685": {"ctype": "40", "cname": "滕州", "id": 2685, "cdesc": "滕州市", "parentid": 194}, "2686": {"ctype": "40", "cname": "临翔", "id": 2686, "cdesc": "临翔区", "parentid": 291}, "2687": {"ctype": "40", "cname": "凤庆", "id": 2687, "cdesc": "凤庆县", "parentid": 291}, "2688": {"ctype": "40", "cname": "云县", "id": 2688, "cdesc": "云县", "parentid": 291}, "2689": {"ctype": "40", "cname": "永德", "id": 2689, "cdesc": "永德县", "parentid": 291}, "2690": {"ctype": "40", "cname": "镇康", "id": 2690, "cdesc": "镇康县", "parentid": 291}, "2691": {"ctype": "40", "cname": "双江拉祜族", "id": 2691, "cdesc": "双江拉祜族", "parentid": 291}, "2692": {"ctype": "40", "cname": "耿马傣族", "id": 2692, "cdesc": "耿马傣族", "parentid": 291}, "2693": {"ctype": "40", "cname": "沧源佤族", "id": 2693, "cdesc": "沧源佤族", "parentid": 291}, "2694": {"ctype": "40", "cname": "东营", "id": 2694, "cdesc": "东营区", "parentid": 195}, "2695": {"ctype": "40", "cname": "河口", "id": 2695, "cdesc": "河口区", "parentid": 195}, "2696": {"ctype": "40", "cname": "广饶", "id": 2696, "cdesc": "广饶县", "parentid": 195}, "2697": {"ctype": "40", "cname": "垦利", "id": 2697, "cdesc": "垦利县", "parentid": 195}, "2698": {"ctype": "40", "cname": "利津", "id": 2698, "cdesc": "利津县", "parentid": 195}, "2699": {"ctype": "40", "cname": "莱山", "id": 2699, "cdesc": "莱山区", "parentid": 196}, "2700": {"ctype": "40", "cname": "芝罘", "id": 2700, "cdesc": "芝罘区", "parentid": 196}, "2701": {"ctype": "40", "cname": "福山", "id": 2701, "cdesc": "福山区", "parentid": 196}, "2702": {"ctype": "40", "cname": "牟平", "id": 2702, "cdesc": "牟平区", "parentid": 196}, "2703": {"ctype": "40", "cname": "龙口", "id": 2703, "cdesc": "龙口市", "parentid": 196}, "2704": {"ctype": "40", "cname": "莱阳", "id": 2704, "cdesc": "莱阳市", "parentid": 196}, "2705": {"ctype": "40", "cname": "莱州", "id": 2705, "cdesc": "莱州市", "parentid": 196}, "2706": {"ctype": "40", "cname": "蓬莱", "id": 2706, "cdesc": "蓬莱市", "parentid": 196}, "2707": {"ctype": "40", "cname": "招远", "id": 2707, "cdesc": "招远市", "parentid": 196}, "2708": {"ctype": "40", "cname": "栖霞", "id": 2708, "cdesc": "栖霞市", "parentid": 196}, "2709": {"ctype": "40", "cname": "海阳", "id": 2709, "cdesc": "海阳市", "parentid": 196}, "2710": {"ctype": "40", "cname": "思茅", "id": 2710, "cdesc": "思茅区", "parentid": 290}, "2711": {"ctype": "40", "cname": "宁洱哈尼族", "id": 2711, "cdesc": "宁洱哈尼族", "parentid": 290}, "2712": {"ctype": "40", "cname": "墨江哈尼族", "id": 2712, "cdesc": "墨江哈尼族", "parentid": 290}, "2713": {"ctype": "40", "cname": "景东彝族", "id": 2713, "cdesc": "景东彝族", "parentid": 290}, "2714": {"ctype": "40", "cname": "景谷傣族", "id": 2714, "cdesc": "景谷傣族", "parentid": 290}, "2715": {"ctype": "40", "cname": "镇沅彝族", "id": 2715, "cdesc": "镇沅彝族", "parentid": 290}, "2716": {"ctype": "40", "cname": "江城哈尼族", "id": 2716, "cdesc": "江城哈尼族", "parentid": 290}, "2717": {"ctype": "40", "cname": "孟连傣族", "id": 2717, "cdesc": "孟连傣族", "parentid": 290}, "2718": {"ctype": "40", "cname": "澜沧拉祜族", "id": 2718, "cdesc": "澜沧拉祜族", "parentid": 290}, "2719": {"ctype": "40", "cname": "西盟佤族", "id": 2719, "cdesc": "西盟佤族", "parentid": 290}, "2720": {"ctype": "40", "cname": "奎文", "id": 2720, "cdesc": "奎文区", "parentid": 197}, "2721": {"ctype": "40", "cname": "潍城", "id": 2721, "cdesc": "潍城区", "parentid": 197}, "2722": {"ctype": "40", "cname": "寒亭", "id": 2722, "cdesc": "寒亭区", "parentid": 197}, "2723": {"ctype": "40", "cname": "坊子", "id": 2723, "cdesc": "坊子区", "parentid": 197}, "2724": {"ctype": "40", "cname": "诸城", "id": 2724, "cdesc": "诸城市", "parentid": 197}, "2725": {"ctype": "40", "cname": "青州", "id": 2725, "cdesc": "青州市", "parentid": 197}, "2726": {"ctype": "40", "cname": "寿光", "id": 2726, "cdesc": "寿光市", "parentid": 197}, "2727": {"ctype": "40", "cname": "安丘", "id": 2727, "cdesc": "安丘市", "parentid": 197}, "2728": {"ctype": "40", "cname": "昌邑", "id": 2728, "cdesc": "昌邑市", "parentid": 197}, "2729": {"ctype": "40", "cname": "高密", "id": 2729, "cdesc": "高密市", "parentid": 197}, "2730": {"ctype": "40", "cname": "临朐", "id": 2730, "cdesc": "临朐县", "parentid": 197}, "2731": {"ctype": "40", "cname": "昌乐", "id": 2731, "cdesc": "昌乐县", "parentid": 197}, "2732": {"ctype": "40", "cname": "任城", "id": 2732, "cdesc": "任城区", "parentid": 198}, "2733": {"ctype": "40", "cname": "兖州", "id": 2733, "cdesc": "兖州区", "parentid": 198}, "2734": {"ctype": "40", "cname": "邹城", "id": 2734, "cdesc": "邹城市", "parentid": 198}, "2735": {"ctype": "40", "cname": "曲阜", "id": 2735, "cdesc": "曲阜市", "parentid": 198}, "2736": {"ctype": "40", "cname": "嘉祥", "id": 2736, "cdesc": "嘉祥县", "parentid": 198}, "2737": {"ctype": "40", "cname": "汶上", "id": 2737, "cdesc": "汶上县", "parentid": 198}, "2738": {"ctype": "40", "cname": "梁山", "id": 2738, "cdesc": "梁山县", "parentid": 198}, "2739": {"ctype": "40", "cname": "微山", "id": 2739, "cdesc": "微山县", "parentid": 198}, "2740": {"ctype": "40", "cname": "鱼台", "id": 2740, "cdesc": "鱼台县", "parentid": 198}, "2741": {"ctype": "40", "cname": "金乡", "id": 2741, "cdesc": "金乡县", "parentid": 198}, "2742": {"ctype": "40", "cname": "泗水", "id": 2742, "cdesc": "泗水县", "parentid": 198}, "2743": {"ctype": "40", "cname": "古城", "id": 2743, "cdesc": "古城区", "parentid": 289}, "2744": {"ctype": "40", "cname": "永胜", "id": 2744, "cdesc": "永胜县", "parentid": 289}, "2745": {"ctype": "40", "cname": "华坪", "id": 2745, "cdesc": "华坪县", "parentid": 289}, "2746": {"ctype": "40", "cname": "玉龙纳西族", "id": 2746, "cdesc": "玉龙纳西族", "parentid": 289}, "2747": {"ctype": "40", "cname": "宁蒗彝族", "id": 2747, "cdesc": "宁蒗彝族", "parentid": 289}, "2748": {"ctype": "40", "cname": "泰山", "id": 2748, "cdesc": "泰山区", "parentid": 199}, "2749": {"ctype": "40", "cname": "岱岳", "id": 2749, "cdesc": "岱岳区", "parentid": 199}, "2750": {"ctype": "40", "cname": "新泰", "id": 2750, "cdesc": "新泰市", "parentid": 199}, "2751": {"ctype": "40", "cname": "肥城", "id": 2751, "cdesc": "肥城市", "parentid": 199}, "2752": {"ctype": "40", "cname": "宁阳", "id": 2752, "cdesc": "宁阳县", "parentid": 199}, "2753": {"ctype": "40", "cname": "东平", "id": 2753, "cdesc": "东平县", "parentid": 199}, "2754": {"ctype": "40", "cname": "环翠", "id": 2754, "cdesc": "环翠区", "parentid": 200}, "2755": {"ctype": "40", "cname": "文登", "id": 2755, "cdesc": "文登区", "parentid": 200}, "2756": {"ctype": "40", "cname": "荣成", "id": 2756, "cdesc": "荣成市", "parentid": 200}, "2757": {"ctype": "40", "cname": "乳山", "id": 2757, "cdesc": "乳山市", "parentid": 200}, "2758": {"ctype": "40", "cname": "隆阳", "id": 2758, "cdesc": "隆阳区", "parentid": 287}, "2759": {"ctype": "40", "cname": "腾冲", "id": 2759, "cdesc": "腾冲市", "parentid": 287}, "2760": {"ctype": "40", "cname": "施甸", "id": 2760, "cdesc": "施甸县", "parentid": 287}, "2761": {"ctype": "40", "cname": "龙陵", "id": 2761, "cdesc": "龙陵县", "parentid": 287}, "2762": {"ctype": "40", "cname": "昌宁", "id": 2762, "cdesc": "昌宁县", "parentid": 287}, "2763": {"ctype": "40", "cname": "东港", "id": 2763, "cdesc": "东港区", "parentid": 201}, "2764": {"ctype": "40", "cname": "岚山", "id": 2764, "cdesc": "岚山区", "parentid": 201}, "2765": {"ctype": "40", "cname": "五莲", "id": 2765, "cdesc": "五莲县", "parentid": 201}, "2766": {"ctype": "40", "cname": "昭阳", "id": 2766, "cdesc": "昭阳区", "parentid": 288}, "2767": {"ctype": "40", "cname": "鲁甸", "id": 2767, "cdesc": "鲁甸县", "parentid": 288}, "2768": {"ctype": "40", "cname": "巧家", "id": 2768, "cdesc": "巧家县", "parentid": 288}, "2769": {"ctype": "40", "cname": "盐津", "id": 2769, "cdesc": "盐津县", "parentid": 288}, "2770": {"ctype": "40", "cname": "大关", "id": 2770, "cdesc": "大关县", "parentid": 288}, "2771": {"ctype": "40", "cname": "永善", "id": 2771, "cdesc": "永善县", "parentid": 288}, "2772": {"ctype": "40", "cname": "绥江", "id": 2772, "cdesc": "绥江县", "parentid": 288}, "2773": {"ctype": "40", "cname": "镇雄", "id": 2773, "cdesc": "镇雄县", "parentid": 288}, "2774": {"ctype": "40", "cname": "彝良", "id": 2774, "cdesc": "彝良县", "parentid": 288}, "2775": {"ctype": "40", "cname": "威信", "id": 2775, "cdesc": "威信县", "parentid": 288}, "2776": {"ctype": "40", "cname": "水富", "id": 2776, "cdesc": "水富县", "parentid": 288}, "2777": {"ctype": "40", "cname": "红塔", "id": 2777, "cdesc": "红塔区", "parentid": 286}, "2778": {"ctype": "40", "cname": "江川", "id": 2778, "cdesc": "江川区", "parentid": 286}, "2779": {"ctype": "40", "cname": "澄江", "id": 2779, "cdesc": "澄江县", "parentid": 286}, "2780": {"ctype": "40", "cname": "通海", "id": 2780, "cdesc": "通海县", "parentid": 286}, "2781": {"ctype": "40", "cname": "华宁", "id": 2781, "cdesc": "华宁县", "parentid": 286}, "2782": {"ctype": "40", "cname": "易门", "id": 2782, "cdesc": "易门县", "parentid": 286}, "2783": {"ctype": "40", "cname": "峨山彝族", "id": 2783, "cdesc": "峨山彝族", "parentid": 286}, "2784": {"ctype": "40", "cname": "新平彝族傣族", "id": 2784, "cdesc": "新平彝族", "parentid": 286}, "2785": {"ctype": "40", "cname": "元江哈尼族", "id": 2785, "cdesc": "元江哈尼族", "parentid": 286}, "2786": {"ctype": "40", "cname": "麒麟", "id": 2786, "cdesc": "麒麟区", "parentid": 285}, "2787": {"ctype": "40", "cname": "沾益", "id": 2787, "cdesc": "沾益区", "parentid": 285}, "2788": {"ctype": "40", "cname": "宣威", "id": 2788, "cdesc": "宣威市", "parentid": 285}, "2789": {"ctype": "40", "cname": "马龙", "id": 2789, "cdesc": "马龙县", "parentid": 285}, "2790": {"ctype": "40", "cname": "富源", "id": 2790, "cdesc": "富源县", "parentid": 285}, "2791": {"ctype": "40", "cname": "罗平", "id": 2791, "cdesc": "罗平县", "parentid": 285}, "2792": {"ctype": "40", "cname": "师宗", "id": 2792, "cdesc": "师宗县", "parentid": 285}, "2793": {"ctype": "40", "cname": "陆良", "id": 2793, "cdesc": "陆良县", "parentid": 285}, "2794": {"ctype": "40", "cname": "会泽", "id": 2794, "cdesc": "会泽县", "parentid": 285}, "2795": {"ctype": "40", "cname": "呈贡", "id": 2795, "cdesc": "呈贡区", "parentid": 284}, "2796": {"ctype": "40", "cname": "盘龙", "id": 2796, "cdesc": "盘龙区", "parentid": 284}, "2797": {"ctype": "40", "cname": "五华", "id": 2797, "cdesc": "五华区", "parentid": 284}, "2798": {"ctype": "40", "cname": "官渡", "id": 2798, "cdesc": "官渡区", "parentid": 284}, "2799": {"ctype": "40", "cname": "西山", "id": 2799, "cdesc": "西山区", "parentid": 284}, "2800": {"ctype": "40", "cname": "东川", "id": 2800, "cdesc": "东川区", "parentid": 284}, "2801": {"ctype": "40", "cname": "安宁", "id": 2801, "cdesc": "安宁市", "parentid": 284}, "2802": {"ctype": "40", "cname": "晋宁", "id": 2802, "cdesc": "晋宁县", "parentid": 284}, "2803": {"ctype": "40", "cname": "富民", "id": 2803, "cdesc": "富民县", "parentid": 284}, "2804": {"ctype": "40", "cname": "宜良", "id": 2804, "cdesc": "宜良县", "parentid": 284}, "2805": {"ctype": "40", "cname": "嵩明", "id": 2805, "cdesc": "嵩明县", "parentid": 284}, "2806": {"ctype": "40", "cname": "石林彝族", "id": 2806, "cdesc": "石林彝族", "parentid": 284}, "2807": {"ctype": "40", "cname": "禄劝彝族", "id": 2807, "cdesc": "禄劝彝族", "parentid": 284}, "2817": {"ctype": "40", "cname": "寻甸回族", "id": 2817, "cdesc": "寻甸回族", "parentid": 284}, "2818": {"ctype": "40", "cname": "滨城", "id": 2818, "cdesc": "滨城区", "parentid": 206}, "2819": {"ctype": "40", "cname": "沾化", "id": 2819, "cdesc": "沾化区", "parentid": 206}, "2820": {"ctype": "40", "cname": "惠民", "id": 2820, "cdesc": "惠民县", "parentid": 206}, "2821": {"ctype": "40", "cname": "阳信", "id": 2821, "cdesc": "阳信县", "parentid": 206}, "2822": {"ctype": "40", "cname": "无棣", "id": 2822, "cdesc": "无棣县", "parentid": 206}, "2823": {"ctype": "40", "cname": "博兴", "id": 2823, "cdesc": "博兴县", "parentid": 206}, "2824": {"ctype": "40", "cname": "都匀", "id": 2824, "cdesc": "都匀市", "parentid": 283}, "2825": {"ctype": "40", "cname": "福泉", "id": 2825, "cdesc": "福泉市", "parentid": 283}, "2826": {"ctype": "40", "cname": "荔波", "id": 2826, "cdesc": "荔波县", "parentid": 283}, "2827": {"ctype": "40", "cname": "贵定", "id": 2827, "cdesc": "贵定县", "parentid": 283}, "2828": {"ctype": "40", "cname": "瓮安", "id": 2828, "cdesc": "瓮安县", "parentid": 283}, "2829": {"ctype": "40", "cname": "独山", "id": 2829, "cdesc": "独山县", "parentid": 283}, "2830": {"ctype": "40", "cname": "平塘", "id": 2830, "cdesc": "平塘县", "parentid": 283}, "2831": {"ctype": "40", "cname": "罗甸", "id": 2831, "cdesc": "罗甸县", "parentid": 283}, "2832": {"ctype": "40", "cname": "长顺", "id": 2832, "cdesc": "长顺县", "parentid": 283}, "2833": {"ctype": "40", "cname": "龙里", "id": 2833, "cdesc": "龙里县", "parentid": 283}, "2834": {"ctype": "40", "cname": "惠水", "id": 2834, "cdesc": "惠水县", "parentid": 283}, "2835": {"ctype": "40", "cname": "三都水族", "id": 2835, "cdesc": "三都水族", "parentid": 283}, "2836": {"ctype": "40", "cname": "德城", "id": 2836, "cdesc": "德城区", "parentid": 204}, "2837": {"ctype": "40", "cname": "陵城", "id": 2837, "cdesc": "陵城区", "parentid": 204}, "2838": {"ctype": "40", "cname": "乐陵", "id": 2838, "cdesc": "乐陵市", "parentid": 204}, "2839": {"ctype": "40", "cname": "禹城", "id": 2839, "cdesc": "禹城市", "parentid": 204}, "2840": {"ctype": "40", "cname": "临邑", "id": 2840, "cdesc": "临邑县", "parentid": 204}, "2841": {"ctype": "40", "cname": "平原", "id": 2841, "cdesc": "平原县", "parentid": 204}, "2842": {"ctype": "40", "cname": "夏津", "id": 2842, "cdesc": "夏津县", "parentid": 204}, "2843": {"ctype": "40", "cname": "武城", "id": 2843, "cdesc": "武城县", "parentid": 204}, "2844": {"ctype": "40", "cname": "庆云", "id": 2844, "cdesc": "庆云县", "parentid": 204}, "2845": {"ctype": "40", "cname": "宁津", "id": 2845, "cdesc": "宁津县", "parentid": 204}, "2846": {"ctype": "40", "cname": "齐河", "id": 2846, "cdesc": "齐河县", "parentid": 204}, "2847": {"ctype": "40", "cname": "镇远", "id": 2847, "cdesc": "镇远县", "parentid": 282}, "2848": {"ctype": "40", "cname": "凯里", "id": 2848, "cdesc": "凯里市", "parentid": 282}, "2849": {"ctype": "40", "cname": "黄平", "id": 2849, "cdesc": "黄平县", "parentid": 282}, "2850": {"ctype": "40", "cname": "施秉", "id": 2850, "cdesc": "施秉县", "parentid": 282}, "2851": {"ctype": "40", "cname": "三穗", "id": 2851, "cdesc": "三穗县", "parentid": 282}, "2852": {"ctype": "40", "cname": "岑巩", "id": 2852, "cdesc": "岑巩县", "parentid": 282}, "2853": {"ctype": "40", "cname": "天柱", "id": 2853, "cdesc": "天柱县", "parentid": 282}, "2854": {"ctype": "40", "cname": "锦屏", "id": 2854, "cdesc": "锦屏县", "parentid": 282}, "2855": {"ctype": "40", "cname": "剑河", "id": 2855, "cdesc": "剑河县", "parentid": 282}, "2856": {"ctype": "40", "cname": "台江", "id": 2856, "cdesc": "台江县", "parentid": 282}, "2857": {"ctype": "40", "cname": "黎平", "id": 2857, "cdesc": "黎平县", "parentid": 282}, "2858": {"ctype": "40", "cname": "榕江", "id": 2858, "cdesc": "榕江县", "parentid": 282}, "2859": {"ctype": "40", "cname": "从江", "id": 2859, "cdesc": "从江县", "parentid": 282}, "2860": {"ctype": "40", "cname": "雷山", "id": 2860, "cdesc": "雷山县", "parentid": 282}, "2861": {"ctype": "40", "cname": "麻江", "id": 2861, "cdesc": "麻江县", "parentid": 282}, "2862": {"ctype": "40", "cname": "丹寨", "id": 2862, "cdesc": "丹寨县", "parentid": 282}, "2863": {"ctype": "40", "cname": "东昌府", "id": 2863, "cdesc": "东昌府区", "parentid": 205}, "2864": {"ctype": "40", "cname": "临清", "id": 2864, "cdesc": "临清市", "parentid": 205}, "2865": {"ctype": "40", "cname": "茌平", "id": 2865, "cdesc": "茌平县", "parentid": 205}, "2866": {"ctype": "40", "cname": "东阿", "id": 2866, "cdesc": "东阿县", "parentid": 205}, "2867": {"ctype": "40", "cname": "高唐", "id": 2867, "cdesc": "高唐县", "parentid": 205}, "2868": {"ctype": "40", "cname": "阳谷", "id": 2868, "cdesc": "阳谷县", "parentid": 205}, "2869": {"ctype": "40", "cname": "冠县", "id": 2869, "cdesc": "冠县", "parentid": 205}, "2870": {"ctype": "40", "cname": "莘县", "id": 2870, "cdesc": "莘县", "parentid": 205}, "2871": {"ctype": "40", "cname": "聊城开发", "id": 2871, "cdesc": "聊城开发区", "parentid": 205}, "2872": {"ctype": "40", "cname": "碧江", "id": 2872, "cdesc": "碧江区", "parentid": 279}, "2873": {"ctype": "40", "cname": "万山", "id": 2873, "cdesc": "万山区", "parentid": 279}, "2874": {"ctype": "40", "cname": "江口", "id": 2874, "cdesc": "江口县", "parentid": 279}, "2875": {"ctype": "40", "cname": "玉屏", "id": 2875, "cdesc": "玉屏县", "parentid": 279}, "2876": {"ctype": "40", "cname": "石阡", "id": 2876, "cdesc": "石阡县", "parentid": 279}, "2877": {"ctype": "40", "cname": "思南", "id": 2877, "cdesc": "思南县", "parentid": 279}, "2878": {"ctype": "40", "cname": "印江", "id": 2878, "cdesc": "印江县", "parentid": 279}, "2879": {"ctype": "40", "cname": "德江", "id": 2879, "cdesc": "德江县", "parentid": 279}, "2880": {"ctype": "40", "cname": "沿河", "id": 2880, "cdesc": "沿河县", "parentid": 279}, "2881": {"ctype": "40", "cname": "松桃苗族", "id": 2881, "cdesc": "松桃苗族", "parentid": 279}, "2882": {"ctype": "40", "cname": "兰山", "id": 2882, "cdesc": "兰山区", "parentid": 203}, "2883": {"ctype": "40", "cname": "河东", "id": 2883, "cdesc": "河东区", "parentid": 203}, "2884": {"ctype": "40", "cname": "罗庄", "id": 2884, "cdesc": "罗庄区", "parentid": 203}, "2885": {"ctype": "40", "cname": "兰陵", "id": 2885, "cdesc": "兰陵县", "parentid": 203}, "2886": {"ctype": "40", "cname": "郯城", "id": 2886, "cdesc": "郯城县", "parentid": 203}, "2887": {"ctype": "40", "cname": "莒南", "id": 2887, "cdesc": "莒南县", "parentid": 203}, "2888": {"ctype": "40", "cname": "沂水", "id": 2888, "cdesc": "沂水县", "parentid": 203}, "2889": {"ctype": "40", "cname": "蒙阴", "id": 2889, "cdesc": "蒙阴县", "parentid": 203}, "2890": {"ctype": "40", "cname": "平邑", "id": 2890, "cdesc": "平邑县", "parentid": 203}, "2891": {"ctype": "40", "cname": "沂南", "id": 2891, "cdesc": "沂南县", "parentid": 203}, "2892": {"ctype": "40", "cname": "临沭", "id": 2892, "cdesc": "临沭县", "parentid": 203}, "2893": {"ctype": "40", "cname": "费县", "id": 2893, "cdesc": "费县", "parentid": 203}, "2894": {"ctype": "40", "cname": "兴义", "id": 2894, "cdesc": "兴义市", "parentid": 280}, "2895": {"ctype": "40", "cname": "兴仁", "id": 2895, "cdesc": "兴仁县", "parentid": 280}, "2896": {"ctype": "40", "cname": "普安", "id": 2896, "cdesc": "普安县", "parentid": 280}, "2897": {"ctype": "40", "cname": "晴隆", "id": 2897, "cdesc": "晴隆县", "parentid": 280}, "2898": {"ctype": "40", "cname": "贞丰", "id": 2898, "cdesc": "贞丰县", "parentid": 280}, "2899": {"ctype": "40", "cname": "望谟", "id": 2899, "cdesc": "望谟县", "parentid": 280}, "2900": {"ctype": "40", "cname": "册亨", "id": 2900, "cdesc": "册亨县", "parentid": 280}, "2901": {"ctype": "40", "cname": "安龙", "id": 2901, "cdesc": "安龙县", "parentid": 280}, "2902": {"ctype": "40", "cname": "牡丹", "id": 2902, "cdesc": "牡丹区", "parentid": 207}, "2903": {"ctype": "40", "cname": "定陶", "id": 2903, "cdesc": "定陶区", "parentid": 207}, "2904": {"ctype": "40", "cname": "曹县", "id": 2904, "cdesc": "曹县", "parentid": 207}, "2905": {"ctype": "40", "cname": "单县", "id": 2905, "cdesc": "单县", "parentid": 207}, "2906": {"ctype": "40", "cname": "巨野", "id": 2906, "cdesc": "巨野县", "parentid": 207}, "2907": {"ctype": "40", "cname": "成武", "id": 2907, "cdesc": "成武县", "parentid": 207}, "2908": {"ctype": "40", "cname": "郓城", "id": 2908, "cdesc": "郓城县", "parentid": 207}, "2909": {"ctype": "40", "cname": "鄄城", "id": 2909, "cdesc": "鄄城县", "parentid": 207}, "2910": {"ctype": "40", "cname": "东明", "id": 2910, "cdesc": "东明县", "parentid": 207}, "2911": {"ctype": "40", "cname": "七星关", "id": 2911, "cdesc": "七星关区", "parentid": 281}, "2912": {"ctype": "40", "cname": "大方", "id": 2912, "cdesc": "大方县", "parentid": 281}, "2913": {"ctype": "40", "cname": "黔西", "id": 2913, "cdesc": "黔西县", "parentid": 281}, "2914": {"ctype": "40", "cname": "金沙", "id": 2914, "cdesc": "金沙县", "parentid": 281}, "2915": {"ctype": "40", "cname": "织金", "id": 2915, "cdesc": "织金县", "parentid": 281}, "2916": {"ctype": "40", "cname": "纳雍", "id": 2916, "cdesc": "纳雍县", "parentid": 281}, "2917": {"ctype": "40", "cname": "威宁", "id": 2917, "cdesc": "威宁县", "parentid": 281}, "2918": {"ctype": "40", "cname": "赫章", "id": 2918, "cdesc": "赫章县", "parentid": 281}, "2919": {"ctype": "40", "cname": "莱城", "id": 2919, "cdesc": "莱城区", "parentid": 202}, "2920": {"ctype": "40", "cname": "镇宁", "id": 2920, "cdesc": "镇宁县", "parentid": 278}, "2921": {"ctype": "40", "cname": "西秀", "id": 2921, "cdesc": "西秀区", "parentid": 278}, "2922": {"ctype": "40", "cname": "平坝", "id": 2922, "cdesc": "平坝区", "parentid": 278}, "2923": {"ctype": "40", "cname": "普定", "id": 2923, "cdesc": "普定县", "parentid": 278}, "2924": {"ctype": "40", "cname": "关岭", "id": 2924, "cdesc": "关岭县", "parentid": 278}, "2925": {"ctype": "40", "cname": "紫云", "id": 2925, "cdesc": "紫云县", "parentid": 278}, "2926": {"ctype": "40", "cname": "红花岗", "id": 2926, "cdesc": "红花岗区", "parentid": 277}, "2927": {"ctype": "40", "cname": "汇川", "id": 2927, "cdesc": "汇川区", "parentid": 277}, "2928": {"ctype": "40", "cname": "播州", "id": 2928, "cdesc": "播州区", "parentid": 277}, "2929": {"ctype": "40", "cname": "桐梓", "id": 2929, "cdesc": "桐梓县", "parentid": 277}, "2930": {"ctype": "40", "cname": "绥阳", "id": 2930, "cdesc": "绥阳县", "parentid": 277}, "2931": {"ctype": "40", "cname": "正安", "id": 2931, "cdesc": "正安县", "parentid": 277}, "2932": {"ctype": "40", "cname": "道真", "id": 2932, "cdesc": "道真县", "parentid": 277}, "2933": {"ctype": "40", "cname": "务川", "id": 2933, "cdesc": "务川县", "parentid": 277}, "2934": {"ctype": "40", "cname": "凤冈", "id": 2934, "cdesc": "凤冈县", "parentid": 277}, "2935": {"ctype": "40", "cname": "湄潭", "id": 2935, "cdesc": "湄潭县", "parentid": 277}, "2936": {"ctype": "40", "cname": "余庆", "id": 2936, "cdesc": "余庆县", "parentid": 277}, "2937": {"ctype": "40", "cname": "习水", "id": 2937, "cdesc": "习水县", "parentid": 277}, "2938": {"ctype": "40", "cname": "赤水", "id": 2938, "cdesc": "赤水市", "parentid": 277}, "2939": {"ctype": "40", "cname": "仁怀", "id": 2939, "cdesc": "仁怀市", "parentid": 277}, "2940": {"ctype": "40", "cname": "钟山", "id": 2940, "cdesc": "钟山区", "parentid": 276}, "2941": {"ctype": "40", "cname": "六枝特", "id": 2941, "cdesc": "六枝特区", "parentid": 276}, "2942": {"ctype": "40", "cname": "水城", "id": 2942, "cdesc": "水城县", "parentid": 276}, "2943": {"ctype": "40", "cname": "盘县", "id": 2943, "cdesc": "盘县", "parentid": 276}, "2944": {"ctype": "40", "cname": "中原", "id": 2944, "cdesc": "中原区", "parentid": 208}, "2945": {"ctype": "40", "cname": "二七", "id": 2945, "cdesc": "二七区", "parentid": 208}, "2946": {"ctype": "40", "cname": "金水", "id": 2946, "cdesc": "金水区", "parentid": 208}, "2947": {"ctype": "40", "cname": "惠济", "id": 2947, "cdesc": "惠济区", "parentid": 208}, "2948": {"ctype": "40", "cname": "管城", "id": 2948, "cdesc": "管城区", "parentid": 208}, "2949": {"ctype": "40", "cname": "上街", "id": 2949, "cdesc": "上街区", "parentid": 208}, "2950": {"ctype": "40", "cname": "新郑", "id": 2950, "cdesc": "新郑市", "parentid": 208}, "2951": {"ctype": "40", "cname": "巩义", "id": 2951, "cdesc": "巩义市", "parentid": 208}, "2952": {"ctype": "40", "cname": "登封", "id": 2952, "cdesc": "登封市", "parentid": 208}, "2953": {"ctype": "40", "cname": "荥阳", "id": 2953, "cdesc": "荥阳市", "parentid": 208}, "2954": {"ctype": "40", "cname": "新密", "id": 2954, "cdesc": "新密市", "parentid": 208}, "2955": {"ctype": "40", "cname": "中牟", "id": 2955, "cdesc": "中牟县", "parentid": 208}, "2956": {"ctype": "40", "cname": "南明", "id": 2956, "cdesc": "南明区", "parentid": 275}, "2957": {"ctype": "40", "cname": "云岩", "id": 2957, "cdesc": "云岩区", "parentid": 275}, "2958": {"ctype": "40", "cname": "花溪", "id": 2958, "cdesc": "花溪区", "parentid": 275}, "2959": {"ctype": "40", "cname": "乌当", "id": 2959, "cdesc": "乌当区", "parentid": 275}, "2960": {"ctype": "40", "cname": "白云", "id": 2960, "cdesc": "白云区", "parentid": 275}, "2961": {"ctype": "40", "cname": "观山湖", "id": 2961, "cdesc": "观山湖区", "parentid": 275}, "2962": {"ctype": "40", "cname": "开阳", "id": 2962, "cdesc": "开阳县", "parentid": 275}, "2963": {"ctype": "40", "cname": "息烽", "id": 2963, "cdesc": "息烽县", "parentid": 275}, "2964": {"ctype": "40", "cname": "修文", "id": 2964, "cdesc": "修文县", "parentid": 275}, "2965": {"ctype": "40", "cname": "清镇", "id": 2965, "cdesc": "清镇市", "parentid": 275}, "2966": {"ctype": "40", "cname": "龙亭", "id": 2966, "cdesc": "龙亭区", "parentid": 209}, "2967": {"ctype": "40", "cname": "鼓楼", "id": 2967, "cdesc": "鼓楼区", "parentid": 209}, "2968": {"ctype": "40", "cname": "禹王台", "id": 2968, "cdesc": "禹王台区", "parentid": 209}, "2969": {"ctype": "40", "cname": "顺河", "id": 2969, "cdesc": "顺河区", "parentid": 209}, "2970": {"ctype": "40", "cname": "祥符", "id": 2970, "cdesc": "祥符区", "parentid": 209}, "2971": {"ctype": "40", "cname": "通许", "id": 2971, "cdesc": "通许县", "parentid": 209}, "2972": {"ctype": "40", "cname": "杞县", "id": 2972, "cdesc": "杞县", "parentid": 209}, "2973": {"ctype": "40", "cname": "兰考", "id": 2973, "cdesc": "兰考县", "parentid": 209}, "2974": {"ctype": "40", "cname": "尉氏", "id": 2974, "cdesc": "尉氏县", "parentid": 209}, "2975": {"ctype": "40", "cname": "涧西", "id": 2975, "cdesc": "涧西区", "parentid": 210}, "2976": {"ctype": "40", "cname": "西工", "id": 2976, "cdesc": "西工区", "parentid": 210}, "2977": {"ctype": "40", "cname": "老城", "id": 2977, "cdesc": "老城区", "parentid": 210}, "2978": {"ctype": "40", "cname": "瀍河", "id": 2978, "cdesc": "瀍河区", "parentid": 210}, "2979": {"ctype": "40", "cname": "洛龙", "id": 2979, "cdesc": "洛龙区", "parentid": 210}, "2980": {"ctype": "40", "cname": "吉利", "id": 2980, "cdesc": "吉利区", "parentid": 210}, "2981": {"ctype": "40", "cname": "偃师", "id": 2981, "cdesc": "偃师市", "parentid": 210}, "2982": {"ctype": "40", "cname": "宜阳", "id": 2982, "cdesc": "宜阳县", "parentid": 210}, "2983": {"ctype": "40", "cname": "孟津", "id": 2983, "cdesc": "孟津县", "parentid": 210}, "2984": {"ctype": "40", "cname": "新安", "id": 2984, "cdesc": "新安县", "parentid": 210}, "2985": {"ctype": "40", "cname": "洛宁", "id": 2985, "cdesc": "洛宁县", "parentid": 210}, "2986": {"ctype": "40", "cname": "栾川", "id": 2986, "cdesc": "栾川县", "parentid": 210}, "2987": {"ctype": "40", "cname": "伊川", "id": 2987, "cdesc": "伊川县", "parentid": 210}, "2988": {"ctype": "40", "cname": "汝阳", "id": 2988, "cdesc": "汝阳县", "parentid": 210}, "2989": {"ctype": "40", "cname": "嵩县", "id": 2989, "cdesc": "嵩县", "parentid": 210}, "2990": {"ctype": "40", "cname": "东坡", "id": 2990, "cdesc": "东坡区", "parentid": 265}, "2991": {"ctype": "40", "cname": "彭山", "id": 2991, "cdesc": "彭山区", "parentid": 265}, "2992": {"ctype": "40", "cname": "仁寿", "id": 2992, "cdesc": "仁寿县", "parentid": 265}, "2993": {"ctype": "40", "cname": "丹棱", "id": 2993, "cdesc": "丹棱县", "parentid": 265}, "2994": {"ctype": "40", "cname": "青神", "id": 2994, "cdesc": "青神县", "parentid": 265}, "2995": {"ctype": "40", "cname": "洪雅", "id": 2995, "cdesc": "洪雅县", "parentid": 265}, "2996": {"ctype": "40", "cname": "新华", "id": 2996, "cdesc": "新华区", "parentid": 211}, "2997": {"ctype": "40", "cname": "卫东", "id": 2997, "cdesc": "卫东区", "parentid": 211}, "2998": {"ctype": "40", "cname": "石龙", "id": 2998, "cdesc": "石龙区", "parentid": 211}, "2999": {"ctype": "40", "cname": "湛河", "id": 2999, "cdesc": "湛河区", "parentid": 211}, "3000": {"ctype": "40", "cname": "舞钢", "id": 3000, "cdesc": "舞钢市", "parentid": 211}, "3001": {"ctype": "40", "cname": "汝州", "id": 3001, "cdesc": "汝州市", "parentid": 211}, "3002": {"ctype": "40", "cname": "鲁山", "id": 3002, "cdesc": "鲁山县", "parentid": 211}, "3003": {"ctype": "40", "cname": "宝丰", "id": 3003, "cdesc": "宝丰县", "parentid": 211}, "3004": {"ctype": "40", "cname": "叶县", "id": 3004, "cdesc": "叶县", "parentid": 211}, "3005": {"ctype": "40", "cname": "郏县", "id": 3005, "cdesc": "郏县", "parentid": 211}, "3006": {"ctype": "40", "cname": "文峰", "id": 3006, "cdesc": "文峰区", "parentid": 212}, "3007": {"ctype": "40", "cname": "北关", "id": 3007, "cdesc": "北关区", "parentid": 212}, "3008": {"ctype": "40", "cname": "殷都", "id": 3008, "cdesc": "殷都区", "parentid": 212}, "3009": {"ctype": "40", "cname": "龙安", "id": 3009, "cdesc": "龙安区", "parentid": 212}, "3010": {"ctype": "40", "cname": "林州", "id": 3010, "cdesc": "林州市", "parentid": 212}, "3011": {"ctype": "40", "cname": "安阳", "id": 3011, "cdesc": "安阳县", "parentid": 212}, "3012": {"ctype": "40", "cname": "汤阴", "id": 3012, "cdesc": "汤阴县", "parentid": 212}, "3013": {"ctype": "40", "cname": "内黄", "id": 3013, "cdesc": "内黄县", "parentid": 212}, "3014": {"ctype": "40", "cname": "滑县", "id": 3014, "cdesc": "滑县", "parentid": 212}, "3015": {"ctype": "40", "cname": "巴州", "id": 3015, "cdesc": "巴州区", "parentid": 270}, "3016": {"ctype": "40", "cname": "恩阳", "id": 3016, "cdesc": "恩阳区", "parentid": 270}, "3017": {"ctype": "40", "cname": "平昌", "id": 3017, "cdesc": "平昌县", "parentid": 270}, "3018": {"ctype": "40", "cname": "通江", "id": 3018, "cdesc": "通江县", "parentid": 270}, "3019": {"ctype": "40", "cname": "南江", "id": 3019, "cdesc": "南江县", "parentid": 270}, "3020": {"ctype": "40", "cname": "鹤山", "id": 3020, "cdesc": "鹤山区", "parentid": 213}, "3021": {"ctype": "40", "cname": "山城", "id": 3021, "cdesc": "山城区", "parentid": 213}, "3022": {"ctype": "40", "cname": "淇滨", "id": 3022, "cdesc": "淇滨区", "parentid": 213}, "3023": {"ctype": "40", "cname": "浚县", "id": 3023, "cdesc": "浚县", "parentid": 213}, "3024": {"ctype": "40", "cname": "淇县", "id": 3024, "cdesc": "淇县", "parentid": 213}, "3025": {"ctype": "40", "cname": "广安", "id": 3025, "cdesc": "广安区", "parentid": 267}, "3026": {"ctype": "40", "cname": "前锋", "id": 3026, "cdesc": "前锋区", "parentid": 267}, "3027": {"ctype": "40", "cname": "邻水", "id": 3027, "cdesc": "邻水县", "parentid": 267}, "3028": {"ctype": "40", "cname": "武胜", "id": 3028, "cdesc": "武胜县", "parentid": 267}, "3029": {"ctype": "40", "cname": "岳池", "id": 3029, "cdesc": "岳池县", "parentid": 267}, "3030": {"ctype": "40", "cname": "华蓥", "id": 3030, "cdesc": "华蓥市", "parentid": 267}, "3031": {"ctype": "40", "cname": "红旗", "id": 3031, "cdesc": "红旗区", "parentid": 214}, "3032": {"ctype": "40", "cname": "卫滨", "id": 3032, "cdesc": "卫滨区", "parentid": 214}, "3033": {"ctype": "40", "cname": "牧野", "id": 3033, "cdesc": "牧野区", "parentid": 214}, "3034": {"ctype": "40", "cname": "凤泉", "id": 3034, "cdesc": "凤泉区", "parentid": 214}, "3035": {"ctype": "40", "cname": "卫辉", "id": 3035, "cdesc": "卫辉市", "parentid": 214}, "3036": {"ctype": "40", "cname": "辉县", "id": 3036, "cdesc": "辉县市", "parentid": 214}, "3037": {"ctype": "40", "cname": "新乡", "id": 3037, "cdesc": "新乡县", "parentid": 214}, "3038": {"ctype": "40", "cname": "获嘉", "id": 3038, "cdesc": "获嘉县", "parentid": 214}, "3039": {"ctype": "40", "cname": "原阳", "id": 3039, "cdesc": "原阳县", "parentid": 214}, "3040": {"ctype": "40", "cname": "延津", "id": 3040, "cdesc": "延津县", "parentid": 214}, "3041": {"ctype": "40", "cname": "封丘", "id": 3041, "cdesc": "封丘县", "parentid": 214}, "3042": {"ctype": "40", "cname": "长垣", "id": 3042, "cdesc": "长垣县", "parentid": 214}, "3043": {"ctype": "40", "cname": "西昌", "id": 3043, "cdesc": "西昌市", "parentid": 274}, "3044": {"ctype": "40", "cname": "德昌", "id": 3044, "cdesc": "德昌县", "parentid": 274}, "3045": {"ctype": "40", "cname": "会理", "id": 3045, "cdesc": "会理县", "parentid": 274}, "3046": {"ctype": "40", "cname": "会东", "id": 3046, "cdesc": "会东县", "parentid": 274}, "3047": {"ctype": "40", "cname": "宁南", "id": 3047, "cdesc": "宁南县", "parentid": 274}, "3048": {"ctype": "40", "cname": "普格", "id": 3048, "cdesc": "普格县", "parentid": 274}, "3049": {"ctype": "40", "cname": "布拖", "id": 3049, "cdesc": "布拖县", "parentid": 274}, "3050": {"ctype": "40", "cname": "昭觉", "id": 3050, "cdesc": "昭觉县", "parentid": 274}, "3051": {"ctype": "40", "cname": "金阳", "id": 3051, "cdesc": "金阳县", "parentid": 274}, "3052": {"ctype": "40", "cname": "雷波", "id": 3052, "cdesc": "雷波县", "parentid": 274}, "3053": {"ctype": "40", "cname": "美姑", "id": 3053, "cdesc": "美姑县", "parentid": 274}, "3054": {"ctype": "40", "cname": "甘洛", "id": 3054, "cdesc": "甘洛县", "parentid": 274}, "3055": {"ctype": "40", "cname": "越西", "id": 3055, "cdesc": "越西县", "parentid": 274}, "3056": {"ctype": "40", "cname": "喜德", "id": 3056, "cdesc": "喜德县", "parentid": 274}, "3057": {"ctype": "40", "cname": "冕宁", "id": 3057, "cdesc": "冕宁县", "parentid": 274}, "3058": {"ctype": "40", "cname": "盐源", "id": 3058, "cdesc": "盐源县", "parentid": 274}, "3059": {"ctype": "40", "cname": "木里藏族", "id": 3059, "cdesc": "木里藏族", "parentid": 274}, "3060": {"ctype": "40", "cname": "山阳", "id": 3060, "cdesc": "山阳区", "parentid": 215}, "3061": {"ctype": "40", "cname": "中站", "id": 3061, "cdesc": "中站区", "parentid": 215}, "3062": {"ctype": "40", "cname": "解放", "id": 3062, "cdesc": "解放区", "parentid": 215}, "3063": {"ctype": "40", "cname": "马村", "id": 3063, "cdesc": "马村区", "parentid": 215}, "3064": {"ctype": "40", "cname": "沁阳", "id": 3064, "cdesc": "沁阳市", "parentid": 215}, "3065": {"ctype": "40", "cname": "孟州", "id": 3065, "cdesc": "孟州市", "parentid": 215}, "3066": {"ctype": "40", "cname": "修武", "id": 3066, "cdesc": "修武县", "parentid": 215}, "3067": {"ctype": "40", "cname": "博爱", "id": 3067, "cdesc": "博爱县", "parentid": 215}, "3068": {"ctype": "40", "cname": "武陟", "id": 3068, "cdesc": "武陟县", "parentid": 215}, "3069": {"ctype": "40", "cname": "温县", "id": 3069, "cdesc": "温县", "parentid": 215}, "3070": {"ctype": "40", "cname": "康定", "id": 3070, "cdesc": "康定市", "parentid": 273}, "3071": {"ctype": "40", "cname": "泸定", "id": 3071, "cdesc": "泸定县", "parentid": 273}, "3072": {"ctype": "40", "cname": "丹巴", "id": 3072, "cdesc": "丹巴县", "parentid": 273}, "3073": {"ctype": "40", "cname": "九龙", "id": 3073, "cdesc": "九龙县", "parentid": 273}, "3074": {"ctype": "40", "cname": "雅江", "id": 3074, "cdesc": "雅江县", "parentid": 273}, "3075": {"ctype": "40", "cname": "道孚", "id": 3075, "cdesc": "道孚县", "parentid": 273}, "3076": {"ctype": "40", "cname": "炉霍", "id": 3076, "cdesc": "炉霍县", "parentid": 273}, "3077": {"ctype": "40", "cname": "甘孜", "id": 3077, "cdesc": "甘孜县", "parentid": 273}, "3078": {"ctype": "40", "cname": "新龙", "id": 3078, "cdesc": "新龙县", "parentid": 273}, "3079": {"ctype": "40", "cname": "德格", "id": 3079, "cdesc": "德格县", "parentid": 273}, "3080": {"ctype": "40", "cname": "白玉", "id": 3080, "cdesc": "白玉县", "parentid": 273}, "3081": {"ctype": "40", "cname": "石渠", "id": 3081, "cdesc": "石渠县", "parentid": 273}, "3082": {"ctype": "40", "cname": "色达", "id": 3082, "cdesc": "色达县", "parentid": 273}, "3083": {"ctype": "40", "cname": "理塘", "id": 3083, "cdesc": "理塘县", "parentid": 273}, "3084": {"ctype": "40", "cname": "巴塘", "id": 3084, "cdesc": "巴塘县", "parentid": 273}, "3085": {"ctype": "40", "cname": "乡城", "id": 3085, "cdesc": "乡城县", "parentid": 273}, "3086": {"ctype": "40", "cname": "稻城", "id": 3086, "cdesc": "稻城县", "parentid": 273}, "3087": {"ctype": "40", "cname": "得荣", "id": 3087, "cdesc": "得荣县", "parentid": 273}, "3088": {"ctype": "40", "cname": "华龙", "id": 3088, "cdesc": "华龙区", "parentid": 216}, "3089": {"ctype": "40", "cname": "濮阳", "id": 3089, "cdesc": "濮阳县", "parentid": 216}, "3090": {"ctype": "40", "cname": "清丰", "id": 3090, "cdesc": "清丰县", "parentid": 216}, "3091": {"ctype": "40", "cname": "南乐", "id": 3091, "cdesc": "南乐县", "parentid": 216}, "3092": {"ctype": "40", "cname": "台前", "id": 3092, "cdesc": "台前县", "parentid": 216}, "3093": {"ctype": "40", "cname": "范县", "id": 3093, "cdesc": "范县", "parentid": 216}, "3094": {"ctype": "40", "cname": "马尔康", "id": 3094, "cdesc": "马尔康市", "parentid": 272}, "3095": {"ctype": "40", "cname": "金川", "id": 3095, "cdesc": "金川县", "parentid": 272}, "3096": {"ctype": "40", "cname": "小金", "id": 3096, "cdesc": "小金县", "parentid": 272}, "3097": {"ctype": "40", "cname": "阿坝", "id": 3097, "cdesc": "阿坝县", "parentid": 272}, "3098": {"ctype": "40", "cname": "若尔盖", "id": 3098, "cdesc": "若尔盖县", "parentid": 272}, "3099": {"ctype": "40", "cname": "红原", "id": 3099, "cdesc": "红原县", "parentid": 272}, "3100": {"ctype": "40", "cname": "壤塘", "id": 3100, "cdesc": "壤塘县", "parentid": 272}, "3101": {"ctype": "40", "cname": "汶川", "id": 3101, "cdesc": "汶川县", "parentid": 272}, "3102": {"ctype": "40", "cname": "理县", "id": 3102, "cdesc": "理县", "parentid": 272}, "3103": {"ctype": "40", "cname": "茂县", "id": 3103, "cdesc": "茂县", "parentid": 272}, "3104": {"ctype": "40", "cname": "松潘", "id": 3104, "cdesc": "松潘县", "parentid": 272}, "3105": {"ctype": "40", "cname": "九寨沟", "id": 3105, "cdesc": "九寨沟县", "parentid": 272}, "3106": {"ctype": "40", "cname": "黑水", "id": 3106, "cdesc": "黑水县", "parentid": 272}, "3107": {"ctype": "40", "cname": "魏都", "id": 3107, "cdesc": "魏都区", "parentid": 217}, "3108": {"ctype": "40", "cname": "禹州", "id": 3108, "cdesc": "禹州市", "parentid": 217}, "3109": {"ctype": "40", "cname": "长葛", "id": 3109, "cdesc": "长葛市", "parentid": 217}, "3110": {"ctype": "40", "cname": "许昌", "id": 3110, "cdesc": "许昌县", "parentid": 217}, "3111": {"ctype": "40", "cname": "鄢陵", "id": 3111, "cdesc": "鄢陵县", "parentid": 217}, "3112": {"ctype": "40", "cname": "襄城", "id": 3112, "cdesc": "襄城县", "parentid": 217}, "3113": {"ctype": "40", "cname": "郾城", "id": 3113, "cdesc": "郾城区", "parentid": 218}, "3114": {"ctype": "40", "cname": "源汇", "id": 3114, "cdesc": "源汇区", "parentid": 218}, "3115": {"ctype": "40", "cname": "召陵", "id": 3115, "cdesc": "召陵区", "parentid": 218}, "3116": {"ctype": "40", "cname": "舞阳", "id": 3116, "cdesc": "舞阳县", "parentid": 218}, "3117": {"ctype": "40", "cname": "临颍", "id": 3117, "cdesc": "临颍县", "parentid": 218}, "3118": {"ctype": "40", "cname": "雨城", "id": 3118, "cdesc": "雨城区", "parentid": 269}, "3119": {"ctype": "40", "cname": "名山", "id": 3119, "cdesc": "名山区", "parentid": 269}, "3120": {"ctype": "40", "cname": "荥经", "id": 3120, "cdesc": "荥经县", "parentid": 269}, "3121": {"ctype": "40", "cname": "汉源", "id": 3121, "cdesc": "汉源县", "parentid": 269}, "3122": {"ctype": "40", "cname": "石棉", "id": 3122, "cdesc": "石棉县", "parentid": 269}, "3123": {"ctype": "40", "cname": "天全", "id": 3123, "cdesc": "天全县", "parentid": 269}, "3124": {"ctype": "40", "cname": "芦山", "id": 3124, "cdesc": "芦山县", "parentid": 269}, "3125": {"ctype": "40", "cname": "宝兴", "id": 3125, "cdesc": "宝兴县", "parentid": 269}, "3126": {"ctype": "40", "cname": "通川", "id": 3126, "cdesc": "通川区", "parentid": 268}, "3127": {"ctype": "40", "cname": "达川", "id": 3127, "cdesc": "达川区", "parentid": 268}, "3128": {"ctype": "40", "cname": "宣汉", "id": 3128, "cdesc": "宣汉县", "parentid": 268}, "3129": {"ctype": "40", "cname": "开江", "id": 3129, "cdesc": "开江县", "parentid": 268}, "3130": {"ctype": "40", "cname": "大竹", "id": 3130, "cdesc": "大竹县", "parentid": 268}, "3131": {"ctype": "40", "cname": "渠县", "id": 3131, "cdesc": "渠县", "parentid": 268}, "3132": {"ctype": "40", "cname": "万源", "id": 3132, "cdesc": "万源市", "parentid": 268}, "3133": {"ctype": "40", "cname": "湖滨", "id": 3133, "cdesc": "湖滨区", "parentid": 219}, "3134": {"ctype": "40", "cname": "陕州", "id": 3134, "cdesc": "陕州区", "parentid": 219}, "3135": {"ctype": "40", "cname": "灵宝", "id": 3135, "cdesc": "灵宝市", "parentid": 219}, "3136": {"ctype": "40", "cname": "义马", "id": 3136, "cdesc": "义马市", "parentid": 219}, "3137": {"ctype": "40", "cname": "渑池", "id": 3137, "cdesc": "渑池县", "parentid": 219}, "3138": {"ctype": "40", "cname": "卢氏", "id": 3138, "cdesc": "卢氏县", "parentid": 219}, "3139": {"ctype": "40", "cname": "顺庆", "id": 3139, "cdesc": "顺庆区", "parentid": 264}, "3140": {"ctype": "40", "cname": "高坪", "id": 3140, "cdesc": "高坪区", "parentid": 264}, "3141": {"ctype": "40", "cname": "嘉陵", "id": 3141, "cdesc": "嘉陵区", "parentid": 264}, "3142": {"ctype": "40", "cname": "西充", "id": 3142, "cdesc": "西充县", "parentid": 264}, "3143": {"ctype": "40", "cname": "南部", "id": 3143, "cdesc": "南部县", "parentid": 264}, "3144": {"ctype": "40", "cname": "蓬安", "id": 3144, "cdesc": "蓬安县", "parentid": 264}, "3145": {"ctype": "40", "cname": "营山", "id": 3145, "cdesc": "营山县", "parentid": 264}, "3146": {"ctype": "40", "cname": "仪陇", "id": 3146, "cdesc": "仪陇县", "parentid": 264}, "3147": {"ctype": "40", "cname": "阆中", "id": 3147, "cdesc": "阆中市", "parentid": 264}, "3148": {"ctype": "40", "cname": "翠屏", "id": 3148, "cdesc": "翠屏区", "parentid": 266}, "3149": {"ctype": "40", "cname": "南溪", "id": 3149, "cdesc": "南溪区", "parentid": 266}, "3150": {"ctype": "40", "cname": "宜宾", "id": 3150, "cdesc": "宜宾县", "parentid": 266}, "3151": {"ctype": "40", "cname": "江安", "id": 3151, "cdesc": "江安县", "parentid": 266}, "3152": {"ctype": "40", "cname": "长宁", "id": 3152, "cdesc": "长宁县", "parentid": 266}, "3153": {"ctype": "40", "cname": "高县", "id": 3153, "cdesc": "高县", "parentid": 266}, "3154": {"ctype": "40", "cname": "筠连", "id": 3154, "cdesc": "筠连县", "parentid": 266}, "3155": {"ctype": "40", "cname": "珙县", "id": 3155, "cdesc": "珙县", "parentid": 266}, "3156": {"ctype": "40", "cname": "兴文", "id": 3156, "cdesc": "兴文县", "parentid": 266}, "3157": {"ctype": "40", "cname": "屏山", "id": 3157, "cdesc": "屏山县", "parentid": 266}, "3158": {"ctype": "40", "cname": "睢阳", "id": 3158, "cdesc": "睢阳区", "parentid": 221}, "3159": {"ctype": "40", "cname": "梁园", "id": 3159, "cdesc": "梁园区", "parentid": 221}, "3160": {"ctype": "40", "cname": "永城", "id": 3160, "cdesc": "永城市", "parentid": 221}, "3161": {"ctype": "40", "cname": "民权", "id": 3161, "cdesc": "民权县", "parentid": 221}, "3162": {"ctype": "40", "cname": "宁陵", "id": 3162, "cdesc": "宁陵县", "parentid": 221}, "3163": {"ctype": "40", "cname": "柘城", "id": 3163, "cdesc": "柘城县", "parentid": 221}, "3164": {"ctype": "40", "cname": "虞城", "id": 3164, "cdesc": "虞城县", "parentid": 221}, "3165": {"ctype": "40", "cname": "夏邑", "id": 3165, "cdesc": "夏邑县", "parentid": 221}, "3166": {"ctype": "40", "cname": "睢县", "id": 3166, "cdesc": "睢县", "parentid": 221}, "3167": {"ctype": "40", "cname": "雁江", "id": 3167, "cdesc": "雁江区", "parentid": 271}, "3168": {"ctype": "40", "cname": "安岳", "id": 3168, "cdesc": "安岳县", "parentid": 271}, "3169": {"ctype": "40", "cname": "乐至", "id": 3169, "cdesc": "乐至县", "parentid": 271}, "3170": {"ctype": "40", "cname": "川汇", "id": 3170, "cdesc": "川汇区", "parentid": 223}, "3171": {"ctype": "40", "cname": "项城", "id": 3171, "cdesc": "项城市", "parentid": 223}, "3172": {"ctype": "40", "cname": "扶沟", "id": 3172, "cdesc": "扶沟县", "parentid": 223}, "3173": {"ctype": "40", "cname": "西华", "id": 3173, "cdesc": "西华县", "parentid": 223}, "3174": {"ctype": "40", "cname": "商水", "id": 3174, "cdesc": "商水县", "parentid": 223}, "3175": {"ctype": "40", "cname": "沈丘", "id": 3175, "cdesc": "沈丘县", "parentid": 223}, "3176": {"ctype": "40", "cname": "淮阳", "id": 3176, "cdesc": "淮阳县", "parentid": 223}, "3177": {"ctype": "40", "cname": "郸城", "id": 3177, "cdesc": "郸城县", "parentid": 223}, "3178": {"ctype": "40", "cname": "太康", "id": 3178, "cdesc": "太康县", "parentid": 223}, "3179": {"ctype": "40", "cname": "鹿邑", "id": 3179, "cdesc": "鹿邑县", "parentid": 223}, "3180": {"ctype": "40", "cname": "驿城", "id": 3180, "cdesc": "驿城区", "parentid": 224}, "3181": {"ctype": "40", "cname": "西平", "id": 3181, "cdesc": "西平县", "parentid": 224}, "3182": {"ctype": "40", "cname": "遂平", "id": 3182, "cdesc": "遂平县", "parentid": 224}, "3183": {"ctype": "40", "cname": "平舆", "id": 3183, "cdesc": "平舆县", "parentid": 224}, "3184": {"ctype": "40", "cname": "上蔡", "id": 3184, "cdesc": "上蔡县", "parentid": 224}, "3185": {"ctype": "40", "cname": "新蔡", "id": 3185, "cdesc": "新蔡县", "parentid": 224}, "3186": {"ctype": "40", "cname": "正阳", "id": 3186, "cdesc": "正阳县", "parentid": 224}, "3187": {"ctype": "40", "cname": "泌阳", "id": 3187, "cdesc": "泌阳县", "parentid": 224}, "3188": {"ctype": "40", "cname": "确山", "id": 3188, "cdesc": "确山县", "parentid": 224}, "3189": {"ctype": "40", "cname": "汝南", "id": 3189, "cdesc": "汝南县", "parentid": 224}, "3190": {"ctype": "40", "cname": "市中", "id": 3190, "cdesc": "市中区", "parentid": 263}, "3191": {"ctype": "40", "cname": "沙湾", "id": 3191, "cdesc": "沙湾区", "parentid": 263}, "3192": {"ctype": "40", "cname": "五通桥", "id": 3192, "cdesc": "五通桥区", "parentid": 263}, "3193": {"ctype": "40", "cname": "金口河", "id": 3193, "cdesc": "金口河区", "parentid": 263}, "3194": {"ctype": "40", "cname": "犍为", "id": 3194, "cdesc": "犍为县", "parentid": 263}, "3195": {"ctype": "40", "cname": "井研", "id": 3195, "cdesc": "井研县", "parentid": 263}, "3196": {"ctype": "40", "cname": "夹江", "id": 3196, "cdesc": "夹江县", "parentid": 263}, "3197": {"ctype": "40", "cname": "沐川", "id": 3197, "cdesc": "沐川县", "parentid": 263}, "3198": {"ctype": "40", "cname": "峨眉山", "id": 3198, "cdesc": "峨眉山市", "parentid": 263}, "3199": {"ctype": "40", "cname": "峨边彝族", "id": 3199, "cdesc": "峨边彝族", "parentid": 263}, "3200": {"ctype": "40", "cname": "马边彝族", "id": 3200, "cdesc": "马边彝族", "parentid": 263}, "3201": {"ctype": "40", "cname": "市中", "id": 3201, "cdesc": "市中区", "parentid": 262}, "3202": {"ctype": "40", "cname": "东兴", "id": 3202, "cdesc": "东兴区", "parentid": 262}, "3203": {"ctype": "40", "cname": "资中", "id": 3203, "cdesc": "资中县", "parentid": 262}, "3204": {"ctype": "40", "cname": "隆昌", "id": 3204, "cdesc": "隆昌县", "parentid": 262}, "3205": {"ctype": "40", "cname": "威远", "id": 3205, "cdesc": "威远县", "parentid": 262}, "3206": {"ctype": "40", "cname": "船山", "id": 3206, "cdesc": "船山区", "parentid": 261}, "3207": {"ctype": "40", "cname": "安居", "id": 3207, "cdesc": "安居区", "parentid": 261}, "3208": {"ctype": "40", "cname": "射洪", "id": 3208, "cdesc": "射洪县", "parentid": 261}, "3209": {"ctype": "40", "cname": "蓬溪", "id": 3209, "cdesc": "蓬溪县", "parentid": 261}, "3210": {"ctype": "40", "cname": "大英", "id": 3210, "cdesc": "大英县", "parentid": 261}, "3211": {"ctype": "40", "cname": "利州", "id": 3211, "cdesc": "利州区", "parentid": 260}, "3212": {"ctype": "40", "cname": "昭化", "id": 3212, "cdesc": "昭化区", "parentid": 260}, "3213": {"ctype": "40", "cname": "朝天", "id": 3213, "cdesc": "朝天区", "parentid": 260}, "3214": {"ctype": "40", "cname": "旺苍", "id": 3214, "cdesc": "旺苍县", "parentid": 260}, "3215": {"ctype": "40", "cname": "青川", "id": 3215, "cdesc": "青川县", "parentid": 260}, "3216": {"ctype": "40", "cname": "剑阁", "id": 3216, "cdesc": "剑阁县", "parentid": 260}, "3217": {"ctype": "40", "cname": "苍溪", "id": 3217, "cdesc": "苍溪县", "parentid": 260}, "3218": {"ctype": "40", "cname": "宛城", "id": 3218, "cdesc": "宛城区", "parentid": 220}, "3219": {"ctype": "40", "cname": "卧龙", "id": 3219, "cdesc": "卧龙区", "parentid": 220}, "3220": {"ctype": "40", "cname": "邓州", "id": 3220, "cdesc": "邓州市", "parentid": 220}, "3221": {"ctype": "40", "cname": "南召", "id": 3221, "cdesc": "南召县", "parentid": 220}, "3222": {"ctype": "40", "cname": "西峡", "id": 3222, "cdesc": "西峡县", "parentid": 220}, "3223": {"ctype": "40", "cname": "方城", "id": 3223, "cdesc": "方城县", "parentid": 220}, "3224": {"ctype": "40", "cname": "镇平", "id": 3224, "cdesc": "镇平县", "parentid": 220}, "3225": {"ctype": "40", "cname": "内乡", "id": 3225, "cdesc": "内乡县", "parentid": 220}, "3226": {"ctype": "40", "cname": "淅川", "id": 3226, "cdesc": "淅川县", "parentid": 220}, "3227": {"ctype": "40", "cname": "社旗", "id": 3227, "cdesc": "社旗县", "parentid": 220}, "3228": {"ctype": "40", "cname": "唐河", "id": 3228, "cdesc": "唐河县", "parentid": 220}, "3229": {"ctype": "40", "cname": "新野", "id": 3229, "cdesc": "新野县", "parentid": 220}, "3230": {"ctype": "40", "cname": "桐柏", "id": 3230, "cdesc": "桐柏县", "parentid": 220}, "3231": {"ctype": "40", "cname": "旌阳", "id": 3231, "cdesc": "旌阳区", "parentid": 258}, "3232": {"ctype": "40", "cname": "广汉", "id": 3232, "cdesc": "广汉市", "parentid": 258}, "3233": {"ctype": "40", "cname": "什邡", "id": 3233, "cdesc": "什邡市", "parentid": 258}, "3234": {"ctype": "40", "cname": "绵竹", "id": 3234, "cdesc": "绵竹市", "parentid": 258}, "3235": {"ctype": "40", "cname": "中江", "id": 3235, "cdesc": "中江县", "parentid": 258}, "3236": {"ctype": "40", "cname": "罗江", "id": 3236, "cdesc": "罗江县", "parentid": 258}, "3237": {"ctype": "40", "cname": "浉河", "id": 3237, "cdesc": "浉河区", "parentid": 222}, "3238": {"ctype": "40", "cname": "平桥", "id": 3238, "cdesc": "平桥区", "parentid": 222}, "3239": {"ctype": "40", "cname": "罗山", "id": 3239, "cdesc": "罗山县", "parentid": 222}, "3240": {"ctype": "40", "cname": "光山", "id": 3240, "cdesc": "光山县", "parentid": 222}, "3241": {"ctype": "40", "cname": "潢川", "id": 3241, "cdesc": "潢川县", "parentid": 222}, "3242": {"ctype": "40", "cname": "固始", "id": 3242, "cdesc": "固始县", "parentid": 222}, "3243": {"ctype": "40", "cname": "淮滨", "id": 3243, "cdesc": "淮滨县", "parentid": 222}, "3244": {"ctype": "40", "cname": "商城", "id": 3244, "cdesc": "商城县", "parentid": 222}, "3245": {"ctype": "40", "cname": "新县", "id": 3245, "cdesc": "新县", "parentid": 222}, "3246": {"ctype": "40", "cname": "息县", "id": 3246, "cdesc": "息县", "parentid": 222}, "3247": {"ctype": "40", "cname": "江阳", "id": 3247, "cdesc": "江阳区", "parentid": 257}, "3248": {"ctype": "40", "cname": "龙马潭", "id": 3248, "cdesc": "龙马潭区", "parentid": 257}, "3249": {"ctype": "40", "cname": "纳溪", "id": 3249, "cdesc": "纳溪区", "parentid": 257}, "3250": {"ctype": "40", "cname": "泸县", "id": 3250, "cdesc": "泸县", "parentid": 257}, "3251": {"ctype": "40", "cname": "合江", "id": 3251, "cdesc": "合江县", "parentid": 257}, "3252": {"ctype": "40", "cname": "叙永", "id": 3252, "cdesc": "叙永县", "parentid": 257}, "3253": {"ctype": "40", "cname": "古蔺", "id": 3253, "cdesc": "古蔺县", "parentid": 257}, "3254": {"ctype": "40", "cname": "东区", "id": 3254, "cdesc": "东区", "parentid": 256}, "3255": {"ctype": "40", "cname": "西区", "id": 3255, "cdesc": "西区", "parentid": 256}, "3256": {"ctype": "40", "cname": "仁和", "id": 3256, "cdesc": "仁和区", "parentid": 256}, "3257": {"ctype": "40", "cname": "米易", "id": 3257, "cdesc": "米易县", "parentid": 256}, "3258": {"ctype": "40", "cname": "盐边", "id": 3258, "cdesc": "盐边县", "parentid": 256}, "3259": {"ctype": "40", "cname": "自流井", "id": 3259, "cdesc": "自流井区", "parentid": 255}, "3260": {"ctype": "40", "cname": "贡井", "id": 3260, "cdesc": "贡井区", "parentid": 255}, "3261": {"ctype": "40", "cname": "大安", "id": 3261, "cdesc": "大安区", "parentid": 255}, "3262": {"ctype": "40", "cname": "沿滩", "id": 3262, "cdesc": "沿滩区", "parentid": 255}, "3263": {"ctype": "40", "cname": "荣县", "id": 3263, "cdesc": "荣县", "parentid": 255}, "3264": {"ctype": "40", "cname": "富顺", "id": 3264, "cdesc": "富顺县", "parentid": 255}, "3265": {"ctype": "40", "cname": "涪城", "id": 3265, "cdesc": "涪城区", "parentid": 259}, "3266": {"ctype": "40", "cname": "游仙", "id": 3266, "cdesc": "游仙区", "parentid": 259}, "3267": {"ctype": "40", "cname": "安州", "id": 3267, "cdesc": "安州区", "parentid": 259}, "3268": {"ctype": "40", "cname": "梓潼", "id": 3268, "cdesc": "梓潼县", "parentid": 259}, "3269": {"ctype": "40", "cname": "三台", "id": 3269, "cdesc": "三台县", "parentid": 259}, "3270": {"ctype": "40", "cname": "盐亭", "id": 3270, "cdesc": "盐亭县", "parentid": 259}, "3271": {"ctype": "40", "cname": "平武", "id": 3271, "cdesc": "平武县", "parentid": 259}, "3272": {"ctype": "40", "cname": "江油", "id": 3272, "cdesc": "江油市", "parentid": 259}, "3273": {"ctype": "40", "cname": "北川羌族", "id": 3273, "cdesc": "北川羌族", "parentid": 259}, "3274": {"ctype": "40", "cname": "锦江", "id": 3274, "cdesc": "锦江区", "parentid": 254}, "3275": {"ctype": "40", "cname": "青羊", "id": 3275, "cdesc": "青羊区", "parentid": 254}, "3276": {"ctype": "40", "cname": "金牛", "id": 3276, "cdesc": "金牛区", "parentid": 254}, "3277": {"ctype": "40", "cname": "武侯", "id": 3277, "cdesc": "武侯区", "parentid": 254}, "3278": {"ctype": "40", "cname": "成华", "id": 3278, "cdesc": "成华区", "parentid": 254}, "3279": {"ctype": "40", "cname": "青白江", "id": 3279, "cdesc": "青白江区", "parentid": 254}, "3280": {"ctype": "40", "cname": "龙泉驿", "id": 3280, "cdesc": "龙泉驿区", "parentid": 254}, "3281": {"ctype": "40", "cname": "新都", "id": 3281, "cdesc": "新都区", "parentid": 254}, "3282": {"ctype": "40", "cname": "温江", "id": 3282, "cdesc": "温江区", "parentid": 254}, "3283": {"ctype": "40", "cname": "双流", "id": 3283, "cdesc": "双流区", "parentid": 254}, "3284": {"ctype": "40", "cname": "郫县", "id": 3284, "cdesc": "郫县", "parentid": 254}, "3285": {"ctype": "40", "cname": "金堂", "id": 3285, "cdesc": "金堂县", "parentid": 254}, "3286": {"ctype": "40", "cname": "大邑", "id": 3286, "cdesc": "大邑县", "parentid": 254}, "3287": {"ctype": "40", "cname": "蒲江", "id": 3287, "cdesc": "蒲江县", "parentid": 254}, "3288": {"ctype": "40", "cname": "新津", "id": 3288, "cdesc": "新津县", "parentid": 254}, "3289": {"ctype": "40", "cname": "都江堰", "id": 3289, "cdesc": "都江堰市", "parentid": 254}, "3290": {"ctype": "40", "cname": "彭州", "id": 3290, "cdesc": "彭州市", "parentid": 254}, "3291": {"ctype": "40", "cname": "崇州", "id": 3291, "cdesc": "崇州市", "parentid": 254}, "3292": {"ctype": "40", "cname": "邛崃", "id": 3292, "cdesc": "邛崃市", "parentid": 254}, "3293": {"ctype": "40", "cname": "简阳", "id": 3293, "cdesc": "简阳市", "parentid": 254}, "3294": {"ctype": "40", "cname": "干冲", "id": 3294, "cdesc": "干冲区", "parentid": 535}, "3295": {"ctype": "40", "cname": "新英湾", "id": 3295, "cdesc": "新英湾区", "parentid": 535}, "3296": {"ctype": "40", "cname": "崖州", "id": 3296, "cdesc": "崖州区", "parentid": 113}, "3297": {"ctype": "40", "cname": "天涯", "id": 3297, "cdesc": "天涯区", "parentid": 113}, "3298": {"ctype": "40", "cname": "吉阳", "id": 3298, "cdesc": "吉阳区", "parentid": 113}, "3299": {"ctype": "40", "cname": "海棠", "id": 3299, "cdesc": "海棠区", "parentid": 113}, "3300": {"ctype": "40", "cname": "江岸", "id": 3300, "cdesc": "江岸区", "parentid": 225}, "3301": {"ctype": "40", "cname": "江汉", "id": 3301, "cdesc": "江汉区", "parentid": 225}, "3302": {"ctype": "40", "cname": "硚口", "id": 3302, "cdesc": "硚口区", "parentid": 225}, "3303": {"ctype": "40", "cname": "汉阳", "id": 3303, "cdesc": "汉阳区", "parentid": 225}, "3304": {"ctype": "40", "cname": "武昌", "id": 3304, "cdesc": "武昌区", "parentid": 225}, "3305": {"ctype": "40", "cname": "青山", "id": 3305, "cdesc": "青山区", "parentid": 225}, "3306": {"ctype": "40", "cname": "洪山", "id": 3306, "cdesc": "洪山区", "parentid": 225}, "3307": {"ctype": "40", "cname": "东西湖", "id": 3307, "cdesc": "东西湖区", "parentid": 225}, "3308": {"ctype": "40", "cname": "汉南", "id": 3308, "cdesc": "汉南区", "parentid": 225}, "3309": {"ctype": "40", "cname": "蔡甸", "id": 3309, "cdesc": "蔡甸区", "parentid": 225}, "3310": {"ctype": "40", "cname": "江夏", "id": 3310, "cdesc": "江夏区", "parentid": 225}, "3311": {"ctype": "40", "cname": "黄陂", "id": 3311, "cdesc": "黄陂区", "parentid": 225}, "3312": {"ctype": "40", "cname": "新洲", "id": 3312, "cdesc": "新洲区", "parentid": 225}, "3313": {"ctype": "40", "cname": "秀英", "id": 3313, "cdesc": "秀英区", "parentid": 112}, "3314": {"ctype": "40", "cname": "龙华", "id": 3314, "cdesc": "龙华区", "parentid": 112}, "3315": {"ctype": "40", "cname": "琼山", "id": 3315, "cdesc": "琼山区", "parentid": 112}, "3316": {"ctype": "40", "cname": "美兰", "id": 3316, "cdesc": "美兰区", "parentid": 112}, "3317": {"ctype": "40", "cname": "黄石港", "id": 3317, "cdesc": "黄石港区", "parentid": 226}, "3318": {"ctype": "40", "cname": "西塞山", "id": 3318, "cdesc": "西塞山区", "parentid": 226}, "3319": {"ctype": "40", "cname": "下陆", "id": 3319, "cdesc": "下陆区", "parentid": 226}, "3320": {"ctype": "40", "cname": "铁山", "id": 3320, "cdesc": "铁山区", "parentid": 226}, "3321": {"ctype": "40", "cname": "大冶", "id": 3321, "cdesc": "大冶市", "parentid": 226}, "3322": {"ctype": "40", "cname": "阳新", "id": 3322, "cdesc": "阳新县", "parentid": 226}, "3323": {"ctype": "40", "cname": "黄石经济技术开发", "id": 3323, "cdesc": "黄石经济技术开发区", "parentid": 226}, "3324": {"ctype": "40", "cname": "茅箭", "id": 3324, "cdesc": "茅箭区", "parentid": 227}, "3325": {"ctype": "40", "cname": "张湾", "id": 3325, "cdesc": "张湾区", "parentid": 227}, "3326": {"ctype": "40", "cname": "十堰经济技术开发", "id": 3326, "cdesc": "十堰经济技术开发区", "parentid": 227}, "3327": {"ctype": "40", "cname": "郧西", "id": 3327, "cdesc": "郧西县", "parentid": 227}, "3328": {"ctype": "40", "cname": "竹山", "id": 3328, "cdesc": "竹山县", "parentid": 227}, "3329": {"ctype": "40", "cname": "竹溪", "id": 3329, "cdesc": "竹溪县", "parentid": 227}, "3330": {"ctype": "40", "cname": "房县", "id": 3330, "cdesc": "房县", "parentid": 227}, "3331": {"ctype": "40", "cname": "丹江口", "id": 3331, "cdesc": "丹江口市", "parentid": 227}, "3332": {"ctype": "40", "cname": "远安", "id": 3332, "cdesc": "远安县", "parentid": 228}, "3333": {"ctype": "40", "cname": "兴山", "id": 3333, "cdesc": "兴山县", "parentid": 228}, "3334": {"ctype": "40", "cname": "秭归", "id": 3334, "cdesc": "秭归县", "parentid": 228}, "3335": {"ctype": "40", "cname": "长阳土家族", "id": 3335, "cdesc": "长阳土家族", "parentid": 228}, "3336": {"ctype": "40", "cname": "五峰土家族", "id": 3336, "cdesc": "五峰土家族", "parentid": 228}, "3337": {"ctype": "40", "cname": "宜都", "id": 3337, "cdesc": "宜都市", "parentid": 228}, "3338": {"ctype": "40", "cname": "当阳", "id": 3338, "cdesc": "当阳市", "parentid": 228}, "3339": {"ctype": "40", "cname": "枝江", "id": 3339, "cdesc": "枝江市", "parentid": 228}, "3340": {"ctype": "40", "cname": "夷陵", "id": 3340, "cdesc": "夷陵区", "parentid": 228}, "3341": {"ctype": "40", "cname": "西陵", "id": 3341, "cdesc": "西陵区", "parentid": 228}, "3342": {"ctype": "40", "cname": "伍家岗", "id": 3342, "cdesc": "伍家岗区", "parentid": 228}, "3343": {"ctype": "40", "cname": "点军", "id": 3343, "cdesc": "点军区", "parentid": 228}, "3344": {"ctype": "40", "cname": "猇亭", "id": 3344, "cdesc": "猇亭区", "parentid": 228}, "3345": {"ctype": "40", "cname": "江州", "id": 3345, "cdesc": "江州区", "parentid": 128}, "3346": {"ctype": "40", "cname": "凭祥", "id": 3346, "cdesc": "凭祥市", "parentid": 128}, "3347": {"ctype": "40", "cname": "扶绥", "id": 3347, "cdesc": "扶绥县", "parentid": 128}, "3348": {"ctype": "40", "cname": "宁明", "id": 3348, "cdesc": "宁明县", "parentid": 128}, "3349": {"ctype": "40", "cname": "龙州", "id": 3349, "cdesc": "龙州县", "parentid": 128}, "3350": {"ctype": "40", "cname": "大新", "id": 3350, "cdesc": "大新县", "parentid": 128}, "3351": {"ctype": "40", "cname": "天等", "id": 3351, "cdesc": "天等县", "parentid": 128}, "3352": {"ctype": "40", "cname": "襄州", "id": 3352, "cdesc": "襄州区", "parentid": 229}, "3353": {"ctype": "40", "cname": "襄城", "id": 3353, "cdesc": "襄城区", "parentid": 229}, "3354": {"ctype": "40", "cname": "樊城", "id": 3354, "cdesc": "樊城区", "parentid": 229}, "3355": {"ctype": "40", "cname": "南漳", "id": 3355, "cdesc": "南漳县", "parentid": 229}, "3356": {"ctype": "40", "cname": "保康", "id": 3356, "cdesc": "保康县", "parentid": 229}, "3357": {"ctype": "40", "cname": "谷城", "id": 3357, "cdesc": "谷城县", "parentid": 229}, "3358": {"ctype": "40", "cname": "枣阳", "id": 3358, "cdesc": "枣阳市", "parentid": 229}, "3359": {"ctype": "40", "cname": "宜城", "id": 3359, "cdesc": "宜城市", "parentid": 229}, "3360": {"ctype": "40", "cname": "老河口", "id": 3360, "cdesc": "老河口市", "parentid": 229}, "3361": {"ctype": "40", "cname": "兴宾", "id": 3361, "cdesc": "兴宾区", "parentid": 127}, "3362": {"ctype": "40", "cname": "合山", "id": 3362, "cdesc": "合山市", "parentid": 127}, "3363": {"ctype": "40", "cname": "象州", "id": 3363, "cdesc": "象州县", "parentid": 127}, "3364": {"ctype": "40", "cname": "武宣", "id": 3364, "cdesc": "武宣县", "parentid": 127}, "3365": {"ctype": "40", "cname": "忻城", "id": 3365, "cdesc": "忻城县", "parentid": 127}, "3366": {"ctype": "40", "cname": "金秀瑶族", "id": 3366, "cdesc": "金秀瑶族", "parentid": 127}, "3367": {"ctype": "40", "cname": "鄂城", "id": 3367, "cdesc": "鄂城区", "parentid": 230}, "3368": {"ctype": "40", "cname": "华容", "id": 3368, "cdesc": "华容区", "parentid": 230}, "3369": {"ctype": "40", "cname": "梁子湖", "id": 3369, "cdesc": "梁子湖区", "parentid": 230}, "3370": {"ctype": "40", "cname": "金城江", "id": 3370, "cdesc": "金城江区", "parentid": 126}, "3371": {"ctype": "40", "cname": "宜州", "id": 3371, "cdesc": "宜州市", "parentid": 126}, "3372": {"ctype": "40", "cname": "南丹", "id": 3372, "cdesc": "南丹县", "parentid": 126}, "3373": {"ctype": "40", "cname": "天峨", "id": 3373, "cdesc": "天峨县", "parentid": 126}, "3374": {"ctype": "40", "cname": "凤山", "id": 3374, "cdesc": "凤山县", "parentid": 126}, "3375": {"ctype": "40", "cname": "东兰", "id": 3375, "cdesc": "东兰县", "parentid": 126}, "3376": {"ctype": "40", "cname": "巴马瑶族", "id": 3376, "cdesc": "巴马瑶族", "parentid": 126}, "3377": {"ctype": "40", "cname": "都安瑶族", "id": 3377, "cdesc": "都安瑶族", "parentid": 126}, "3378": {"ctype": "40", "cname": "大化瑶族", "id": 3378, "cdesc": "大化瑶族", "parentid": 126}, "3379": {"ctype": "40", "cname": "罗城仫佬族", "id": 3379, "cdesc": "罗城仫佬族", "parentid": 126}, "3380": {"ctype": "40", "cname": "环江毛南族", "id": 3380, "cdesc": "环江毛南族", "parentid": 126}, "3381": {"ctype": "40", "cname": "八步", "id": 3381, "cdesc": "八步区", "parentid": 125}, "3382": {"ctype": "40", "cname": "昭平", "id": 3382, "cdesc": "昭平县", "parentid": 125}, "3383": {"ctype": "40", "cname": "钟山", "id": 3383, "cdesc": "钟山县", "parentid": 125}, "3384": {"ctype": "40", "cname": "富川瑶族", "id": 3384, "cdesc": "富川瑶族", "parentid": 125}, "3385": {"ctype": "40", "cname": "右江", "id": 3385, "cdesc": "右江区", "parentid": 124}, "3386": {"ctype": "40", "cname": "靖西", "id": 3386, "cdesc": "靖西市", "parentid": 124}, "3387": {"ctype": "40", "cname": "田阳", "id": 3387, "cdesc": "田阳县", "parentid": 124}, "3388": {"ctype": "40", "cname": "田东", "id": 3388, "cdesc": "田东县", "parentid": 124}, "3389": {"ctype": "40", "cname": "平果", "id": 3389, "cdesc": "平果县", "parentid": 124}, "3390": {"ctype": "40", "cname": "德保", "id": 3390, "cdesc": "德保县", "parentid": 124}, "3391": {"ctype": "40", "cname": "那坡", "id": 3391, "cdesc": "那坡县", "parentid": 124}, "3392": {"ctype": "40", "cname": "凌云", "id": 3392, "cdesc": "凌云县", "parentid": 124}, "3393": {"ctype": "40", "cname": "乐业", "id": 3393, "cdesc": "乐业县", "parentid": 124}, "3394": {"ctype": "40", "cname": "田林", "id": 3394, "cdesc": "田林县", "parentid": 124}, "3395": {"ctype": "40", "cname": "西林", "id": 3395, "cdesc": "西林县", "parentid": 124}, "3396": {"ctype": "40", "cname": "隆林各族", "id": 3396, "cdesc": "隆林各族", "parentid": 124}, "3397": {"ctype": "40", "cname": "钟祥", "id": 3397, "cdesc": "钟祥市", "parentid": 231}, "3398": {"ctype": "40", "cname": "东宝", "id": 3398, "cdesc": "东宝区", "parentid": 231}, "3399": {"ctype": "40", "cname": "掇刀", "id": 3399, "cdesc": "掇刀区", "parentid": 231}, "3400": {"ctype": "40", "cname": "漳河新", "id": 3400, "cdesc": "漳河新区", "parentid": 231}, "3401": {"ctype": "40", "cname": "屈家岭管理", "id": 3401, "cdesc": "屈家岭管理区", "parentid": 231}, "3402": {"ctype": "40", "cname": "京山", "id": 3402, "cdesc": "京山县", "parentid": 231}, "3403": {"ctype": "40", "cname": "沙洋", "id": 3403, "cdesc": "沙洋县", "parentid": 231}, "3404": {"ctype": "40", "cname": "荆门高新技术产业", "id": 3404, "cdesc": "荆门高新技术产业", "parentid": 231}, "3405": {"ctype": "40", "cname": "玉州", "id": 3405, "cdesc": "玉州区", "parentid": 123}, "3406": {"ctype": "40", "cname": "福绵", "id": 3406, "cdesc": "福绵区", "parentid": 123}, "3407": {"ctype": "40", "cname": "北流", "id": 3407, "cdesc": "北流市", "parentid": 123}, "3408": {"ctype": "40", "cname": "容县", "id": 3408, "cdesc": "容县", "parentid": 123}, "3409": {"ctype": "40", "cname": "陆川", "id": 3409, "cdesc": "陆川县", "parentid": 123}, "3410": {"ctype": "40", "cname": "博白", "id": 3410, "cdesc": "博白县", "parentid": 123}, "3411": {"ctype": "40", "cname": "兴业", "id": 3411, "cdesc": "兴业县", "parentid": 123}, "3412": {"ctype": "40", "cname": "孝南", "id": 3412, "cdesc": "孝南区", "parentid": 232}, "3413": {"ctype": "40", "cname": "汉川", "id": 3413, "cdesc": "汉川市", "parentid": 232}, "3414": {"ctype": "40", "cname": "应城", "id": 3414, "cdesc": "应城市", "parentid": 232}, "3415": {"ctype": "40", "cname": "安陆", "id": 3415, "cdesc": "安陆市", "parentid": 232}, "3416": {"ctype": "40", "cname": "云梦", "id": 3416, "cdesc": "云梦县", "parentid": 232}, "3417": {"ctype": "40", "cname": "孝昌", "id": 3417, "cdesc": "孝昌县", "parentid": 232}, "3418": {"ctype": "40", "cname": "大悟", "id": 3418, "cdesc": "大悟县", "parentid": 232}, "3419": {"ctype": "40", "cname": "港北", "id": 3419, "cdesc": "港北区", "parentid": 122}, "3420": {"ctype": "40", "cname": "港南", "id": 3420, "cdesc": "港南区", "parentid": 122}, "3421": {"ctype": "40", "cname": "覃塘", "id": 3421, "cdesc": "覃塘区", "parentid": 122}, "3422": {"ctype": "40", "cname": "桂平", "id": 3422, "cdesc": "桂平市", "parentid": 122}, "3423": {"ctype": "40", "cname": "平南", "id": 3423, "cdesc": "平南县", "parentid": 122}, "3424": {"ctype": "40", "cname": "钦南", "id": 3424, "cdesc": "钦南区", "parentid": 121}, "3425": {"ctype": "40", "cname": "钦北", "id": 3425, "cdesc": "钦北区", "parentid": 121}, "3426": {"ctype": "40", "cname": "灵山", "id": 3426, "cdesc": "灵山县", "parentid": 121}, "3427": {"ctype": "40", "cname": "浦北", "id": 3427, "cdesc": "浦北县", "parentid": 121}, "3428": {"ctype": "40", "cname": "港口", "id": 3428, "cdesc": "港口区", "parentid": 120}, "3429": {"ctype": "40", "cname": "防城", "id": 3429, "cdesc": "防城区", "parentid": 120}, "3430": {"ctype": "40", "cname": "东兴", "id": 3430, "cdesc": "东兴市", "parentid": 120}, "3431": {"ctype": "40", "cname": "上思", "id": 3431, "cdesc": "上思县", "parentid": 120}, "3432": {"ctype": "40", "cname": "海城", "id": 3432, "cdesc": "海城区", "parentid": 119}, "3433": {"ctype": "40", "cname": "银海", "id": 3433, "cdesc": "银海区", "parentid": 119}, "3434": {"ctype": "40", "cname": "铁山港", "id": 3434, "cdesc": "铁山港区", "parentid": 119}, "3435": {"ctype": "40", "cname": "合浦", "id": 3435, "cdesc": "合浦县", "parentid": 119}, "3436": {"ctype": "40", "cname": "荆州", "id": 3436, "cdesc": "荆州区", "parentid": 233}, "3437": {"ctype": "40", "cname": "沙市", "id": 3437, "cdesc": "沙市区", "parentid": 233}, "3438": {"ctype": "40", "cname": "江陵", "id": 3438, "cdesc": "江陵县", "parentid": 233}, "3439": {"ctype": "40", "cname": "松滋", "id": 3439, "cdesc": "松滋市", "parentid": 233}, "3440": {"ctype": "40", "cname": "公安", "id": 3440, "cdesc": "公安县", "parentid": 233}, "3441": {"ctype": "40", "cname": "石首", "id": 3441, "cdesc": "石首市", "parentid": 233}, "3442": {"ctype": "40", "cname": "监利", "id": 3442, "cdesc": "监利县", "parentid": 233}, "3443": {"ctype": "40", "cname": "洪湖", "id": 3443, "cdesc": "洪湖市", "parentid": 233}, "3444": {"ctype": "40", "cname": "荆州经济开发", "id": 3444, "cdesc": "荆州经济开发区", "parentid": 233}, "3445": {"ctype": "40", "cname": "长洲", "id": 3445, "cdesc": "长洲区", "parentid": 118}, "3446": {"ctype": "40", "cname": "万秀", "id": 3446, "cdesc": "万秀区", "parentid": 118}, "3447": {"ctype": "40", "cname": "龙圩", "id": 3447, "cdesc": "龙圩区", "parentid": 118}, "3448": {"ctype": "40", "cname": "岑溪", "id": 3448, "cdesc": "岑溪市", "parentid": 118}, "3449": {"ctype": "40", "cname": "苍梧", "id": 3449, "cdesc": "苍梧县", "parentid": 118}, "3450": {"ctype": "40", "cname": "蒙山", "id": 3450, "cdesc": "蒙山县", "parentid": 118}, "3451": {"ctype": "40", "cname": "藤县", "id": 3451, "cdesc": "藤县", "parentid": 118}, "3452": {"ctype": "40", "cname": "黄州", "id": 3452, "cdesc": "黄州区", "parentid": 234}, "3453": {"ctype": "40", "cname": "麻城", "id": 3453, "cdesc": "麻城市", "parentid": 234}, "3454": {"ctype": "40", "cname": "武穴", "id": 3454, "cdesc": "武穴市", "parentid": 234}, "3455": {"ctype": "40", "cname": "团风", "id": 3455, "cdesc": "团风县", "parentid": 234}, "3456": {"ctype": "40", "cname": "浠水", "id": 3456, "cdesc": "浠水县", "parentid": 234}, "3457": {"ctype": "40", "cname": "罗田", "id": 3457, "cdesc": "罗田县", "parentid": 234}, "3458": {"ctype": "40", "cname": "英山", "id": 3458, "cdesc": "英山县", "parentid": 234}, "3459": {"ctype": "40", "cname": "蕲春", "id": 3459, "cdesc": "蕲春县", "parentid": 234}, "3460": {"ctype": "40", "cname": "黄梅", "id": 3460, "cdesc": "黄梅县", "parentid": 234}, "3461": {"ctype": "40", "cname": "红安", "id": 3461, "cdesc": "红安县", "parentid": 234}, "3462": {"ctype": "40", "cname": "龙感湖管理", "id": 3462, "cdesc": "龙感湖管理区", "parentid": 234}, "3463": {"ctype": "40", "cname": "象山", "id": 3463, "cdesc": "象山区", "parentid": 117}, "3464": {"ctype": "40", "cname": "秀峰", "id": 3464, "cdesc": "秀峰区", "parentid": 117}, "3465": {"ctype": "40", "cname": "叠彩", "id": 3465, "cdesc": "叠彩区", "parentid": 117}, "3466": {"ctype": "40", "cname": "七星", "id": 3466, "cdesc": "七星区", "parentid": 117}, "3467": {"ctype": "40", "cname": "雁山", "id": 3467, "cdesc": "雁山区", "parentid": 117}, "3468": {"ctype": "40", "cname": "临桂", "id": 3468, "cdesc": "临桂区", "parentid": 117}, "3469": {"ctype": "40", "cname": "阳朔", "id": 3469, "cdesc": "阳朔县", "parentid": 117}, "3470": {"ctype": "40", "cname": "灵川", "id": 3470, "cdesc": "灵川县", "parentid": 117}, "3471": {"ctype": "40", "cname": "全州", "id": 3471, "cdesc": "全州县", "parentid": 117}, "3472": {"ctype": "40", "cname": "平乐", "id": 3472, "cdesc": "平乐县", "parentid": 117}, "3473": {"ctype": "40", "cname": "兴安", "id": 3473, "cdesc": "兴安县", "parentid": 117}, "3474": {"ctype": "40", "cname": "灌阳", "id": 3474, "cdesc": "灌阳县", "parentid": 117}, "3475": {"ctype": "40", "cname": "荔浦", "id": 3475, "cdesc": "荔浦县", "parentid": 117}, "3476": {"ctype": "40", "cname": "资源", "id": 3476, "cdesc": "资源县", "parentid": 117}, "3477": {"ctype": "40", "cname": "永福", "id": 3477, "cdesc": "永福县", "parentid": 117}, "3478": {"ctype": "40", "cname": "龙胜各族", "id": 3478, "cdesc": "龙胜各族", "parentid": 117}, "3479": {"ctype": "40", "cname": "恭城瑶族", "id": 3479, "cdesc": "恭城瑶族", "parentid": 117}, "3480": {"ctype": "40", "cname": "咸安", "id": 3480, "cdesc": "咸安区", "parentid": 235}, "3481": {"ctype": "40", "cname": "通山", "id": 3481, "cdesc": "通山县", "parentid": 235}, "3482": {"ctype": "40", "cname": "通城", "id": 3482, "cdesc": "通城县", "parentid": 235}, "3483": {"ctype": "40", "cname": "嘉鱼", "id": 3483, "cdesc": "嘉鱼县", "parentid": 235}, "3484": {"ctype": "40", "cname": "崇阳", "id": 3484, "cdesc": "崇阳县", "parentid": 235}, "3485": {"ctype": "40", "cname": "赤壁", "id": 3485, "cdesc": "赤壁市", "parentid": 235}, "3486": {"ctype": "40", "cname": "柳北", "id": 3486, "cdesc": "柳北区", "parentid": 116}, "3487": {"ctype": "40", "cname": "柳南", "id": 3487, "cdesc": "柳南区", "parentid": 116}, "3488": {"ctype": "40", "cname": "城中", "id": 3488, "cdesc": "城中区", "parentid": 116}, "3489": {"ctype": "40", "cname": "鱼峰", "id": 3489, "cdesc": "鱼峰区", "parentid": 116}, "3490": {"ctype": "40", "cname": "柳城", "id": 3490, "cdesc": "柳城县", "parentid": 116}, "3491": {"ctype": "40", "cname": "柳江", "id": 3491, "cdesc": "柳江县", "parentid": 116}, "3492": {"ctype": "40", "cname": "鹿寨", "id": 3492, "cdesc": "鹿寨县", "parentid": 116}, "3493": {"ctype": "40", "cname": "融安", "id": 3493, "cdesc": "融安县", "parentid": 116}, "3494": {"ctype": "40", "cname": "融水苗族", "id": 3494, "cdesc": "融水苗族", "parentid": 116}, "3495": {"ctype": "40", "cname": "三江侗族自治", "id": 3495, "cdesc": "三江侗族", "parentid": 116}, "3496": {"ctype": "40", "cname": "广水", "id": 3496, "cdesc": "广水市", "parentid": 236}, "3497": {"ctype": "40", "cname": "曾都", "id": 3497, "cdesc": "曾都区", "parentid": 236}, "3498": {"ctype": "40", "cname": "随县", "id": 3498, "cdesc": "随县", "parentid": 236}, "3499": {"ctype": "40", "cname": "青秀", "id": 3499, "cdesc": "青秀区", "parentid": 114}, "3500": {"ctype": "40", "cname": "兴宁", "id": 3500, "cdesc": "兴宁区", "parentid": 114}, "3501": {"ctype": "40", "cname": "西乡塘", "id": 3501, "cdesc": "西乡塘区", "parentid": 114}, "3502": {"ctype": "40", "cname": "江南", "id": 3502, "cdesc": "江南区", "parentid": 114}, "3503": {"ctype": "40", "cname": "良庆", "id": 3503, "cdesc": "良庆区", "parentid": 114}, "3504": {"ctype": "40", "cname": "邕宁", "id": 3504, "cdesc": "邕宁区", "parentid": 114}, "3505": {"ctype": "40", "cname": "武鸣", "id": 3505, "cdesc": "武鸣区", "parentid": 114}, "3506": {"ctype": "40", "cname": "隆安", "id": 3506, "cdesc": "隆安县", "parentid": 114}, "3507": {"ctype": "40", "cname": "马山", "id": 3507, "cdesc": "马山县", "parentid": 114}, "3508": {"ctype": "40", "cname": "上林", "id": 3508, "cdesc": "上林县", "parentid": 114}, "3509": {"ctype": "40", "cname": "宾阳", "id": 3509, "cdesc": "宾阳县", "parentid": 114}, "3510": {"ctype": "40", "cname": "横县", "id": 3510, "cdesc": "横县", "parentid": 114}, "3511": {"ctype": "40", "cname": "恩施", "id": 3511, "cdesc": "恩施市", "parentid": 237}, "3512": {"ctype": "40", "cname": "巴东", "id": 3512, "cdesc": "巴东县", "parentid": 237}, "3513": {"ctype": "40", "cname": "宣恩", "id": 3513, "cdesc": "宣恩县", "parentid": 237}, "3514": {"ctype": "40", "cname": "咸丰", "id": 3514, "cdesc": "咸丰县", "parentid": 237}, "3515": {"ctype": "40", "cname": "来凤", "id": 3515, "cdesc": "来凤县", "parentid": 237}, "3516": {"ctype": "40", "cname": "鹤峰", "id": 3516, "cdesc": "鹤峰县", "parentid": 237}, "3517": {"ctype": "40", "cname": "云城", "id": 3517, "cdesc": "云城区", "parentid": 110}, "3518": {"ctype": "40", "cname": "云安", "id": 3518, "cdesc": "云安区", "parentid": 110}, "3519": {"ctype": "40", "cname": "罗定", "id": 3519, "cdesc": "罗定市", "parentid": 110}, "3520": {"ctype": "40", "cname": "新兴", "id": 3520, "cdesc": "新兴县", "parentid": 110}, "3521": {"ctype": "40", "cname": "郁南", "id": 3521, "cdesc": "郁南县", "parentid": 110}, "3522": {"ctype": "40", "cname": "榕城", "id": 3522, "cdesc": "榕城区", "parentid": 109}, "3523": {"ctype": "40", "cname": "揭东", "id": 3523, "cdesc": "揭东区", "parentid": 109}, "3524": {"ctype": "40", "cname": "普宁", "id": 3524, "cdesc": "普宁市", "parentid": 109}, "3525": {"ctype": "40", "cname": "惠来", "id": 3525, "cdesc": "惠来县", "parentid": 109}, "3526": {"ctype": "40", "cname": "揭西", "id": 3526, "cdesc": "揭西县", "parentid": 109}, "3527": {"ctype": "40", "cname": "湘桥", "id": 3527, "cdesc": "湘桥区", "parentid": 108}, "3528": {"ctype": "40", "cname": "潮安", "id": 3528, "cdesc": "潮安区", "parentid": 108}, "3529": {"ctype": "40", "cname": "饶平", "id": 3529, "cdesc": "饶平县", "parentid": 108}, "3530": {"ctype": "40", "cname": "芙蓉", "id": 3530, "cdesc": "芙蓉区", "parentid": 239}, "3531": {"ctype": "40", "cname": "天心", "id": 3531, "cdesc": "天心区", "parentid": 239}, "3532": {"ctype": "40", "cname": "岳麓", "id": 3532, "cdesc": "岳麓区", "parentid": 239}, "3533": {"ctype": "40", "cname": "开福", "id": 3533, "cdesc": "开福区", "parentid": 239}, "3534": {"ctype": "40", "cname": "雨花", "id": 3534, "cdesc": "雨花区", "parentid": 239}, "3535": {"ctype": "40", "cname": "望城", "id": 3535, "cdesc": "望城区", "parentid": 239}, "3536": {"ctype": "40", "cname": "长沙", "id": 3536, "cdesc": "长沙县", "parentid": 239}, "3537": {"ctype": "40", "cname": "宁乡", "id": 3537, "cdesc": "宁乡县", "parentid": 239}, "3538": {"ctype": "40", "cname": "浏阳", "id": 3538, "cdesc": "浏阳市", "parentid": 239}, "3539": {"ctype": "40", "cname": "清城", "id": 3539, "cdesc": "清城区", "parentid": 107}, "3540": {"ctype": "40", "cname": "清新", "id": 3540, "cdesc": "清新区", "parentid": 107}, "3541": {"ctype": "40", "cname": "英德", "id": 3541, "cdesc": "英德市", "parentid": 107}, "3542": {"ctype": "40", "cname": "连州", "id": 3542, "cdesc": "连州市", "parentid": 107}, "3543": {"ctype": "40", "cname": "佛冈", "id": 3543, "cdesc": "佛冈县", "parentid": 107}, "3544": {"ctype": "40", "cname": "阳山", "id": 3544, "cdesc": "阳山县", "parentid": 107}, "3545": {"ctype": "40", "cname": "连山壮族瑶族自治", "id": 3545, "cdesc": "连山壮族瑶族自治县", "parentid": 107}, "3546": {"ctype": "40", "cname": "连南瑶族自治", "id": 3546, "cdesc": "连南瑶族自治县", "parentid": 107}, "3547": {"ctype": "40", "cname": "天元", "id": 3547, "cdesc": "天元区", "parentid": 240}, "3548": {"ctype": "40", "cname": "荷塘", "id": 3548, "cdesc": "荷塘区", "parentid": 240}, "3549": {"ctype": "40", "cname": "芦淞", "id": 3549, "cdesc": "芦淞区", "parentid": 240}, "3550": {"ctype": "40", "cname": "石峰", "id": 3550, "cdesc": "石峰区", "parentid": 240}, "3551": {"ctype": "40", "cname": "云龙示范", "id": 3551, "cdesc": "云龙示范区", "parentid": 240}, "3552": {"ctype": "40", "cname": "株洲", "id": 3552, "cdesc": "株洲县", "parentid": 240}, "3553": {"ctype": "40", "cname": "攸县", "id": 3553, "cdesc": "攸县", "parentid": 240}, "3554": {"ctype": "40", "cname": "茶陵", "id": 3554, "cdesc": "茶陵县", "parentid": 240}, "3555": {"ctype": "40", "cname": "炎陵", "id": 3555, "cdesc": "炎陵县", "parentid": 240}, "3556": {"ctype": "40", "cname": "醴陵", "id": 3556, "cdesc": "醴陵市", "parentid": 240}, "3557": {"ctype": "40", "cname": "雨湖", "id": 3557, "cdesc": "雨湖区", "parentid": 241}, "3558": {"ctype": "40", "cname": "岳塘", "id": 3558, "cdesc": "岳塘区", "parentid": 241}, "3559": {"ctype": "40", "cname": "湘潭", "id": 3559, "cdesc": "湘潭县", "parentid": 241}, "3560": {"ctype": "40", "cname": "韶山", "id": 3560, "cdesc": "韶山市", "parentid": 241}, "3561": {"ctype": "40", "cname": "湘乡", "id": 3561, "cdesc": "湘乡市", "parentid": 241}, "3562": {"ctype": "40", "cname": "江城", "id": 3562, "cdesc": "江城区", "parentid": 106}, "3563": {"ctype": "40", "cname": "阳东", "id": 3563, "cdesc": "阳东区", "parentid": 106}, "3564": {"ctype": "40", "cname": "阳春", "id": 3564, "cdesc": "阳春市", "parentid": 106}, "3565": {"ctype": "40", "cname": "阳西", "id": 3565, "cdesc": "阳西县", "parentid": 106}, "3566": {"ctype": "40", "cname": "雁峰", "id": 3566, "cdesc": "雁峰区", "parentid": 242}, "3567": {"ctype": "40", "cname": "石鼓", "id": 3567, "cdesc": "石鼓区", "parentid": 242}, "3568": {"ctype": "40", "cname": "珠晖", "id": 3568, "cdesc": "珠晖区", "parentid": 242}, "3569": {"ctype": "40", "cname": "蒸湘", "id": 3569, "cdesc": "蒸湘区", "parentid": 242}, "3570": {"ctype": "40", "cname": "南岳", "id": 3570, "cdesc": "南岳区", "parentid": 242}, "3571": {"ctype": "40", "cname": "衡阳", "id": 3571, "cdesc": "衡阳县", "parentid": 242}, "3572": {"ctype": "40", "cname": "衡南", "id": 3572, "cdesc": "衡南县", "parentid": 242}, "3573": {"ctype": "40", "cname": "衡山", "id": 3573, "cdesc": "衡山县", "parentid": 242}, "3574": {"ctype": "40", "cname": "衡东", "id": 3574, "cdesc": "衡东县", "parentid": 242}, "3575": {"ctype": "40", "cname": "祁东", "id": 3575, "cdesc": "祁东县", "parentid": 242}, "3576": {"ctype": "40", "cname": "耒阳", "id": 3576, "cdesc": "耒阳市", "parentid": 242}, "3577": {"ctype": "40", "cname": "常宁", "id": 3577, "cdesc": "常宁市", "parentid": 242}, "3578": {"ctype": "40", "cname": "源城", "id": 3578, "cdesc": "源城区", "parentid": 105}, "3579": {"ctype": "40", "cname": "龙川", "id": 3579, "cdesc": "龙川县", "parentid": 105}, "3580": {"ctype": "40", "cname": "连平", "id": 3580, "cdesc": "连平县", "parentid": 105}, "3581": {"ctype": "40", "cname": "东源", "id": 3581, "cdesc": "东源县", "parentid": 105}, "3582": {"ctype": "40", "cname": "和平", "id": 3582, "cdesc": "和平县", "parentid": 105}, "3583": {"ctype": "40", "cname": "紫金", "id": 3583, "cdesc": "紫金县", "parentid": 105}, "3584": {"ctype": "40", "cname": "双清", "id": 3584, "cdesc": "双清区", "parentid": 243}, "3585": {"ctype": "40", "cname": "大祥", "id": 3585, "cdesc": "大祥区", "parentid": 243}, "3586": {"ctype": "40", "cname": "北塔", "id": 3586, "cdesc": "北塔区", "parentid": 243}, "3587": {"ctype": "40", "cname": "邵东", "id": 3587, "cdesc": "邵东县", "parentid": 243}, "3588": {"ctype": "40", "cname": "新邵", "id": 3588, "cdesc": "新邵县", "parentid": 243}, "3589": {"ctype": "40", "cname": "邵阳", "id": 3589, "cdesc": "邵阳县", "parentid": 243}, "3590": {"ctype": "40", "cname": "隆回", "id": 3590, "cdesc": "隆回县", "parentid": 243}, "3591": {"ctype": "40", "cname": "洞口", "id": 3591, "cdesc": "洞口县", "parentid": 243}, "3592": {"ctype": "40", "cname": "绥宁", "id": 3592, "cdesc": "绥宁县", "parentid": 243}, "3593": {"ctype": "40", "cname": "新宁", "id": 3593, "cdesc": "新宁县", "parentid": 243}, "3594": {"ctype": "40", "cname": "城步苗族自治", "id": 3594, "cdesc": "城步苗族自治县", "parentid": 243}, "3595": {"ctype": "40", "cname": "武冈", "id": 3595, "cdesc": "武冈市", "parentid": 243}, "3596": {"ctype": "40", "cname": "城区", "id": 3596, "cdesc": "城区", "parentid": 104}, "3597": {"ctype": "40", "cname": "陆丰", "id": 3597, "cdesc": "陆丰市", "parentid": 104}, "3598": {"ctype": "40", "cname": "海丰", "id": 3598, "cdesc": "海丰县", "parentid": 104}, "3599": {"ctype": "40", "cname": "陆河", "id": 3599, "cdesc": "陆河县", "parentid": 104}, "3600": {"ctype": "40", "cname": "岳阳楼", "id": 3600, "cdesc": "岳阳楼区", "parentid": 244}, "3601": {"ctype": "40", "cname": "君山", "id": 3601, "cdesc": "君山区", "parentid": 244}, "3602": {"ctype": "40", "cname": "云溪", "id": 3602, "cdesc": "云溪区", "parentid": 244}, "3603": {"ctype": "40", "cname": "岳阳", "id": 3603, "cdesc": "岳阳县", "parentid": 244}, "3604": {"ctype": "40", "cname": "平江", "id": 3604, "cdesc": "平江县", "parentid": 244}, "3605": {"ctype": "40", "cname": "湘阴", "id": 3605, "cdesc": "湘阴县", "parentid": 244}, "3606": {"ctype": "40", "cname": "华容", "id": 3606, "cdesc": "华容县", "parentid": 244}, "3607": {"ctype": "40", "cname": "汨罗", "id": 3607, "cdesc": "汨罗市", "parentid": 244}, "3608": {"ctype": "40", "cname": "临湘", "id": 3608, "cdesc": "临湘市", "parentid": 244}, "3609": {"ctype": "40", "cname": "武陵", "id": 3609, "cdesc": "武陵区", "parentid": 245}, "3610": {"ctype": "40", "cname": "鼎城", "id": 3610, "cdesc": "鼎城区", "parentid": 245}, "3611": {"ctype": "40", "cname": "安乡", "id": 3611, "cdesc": "安乡县", "parentid": 245}, "3612": {"ctype": "40", "cname": "汉寿", "id": 3612, "cdesc": "汉寿县", "parentid": 245}, "3613": {"ctype": "40", "cname": "澧县", "id": 3613, "cdesc": "澧县", "parentid": 245}, "3614": {"ctype": "40", "cname": "临澧", "id": 3614, "cdesc": "临澧县", "parentid": 245}, "3615": {"ctype": "40", "cname": "桃源", "id": 3615, "cdesc": "桃源县", "parentid": 245}, "3616": {"ctype": "40", "cname": "石门", "id": 3616, "cdesc": "石门县", "parentid": 245}, "3617": {"ctype": "40", "cname": "津市", "id": 3617, "cdesc": "津市市", "parentid": 245}, "3618": {"ctype": "40", "cname": "永定", "id": 3618, "cdesc": "永定区", "parentid": 246}, "3619": {"ctype": "40", "cname": "武陵源", "id": 3619, "cdesc": "武陵源区", "parentid": 246}, "3620": {"ctype": "40", "cname": "慈利", "id": 3620, "cdesc": "慈利县", "parentid": 246}, "3621": {"ctype": "40", "cname": "桑植", "id": 3621, "cdesc": "桑植县", "parentid": 246}, "3622": {"ctype": "40", "cname": "资阳", "id": 3622, "cdesc": "资阳区", "parentid": 247}, "3623": {"ctype": "40", "cname": "赫山", "id": 3623, "cdesc": "赫山区", "parentid": 247}, "3624": {"ctype": "40", "cname": "大通湖", "id": 3624, "cdesc": "大通湖区", "parentid": 247}, "3625": {"ctype": "40", "cname": "安化", "id": 3625, "cdesc": "安化县", "parentid": 247}, "3626": {"ctype": "40", "cname": "桃江", "id": 3626, "cdesc": "桃江县", "parentid": 247}, "3627": {"ctype": "40", "cname": "南县", "id": 3627, "cdesc": "南县", "parentid": 247}, "3628": {"ctype": "40", "cname": "沅江", "id": 3628, "cdesc": "沅江市", "parentid": 247}, "3629": {"ctype": "40", "cname": "娄星", "id": 3629, "cdesc": "娄星区", "parentid": 251}, "3630": {"ctype": "40", "cname": "双峰", "id": 3630, "cdesc": "双峰县", "parentid": 251}, "3631": {"ctype": "40", "cname": "新化", "id": 3631, "cdesc": "新化县", "parentid": 251}, "3632": {"ctype": "40", "cname": "涟源", "id": 3632, "cdesc": "涟源市", "parentid": 251}, "3633": {"ctype": "40", "cname": "冷水江", "id": 3633, "cdesc": "冷水江市", "parentid": 251}, "3634": {"ctype": "40", "cname": "梅江", "id": 3634, "cdesc": "梅江区", "parentid": 103}, "3635": {"ctype": "40", "cname": "梅县", "id": 3635, "cdesc": "梅县区", "parentid": 103}, "3636": {"ctype": "40", "cname": "兴宁", "id": 3636, "cdesc": "兴宁市", "parentid": 103}, "3637": {"ctype": "40", "cname": "大埔", "id": 3637, "cdesc": "大埔县", "parentid": 103}, "3638": {"ctype": "40", "cname": "丰顺", "id": 3638, "cdesc": "丰顺县", "parentid": 103}, "3639": {"ctype": "40", "cname": "五华", "id": 3639, "cdesc": "五华县", "parentid": 103}, "3640": {"ctype": "40", "cname": "平远", "id": 3640, "cdesc": "平远县", "parentid": 103}, "3641": {"ctype": "40", "cname": "蕉岭", "id": 3641, "cdesc": "蕉岭县", "parentid": 103}, "3642": {"ctype": "40", "cname": "惠城", "id": 3642, "cdesc": "惠城区", "parentid": 102}, "3643": {"ctype": "40", "cname": "惠阳", "id": 3643, "cdesc": "惠阳区", "parentid": 102}, "3644": {"ctype": "40", "cname": "博罗", "id": 3644, "cdesc": "博罗县", "parentid": 102}, "3645": {"ctype": "40", "cname": "龙门", "id": 3645, "cdesc": "龙门县", "parentid": 102}, "3646": {"ctype": "40", "cname": "惠东", "id": 3646, "cdesc": "惠东县", "parentid": 102}, "3647": {"ctype": "40", "cname": "苏仙", "id": 3647, "cdesc": "苏仙区", "parentid": 248}, "3648": {"ctype": "40", "cname": "北湖", "id": 3648, "cdesc": "北湖区", "parentid": 248}, "3649": {"ctype": "40", "cname": "安仁", "id": 3649, "cdesc": "安仁县", "parentid": 248}, "3650": {"ctype": "40", "cname": "桂阳", "id": 3650, "cdesc": "桂阳县", "parentid": 248}, "3651": {"ctype": "40", "cname": "永兴", "id": 3651, "cdesc": "永兴县", "parentid": 248}, "3652": {"ctype": "40", "cname": "宜章", "id": 3652, "cdesc": "宜章县", "parentid": 248}, "3653": {"ctype": "40", "cname": "嘉禾", "id": 3653, "cdesc": "嘉禾县", "parentid": 248}, "3654": {"ctype": "40", "cname": "临武", "id": 3654, "cdesc": "临武县", "parentid": 248}, "3655": {"ctype": "40", "cname": "汝城", "id": 3655, "cdesc": "汝城县", "parentid": 248}, "3656": {"ctype": "40", "cname": "桂东", "id": 3656, "cdesc": "桂东县", "parentid": 248}, "3657": {"ctype": "40", "cname": "资兴", "id": 3657, "cdesc": "资兴市", "parentid": 248}, "3658": {"ctype": "40", "cname": "茂南", "id": 3658, "cdesc": "茂南区", "parentid": 100}, "3659": {"ctype": "40", "cname": "电白", "id": 3659, "cdesc": "电白区", "parentid": 100}, "3660": {"ctype": "40", "cname": "高州", "id": 3660, "cdesc": "高州市", "parentid": 100}, "3661": {"ctype": "40", "cname": "化州", "id": 3661, "cdesc": "化州市", "parentid": 100}, "3662": {"ctype": "40", "cname": "信宜", "id": 3662, "cdesc": "信宜市", "parentid": 100}, "3663": {"ctype": "40", "cname": "零陵", "id": 3663, "cdesc": "零陵区", "parentid": 249}, "3664": {"ctype": "40", "cname": "冷水滩", "id": 3664, "cdesc": "冷水滩区", "parentid": 249}, "3665": {"ctype": "40", "cname": "道县", "id": 3665, "cdesc": "道县", "parentid": 249}, "3666": {"ctype": "40", "cname": "祁阳", "id": 3666, "cdesc": "祁阳县", "parentid": 249}, "3667": {"ctype": "40", "cname": "东安", "id": 3667, "cdesc": "东安县", "parentid": 249}, "3668": {"ctype": "40", "cname": "双牌", "id": 3668, "cdesc": "双牌县", "parentid": 249}, "3669": {"ctype": "40", "cname": "江永", "id": 3669, "cdesc": "江永县", "parentid": 249}, "3670": {"ctype": "40", "cname": "宁远", "id": 3670, "cdesc": "宁远县", "parentid": 249}, "3671": {"ctype": "40", "cname": "蓝山", "id": 3671, "cdesc": "蓝山县", "parentid": 249}, "3672": {"ctype": "40", "cname": "新田", "id": 3672, "cdesc": "新田县", "parentid": 249}, "3673": {"ctype": "40", "cname": "江华瑶族自治", "id": 3673, "cdesc": "江华瑶族自治县", "parentid": 249}, "3674": {"ctype": "40", "cname": "金洞管理", "id": 3674, "cdesc": "金洞管理区", "parentid": 249}, "3675": {"ctype": "40", "cname": "回龙圩管理", "id": 3675, "cdesc": "回龙圩管理区", "parentid": 249}, "3676": {"ctype": "40", "cname": "江海", "id": 3676, "cdesc": "江海区", "parentid": 98}, "3677": {"ctype": "40", "cname": "蓬江", "id": 3677, "cdesc": "蓬江区", "parentid": 98}, "3678": {"ctype": "40", "cname": "新会", "id": 3678, "cdesc": "新会区", "parentid": 98}, "3679": {"ctype": "40", "cname": "台山", "id": 3679, "cdesc": "台山市", "parentid": 98}, "3680": {"ctype": "40", "cname": "鹤山", "id": 3680, "cdesc": "鹤山市", "parentid": 98}, "3681": {"ctype": "40", "cname": "开平", "id": 3681, "cdesc": "开平市", "parentid": 98}, "3682": {"ctype": "40", "cname": "恩平", "id": 3682, "cdesc": "恩平市", "parentid": 98}, "3683": {"ctype": "40", "cname": "鹤城", "id": 3683, "cdesc": "鹤城区", "parentid": 250}, "3684": {"ctype": "40", "cname": "中方", "id": 3684, "cdesc": "中方县", "parentid": 250}, "3685": {"ctype": "40", "cname": "沅陵", "id": 3685, "cdesc": "沅陵县", "parentid": 250}, "3686": {"ctype": "40", "cname": "辰溪", "id": 3686, "cdesc": "辰溪县", "parentid": 250}, "3687": {"ctype": "40", "cname": "溆浦", "id": 3687, "cdesc": "溆浦县", "parentid": 250}, "3688": {"ctype": "40", "cname": "会同", "id": 3688, "cdesc": "会同县", "parentid": 250}, "3689": {"ctype": "40", "cname": "麻阳苗族自治", "id": 3689, "cdesc": "麻阳苗族自治县", "parentid": 250}, "3690": {"ctype": "40", "cname": "新晃侗族自治", "id": 3690, "cdesc": "新晃侗族自治县", "parentid": 250}, "3691": {"ctype": "40", "cname": "芷江侗族自治", "id": 3691, "cdesc": "芷江侗族自治县", "parentid": 250}, "3692": {"ctype": "40", "cname": "靖州苗族侗族自治", "id": 3692, "cdesc": "靖州苗族侗族自治县", "parentid": 250}, "3693": {"ctype": "40", "cname": "通道侗族自治", "id": 3693, "cdesc": "通道侗族自治县", "parentid": 250}, "3694": {"ctype": "40", "cname": "洪江", "id": 3694, "cdesc": "洪江市", "parentid": 250}, "3695": {"ctype": "40", "cname": "洪江管理", "id": 3695, "cdesc": "洪江管理区", "parentid": 250}, "3696": {"ctype": "40", "cname": "吉首", "id": 3696, "cdesc": "吉首市", "parentid": 252}, "3697": {"ctype": "40", "cname": "泸溪", "id": 3697, "cdesc": "泸溪县", "parentid": 252}, "3698": {"ctype": "40", "cname": "凤凰", "id": 3698, "cdesc": "凤凰县", "parentid": 252}, "3699": {"ctype": "40", "cname": "花垣", "id": 3699, "cdesc": "花垣县", "parentid": 252}, "3700": {"ctype": "40", "cname": "保靖", "id": 3700, "cdesc": "保靖县", "parentid": 252}, "3701": {"ctype": "40", "cname": "古丈", "id": 3701, "cdesc": "古丈县", "parentid": 252}, "3702": {"ctype": "40", "cname": "永顺", "id": 3702, "cdesc": "永顺县", "parentid": 252}, "3703": {"ctype": "40", "cname": "龙山", "id": 3703, "cdesc": "龙山县", "parentid": 252}, "3704": {"ctype": "40", "cname": "端州", "id": 3704, "cdesc": "端州区", "parentid": 101}, "3705": {"ctype": "40", "cname": "鼎湖", "id": 3705, "cdesc": "鼎湖区", "parentid": 101}, "3706": {"ctype": "40", "cname": "高要", "id": 3706, "cdesc": "高要区", "parentid": 101}, "3707": {"ctype": "40", "cname": "四会", "id": 3707, "cdesc": "四会市", "parentid": 101}, "3708": {"ctype": "40", "cname": "广宁", "id": 3708, "cdesc": "广宁县", "parentid": 101}, "3709": {"ctype": "40", "cname": "怀集", "id": 3709, "cdesc": "怀集县", "parentid": 101}, "3710": {"ctype": "40", "cname": "封开", "id": 3710, "cdesc": "封开县", "parentid": 101}, "3711": {"ctype": "40", "cname": "德庆", "id": 3711, "cdesc": "德庆县", "parentid": 101}, "3712": {"ctype": "40", "cname": "赤坎", "id": 3712, "cdesc": "赤坎区", "parentid": 99}, "3713": {"ctype": "40", "cname": "霞山", "id": 3713, "cdesc": "霞山区", "parentid": 99}, "3714": {"ctype": "40", "cname": "坡头", "id": 3714, "cdesc": "坡头区", "parentid": 99}, "3715": {"ctype": "40", "cname": "麻章", "id": 3715, "cdesc": "麻章区", "parentid": 99}, "3716": {"ctype": "40", "cname": "廉江", "id": 3716, "cdesc": "廉江市", "parentid": 99}, "3717": {"ctype": "40", "cname": "吴川", "id": 3717, "cdesc": "吴川市", "parentid": 99}, "3718": {"ctype": "40", "cname": "雷州", "id": 3718, "cdesc": "雷州市", "parentid": 99}, "3719": {"ctype": "40", "cname": "遂溪", "id": 3719, "cdesc": "遂溪县", "parentid": 99}, "3720": {"ctype": "40", "cname": "徐闻", "id": 3720, "cdesc": "徐闻县", "parentid": 99}, "3721": {"ctype": "40", "cname": "浈江", "id": 3721, "cdesc": "浈江区", "parentid": 93}, "3722": {"ctype": "40", "cname": "武江", "id": 3722, "cdesc": "武江区", "parentid": 93}, "3723": {"ctype": "40", "cname": "曲江", "id": 3723, "cdesc": "曲江区", "parentid": 93}, "3724": {"ctype": "40", "cname": "乐昌", "id": 3724, "cdesc": "乐昌市", "parentid": 93}, "3725": {"ctype": "40", "cname": "南雄", "id": 3725, "cdesc": "南雄市", "parentid": 93}, "3726": {"ctype": "40", "cname": "始兴", "id": 3726, "cdesc": "始兴县", "parentid": 93}, "3727": {"ctype": "40", "cname": "仁化", "id": 3727, "cdesc": "仁化县", "parentid": 93}, "3728": {"ctype": "40", "cname": "翁源", "id": 3728, "cdesc": "翁源县", "parentid": 93}, "3729": {"ctype": "40", "cname": "新丰", "id": 3729, "cdesc": "新丰县", "parentid": 93}, "3730": {"ctype": "40", "cname": "乳源瑶族自治", "id": 3730, "cdesc": "乳源瑶族自治县", "parentid": 93}, "3731": {"ctype": "40", "cname": "禅城", "id": 3731, "cdesc": "禅城区", "parentid": 97}, "3732": {"ctype": "40", "cname": "高明", "id": 3732, "cdesc": "高明区", "parentid": 97}, "3733": {"ctype": "40", "cname": "三水", "id": 3733, "cdesc": "三水区", "parentid": 97}, "3734": {"ctype": "40", "cname": "南海", "id": 3734, "cdesc": "南海区", "parentid": 97}, "3735": {"ctype": "40", "cname": "顺德", "id": 3735, "cdesc": "顺德区", "parentid": 97}, "3736": {"ctype": "40", "cname": "金平", "id": 3736, "cdesc": "金平区", "parentid": 96}, "3737": {"ctype": "40", "cname": "龙湖", "id": 3737, "cdesc": "龙湖区", "parentid": 96}, "3738": {"ctype": "40", "cname": "濠江", "id": 3738, "cdesc": "濠江区", "parentid": 96}, "3739": {"ctype": "40", "cname": "潮南", "id": 3739, "cdesc": "潮南区", "parentid": 96}, "3740": {"ctype": "40", "cname": "潮阳", "id": 3740, "cdesc": "潮阳区", "parentid": 96}, "3741": {"ctype": "40", "cname": "澄海", "id": 3741, "cdesc": "澄海区", "parentid": 96}, "3742": {"ctype": "40", "cname": "南澳", "id": 3742, "cdesc": "南澳县", "parentid": 96}, "3743": {"ctype": "40", "cname": "香洲", "id": 3743, "cdesc": "香洲区", "parentid": 95}, "3744": {"ctype": "40", "cname": "斗门", "id": 3744, "cdesc": "斗门区", "parentid": 95}, "3745": {"ctype": "40", "cname": "金湾", "id": 3745, "cdesc": "金湾区", "parentid": 95}, "3746": {"ctype": "40", "cname": "福田", "id": 3746, "cdesc": "福田区", "parentid": 94}, "3747": {"ctype": "40", "cname": "罗湖", "id": 3747, "cdesc": "罗湖区", "parentid": 94}, "3748": {"ctype": "40", "cname": "南山", "id": 3748, "cdesc": "南山区", "parentid": 94}, "3749": {"ctype": "40", "cname": "盐田", "id": 3749, "cdesc": "盐田区", "parentid": 94}, "3750": {"ctype": "40", "cname": "宝安", "id": 3750, "cdesc": "宝安区", "parentid": 94}, "3751": {"ctype": "40", "cname": "龙岗", "id": 3751, "cdesc": "龙岗区", "parentid": 94}, "3752": {"ctype": "40", "cname": "越秀", "id": 3752, "cdesc": "越秀区", "parentid": 92}, "3753": {"ctype": "40", "cname": "荔湾", "id": 3753, "cdesc": "荔湾区", "parentid": 92}, "3754": {"ctype": "40", "cname": "海珠", "id": 3754, "cdesc": "海珠区", "parentid": 92}, "3755": {"ctype": "40", "cname": "天河", "id": 3755, "cdesc": "天河区", "parentid": 92}, "3756": {"ctype": "40", "cname": "白云", "id": 3756, "cdesc": "白云区", "parentid": 92}, "3757": {"ctype": "40", "cname": "黄埔", "id": 3757, "cdesc": "黄埔区", "parentid": 92}, "3758": {"ctype": "40", "cname": "花都", "id": 3758, "cdesc": "花都区", "parentid": 92}, "3759": {"ctype": "40", "cname": "番禺", "id": 3759, "cdesc": "番禺区", "parentid": 92}, "3760": {"ctype": "40", "cname": "南沙", "id": 3760, "cdesc": "南沙区", "parentid": 92}, "3761": {"ctype": "40", "cname": "增城", "id": 3761, "cdesc": "增城区", "parentid": 92}, "3762": {"ctype": "40", "cname": "从化", "id": 3762, "cdesc": "从化区", "parentid": 92}, "3766": {"ctype": "30", "cname": "梁平", "id": 3766, "cdesc": "梁平", "parentid": 30}, "3769": {"ctype": "30", "cname": "丰都", "id": 3769, "cdesc": "丰都", "parentid": 30}, "3770": {"ctype": "30", "cname": "城口", "id": 3770, "cdesc": "城口", "parentid": 30}, "3771": {"ctype": "30", "cname": "垫江", "id": 3771, "cdesc": "垫江", "parentid": 30}, "3772": {"ctype": "30", "cname": "忠县", "id": 3772, "cdesc": "忠县", "parentid": 30}, "3773": {"ctype": "30", "cname": "云阳", "id": 3773, "cdesc": "云阳", "parentid": 30}, "3774": {"ctype": "30", "cname": "奉节", "id": 3774, "cdesc": "奉节", "parentid": 30}, "3775": {"ctype": "30", "cname": "巫山", "id": 3775, "cdesc": "巫山", "parentid": 30}, "3776": {"ctype": "30", "cname": "巫溪", "id": 3776, "cdesc": "巫溪", "parentid": 30}, "3777": {"ctype": "30", "cname": "石柱", "id": 3777, "cdesc": "石柱", "parentid": 30}, "3778": {"ctype": "30", "cname": "秀山", "id": 3778, "cdesc": "秀山", "parentid": 30}, "3779": {"ctype": "30", "cname": "武隆", "id": 3779, "cdesc": "武隆", "parentid": 30}, "3780": {"ctype": "30", "cname": "酉阳", "id": 3780, "cdesc": "酉阳", "parentid": 30}, "3781": {"ctype": "30", "cname": "彭水", "id": 3781, "cdesc": "彭水", "parentid": 30}, "3782": {"ctype": "30", "cname": "南开", "id": 3782, "cdesc": "南开区", "parentid": 16}}
        '''
        self.dict_area = json.loads(areaJson)

    def getDict_area(self):
        return self.dict_area


if __name__=="__main__":
    a = AreaGet()
    print(a.getDict_area())